SystemOrganization addCategory: #'FileSystem-Git'!
SystemOrganization addCategory: #'FileSystem-Git-Core'!
SystemOrganization addCategory: #'FileSystem-Git-Help'!
SystemOrganization addCategory: #'FileSystem-Git-Monticello'!
SystemOrganization addCategory: #'FileSystem-Git-Monticello-Tests'!
SystemOrganization addCategory: #'FileSystem-Git-Notifications'!
SystemOrganization addCategory: #'FileSystem-Git-Plumbing-Core'!
SystemOrganization addCategory: #'FileSystem-Git-Plumbing-Exceptions'!
SystemOrganization addCategory: #'FileSystem-Git-Plumbing-Notifications'!
SystemOrganization addCategory: #'FileSystem-Git-Plumbing-Packs'!
SystemOrganization addCategory: #'FileSystem-Git-Plumbing-Tests'!
SystemOrganization addCategory: #'FileSystem-Git-Plumbing-Traits'!
SystemOrganization addCategory: #'FileSystem-Git-Plumbing-Utilities'!
SystemOrganization addCategory: #'FileSystem-Git-Remote'!
SystemOrganization addCategory: #'FileSystem-Git-Remote-Tests'!
SystemOrganization addCategory: #'FileSystem-Git-Tests'!

Trait named: #TGitVisitor
	uses: {}
	category: 'FileSystem-Git-Plumbing-Traits'!

!TGitVisitor methodsFor: 'visiting' stamp: 'MaxLeske 8/13/2012 22:10'!
visit: anObject
	"avoid extending Collection"
	anObject isCollection ifTrue: [ ^ self visitCollection: anObject ].
	
	anObject accept: self! !

!TGitVisitor methodsFor: 'visiting' stamp: 'MaxLeske 8/13/2012 22:03'!
visitBlob: aBlob! !

!TGitVisitor methodsFor: 'visiting' stamp: 'MaxLeske 8/13/2012 22:08'!
visitCollection: aCollection
	aCollection do: [ :object | self visit: object ]! !

!TGitVisitor methodsFor: 'visiting' stamp: 'MaxLeske 8/13/2012 22:05'!
visitCommit: aCommit
	self visitCollection: aCommit parents! !

!TGitVisitor methodsFor: 'visiting' stamp: 'MaxLeske 8/13/2012 22:17'!
visitRepository: aRepository
	self
		visitCommit: aRepository head;
		visitCollection: aRepository tags;
		visitCollection: aRepository branches! !

!TGitVisitor methodsFor: 'visiting' stamp: 'MaxLeske 8/18/2012 16:01'!
visitTag: aTag
	aTag isLightWeightTag ifTrue: [ ^ self ].
	
	self visitCommit: aTag object! !

!TGitVisitor methodsFor: 'visiting' stamp: 'MaxLeske 8/13/2012 22:05'!
visitTree: aTree
	self visitCollection: aTree objects! !

HierarchicalUrl subclass: #GitUrl
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Remote'!

!GitUrl class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 12/25/2011 13:36'!
schemeName
	^ 'git'! !

MCReader subclass: #MCGitReader
	instanceVariableNames: 'infoCache definitions info dependencies package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Monticello'!

!MCGitReader methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 23:21'!
classFolders
	^ self reference glob: [ :ref| 
		ref isDirectory and: [ ref extension = 'class' ]]! !

!MCGitReader methodsFor: 'accessing' stamp: 'CamilloBruni 7/13/2011 15:41'!
definitions
	^ definitions ifNil: [ definitions := self loadDefinitions].! !

!MCGitReader methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 22:21'!
dependencies
	^ dependencies ifNil: [ dependencies := self loadDependencies ]! !

!MCGitReader methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 22:53'!
filesystem
	^ self reference filesystem! !

!MCGitReader methodsFor: 'accessing' stamp: 'CamilloBruni 7/13/2011 15:41'!
info
	^ info ifNil: [ info := self loadVersionInfo ]! !

!MCGitReader methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 22:48'!
legacyVersion
	| version versionInfo |

	"1 vs 0 based offsets madness!! hence convert from internal streams to external ones"
	version := MCMczReader versionFromStream: (self reference , 'mcz') readStream contents readStream.
	
	versionInfo := version info.
	
	"manually hack in the UUID"
	versionInfo
		initializeWithName: version name 
		id: self reference filesystem revision sha1
		message: versionInfo message 
		date: versionInfo date 
		time: versionInfo time 
		author: versionInfo author
		ancestors: versionInfo ancestors 
		stepChildren: versionInfo stepChildren.
	
	version 
		setPackage: version package
		info: versionInfo
		snapshot: version snapshot
		dependencies: version dependencies.
	^ version
		! !

!MCGitReader methodsFor: 'loading' stamp: 'CamilloBruni 1/23/2012 23:42'!
loadDefinitions

	| newDefinitions |
	
	newDefinitions := OrderedCollection new.
	
	self classFolders do: [:classFolder |
		MCGitClassReader loadDefinitionsFrom: classFolder into: newDefinitions ].
	
	^ newDefinitions
	
	"self flag: 'properly reconstruct the definitions from the repository data'.
	^ ( MCStReader on: (self reference / 'source.st') readStream) definitions"! !

!MCGitReader methodsFor: 'loading' stamp: 'CamilloBruni 7/12/2011 13:26'!
loadDependencies
	^ OrderedCollection new! !

!MCGitReader methodsFor: 'loading' stamp: 'CamilloBruni 7/12/2011 15:22'!
loadPackage
	^ MCPackage named: self reference basename! !

!MCGitReader methodsFor: 'loading' stamp: 'CamilloBruni 8/9/2011 20:41'!
loadVersionInfo
	^ MCGitVersionInfo with: self reference filesystem! !

!MCGitReader methodsFor: 'accessing' stamp: 'Camillobruni 8/18/2011 17:01'!
package
	self halt.
	^ package ifNil: [ package := self loadPackage ]! !

!MCGitReader methodsFor: 'accessing' stamp: 'lr 10/29/2010 17:55'!
reference
	^ stream! !

!MCGitReader methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 23:18'!
snapshot
	^ MCSnapshot fromDefinitions: self definitions! !

!MCGitReader methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 22:53'!
version
	^ MCGitVersion filesystem: self filesystem ! !

FileSystemStore subclass: #GitStore
	instanceVariableNames: 'revision cache modManager repository cacheStore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Core'!

!GitStore commentStamp: 'CamilloBruni 8/1/2011 18:33' prior: 0!
I am used to access files and directorys of a specific version of a git repository.!

!GitStore class methodsFor: 'instance creation' stamp: 'CamilloBruni 8/30/2012 14:04'!
cache: aFilesystem
	^ self basicNew
		initializeWithCache: aFilesystem;
		yourself! !

!GitStore class methodsFor: 'instance creation' stamp: 'CamilloBruni 8/30/2012 14:04'!
memory
	^ self cache: (FileSystem memory)! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 7/15/2011 16:36'!
basenameFromEntry: entry
	^ cacheStore basenameFromEntry: entry! !

!GitStore methodsFor: 'internal' stamp: 'CamilloBruni 9/3/2012 19:01'!
basicCommit: aMessage to: branchName
	| commit parents author committer |
	"Disallow empty commits"
	modManager hasModifications ifFalse: [ ^ self ].
	modManager processChanges.
	
	commit := GitCommit
		withTree: modManager rootTree
		message: aMessage
		author: (author ifNil: [ author := GitStamp now ])
		committer: (committer ifNil: [ committer := GitStamp now ])
		in: repository.
		
	parents := OrderedCollection new.
	revision ifNotNil: [ parents add: revision hexHash ].
	commit 
		parents: parents;
		store.
	
	repository 
		updateRef: repository headsDir / branchName 
		to: commit hexHash.
	self revision: commit.! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 8/1/2011 16:30'!
basicCopy: source ifAbsent: aBlock to: destination ifPresent: pBlock  filesystem: aFilesystem
	self ensure: source.
	self ensure: destination.
	cacheStore basicCopy: source ifAbsent: aBlock to: destination ifPresent: pBlock  filesystem: aFilesystem.
	modManager markFileCreated: destination.! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 9/3/2012 18:50'!
basicCreationTime: aNode
	^ cacheStore basicCreationTime: aNode! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 7/15/2011 16:46'!
basicIsDirectory: aPath
	^ cacheStore basicIsDirectory: aPath! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 7/15/2011 16:46'!
basicIsFile: entry
	^ cacheStore basicIsFile: entry! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 9/3/2012 18:51'!
basicIsSymlink: aPath
	^ cacheStore basicIsSymlink: aPath! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 9/3/2012 18:50'!
basicModificationTime: aNode
	^ cacheStore basicModificationTime: aNode! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 8/1/2011 16:30'!
basicOpen: aPath writable: isWritable
	isWritable ifTrue: [ modManager markFileCreated: aPath ].
	self ensure: aPath.
	^ cacheStore
		basicOpen: aPath
		writable: isWritable! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 9/3/2012 18:51'!
basicPosixPermissions: aNode
	^ cacheStore basicPosixPermissions: aNode! !

!GitStore methodsFor: 'internal' stamp: 'CamilloBruni 7/19/2011 17:46'!
basicReset
	self flag: 'TODO: explicitely pass a revision/commit to the basicreset'.
	self flag: 'TODO: merge with ModificationManager >> clearRootTree'.
	
	cache workingDirectory children do: [ :reference|
		reference deleteAll].
	self repository: repository.
	self initializeWithCache: cache.
	! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 9/3/2012 18:50'!
basicSize: aPath
	^ cacheStore basicSize: aPath! !

!GitStore methodsFor: 'internal' stamp: 'CamilloBruni 7/15/2011 15:49'!
basicSwitchToBranch: branchName
	repository updateHeadToBranch: branchName.
	self basicReset.! !

!GitStore methodsFor: 'internal' stamp: 'CamilloBruni 9/2/2012 11:12'!
basicTag: tagName
	repository 
		updateRef: repository tagsDir / tagName 
		to: revision hexHash.
	self basicReset.! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 7/13/2011 19:42'!
branch: branchName message: aMessage
"Creates a commit in branch ==branchName== with message ==aMessage==. If the branch doesn't exist it will be created."

	self basicCommit: aMessage to: branchName.
	(branchName = self branchName)
		ifFalse: [ self basicSwitchToBranch: branchName ]! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 7/15/2011 17:36'!
branch: branchName message: message andTag: tagName
	self
		branch: branchName
		message: message.
	self 
		tagRevision: self
		with: tagName! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 7/13/2011 19:33'!
branchName
	self flag: 'this might be conceptually wrong'.
	^ repository activeBranchName! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 7/13/2011 20:22'!
branchNames
	^ repository branchNames! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 7/13/2011 20:23'!
branches
	^ repository branches! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 8/1/2011 17:20'!
commit: aMessage
	"Creates a commit with message ==aMessage== in the currently active branch."
	self basicCommit: aMessage to: self branchName! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 9/2/2012 12:23'!
commit: aMessage andTag: tagName
	"Creates a commit with message ==aMessage== and creates a tag for that commit with name ==tagName==."

	self 
		commit: aMessage;
		basicTag: tagName! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 8/1/2011 16:30'!
createDirectory: aPath
	self ensure: aPath.
	cache createDirectory: aPath.
	modManager markDirectoryCreated: aPath.! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 7/15/2011 18:45'!
delete: anObject
	(cache exists: anObject)
			ifTrue: [ cache delete: anObject].
	modManager
		markDeleted: anObject.! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 7/15/2011 16:46'!
delimiter
	^ cacheStore delimiter! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 7/15/2011 18:03'!
detachWorkingCopy
	"removes all entries that exist in the parent tree from the
	working copy. Changes will stay intact.
	The next commit will not contain any objects 
	present in the parent tree."
	
	modManager clearRootTree! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 7/19/2011 18:00'!
directoryAt: aPath ifAbsent: absentBlock nodesDo: aBlock
	self ensure: aPath.
	"load the directory into the cache"
	(modManager treeAt: aPath) entries do: [ :gitEntry|
			self ensure: aPath / gitEntry entryName.
		].
	cacheStore directoryAt: aPath ifAbsent: absentBlock nodesDo: aBlock.! !

!GitStore methodsFor: 'internal' stamp: 'CamilloBruni 7/19/2011 17:54'!
ensure: aPath 
	aPath isRoot ifTrue: [ ^ aPath ].
	"Make sure we have the lates version of the cache"
	(modManager isDeleted: aPath) ifTrue: [ ^ aPath ].
	(cacheStore exists: aPath) ifTrue: [ ^ aPath ].
	
	self loadFromRepository: aPath.
	^ aPath.! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 7/15/2011 19:16'!
entryFromNode: anObject filesystem: aFilesystem path: aPath	
	self flag: 'TODO: check if we need to intercept here and update the modification manager and the cache'.
	^ cacheStore entryFromNode: anObject filesystem: aFilesystem path: aPath! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 7/15/2011 19:16'!
entryFromNode: node path: path for: aFileystem	
	self flag: 'TODO: check if we need to intercept here and update the modification manager and the cache'.
	^ cacheStore entryFromNode: node path: path for: aFileystem! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 7/15/2011 19:06'!
exists: aPath
	(modManager isDeleted: aPath)
		ifTrue: [ ^ false ].
	self ensure: aPath.
	^ cacheStore exists: aPath! !

!GitStore methodsFor: 'printing' stamp: 'CamilloBruni 7/15/2011 15:53'!
forReferencePrintOn: aStream
	aStream nextPutAll: 'git:'! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 7/15/2011 19:16'!
growFile: path to: anInteger
	self flag: 'TODO: check if we need to intercept here and update the modification manager and the cache'.
	^ cacheStore growFile: path to: anInteger! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 7/15/2011 16:47'!
handleClass
	^ cacheStore handleClass! !

!GitStore methodsFor: 'initialize-release' stamp: 'CamilloBruni 8/30/2012 14:04'!
initializeWithCache: aFilessytem
	super initialize.
	cache := aFilessytem.
	cacheStore := cache store.
	modManager := GitModificationManager 
		initializeWith: repository
		with: cache
		for: revision.! !

!GitStore methodsFor: 'internal' stamp: 'CamilloBruni 7/15/2011 21:07'!
loadFromRepository: aPath
	"try to load the given path from the repositry into our cache"
	|currentGitTree|
	currentGitTree := self loadGitTreeAt: aPath.
	"path doesn't exist in the repository either"
	currentGitTree ifNil: [ ^ self ].
	
			! !

!GitStore methodsFor: 'internal' stamp: 'MaxLeske 2/28/2012 18:26'!
loadGitTreeAt: aPath
	"recursivel walk through all the git trees and resolve the path"
	|currentGitTree|
	currentGitTree := modManager rootTree.
	
	(aPath withParents reject: [ :path | path isRoot]) do: [ :path |
		currentGitTree isTree ifFalse: [ ^ nil ]. 
		currentGitTree
			entryAt: path basename
			ifPresent: [ :entry | 
				currentGitTree := entry object.
				self updateCacheAt: path with: currentGitTree.]
			ifAbsent: [ ^ nil ] ].
	^ currentGitTree! !

!GitStore methodsFor: 'initialize-release' stamp: 'CamilloBruni 7/19/2011 17:54'!
loadRootIntoCache
	revision ifNil: [ ^ self ].
	self halt.
	! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 7/15/2011 15:11'!
message
	^ revision isNil
		ifTrue: [ '' ]
		ifFalse: [ revision message ]! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 9/2/2012 11:12'!
name
"Answers the sha1 name of the currently active commit (the checked out version of the repository)."

	^ revision
		ifNotNil: [ revision hexHash ]
		ifNil: [ '' ]! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 7/15/2011 18:54'!
nodeAt: aPath ifPresent: presentBlock ifAbsent: absentBlock
	self ensure: aPath.
	^ cacheStore
		nodeAt:  aPath
		ifPresent: presentBlock
		ifAbsent: absentBlock! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 7/15/2011 16:47'!
openFileStream: path writable: aBoolean
	^ cacheStore openFileStream: path writable: aBoolean! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 7/15/2011 17:17'!
parents
	revision ifNil: [ ^ OrderedCollection new ].
	^ revision parents ! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 7/15/2011 16:47'!
pathFromString: aString
	^ cacheStore pathFromString: aString! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 7/15/2011 16:47'!
replaceFile: path in: aBlock
	^ cacheStore replaceFile: path in: aBlock! !

!GitStore methodsFor: 'initialize-release' stamp: 'CamilloBruni 9/2/2012 12:22'!
repository: aGitRepository
	repository := aGitRepository.
	modManager repository: repository.
	revision ifNil: [ self revision: (repository headIfAbsent: [ nil ]) ].! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 7/13/2011 19:48'!
reset
	self basicReset! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 7/13/2011 17:56'!
revision
	^ revision! !

!GitStore methodsFor: 'initialize-release' stamp: 'CamilloBruni 9/2/2012 18:37'!
revision: aGitCommit
	revision := aGitCommit.
	revision ifNil: [ ^ self ].
	repository ifNil: [ repository := aGitCommit repository ].
	self flag: 'TODO: directly use the commit as a reference'.
	self basicReset.! !

!GitStore methodsFor: 'delegate' stamp: 'CamilloBruni 9/3/2012 18:24'!
revisionHash
	^ revision hexHash! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 7/13/2011 20:22'!
tagNames
	^ repository tagNames! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 7/15/2011 17:36'!
tagRevision: aRevision with: aString
	aRevision basicTag: aString! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 7/13/2011 20:23'!
tags
	^ repository tags! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 7/15/2011 15:33'!
timeStampOfCommit
	revision
		ifNotNil: [ ^ revision committer timeStamp ]
		ifNil: [ ^ nil ]! !

!GitStore methodsFor: 'git-delegating' stamp: 'CamilloBruni 7/15/2011 15:33'!
timeStampOfCreation
	revision
		ifNotNil: [ ^ revision author timeStamp ]
		ifNil: [ ^ nil ]! !

!GitStore methodsFor: 'internal' stamp: 'CamilloBruni 7/15/2011 21:09'!
updateCacheAt: aPath with: aGitTree
	self flag: 'TODO: merge the modmanager cache and the store cache into a single instance'.
	modManager updateCacheAt: aPath with: aGitTree.
	(cacheStore exists: aPath) ifTrue: [ ^ self ].
	aGitTree isTree
		ifTrue: [ cacheStore ensureDirectory: aPath ]
		ifFalse: [
			"its a file, hence load its contents into the cache"
			cacheStore ensureDirectory: aPath parent.
			(cache referenceTo: aPath) 
					writeStreamDo: [ :stream | stream nextPutAll: aGitTree bytes ]].
			! !

!ByteArray methodsFor: '*FileSystem-Git-Plumbing' stamp: 'CamilloBruni 9/1/2012 12:14'!
asByteHash
	^ self! !

!ByteArray methodsFor: '*FileSystem-Git-Plumbing' stamp: 'CamilloBruni 9/1/2012 12:14'!
asHexHash
	^ self hex! !

!ByteArray methodsFor: '*FileSystem-Git-Plumbing' stamp: 'CamilloBruni 9/1/2012 12:14'!
asIntegerHash
	^ self asInteger! !

Error subclass: #GitError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Exceptions'!

GitError subclass: #GitIndexFileNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Exceptions'!

GitError subclass: #GitInvalidBytesError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Exceptions'!

GitError subclass: #GitInvalidIndexFileError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Exceptions'!

GitError subclass: #GitInvalidObjectError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Exceptions'!

GitError subclass: #GitInvalidPackFileError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Exceptions'!

GitError subclass: #GitInvalidRepositoryError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Exceptions'!

GitError subclass: #GitObjectNotFoundError
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Exceptions'!

!GitObjectNotFoundError class methodsFor: 'exceptioninstantiator' stamp: 'MaxLeske 8/11/2011 22:05'!
signal: aString with: data
	^ self new
		signal: aString;
		data: data! !

!GitObjectNotFoundError methodsFor: 'accessing' stamp: 'MaxLeske 8/11/2011 22:05'!
data
	^ data! !

!GitObjectNotFoundError methodsFor: 'accessing' stamp: 'MaxLeske 8/11/2011 22:05'!
data: anObject
	data := anObject! !

!GitObjectNotFoundError methodsFor: 'printing' stamp: 'MaxLeske 2/28/2012 19:42'!
messageText
	^ String streamContents: [ :stream |
		stream
			nextPutAll: messageText;
			nextPutAll: ' Known object data: ';
			nextPutAll: data printString ] ! !

GitError subclass: #GitUnsupportedOperationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Exceptions'!

GitError subclass: #GitValidationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Exceptions'!

!FileSystem class methodsFor: '*FileSystem-Git' stamp: 'CamilloBruni 9/2/2012 11:36'!
git
	"Return a GitFileSystem running in memory"
	^ self onGit: self memory root! !

!FileSystem class methodsFor: '*FileSystem-Git' stamp: 'CamilloBruni 9/1/2012 12:16'!
onGit: aReference
	^ (FileSystemGitRepository on: aReference) head! !

FileSystem subclass: #GitFilesystem
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Core'!

!GitFilesystem commentStamp: 'CamilloBruni 8/1/2011 18:30' prior: 0!
I am wrapper for accessing the files of a specific revision from a git repository. I am almost never used directly but create by a FSGitRepository.

	ref := FSFilesystem onDisnk / 'home' / 'MyUser' / 'foo.git'.
	basicRepository := GitRepository on: ref.
	fsRepository := FSGitRepository  on: ref.
	workingCopy := fsRepository head. "this returns an FSGitFilesystem for head"!

!GitFilesystem methodsFor: 'comparing' stamp: 'CamilloBruni 7/15/2011 15:59'!
= other
	(self name isEmptyOrNil and: [ other name isEmptyOrNil ])
		ifFalse: [ ^ self name = other name ]
		ifTrue: [ ^ self == other ]! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 7/15/2011 17:37'!
branch: branchName message: aMessage
	store branch: branchName message: aMessage! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 7/15/2011 17:37'!
branch: branchName message: message andTag: tagName
	store branch: branchName message: message andTag: tagName! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 7/13/2011 20:21'!
branchName
	^ store branchName! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 7/15/2011 15:26'!
branchNames
	^ repository branchNames! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 7/15/2011 15:26'!
branches
	^ repository branches! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 7/13/2011 20:18'!
commit: aMessageString
	^ store commit: aMessageString! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 7/15/2011 15:36'!
commit: aMessageString andTag: tagName
	^ store commit: aMessageString andTag: tagName! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 7/15/2011 18:03'!
detachWorkingCopy
	store detachWorkingCopy.! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 7/13/2011 20:15'!
message
	^ store message! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 8/1/2011 16:17'!
name
"Answers the sha1 name of the currently active commit (the checked out version of the repository)."

	^ self store name! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 7/15/2011 17:18'!
parents
	^ store parents collect: [ :commit | 
		repository filesystemOn: commit ]! !

!GitFilesystem methodsFor: 'accessing' stamp: 'CamilloBruni 7/15/2011 15:26'!
repository
	^ repository! !

!GitFilesystem methodsFor: 'accessing' stamp: 'CamilloBruni 7/15/2011 15:26'!
repository: anFSGitRepository
	repository := anFSGitRepository! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 7/13/2011 19:46'!
reset
	store reset! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 7/13/2011 20:21'!
revision
	^ store revision! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 1/23/2012 22:33'!
revisionHash
	^ store revisionHash! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 7/15/2011 15:27'!
tagNames
	^ repository tagNames! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 7/15/2011 15:27'!
tags
	^ repository tags! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 7/15/2011 15:33'!
timeStampOfCommit
	^ store timeStampOfCommit! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 7/15/2011 15:33'!
timeStampOfCreation
	^ store timeStampOfCreation! !

!GitFilesystem methodsFor: 'delegating' stamp: 'CamilloBruni 8/9/2011 16:57'!
validate
	^ repository validate! !

MCWriter subclass: #MCGitWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Monticello'!

!MCGitWriter class methodsFor: 'writing' stamp: 'lr 10/29/2010 17:31'!
fileOut: aVersion on: aStream
	| inst |
	inst := self on: aStream.
	inst writeVersion: aVersion! !

!MCGitWriter class methodsFor: 'accessing' stamp: 'CamilloBruni 8/9/2011 15:26'!
readerClass
	^ MCStReader! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 4/29/2011 13:42'!
addDefinition: definition
	self writeDefinition: definition.! !

!MCGitWriter methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2011 01:47'!
classPathFor: aClass 
	^ self classPathForPackage: aClass category class: aClass name! !

!MCGitWriter methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 19:40'!
classPathForPackage: packageName class: className
	|path|
	
	path := self reference.
	
	($- split: packageName) do: [ :categorySegment|
		path := path / categorySegment].
	
	path := path / className, 'class'.
	path ensureDirectory.
	
	^ path! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 8/9/2011 15:39'!
convert: aString
	^ aString replaceAll: Character cr with: Character lf! !

!MCGitWriter methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 19:35'!
methodPathFor: aMethodDefinition
	|path|
	path := self classPathFor: (aMethodDefinition classIsMeta 
											ifTrue: [ aMethodDefinition actualClass theNonMetaClass ] 
											ifFalse: [ aMethodDefinition actualClass ]).
	
	aMethodDefinition actualClass.
	path := path / (aMethodDefinition classIsMeta 
											ifTrue: [ 'class-side' ] 
											ifFalse: [ 'instance-side' ]).
	path := path / aMethodDefinition category.
	^ path! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 1/24/2012 12:21'!
modifyClass: oldDefinition to: newDefinition
	(self classPathFor: oldDefinition) delete.
	self writeClassDefinition: newDefinition.! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 7/6/2011 15:34'!
modifyDefinition: oldDefinition to: newDefinition
	oldDefinition isOrganizationDefinition
		ifTrue: [ ^ self modifyPackage: oldDefinition to:  newDefinition].
	oldDefinition isClassDefinition
		ifTrue: [ ^ self modifyClass: oldDefinition to:  newDefinition ].
	oldDefinition isMethodDefinition
		ifTrue: [ ^ self modifyMethod: oldDefinition to:  newDefinition].
	self error: 'unknown definition for removal'.! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 1/24/2012 12:19'!
modifyMethod: oldDefinition to: newDefinition
	(self methodPathFor: oldDefinition) delete.
	self writeMethodDefinition: newDefinition.! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 7/6/2011 15:35'!
modifyPackage: oldDefinition to:  newDefinition
	self shouldBeImplemented! !

!MCGitWriter methodsFor: 'accessing' stamp: 'lr 10/29/2010 17:32'!
reference
	^ stream! !

!MCGitWriter methodsFor: 'removing' stamp: 'CamilloBruni 4/29/2011 01:49'!
removeClass: aClassDefinition
	(self classPathForPackage: aClassDefinition category class: aClassDefinition className) delete
	! !

!MCGitWriter methodsFor: 'removing' stamp: 'CamilloBruni 4/29/2011 13:56'!
removeDefinition: aDefinition
	aDefinition isOrganizationDefinition
		ifTrue: [ ^ self removePackage: aDefinition ].
	aDefinition isClassDefinition
		ifTrue: [ ^ self removeClass: aDefinition ].
	aDefinition isMethodDefinition
		ifTrue: [ ^ self removeMethod: aDefinition ].
	self error: 'unknown definition for removal'.! !

!MCGitWriter methodsFor: 'removing' stamp: 'CamilloBruni 4/29/2011 15:54'!
removeMethod: aMCMethodDefinition 
	(self methodPathFor: aMCMethodDefinition) delete.! !

!MCGitWriter methodsFor: 'legacy' stamp: 'CamilloBruni 8/9/2011 15:39'!
serializeDefinitions: aCollection
	^ String streamContents: [ :s |
		(MCStWriter on: s)
			writeDefinitions: aCollection ]! !

!MCGitWriter methodsFor: 'serializing' stamp: 'CamilloBruni 4/28/2011 23:48'!
serializeMethodDefinition: aMethodDefinition 
	^ String streamContents: [ :s |
		(MCStWriter on: s)
			visitMethodDefinition: aMethodDefinition]! !

!MCGitWriter methodsFor: 'legacy' stamp: 'lr 10/29/2010 17:44'!
serializeVersionInfo: aVersionInfo
	^ String streamContents: [ :s |
		(MCVersionInfoWriter on: s)
			writeVersionInfo: aVersionInfo ]! !

!MCGitWriter methodsFor: 'accessing' stamp: 'lr 10/29/2010 17:22'!
snapshotWriterClass
	^ MCStWriter! !

!MCGitWriter methodsFor: 'syncing' stamp: 'CamilloBruni 7/6/2011 15:33'!
syncClassAt: directory
	|className|
	className := (directory basename copyUpToLast: $.) asSymbol.
	(Smalltalk includesKey: className)
		ifFalse: [ ^ directory delete ].
	self syncMethodsOfClass: (Smalltalk at: className) in: directory.! !

!MCGitWriter methodsFor: 'syncing' stamp: 'CamilloBruni 5/19/2011 21:38'!
syncMethods: selectorCollection withFiles: aDirectory 
	|selectors methodFiles|
	aDirectory exists
		ifFalse: [ ^ self ].
	selectors := selectorCollection asSet.
	methodFiles := aDirectory glob: [:path| path basename endsWith: '.st'].
	methodFiles do: [ :path|
		(selectors includes: (path basename copyUpToLast: $.) asSymbol)
			ifFalse: [ path reference delete ]].! !

!MCGitWriter methodsFor: 'updating' stamp: 'CamilloBruni 4/29/2011 15:47'!
syncMethodsOfClass: aClass in: aDirectory 
	self syncMethods: (aClass methodDict keys) withFiles: aDirectory / #instancemethod.
	self syncMethods: (aClass class methodDict) keys withFiles: aDirectory / #classmethod.
							! !

!MCGitWriter methodsFor: 'syncing' stamp: 'CamilloBruni 4/29/2011 14:55'!
syncPackageAt: directory
	self flag: 'to be implemented'.
	self syncPackagesAt: directory.! !

!MCGitWriter methodsFor: 'syncing' stamp: 'CamilloBruni 8/9/2011 15:42'!
syncPackagesAt: aPath
	aPath directories do: [ :directory|
		(directory basename endsWith: '.cls')
			ifFalse: [ self syncPackageAt: directory ]
			ifTrue: [	self syncClassAt: directory ]].! !

!MCGitWriter methodsFor: 'syncing' stamp: 'CamilloBruni 4/29/2011 14:49'!
syncSources
	self syncPackagesAt: self reference.! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 9/2/2012 18:42'!
writeClassDefinition: aClassDefinition 
	| classPath |
	
	classPath := self classPathFor: aClassDefinition.
	
	((classPath / 'instance-side') ensureDirectory / 'definition.st') writeStreamDo: [ :s|
		self writeClassDefinition: aClassDefinition on: s].
	
	((classPath / 'class-side') ensureDirectory / 'definition.st') writeStreamDo: [ :s|
		self writeMetaClassDefinition: aClassDefinition on: s].
	
	(classPath / 'README.txt') writeStreamDo: [ :s|
		s nextPutAll: (self convert: aClassDefinition comment)].
	! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 1/24/2012 12:28'!
writeClassDefinition: aClassDefinition on: aStream 
	aClassDefinition printDefinitionOn: aStream.! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 1/24/2012 12:19'!
writeDefinition: aDefinition

	aDefinition isOrganizationDefinition
		ifTrue: [ ^ self writePackageDefinition: aDefinition ].
		
	aDefinition isClassDefinition
		ifTrue: [ ^ self writeClassDefinition: aDefinition ].
		
	aDefinition isMethodDefinition
		ifTrue: [ ^ self writeMethodDefinition: aDefinition ].
		
	self error: 'unknown definition for removal'.! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 1/24/2012 12:19'!
writeDefinitions: definitions	
	definitions do: [ :each|
		self writeDefinition: each ].! !

!MCGitWriter methodsFor: 'legacy' stamp: 'CamilloBruni 8/9/2011 15:40'!
writeInfo: aVersionInfo
	(self reference / 'version') writeStreamDo: [ :s |
		s nextPutAll: (self convert: (self serializeVersionInfo: aVersionInfo)) ]! !

!MCGitWriter methodsFor: 'legacy' stamp: 'CamilloBruni 8/9/2011 15:39'!
writeLegacySnapshot: aSnapshot
	(self reference / 'source.st')
		writeStreamDo: [ :s | 
			s nextPutAll: (self convert: (self serializeDefinitions: aSnapshot definitions)) ].! !

!MCGitWriter methodsFor: 'legacy' stamp: 'Camillobruni 8/18/2011 17:02'!
writeLegacyVersion: aVersion
	|buffer|
	"lazy... write all formats then later on decide on what to load"
	"self writeInfo: aVersion info.
	self writeLegacySnapshot: aVersion snapshot."
	
	buffer := ByteArray streamContents: [ :s|
			aVersion fileOutOn: s].
	
	(self reference / (aVersion info name, '.mcz')) writeStreamDo: [ :s| 
		s nextPutAll: buffer ].! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 1/24/2012 12:27'!
writeMetaClassDefinition: aClassDefinition on: aStream 

	aStream nextPutAll: aClassDefinition className;
			nextPutAll: ' class';
			lf; tab.
			
	aClassDefinition hasClassTraitComposition ifTrue: [
		aStream nextPutAll: 'uses: ';
			nextPutAll: aClassDefinition classTraitCompositionString;
			lf; tab].
		
	aStream nextPutAll: 'instanceVariableNames: ''';
		nextPutAll: aClassDefinition classInstanceVariablesString;
		nextPut: $'! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 1/24/2012 12:19'!
writeMethodDefinition: aMethodDefinition
	|path|
	
	path := self methodPathFor: aMethodDefinition.
	path ensureDirectory.
	
	(path / aMethodDefinition selector, 'st')
		writeStreamDo: [ :s| 
			self writeMethodDefinition: aMethodDefinition on: s].! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 1/24/2012 12:18'!
writeMethodDefinition: aMethodDefinition on: aStream
	aStream nextPutAll: (self convert: (self serializeMethodDefinition: aMethodDefinition)).! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 4/29/2011 01:43'!
writeModificationPatch: aMCAddition
	self modifyDefinition: aMCAddition definition.! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 1/24/2012 12:19'!
writePackageDefinition: aMCOrganizationDefinition 
	aMCOrganizationDefinition categories do: [ :category|
		(self reference / category) ensureDirectory].! !

!MCGitWriter methodsFor: 'visiting' stamp: 'CamilloBruni 8/9/2011 20:44'!
writePatch: aMCPatch 
	(aMCPatch simplifyHierarchy) operations do: [:operation|
		self writePatchOperation: operation].! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 4/29/2011 13:42'!
writePatchOperation: aPatchOperation
	aPatchOperation applyTo: self.! !

!MCGitWriter methodsFor: 'writing' stamp: 'CamilloBruni 4/29/2011 01:43'!
writeRemovalPatch: aMCAddition
	self removeDefinition: aMCAddition definition.! !

!MCGitWriter methodsFor: 'visiting' stamp: 'CamilloBruni 8/9/2011 15:40'!
writeSnapshot: aSnapshot
	"write out a nice file based representation so you can easily track changes with a common git tool"
	self writeDefinitions: aSnapshot definitions! !

!MCGitWriter methodsFor: 'visiting' stamp: 'CamilloBruni 2/1/2012 23:50'!
writeVersion: aVersion
	aVersion isDiffy
		ifTrue: [ self writePatch: aVersion patch ]
		ifFalse: [ self writeSnapshot: aVersion snapshot].
	self syncSources.! !

!MCPatch methodsFor: '*FileSystem-Git-Monticello' stamp: 'CamilloBruni 8/9/2011 20:43'!
classRemovals
	^ operations select: [ :operation| 
			operation isRemoval and: [operation definition isClassDefinition]]! !

!MCPatch methodsFor: '*FileSystem-Git-Monticello' stamp: 'CamilloBruni 8/9/2011 20:43'!
methodRemovals
	^ operations select: [ :operation| 
			operation isRemoval and: [operation definition isMethodDefinition]]! !

!MCPatch methodsFor: '*FileSystem-Git-Monticello' stamp: 'CamilloBruni 8/9/2011 20:43'!
packageRemovals
	^ operations select: [ :operation| 
			operation isRemoval and: [operation definition isOrganizationDefinition]]! !

!MCPatch methodsFor: '*FileSystem-Git-Monticello' stamp: 'CamilloBruni 8/9/2011 20:43'!
removeMethodsOfClass: aClassName
	self methodRemovals do: [ :methodOperation|
		methodOperation definition className == aClassName
			ifTrue: [operations remove: methodOperation]]! !

!MCPatch methodsFor: '*FileSystem-Git-Monticello' stamp: 'CamilloBruni 8/9/2011 20:43'!
simplifyClassRemovals
	self packageRemovals do: [ :packageRemoval|
		operations remove: packageRemoval.
		self removeMethodsOfClass: packageRemoval definition className].! !

!MCPatch methodsFor: '*FileSystem-Git-Monticello' stamp: 'CamilloBruni 8/9/2011 20:43'!
simplifyHierarchy
	self simplifyClassRemovals.
	self simplifyMethodRemovals.! !

!MCPatch methodsFor: '*FileSystem-Git-Monticello' stamp: 'CamilloBruni 8/9/2011 20:43'!
simplifyMethodRemovals
	self classRemovals do: [ :classRemoval|
		self removeMethodsOfClass: classRemoval definition className].! !

!String methodsFor: '*FileSystem-Git-Plumbing' stamp: 'CamilloBruni 9/1/2012 12:15'!
asByteHash
	^ ByteArray readHexFrom: self! !

!String methodsFor: '*FileSystem-Git-Plumbing' stamp: 'CamilloBruni 9/1/2012 12:15'!
asHexHash
	^ self! !

!String methodsFor: '*FileSystem-Git-Plumbing' stamp: 'CamilloBruni 9/1/2012 12:15'!
asIntegerHash
	^ Integer readFrom: self base: 16! !

!Integer methodsFor: '*FileSystem-Git-Plumbing' stamp: 'CamilloBruni 9/1/2012 12:15'!
asByteHash
	^ self asHexHash asByteHash! !

!Integer methodsFor: '*FileSystem-Git-Plumbing' stamp: 'CamilloBruni 9/1/2012 12:15'!
asHexHash
	^ (self printStringBase: 16 length: 40 padded: true) asLowercase! !

!Integer methodsFor: '*FileSystem-Git-Plumbing' stamp: 'CamilloBruni 9/1/2012 12:15'!
asIntegerHash
	^ self! !

!PositionableStream methodsFor: '*FileSystem-Git' stamp: 'DamienCassou 1/30/2013 15:36'!
peek: anInteger
	| oldPosition result |
	oldPosition := position.
	result := self next: anInteger.
	position := oldPosition.
	^ result! !

MCVersionInfo subclass: #MCGitVersionInfo
	instanceVariableNames: 'commit filesystem aCommit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Monticello'!

!MCGitVersionInfo class methodsFor: 'instance creation' stamp: 'CamilloBruni 1/23/2012 23:06'!
filesystem: aGitFS
	"create a new info for the current revision"
	^ self filesystem: aGitFS commit: aGitFS revision! !

!MCGitVersionInfo class methodsFor: 'instance creation' stamp: 'CamilloBruni 1/23/2012 23:07'!
filesystem: aGitFS commit: aGitCommit
	^ self basicNew 
		initializeWithFilesystem: aGitFS commit: aGitCommit! !

!MCGitVersionInfo methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 23:00'!
ancestors
	^ ancestors ifNil: [ 
		ancestors := self loadAncestors ]! !

!MCGitVersionInfo methodsFor: 'initialize release' stamp: 'CamilloBruni 7/8/2011 12:41'!
commit
	^ commit! !

!MCGitVersionInfo methodsFor: 'initialize release' stamp: 'CamilloBruni 1/23/2012 23:18'!
initializeWithFilesystem: aGitFS commit: aGitCommit
	"Don't do super initialize and keep the instVars niled out for lazy initialization".
	filesystem := aGitFS.
	commit := aGitCommit.
	self loadBasicProperties.
	! !

!MCGitVersionInfo methodsFor: 'loading' stamp: 'CamilloBruni 1/23/2012 23:05'!
loadAncestors
	^ commit parents collect: [ :aGitCommit|
		self class filesystem: filesystem commit: aGitCommit ]! !

!MCGitVersionInfo methodsFor: 'loading' stamp: 'CamilloBruni 9/2/2012 11:12'!
loadBasicProperties
	id := commit hexHash.
	author := commit author name.
	date := commit author timeStamp date.
	time := commit author timeStamp time.
	message := commit message.
	name := self loadName.
	"ancestors are lazy"! !

!MCGitVersionInfo methodsFor: 'loading' stamp: 'CamilloBruni 1/23/2012 23:09'!
loadName
	| tags |
	tags := commit tags.
	tags isEmpty 
		ifFalse: [ ^ tags first name ].
	^ commit sha1! !

!MCGitVersionInfo methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 23:10'!
stepChildren
	self flag: 'TODO: not needed for now'.
	^ #()! !

CustomHelp subclass: #HelpOnGit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Help'!

HelpOnGit subclass: #GitHowTo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Help'!

!GitHowTo class methodsFor: 'pages' stamp: 'CamilloBruni 9/1/2012 12:12'!
advancedManipulations
	"This method was automatically generated. Edit it using:"
	"GitHowTo edit: #advancedManipulations"
	^HelpTopic
		title: 'Advanced manipulations'
		contents: 
'** How to use FileSystem-Git - Advanced manipulations **
=====================================================

To provide a better picture of what Git is capable of we will create a second commit so that the repository holds two versions of the working copy:
	(workingCopy / ''dir1'') ensureDirectory.
	anotherFile := workingCopy root resolve: ''dir1/anotherFile.txt''.
	anotherFile writeStreamDo: [ :stream |
		stream nextPutAll: ''beginning of another file.'' ].
	workingCopy commit: ''added a second file''.
	
Evaluating the following will now answer a collection of four references: "/", "/newFile.txt", "/dir1" and "/dir1/anotherFile.txt":
   workingCopy root allChildren.

Once you are satisfied with your changes you might want to commit and at the same time mark that commit specially. FS-Git offers convenience methods for this scenario:
	workingCopy
		commit: ''a commit message''
		andTag: ''version 1.0''.

#commit:andTag: creates a commit and a tag referencing that commit (at the moment only light tags are supported). From now on it will be easy to identify the commit that was used for the release of version 1.0. You might also choose to tag another commit you made earlier:
	workingCopy
		tagRevision: workingCopy parents first
		with: ''introduces cool new feature''.
		
Version 1.0 will probably not be the last version. It might therefore be convenient to do new work on a separate branch to separate versions clearly:
	workingCopy
		branch: ''my fork''
		message: ''a commit message''.
		
#branch:message: creates a commit with the current changes and a new branch referencing that commit. If the branch already exists it will be updated to the current commit. Of course you can also commit to a new branch and tag that commit with only one message if you like:
	workingCopy
		branch: ''my fork''
		message: ''alpha release''
		andTag: ''1.1 alpha''.
		
There are also messages to  access commit information. E.g. sending #name to an FSGitFilesystem object will answer the sha1 signature of that commit:
	parentSignature := workingCopy parents first name.
	
To retrieve the commit message of a particular version send the FSGitFilesystem object the message #message:
	commitMessage := workingCopy parents first message.!!' readStream nextChunkText! !

!GitHowTo class methodsFor: 'accessing' stamp: 'MaxLeske 9/3/2012 20:59'!
bookName
	^ 'How to use FileSystem-Git'! !

!GitHowTo class methodsFor: 'pages' stamp: 'MaxLeske 8/14/2011 21:45'!
firstSteps
	"This method was automatically generated. Edit it using:"
	"FSGitHowTo edit: #firstSteps"
	^HelpTopic
		title: 'First Steps with the Git filesystem'
		contents: 
'** How to use FS-Git - First Steps with the Git filesystem **
=====================================================

The idea behind using FSGitFilesystem objects is to modify the working copy of a Git repository and then commit those changes. Here is a simple example of how to modify the working copy. In a first step we assign an instance of FSGitFilesystem to the variable "workingCopy". The FSGitFilesystem object contains the working copy of the head commit of the created repository (the repository is empty so the working copy is too):
   workingCopy := repo head.

We then assign a reference (instance of FSReference) to the variable "newFile". The reference points to a file that does not yet exists. We create it by writing some content to it:
	newFile := workingCopy root / ''newfile.txt''.
	newFile writeStreamDo: [ :stream |
		stream nextPutAll: ''some content'' ].
	
Note that ''workingCopy root'' answers the root of the Git filesystem and not the root of the disk filesystem. If you made a mistake and simply want to have a clean workingCopy again you can send #reset to the workingCopy:
   workingCopy reset.

Assuming that the changes are fine, the file is committed to the repository thus saving the state of the working copy. The message #commit expects a message string describing the changes made:
	workingCopy commit: ''created a new file''.
	
Committing the changes will create and update objects and references in your repository as needed. After the commit has succeeded the FSGitFilesystem object (the one referenced by the variable "workingCopy") will point to that commit with all the recent changes reflected in the working copy.

The contents of the file we committed can be retrieved using the Filesystem protocol:
	fileContents := newFile readStreamDo: [ :stream |
		stream contents asString ].!!' readStream nextChunkText! !

!GitHowTo class methodsFor: 'pages' stamp: 'MaxLeske 8/14/2011 21:40'!
introduction
	"This method was automatically generated. Edit it using:"
	"FSGitHowTo edit: #introduction"
	^HelpTopic
		title: 'Introduction'
		contents: 
'** How to use FS-Git - Introduction **
=====================================================

FS-Git extends the Filesystem framework to enable work with Git repositories. The class FSGitFilesystem defines additional messages to the standard Filesystem protocol to manipulate and read repositories.

For this tutorial I will assume that you are familiar with Filesystem. If you are not, then please take a look at the help on Filesystem.!!' readStream nextChunkText! !

!GitHowTo class methodsFor: 'accessing' stamp: 'MaxLeske 8/14/2011 22:10'!
pages
	^ #(introduction workingWithRepositories advancedManipulations)! !

!GitHowTo class methodsFor: 'pages' stamp: 'CamilloBruni 8/30/2012 14:10'!
workingWithRepositories
	"This method was automatically generated. Edit it using:"
	"FSGitHowTo edit: #introduction"
	^HelpTopic
		title: 'Working with repositories'
		contents: 
'** How to use FS-Git - Working with repositories **
=====================================================

There are two classes a user of FS-Git needs to know: FSGitRepository and FSGitFilesystem. FSGitFilesystem implements the public Filesystem protocol and is the central object for most of the work. FSGitRepository encapsulates the knowledge of communication with a Git repository and is the starting point for working with Git.

A speciality about FSGit is that it provides a filesystem on top of another filesystem. Therefore, to instantiate a repository we need a reference to another filesystem. For this introduction we will work on a disk filesystem:
	repoReference := FileSystem disk root resolve: ''/Developer/webApp''. 
	repo := FSGitRepository on: repoReference.

FSGitRepository defines four messages to browse the contents of a git repository: 
	
	repo head.

#head answers an FSGitFilesystem object representing the head commit of the current repository.
	
	repo branches.

#branches answers a dictionary of branch names (strings) associated with FSGitFilesystem objects. Each object represents the head commit of a branch.

	repo tags.
#tags answers a dictionary of tag names (strings) associated with FSGitFilesystem objects. Each object represents a commit referenced by a tag found in the repository.

	repo versions.
#versions answers a collection of FSGitFilesystem objects, one for every commit found in the repository (independent of the active branch). Depending on the size of the repository this statement may take several minutes to complete.!!' readStream nextChunkText! !

!HelpOnGit class methodsFor: 'accessing' stamp: 'MaxLeske 9/3/2012 20:59'!
bookName
	^ 'FileSytem-Git'! !

!HelpOnGit class methodsFor: 'accessing' stamp: 'MaxLeske 8/14/2011 21:33'!
pages
	^ #(quickstart)! !

!HelpOnGit class methodsFor: 'pages' stamp: 'CamilloBruni 8/30/2012 14:08'!
quickstart
	"This method was automatically generated. Edit it using:"
	"HelpOnFSGit edit: #quickstart"
	^HelpTopic
		title: 'Quick-start'
		contents: 
'** Quickstart **
=====================================================

Get a filesystem on the head of a Git repository (new or existing) by evaluating the following expression in a workspace:
	workingCopy := FileSystem onGit: (<anFSReference>).
	
Examples of expressions for <anFSReference>:
	->  FSFilesystem inMemory / ''repository''
	->  FSFilesystem disk root resolve: ''/Users/mikado/Desktop/repository''
	
Create a file in the working copy:
	(workingCopy / ''<file name>'') writeStreamDo: [ :stream | 
		stream nextPutAll: ''<file content>'' ].
	
Finally, commit your changes:
	workingCopy commit: ''<commit message>''.!!' readStream nextChunkText! !

ZLibReadStream subclass: #GitZLibReadStream
	instanceVariableNames: 'sourceStartPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Utilities'!

!GitZLibReadStream methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 18:24'!
contents
	| contents |
	contents := super contents.
	"NOTE: sourcePos will usually start at 0, independent of the position of the source stream"
	sourceStream ifNotNil: [ sourceStream position: sourceStartPosition + sourcePos ].
	^ contents! !

!GitZLibReadStream methodsFor: 'initialize' stamp: 'MaxLeske 9/8/2012 18:04'!
on: aCollectionOrStream
	aCollectionOrStream isStream ifTrue: [
		sourceStartPosition := aCollectionOrStream position ].
	
	super on: aCollectionOrStream! !

!MCClassDefinition methodsFor: '*FileSystem-Git' stamp: 'CamilloBruni 9/2/2012 18:43'!
name
	^ name! !

!ZnMimeType class methodsFor: '*FileSystem-Git' stamp: 'DamienCassou 1/29/2013 15:08'!
applicationGitUploadPackAdvertisement
	^ self main: 'application' sub: 'x-git-upload-pack-advertisement'! !

!ZnMimeType class methodsFor: '*FileSystem-Git' stamp: 'DamienCassou 1/29/2013 15:08'!
applicationGitUploadPackRequest
	^ self main: 'application' sub: 'x-git-upload-pack-request'! !

!ZnMimeType class methodsFor: '*FileSystem-Git' stamp: 'DamienCassou 1/29/2013 15:08'!
applicationGitUploadPackResult
	^ self main: 'application' sub: 'x-git-upload-pack-result'! !

MCRepositoryTest subclass: #MCGitRepositoryTest
	instanceVariableNames: 'filesystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Monticello-Tests'!

!MCGitRepositoryTest methodsFor: 'actions' stamp: 'MaxLeske 8/25/2011 19:10'!
addVersion: aVersion 
	repository storeVersion: aVersion! !

!MCGitRepositoryTest methodsFor: 'running' stamp: 'DamienCassou 1/28/2013 20:13'!
runCase
	Author useAuthor: 'Montgomery C. Burns' during: [ super runCase ]! !

!MCGitRepositoryTest methodsFor: 'running' stamp: 'DamienCassou 1/28/2013 20:08'!
setUp
	
	filesystem :=  FileSystem memory.
	repository :=  MCGitRepository reference: filesystem root.
	
	GitStamp
		defaultName: 'Homer Simpson';
		defaultEmail: 'homer@nuke.com'.
! !

!MCGitRepositoryTest methodsFor: 'building' stamp: 'CamilloBruni 9/5/2012 22:14'!
snapshot1
	^ (MCSnapshot fromDefinitions: 
		(Array  
			with: (MCClassDefinition 
				name: 'ClassY'
				superclassName: 'Object'
				category: 'y' 
				instVarNames: ''
				comment: 'comment y')))! !

!MCGitRepositoryTest methodsFor: 'building' stamp: 'CamilloBruni 9/5/2012 22:13'!
snapshot2
	^ (MCSnapshot fromDefinitions: 
		(Array 
			with: (MCClassDefinition 
				name: 'ClassX'
				superclassName: 'Object'
				category: 'x' 
				instVarNames: ''
				comment: 'comment x')))! !

!MCGitRepositoryTest methodsFor: 'running' stamp: 'DamienCassou 1/28/2013 20:08'!
tearDown
	GitStamp
		defaultName: nil;
		defaultEmail: nil.! !

!MCGitRepositoryTest methodsFor: 'tests' stamp: 'Camillobruni 8/25/2011 18:52'!
testAddAndLoad
	self flag: 'fix'! !

!MCGitRepositoryTest methodsFor: 'tests' stamp: 'CamilloBruni 9/5/2012 22:21'!
testAddedFiles
	| versionInfo root |
	versionInfo := self addVersionWithSnapshot: self snapshot1 name: 'rev1'.
	root := repository repository tagNamed: versionInfo name.
	
	self assert: versionInfo name equals: 'MonticelloTest-xxx.1-rev1'.
	
	self assert: (root / 'y') exists.! !

!MCGitRepositoryTest methodsFor: 'tests' stamp: 'Camillobruni 8/25/2011 18:52'!
testStoreAndLoad
	self flag: 'fix'! !

Notification subclass: #GitRepositoryDeleteRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Notifications'!

!GitRepositoryDeleteRequest methodsFor: 'exceptiondescription' stamp: 'MaxLeske 7/24/2010 15:12'!
defaultAction
	^ StandardWindow new questionWithoutCancel: 
		'Do you really want to remove the repository? This cannot be undone!!'! !

Notification subclass: #GitResetRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Notifications'!

!GitResetRequest methodsFor: 'exceptiondescription' stamp: 'MaxLeske 7/24/2010 16:15'!
defaultAction
	^ StandardWindow 	new questionWithoutCancel: 
		'You will loose all changes that you didn''t commit. Do you really want the modifications to be reset?'! !

Notification subclass: #GitStampEmailRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Notifications'!

!GitStampEmailRequest commentStamp: '<historical>' prior: 0!
I provide a mechanism to handle a request for the e-mail address used in a GitStamp object before it triggers an input form. This is especially useful for testing purposes and scripts.!

!GitStampEmailRequest methodsFor: 'exceptiondescription' stamp: 'CamilloBruni 6/22/2011 05:21'!
defaultAction
	| mail |
	mail := GitStamp requestEmail.
	GitStamp defaultEmail: mail.
	^ mail! !

Notification subclass: #GitStampNameRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Notifications'!

!GitStampNameRequest commentStamp: '<historical>' prior: 0!
I provide a mechanism to handle a request for the name used in a GitStamp object before it triggers an input form. This is especially useful for testing purposes and scripts.!

!GitStampNameRequest methodsFor: 'exceptiondescription' stamp: 'MaxLeske 7/13/2010 14:50'!
defaultAction
	| name |
	name := GitStamp requestName.
	GitStamp defaultName: name.
	^ name! !

Notification subclass: #GitSwitchBranchRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Notifications'!

!GitSwitchBranchRequest methodsFor: 'exceptiondescription' stamp: 'MaxLeske 7/24/2010 16:18'!
defaultAction
	^ StandardWindow new questionWithoutCancel: 
		'You will loose all changes you didn''t commit. Do you really want to switch branches?'! !

MCVersion subclass: #MCGitVersion
	instanceVariableNames: 'filesystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Monticello'!

!MCGitVersion class methodsFor: 'instance creation' stamp: 'CamilloBruni 1/23/2012 22:55'!
filesystem: aGitFS
	^ self basicNew
		initializeWithFilesystem: aGitFS! !

!MCGitVersion methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 22:55'!
filesystem
	^ filesystem! !

!MCGitVersion methodsFor: 'initialize-release' stamp: 'CamilloBruni 1/23/2012 22:55'!
initializeWithFilesystem: aGitFilesystem
	super initialize.
	filesystem := aGitFilesystem.
	info := MCGitVersionInfo filesystem: self filesystem.! !

!MCGitVersion methodsFor: 'loading' stamp: 'CamilloBruni 1/23/2012 23:16'!
loadSnapshot
	^ (MCGitReader on: self filesystem root) snapshot! !

!MCGitVersion methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 23:12'!
snapshot
	^ snapshot ifNil: [ 
		snapshot := self loadSnapshot ].! !

!MCGitVersion methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 22:57'!
summary
	^ String streamContents: [:s |
		s nextPutAll: info summaryHeader.
		"self dependencies isEmpty ifFalse: [
			s cr; nextPutAll: 'Dependencies: '.
			self dependencies
				do: [:ea | s nextPutAll: ea versionInfo name]
				separatedBy: [s nextPutAll: ', ']]".
		s cr; cr; nextPutAll: info message]! !

ClassTestCase subclass: #GitAbstractProtocolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Remote-Tests'!

!GitAbstractProtocolTest class methodsFor: 'testing' stamp: 'DamienCassou 1/28/2013 19:01'!
isAbstract
	^ self name = #GitAbstractProtocolTest! !

!GitAbstractProtocolTest methodsFor: 'as yet unclassified' stamp: 'DamienCassou 1/30/2013 16:53'!
classToBeTested
	| className |
	className := self class name asString copyFrom: 1 to: self class name size - 4.
	^ Smalltalk globals at: className asString asSymbol! !

!GitAbstractProtocolTest methodsFor: 'helper' stamp: 'DamienCassou 1/28/2013 19:03'!
newProtocol
	^ GitAbstractProtocol url: self url! !

!GitAbstractProtocolTest methodsFor: 'tests' stamp: 'DamienCassou 1/30/2013 13:27'!
testCorrectProtocol
	self assert: self newProtocol class equals: self targetClass! !

!GitAbstractProtocolTest methodsFor: 'tests' stamp: 'DamienCassou 1/28/2013 18:58'!
testTags
	| protocol tags |
	protocol := self newProtocol.
	tags := protocol tags.
	self deny: tags isEmpty.! !

!GitAbstractProtocolTest methodsFor: 'helper' stamp: 'DamienCassou 1/28/2013 19:03'!
url
	^ self subclassResponsibility ! !

GitAbstractProtocolTest subclass: #GitDumbHTTPProtocolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Remote-Tests'!

!GitDumbHTTPProtocolTest methodsFor: 'testing' stamp: 'DamienCassou 1/30/2013 13:21'!
expectedFailures
	"Most tests are failing because we did not find any dumb repository to test against. "
	^ self class allTestSelectors copyWithoutAll: #(testNegotiation testClassComment testCoverage testNew testUnCategorizedMethods)! !

!GitDumbHTTPProtocolTest methodsFor: 'tests' stamp: 'DamienCassou 1/29/2013 14:38'!
testNegotiation
	self flag: 'Find a url for a dumb http repository. We only found smart ones on the web'.
	self assert: (GitDumbHTTPProtocol isSmartRepository: 'https://git.gitorious.org/pharo-build/pharo-build.git').
! !

!GitDumbHTTPProtocolTest methodsFor: 'helper' stamp: 'DamienCassou 1/29/2013 14:30'!
url
	^ 'https://git.gitorious.org/pharo-build/pharo-build.git'! !

GitAbstractProtocolTest subclass: #GitProtocolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Remote-Tests'!

!GitProtocolTest methodsFor: 'tests' stamp: 'DamienCassou 1/31/2013 16:25'!
testFetchingABranch
	| protocol branch result |
	
	protocol := self newProtocol.
	branch := protocol branches anyOne.
	result := protocol want: branch.

	self deny: result isEmpty.! !

!GitProtocolTest methodsFor: 'tests' stamp: 'DamienCassou 1/30/2013 16:10'!
testFetchingATag
	| protocol tag result |
	
	protocol := self newProtocol.
	tag := protocol tags anyOne.
	result := protocol want: tag.
	
	self deny: result isEmpty.! !

!GitProtocolTest methodsFor: 'helper' stamp: 'DamienCassou 1/29/2013 16:38'!
url
	^ 'git://github.com/dh83/filesystem-git-test-repository.git'.! !

GitProtocolTest subclass: #GitSmartHTTPProtocolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Remote-Tests'!

!GitSmartHTTPProtocolTest class methodsFor: 'testing' stamp: 'DamienCassou 1/30/2013 13:32'!
shouldInheritSelectors
	^ true! !

!GitSmartHTTPProtocolTest methodsFor: 'tests' stamp: 'CamilloBruni 2/12/2013 17:08'!
testBranches
	self deny: self newProtocol branches isEmpty! !

!GitSmartHTTPProtocolTest methodsFor: 'tests' stamp: 'DamienCassou 1/29/2013 15:24'!
testWant
	|protocol signature|
	protocol := self newProtocol.
	signature := '12345'.! !

!GitSmartHTTPProtocolTest methodsFor: 'helper' stamp: 'DamienCassou 1/29/2013 14:44'!
url
	^ 'https://git.gitorious.org/gitorious/mainline.git'! !

ClassTestCase subclass: #GitProtocolReaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Remote-Tests'!

!GitProtocolReaderTest class methodsFor: 'testing' stamp: 'DamienCassou 1/30/2013 16:37'!
isAbstract
	^ false! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/30/2013 16:34'!
example4Zeros
	^ #[ 48 48 48 48 ]! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/30/2013 16:34'!
exampleAdditionalDataLine
	^#[48 48 48 54 1 230]! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/30/2013 16:34'!
exampleBranch1
	^ #[48 48 52 48 49 48 55 97 50 48 51 99 50 98 53 98 53 99 102 50 53 102 101 55 53 57 48 54 57 101 97 56 48 50 54 97 52 97 100 54 98 99 98 57 32 114 101 102 115 47 104 101 97 100 115 47 98 114 97 110 99 104 49 10]! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/30/2013 16:34'!
exampleCompressingMessages
	^ #[67 111 109 112 114 101 115 115 105 110 103 32 111 98 106 101 99 116 115 58 32 32 50 48 37 32 40 49 47 53 41 32 32 32 13 67 111 109 112 114 101 115 115 105 110 103 32 111 98 106 101 99 116 115 58 32 32 52 48 37 32 40 50 47 53 41 32 32 32 13 67 111 109 112 114 101 115 115 105 110 103 32 111 98 106 101 99 116 115 58 32 32 54 48 37 32 40 51 47 53 41 32 32 32 13 67 111 109 112 114 101 115 115 105 110 103 32 111 98 106 101 99 116 115 58 32 32 56]! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/30/2013 16:34'!
exampleCompressingMessagesLine
	^ #[48 48 56 53
		2 "stream code 2 = progress messages"] , self exampleCompressingMessages! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/30/2013 16:34'!
exampleCountingObjects
	^ #[ 48 48 50 48 2 67 111 117 110 116 105 110 103 32 111 98 106 101 99 116 115 58 32 55 44 32 100 111 110 101 46 10 ]! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/30/2013 16:34'!
exampleDataLine
	"self new exampleDataLine asString "
	^#[48 50 56 54 " 4-byte size "
		1 "stream code 1 = pack data " ] , self examplePackData ! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/30/2013 16:34'!
exampleErrorMessage
	^ 'This is an error' asByteArray! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/30/2013 16:34'!
exampleErrorMessageLine
	^#[48 48 49 53 " 4-byte size "
		3 "stream code 3 = error message " ] , self exampleErrorMessage! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/31/2013 13:05'!
exampleFirstResponseLine
	"self new exampleFirstResponseLine asString "
	^ #[48 48 57 98 51 50 102 49 100 50 49 57 57 55 55 101 102 102 54 100 52 54 54 57 53 48 100 100 98 54 101 48 56 54 100 99 55 100 53 102 51 102 52 102 32 72 69 65 68 0 109 117 108 116 105 95 97 99 107 32 116 104 105 110 45 112 97 99 107 32 115 105 100 101 45 98 97 110 100 32 115 105 100 101 45 98 97 110 100 45 54 52 107 32 111 102 115 45 100 101 108 116 97 32 115 104 97 108 108 111 119 32 110 111 45 112 114 111 103 114 101 115 115 32 105 110 99 108 117 100 101 45 116 97 103 32 109 117 108 116 105 95 97 99 107 95 100 101 116 97 105 108 101 100 10 ]! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/30/2013 16:34'!
exampleMaster
	^ #[48 48 51 102 51 50 102 49 100 50 49 57 57 55 55 101 102 102 54 100 52 54 54 57 53 48 100 100 98 54 101 48 56 54 100 99 55 100 53 102 51 102 52 102 32 114 101 102 115 47 104 101 97 100 115 47 109 97 115 116 101 114 10]! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/30/2013 16:34'!
exampleNak
	^ #[ 48 48 48 56 78 65 75 10]! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/30/2013 16:34'!
examplePackData
	^#[ 80 65 67 75 0 0 0 2 0 0 0 7 150 15 120 156 157 204 77 74 4 49 16 64 225 125 78 145 189 208 84 165 147 84 7 68 100 60 73 85 82 229 4 250 71 66 198 243 143 226 13 92 126 111 241 230 80 245 4 210 98 48 172 6 136 194 69 152 33 147 69 91 77 140 178 80 220 90 129 140 238 139 135 158 211 87 2 67 141 44 197 40 132 172 5 182 22 72 72 91 136 57 97 10 148 182 194 153 29 63 230 253 26 254 131 143 190 239 151 191 141 199 217 253 107 253 163 252 234 253 243 224 190 47 245 58 222 60 174 169 68 90 55 72 254 5 16 192 253 212 163 207 169 255 63 56 110 77 155 255 198 69 6 159 245 142 139 245 93 221 19 32 164 75 115 152 14 120 156 157 204 65 14 194 32 16 64 209 61 167 96 111 210 48 3 12 54 49 198 232 73 6 24 148 132 182 134 80 207 175 198 27 184 124 127 241 71 23 209 209 139 161 148 32 100 246 30 98 68 73 25 41 227 145 24 16 128 147 41 152 156 160 122 114 151 117 104 23 72 168 20 143 104 156 133 76 86 178 203 148 203 204 46 21 96 137 30 173 4 143 138 247 241 216 186 190 241 82 91 219 244 181 239 107 213 167 244 99 252 234 114 95 184 182 41 109 203 89 131 245 179 11 150 102 175 15 6 140 81 159 186 212 49 228 255 131 122 225 84 106 19 245 6 117 102 71 60 158 11 120 156 157 204 65 10 66 33 16 128 225 189 167 152 125 240 112 210 230 77 16 17 117 18 29 199 18 52 65 124 157 191 162 27 180 252 254 197 63 135 42 80 224 68 126 31 89 179 21 34 101 142 46 186 44 74 178 122 135 130 156 81 35 147 9 219 124 244 1 183 208 74 173 29 174 99 123 22 56 201 143 241 171 203 189 133 82 23 233 237 12 232 14 71 191 58 98 132 157 69 107 205 167 182 50 167 254 127 48 33 37 77 240 194 37 151 170 230 13 125 171 59 109 161 7 120 156 51 52 48 48 51 49 81 40 51 212 75 42 74 204 75 206 48 212 75 203 204 73 101 120 54 247 209 236 77 23 175 57 123 119 107 174 43 143 186 113 232 73 79 240 68 67 184 82 130 74 140 112 43 1 0 104 161 50 51 166 4 120 156 51 52 48 48 51 49 81 40 51 212 75 203 204 73 101 120 54 247 209 236 77 23 175 57 123 119 107 174 43 143 186 113 232 73 79 240 68 67 168 18 35 220 74 0 1 77 31 154 163 2 120 156 51 52 48 48 51 49 81 40 51 212 75 203 204 73 101 120 54 247 209 236 77 23 175 57 123 119 107 174 43 143 186 113 232 73 79 240 68 0 236 9 15 205 48 120 156 3 0 0 0 0 1 231 114 31 40 37 114 98 222 158 239 61 64 164 141 44 116 23 186 238 ]! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/30/2013 16:34'!
exampleResponse
	" self new exampleResponse "
	" self new exampleResponse asString"
	^ self exampleFirstResponseLine , self exampleBranch1 , self exampleMaster , self exampleTagV2 , self exampleTagV3 , self example4Zeros , self exampleNak , self exampleCountingObjects , self exampleCompressingMessagesLine , self exampleDataLine , self exampleTotalDeltaReused , self exampleAdditionalDataLine , self example4Zeros ! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/31/2013 13:05'!
exampleTagV2
	"self new exampleTagV2 asString "
	^ #[48 48 51 97 99 55 48 102 49 101 52 97 98 57 102 55 50 50 54 101 57 48 56 100 50 55 98 55 101 100 50 52 54 53 49 53 50 55 53 56 57 97 54 97 32 114 101 102 115 47 116 97 103 115 47 118 50 10]! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/31/2013 13:36'!
exampleTagV3
	"self new exampleTagV3 asString "
 ^ #[48 48 51 97 49 48 55 97 50 48 51 99 50 98 53 98 53 99 102 50 53 102 101 55 53 57 48 54 57 101 97 56 48 50 54 97 52 97 100 54 98 99 98 57 32 114 101 102 115 47 116 97 103 115 47 118 51 10 ]! !

!GitProtocolReaderTest methodsFor: 'example response' stamp: 'DamienCassou 1/30/2013 16:34'!
exampleTotalDeltaReused
	^ #[48 48 50 98 2 84 111 116 97 108 32 55 32 40 100 101 108 116 97 32 48 41 44 32 114 101 117 115 101 100 32 55 32 40 100 101 108 116 97 32 48 41 10]! !

!GitProtocolReaderTest methodsFor: 'helpers' stamp: 'DamienCassou 1/30/2013 16:40'!
newReaderFor: aStringOrStream
	^ self targetClass on: aStringOrStream readStream! !

!GitProtocolReaderTest methodsFor: 'tests' stamp: 'DamienCassou 1/31/2013 10:33'!
testParseUploadPackResponse
	| reader refs capabilities |
	reader := self newReaderFor: self exampleResponse.
	refs := reader parseUploadPackResponse.
	self assert: refs size equals: 6. "5 refs + capabilities "
	capabilities := refs at: #capabilities.
	self assert: capabilities size equals: 9.
	#('multi_ack' 'thin-pack' 'side-band' 'side-band-64k' 'ofs-delta' 'shallow' 'no-progress' 'include-tag' 'multi_ack_detailed')
		allSatisfy: [:cap | capabilities includes: cap ].
	self assert: (refs at: 'HEAD') equals: '32f1d219977eff6d466950ddb6e086dc7d5f3f4f'.
	self assert: (refs at: 'refs/heads/branch1') equals: '107a203c2b5b5cf25fe759069ea8026a4ad6bcb9'.
	self assert: (refs at: 'refs/heads/master') equals: '32f1d219977eff6d466950ddb6e086dc7d5f3f4f'.
	self assert: (refs at: 'refs/tags/v2') equals: 'c70f1e4ab9f7226e908d27b7ed24651527589a6a'.
	self assert: (refs at: 'refs/tags/v3') equals: '107a203c2b5b5cf25fe759069ea8026a4ad6bcb9'.! !

!GitProtocolReaderTest methodsFor: 'tests' stamp: 'DamienCassou 1/30/2013 19:36'!
testReadPktLine

	self assert: (self newReaderFor: '0006a', String lf) readPktLine equals: 'a'.
	self assert: (self newReaderFor: '0005a') readPktLine equals: 'a'.
	self assert: (self newReaderFor: '000bfoobar', String lf) readPktLine equals: 'foobar'.
	self assert: (self newReaderFor: '0004' readStream) readPktLine equals: ''.
	
	self should: [(self newReaderFor: '000') readPktLine] raise: Error.
	self assert: ((self newReaderFor: '000' )readPktLineIfZero: ['ok']) equals: 'ok'! !

!GitProtocolReaderTest methodsFor: 'tests' stamp: 'DamienCassou 1/30/2013 16:45'!
testReadSideBandErrorMessage
	(self newReaderFor: self exampleErrorMessageLine)
		readSideBandResponseIfData: [ :data | self fail ]
		ifMessage: [ :data | self fail ]
		ifError: [ :data | ^ self assert: data equals: self exampleErrorMessage  ]
		ifZero: [ :data | self fail ].
	self fail! !

!GitProtocolReaderTest methodsFor: 'tests' stamp: 'DamienCassou 1/30/2013 16:48'!
testReadSideBandPackData
	(self newReaderFor: self exampleDataLine)
		readSideBandResponseIfData: [ :data | ^ self assert: data equals: self examplePackData ]
		ifMessage: [ :data | self fail ]
		ifError: [ :data | self fail ]
		ifZero: [ :data | self fail ].
	self fail! !

!GitProtocolReaderTest methodsFor: 'tests' stamp: 'DamienCassou 1/30/2013 16:48'!
testReadSideBandProgressMessages
	(self newReaderFor: self exampleCompressingMessagesLine)
		readSideBandResponseIfData: [ :data | self fail ]
		ifMessage: [ :data | ^ self assert: data equals: self exampleCompressingMessages  ]
		ifError: [ :data | self fail ]
		ifZero: [ :data | self fail ].
	self fail! !

!GitProtocolReaderTest methodsFor: 'tests' stamp: 'DamienCassou 1/30/2013 16:49'!
testReadSideBandZero
	(self newReaderFor: self example4Zeros)
		readSideBandResponseIfData: [ :data | ^ self fail ]
		ifMessage: [ :data | self fail ]
		ifError: [ :data | self fail ]
		ifZero: [ ^ self "succeed" ].
	self fail! !

ClassTestCase subclass: #GitProtocolWriterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Remote-Tests'!

!GitProtocolWriterTest methodsFor: 'tests' stamp: 'DamienCassou 1/31/2013 14:05'!
testWantAllCapabilitiesMoreThanOne
	| gitSignatures capabilities |
	
	gitSignatures := Array
						with: '003ac70f1e4ab9f7226e908d27b7ed24651527589a6a'
						with: '003a107a203c2b5b5cf25fe759069ea8026a4ad6bcb9'.
	capabilities := GitProtocolCapabilities multiAck thinPack sideBand.
	
	self
		withWriterAssert: [ :writer | writer sendWantAll: gitSignatures capabilities: capabilities shallowLines: nil depth: nil]
		equals: '0054want 003ac70f1e4ab9f7226e908d27b7ed24651527589a6a multi_ack thin-pack side-band', String lf,
				'0036want 003a107a203c2b5b5cf25fe759069ea8026a4ad6bcb9', String lf! !

!GitProtocolWriterTest methodsFor: 'tests' stamp: 'DamienCassou 2/4/2013 09:57'!
testWantAllCapabilitiesOnlyOne
	| gitSignatures capabilities |
	
	gitSignatures := Array with: '003ac70f1e4ab9f7226e908d27b7ed24651527589a6a'.
	capabilities := GitProtocolCapabilities multiAck thinPack sideBand.
	
	self
		withWriterAssert: [ :writer | writer sendWantAll: gitSignatures capabilities: capabilities shallowLines: nil depth: nil]
		equals: '0054want 003ac70f1e4ab9f7226e908d27b7ed24651527589a6a multi_ack thin-pack side-band', String lf! !

!GitProtocolWriterTest methodsFor: 'tests' stamp: 'DamienCassou 1/31/2013 14:27'!
testWantAllCapabilitiesWithAllOptions
	| gitSignatures capabilities shallowLines depth |
	
	gitSignatures := Array with: '003ac70f1e4ab9f7226e908d27b7ed24651527589a6a'.
	capabilities := GitProtocolCapabilities multiAck thinPack sideBand.
	shallowLines := Array with: '003ac70f1e4ab9f7226e908d27b7ed24651527589a6a'.
	depth := 2.
	self
		withWriterAssert: [ :writer |
				writer
					sendWantAll: gitSignatures
					capabilities: capabilities
					shallowLines: shallowLines
					depth: depth ]
		equals: '0054want 003ac70f1e4ab9f7226e908d27b7ed24651527589a6a multi_ack thin-pack side-band', String lf,
				'0039shallow 003ac70f1e4ab9f7226e908d27b7ed24651527589a6a', String lf,
				'000ddeepen 2', String lf! !

!GitProtocolWriterTest methodsFor: 'tests' stamp: 'DamienCassou 1/30/2013 18:04'!
testWritePktLine
	|protocol|
	protocol := self targetClass on: String new writeStream.
	self assert: (protocol encodePktLine: 'a', String lf) equals: '0006a', String lf.
	self assert: (protocol encodePktLine: 'a') equals: '0005a'.
	self assert: (protocol encodePktLine: 'foobar', String lf) equals: '000bfoobar', String lf.
	self assert: (protocol encodePktLine: '') equals: '0004'.! !

!GitProtocolWriterTest methodsFor: 'helpers' stamp: 'DamienCassou 1/30/2013 18:00'!
withWriterAssert: aBlock equals: aString
	| result |
	result := String streamContents: [ :stream |
		| writer |
		writer := self targetClass on: stream.
		aBlock value: writer].
	self assert: result equals: aString! !

FileSystemTest subclass: #FileSystemGitTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Tests'!

!FileSystemGitTests class methodsFor: 'history' stamp: 'CamilloBruni 8/1/2011 16:49'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #testCopyDestExists; add: #testEntryAt; add: #testRootExists; add: #testEnsureDirectory; add: #testCopy; add: #testCreateDirectoryNoParent; add: #testDefaultWorkingDirectory; add: #testDirectory; add: #testRootIsNotAFile; add: #testSetWorkingDirectory; add: #testEnsureDirectoryExists; add: #testChildrenAt; add: #testReadStreamDo; add: #testChangeDirectory; add: #testReadStreamIfAbsent; add: #testSetRelativeWorkingDirectory; add: #testFileNames; add: #testWriteStream; add: #testChangeDirectoryString; add: #testCreateDirectoryExists; add: #testFile; add: #testReadStream; add: #testReadStreamDoIfAbsent; add: #testDelimiter; add: #testWriteStreamDoIfPresent; add: #testWriteStreamIfPresent; add: #testRoot; add: #testWriteStreamDo; add: #testRootIsDirectory; add: #testWorking; add: #testEnsureDirectoryCreatesParent; add: #testEntriesAt; add: #testFileStreamDo; add: #testCopySourceDoesntExist; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 60559; instVarAt: 2 put: (Duration seconds: 7200 nanoSeconds: 0); instVarAt: 3 put: 2455775; instVarAt: 4 put: 0; yourself)); yourself)! !

!FileSystemGitTests class methodsFor: 'accessing' stamp: 'MaxLeske 7/24/2010 17:26'!
packageNamesUnderTest
	^ #('FS-Git')! !

!FileSystemGitTests methodsFor: 'initialize-release' stamp: 'MaxLeske 9/3/2012 21:56'!
createFileSystem
	^ (FileSystemGitRepository on: (FileSystem memory / 'testRepo.git')) head.! !

!FileSystemGitTests methodsFor: 'tests' stamp: 'MaxLeske 9/3/2012 21:41'!
testCreateDirectoryNoParent
	| path |
	path := Path root / 'griffle' / 'glob'.
	self 
		should: [ filesystem createDirectory: path ]
		raise: DirectoryDoesNotExist! !

TestCase subclass: #GitTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

GitTestCase subclass: #FileSystemGitRepositoryTests
	instanceVariableNames: 'repository basicRepository reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Tests'!

!FileSystemGitRepositoryTests class methodsFor: 'history' stamp: 'CamilloBruni 8/1/2011 16:49'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new) add: #testLightTags; yourself)); add: (#passed->((Set new) add: #testVersionsOrder; add: #testFullTags; add: #testVersions; add: #testBranches; add: #testTags; add: #testHead; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 60559; instVarAt: 2 put: (Duration seconds: 7200 nanoSeconds: 0); instVarAt: 3 put: 2455775; instVarAt: 4 put: 0; yourself)); yourself)! !

!FileSystemGitRepositoryTests methodsFor: 'running' stamp: 'CamilloBruni 9/3/2012 18:53'!
setUp
	| commit1 commit2  blob1 blob2 tree1 tree2 stamp |
	super setUp.
	stamp := GitStamp new
		name: 'Homer Simpson';
		email: 'homer@nuke.com';
		yourself.
	reference := (FileSystem memory / 'test.git').
	basicRepository := GitRepository on: reference.

	blob1 := (GitBlob bytes: 'testBlob' in: basicRepository) store; yourself.
	blob2 := (GitBlob bytes: 'second test Blob' in: basicRepository) store; yourself.
	tree1 := GitTree 
		entries: {
			GitTreeEntry
				fileNamed: 'blob1'
				hash: blob1 hash
				in: basicRepository}
		in: basicRepository.
	tree1 store.
	
	tree2 := GitTree 
		entries: {
			GitTreeEntry
				fileNamed: 'blob2'
				hash: blob2 hash
				in: basicRepository}
		in: basicRepository.
	tree2 store.
	
	commit1 := (GitCommit in: basicRepository)
		tree: tree1;
		message: 'message1';
		author: stamp;
		committer: stamp;
		store;
		yourself.
	
	commit2 := (GitCommit in: basicRepository)
		tree: tree2;
		message: 'message2';
		author: stamp;
		committer: stamp;
		parents: { commit1 hexHash };
		store;
		yourself.
	
	basicRepository
		updateRef: basicRepository headsDir / 'branch1' to: commit1 hexHash;
		updateRef: basicRepository headsDir / 'master' to: commit2 hexHash.	
	GitFSCK validate: basicRepository.
	
	repository := FileSystemGitRepository on: reference.! !

!FileSystemGitRepositoryTests methodsFor: 'running' stamp: 'CamilloBruni 6/22/2011 05:22'!
tearDown
	GitFSCK validate: basicRepository.! !

!FileSystemGitRepositoryTests methodsFor: 'tests' stamp: 'CamilloBruni 9/3/2012 16:32'!
testBranches
	| branches |
	branches := repository branches.
	self assert: branches size = 2.
	branches do: [ :aBranch |
		self assert: aBranch species = GitFilesystem.
		self assert: ({ Path / 'blob1'. Path / 'blob2' } 
			includes: aBranch root children first path) ]! !

!FileSystemGitRepositoryTests methodsFor: 'tests' stamp: 'MaxLeske 9/4/2012 22:13'!
testFullTags
	| commit tags tag|
	commit := basicRepository objectNamed: (basicRepository resolveRef: 'refs/heads/branch1').
	[[ tag := GitTag
		named: 'version 4.3alpha'
		for: commit
		message: 'PGP encrypted string'
		in: basicRepository ] 
			on: GitStampNameRequest 
			do: [ :req | req resume: 'Homer Simpson' ]]
				on: GitStampEmailRequest
				do: [ :req | req resume: 'homer@nuke.com' ].
			
	tags := repository tags.
	
	self assert: tags size = 1.
	
	self assert: tags keys first equals: tag.
	self assert: tags values first species equals: GitFilesystem.
	self assert: tags values first revision equals: commit.! !

!FileSystemGitRepositoryTests methodsFor: 'tests' stamp: 'CamilloBruni 9/1/2012 12:39'!
testHead
	| head fsOnHead |
	head := basicRepository objectNamed: basicRepository headRef.
	fsOnHead := repository head.
	self assert: fsOnHead species = GitFilesystem.
	self assert: head = (fsOnHead  revision)! !

!FileSystemGitRepositoryTests methodsFor: 'tests' stamp: 'CamilloBruni 9/2/2012 11:11'!
testLightTags
	| master branch1 tags |
	master := basicRepository resolveRef: 'refs/heads/master'.
	branch1 := basicRepository resolveRef: 'refs/heads/branch1'.
	basicRepository 
		updateRef: basicRepository tagsDir / 'version 4.3alpha' to: master;
		updateRef: basicRepository tagsDir / 'fail' to: branch1.
		
	tags := repository tags.
	self assert: tags size = 2.
	tags do: [ :each |
		self assert: each species = GitFilesystem.
		self assert: ({ master. branch1} includes: each revision hexHash) ]! !

!FileSystemGitRepositoryTests methodsFor: 'tests' stamp: 'CamilloBruni 9/2/2012 11:12'!
testTags
	self assert: repository tags isEmpty.
	
	basicRepository 
		updateRef: basicRepository tagsDir / 'tag1' 
		to: basicRepository head hexHash.
	self assert: repository tags size = 1.
	self assert: (repository tags includes: repository head).
	
	basicRepository 
		updateRef: basicRepository tagsDir / 'tag2' 
		to: basicRepository head parents first hexHash.
	self assert: repository tags size = 2.
	self assert: (repository tags includes: repository head).
	self assert: (repository tags includes: repository head parents first)! !

!FileSystemGitRepositoryTests methodsFor: 'tests' stamp: 'CamilloBruni 9/3/2012 18:32'!
testVersions
	| versions version1 version2 workingCopy |
	
	self assert: repository versions size equals: 2.
	workingCopy := repository head.
	(workingCopy / 'aFile') writeStreamDo: [ :stream | stream nextPutAll: 'aFile' ].
	workingCopy commit: 'message3'.
	
	versions := repository versions.
	self assert: versions size equals: 3.
	
	versions detect: [ :version| version message = 'message3' ].
	version1 := versions detect: [ :version | version message = 'message1' ].
	version2 := versions detect: [ :version | version message = 'message2' ].
	
	self assert: version1 root children size equals: 1.
	self assert: version1 root children first basename equals: 'blob1'.
	
	self assert: version2 root children size equals: 1.
	self assert: version2 root children first basename equals: 'blob2'! !

!FileSystemGitRepositoryTests methodsFor: 'tests' stamp: 'CamilloBruni 9/3/2012 16:20'!
testVersionsOrder
	| versions versionOld versionNew |
	versions := repository versions.
	versionOld := versions detect: [ :version | version message = 'message1' ].
	versionNew := versions detect: [ :version | version message = 'message2' ].
	self assert: versionNew = (versions at: 1).
	self assert: versionOld = (versions at: 2)! !

GitTestCase subclass: #GitBlobTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

!GitBlobTests class methodsFor: 'history' stamp: 'CamilloBruni 8/1/2011 16:49'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #testRetrievingBytes; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 60559; instVarAt: 2 put: (Duration seconds: 7200 nanoSeconds: 0); instVarAt: 3 put: 2455775; instVarAt: 4 put: 0; yourself)); yourself)! !

!GitBlobTests methodsFor: 'tests' stamp: 'MaxLeske 2/28/2012 18:32'!
testRetrievingBytes
	| blob |
	blob := GitBlob bytes: 'testBlob' in: nil.
	self assert: blob bytes = ('testBlob' asByteArray).
	
	blob := GitBlob bytes: 3242 in: nil.
	self assert: blob bytes = (3242 asByteArray).
	
	blob := GitBlob bytes: #[3 42 45 3] in: nil.
	self assert: blob bytes = #[3 42 45 3]! !

GitTestCase subclass: #GitCommitTests
	instanceVariableNames: 'repository repoDir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

!GitCommitTests class methodsFor: 'history' stamp: 'CamilloBruni 8/1/2011 16:49'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #testPrintOn; add: #testWritingSameCommitTwice; add: #testInitializeWithEverything; add: #testRetrievingParents; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 60559; instVarAt: 2 put: (Duration seconds: 7200 nanoSeconds: 0); instVarAt: 3 put: 2455775; instVarAt: 4 put: 0; yourself)); yourself)! !

!GitCommitTests methodsFor: 'helpers' stamp: 'MaxLeske 2/28/2012 16:42'!
createSomeBlobs
	^ #(file1 file2 file3) collect: [ :aString |
		(GitBlob bytes: aString in: repository) store; yourself ]! !

!GitCommitTests methodsFor: 'helpers' stamp: 'CamilloBruni 9/3/2012 18:59'!
createSomeCommits
	| i commits |
	i := 0.
	commits := self createSomeTrees collect: [ :tree |
		i := i + 1.
		GitCommit
			withTree: tree
			message: 'commit ', i asString 
			author: self defaultStamp
			committer: self defaultStamp
			in: repository ].
		
	commits last parents: ((commits reversed allButFirst: 1) collect: [ :commit | commit hexHash ]).
	commits second parents: (OrderedCollection with: commits first hexHash).
	commits do: [ :commit | commit store ].
	repository updateRef: repository headsDir / 'master' to: commits last hexHash! !

!GitCommitTests methodsFor: 'helpers' stamp: 'CamilloBruni 9/3/2012 18:53'!
createSomeTreeEntries
	^ self createSomeBlobs collect: [ :blob |
		GitTreeEntry
			fileNamed: blob bytes asString
			hash: blob hash
			in: repository  ]
	! !

!GitCommitTests methodsFor: 'helpers' stamp: 'MaxLeske 2/28/2012 16:40'!
createSomeTrees
	| entries trees |
	entries := self createSomeTreeEntries.
	trees := OrderedCollection new.
	1 to: entries size do: [ :index || theEntries |
		theEntries := OrderedCollection new.
			1 to: index do: [ :innerIndex |
				theEntries add: (entries at: innerIndex) ].
		trees add: (GitTree entries: theEntries in: repository) ].
	
	trees do: [ :tree | tree store ].
	^ trees! !

!GitCommitTests methodsFor: 'running' stamp: 'CamilloBruni 8/30/2012 14:09'!
setUp
	super setUp.
	repoDir := FileSystem memory workingDirectory / 'repo'.
	repository := GitRepository on: repoDir.
	self createSomeCommits! !

!GitCommitTests methodsFor: 'tests' stamp: 'CamilloBruni 9/3/2012 18:59'!
testInitializeWithEverything
	| commit tree message author committer blob |
	blob := GitBlob bytes: 'aBlob' in: nil.
	message := 'a test message'.
	author := (GitStamp new
				email: 'mail@server.ext';
				name: 'Homer Simpson';
				timeStamp: TimeStamp now;
				yourself).
	committer := (GitStamp new
					email: 'homer@simpson.spr';
					name: 'Bart Simpson';
					timeStamp: TimeStamp now;
					yourself).
	tree := GitTree 
		entries: {
			GitTreeEntry 
				fileNamed: 'filename'
				hash: blob hash
				in: repository }
		in: nil.
	
	commit := GitCommit 
				withTree: tree
				message: message
				author: author
				committer: committer
				in: nil.
	
	self assert: commit tree = tree.
	self assert: commit message = message.
	self assert: commit author = author.
	self assert: commit committer = committer! !

!GitCommitTests methodsFor: 'tests' stamp: 'MaxLeske 6/27/2010 19:55'!
testPrintOn
	| message commit template |
	message := 'printOn test'.
	commit := GitCommit new.
	commit message: message.
	
	template := 'a GitCommit(''printOn test'')'.
	
	self assert: commit printString = template.! !

!GitCommitTests methodsFor: 'tests' stamp: 'MaxLeske 2/26/2012 15:40'!
testRetrievingParents
	| commit |
	commit := repository head.
	
	self assert: commit tree entries size = 3.
	self assert: commit parents size = 2.
	self assert: commit parents first tree entries size = 2.
	self assert: (commit parents first tree entries anySatisfy: [ :entry |
		entry entryName = 'file1' ]).
	self assert: (commit parents first tree entries anySatisfy: [ :entry |
		entry entryName = 'file2' ]).
	self assert: commit parents second tree entries size = 1.
	self assert: (commit parents second tree entries anySatisfy: [ :entry |
		entry entryName = 'file1' ])! !

!GitCommitTests methodsFor: 'tests' stamp: 'CamilloBruni 9/3/2012 18:59'!
testWritingSameCommitTwice
	| commit newRepository tree blob treeEntry |
	newRepository := GitRepository on: (FileSystem memory root).
	blob := GitBlob bytes: 'ablob' in: newRepository.
	treeEntry :=
		GitTreeEntry 
			fileNamed: 'theblob'
			hash: blob hash
			in: repository.
	tree := GitTree entries: { treeEntry } in: newRepository.
	commit := 
		GitCommit 
		withTree: tree 
		message: 'a commit'
		author: self defaultStamp
		committer: self defaultStamp
		in: newRepository.
	commit 
		store.
	newRepository updateRef: newRepository headsDir / 'master' to: commit hexHash.
	
	self shouldnt: [ commit store ] raise: Exception.! !

GitTestCase subclass: #GitFilesystemUsageTests
	instanceVariableNames: 'basicRepository fsRepository workingCopy shouldValidateRepos reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Tests'!

!GitFilesystemUsageTests class methodsFor: 'history' stamp: 'CamilloBruni 8/1/2011 16:49'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new) add: #testDeletingMultipleDirectories; add: #testDeleting; add: #testDeletingMultipleWithIntermediateCreate; yourself)); add: (#passed->((Set new) add: #testRevisionChangeWithReload; add: #testEquals; add: #testLoadExistingFilesFromHead; add: #testParents; add: #testDeletingDirectory; add: #testCreateAndDeleteFile; add: #testReset; add: #testReadingNonBareRepository; add: #testGettingCommitTimestamp; add: #testTagging; add: #testCommittingCreateAndDelete; add: #testCopyingExistingFile; add: #testParentsWithReload; add: #testModifying; add: #testDeleteExistingFile; add: #testDeleteModifiedFile; add: #testBranchMessageAndTag; add: #testResetWithDeletions; add: #testBranching; add: #testReadExistingModifiedFile; add: #testDetachingWorkingCopy; add: #testTags; add: #testAddingMultipleDirectoriesFails; add: #testCreateAndReadFile; add: #testAddingWithReload; add: #testActiveBranch; add: #testReadNonexistentFile; add: #testCompleteUsecase; add: #testReadExistingFile; add: #testReadingBareRepository; add: #testAddingSingleDirectoryFails; add: #testCommittingWithReload; add: #testRevisionChange; add: #testAdding; add: #testCompleteUsecase2; add: #testLoadExistingFilesFromRevision; add: #testModifyingWithReload; add: #testCopyingWithReload; add: #testLoadExistingFiles; add: #testModifyExistingFile; add: #testCopying; add: #testCommitting; add: #testEmptyCommitTimeStamp; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 60559; instVarAt: 2 put: (Duration seconds: 7200 nanoSeconds: 0); instVarAt: 3 put: 2455775; instVarAt: 4 put: 0; yourself)); yourself)! !

!GitFilesystemUsageTests methodsFor: 'helpers' stamp: 'MaxLeske 10/18/2010 16:11'!
branch: branchName message: aMessage
	[ [ workingCopy branch: branchName message: aMessage ] 
		on: GitStampNameRequest
		do: [ :req | req resume: 'Homer Simpson' ] ]
			on: GitStampEmailRequest 
			do: [ :req | req resume: 'homer@nuke.com' ]! !

!GitFilesystemUsageTests methodsFor: 'helpers' stamp: 'CamilloBruni 8/1/2011 16:54'!
commit: message
	workingCopy commit: message.
	GitFSCK validate: basicRepository.! !

!GitFilesystemUsageTests methodsFor: 'helpers' stamp: 'MaxLeske 10/18/2010 16:11'!
commit: aMessage andTag: tagName
	[ [ workingCopy commit: aMessage andTag: tagName ] 
		on: GitStampNameRequest
		do: [ :req | req resume: 'Homer Simpson' ] ]
			on: GitStampEmailRequest 
			do: [ :req | req resume: 'homer@nuke.com' ]! !

!GitFilesystemUsageTests methodsFor: 'helpers' stamp: 'CamilloBruni 9/3/2012 19:15'!
createFixedTimeStampCommitIn: anFSReference
	| repository blob tree commit committer author |
	repository := GitRepository on: anFSReference.
	
	blob := GitBlob bytes: 'blob1' in: repository.
	blob store.
	
	tree := GitTree 
		entries: {
			GitTreeEntry
				fileNamed: 'first blob'
				hash: blob hash
				in: repository }
		in: repository.
	tree store.
		
	committer := (GitStamp new
		email: 'mail@server.ext';
		name: 'Homer Simpson';
		timeStamp: (DateAndTime year: 2011 month: 06 day: 28 hour: 22 minute: 10) asTimeStamp;
		yourself).
	author := (GitStamp new
		email: 'mail@server.ext';
		name: 'Homer Simpson';
		timeStamp: (DateAndTime year: 2010 month: 06 day: 27 hour: 21 minute: 11) asTimeStamp;
		yourself). 
					
	commit := GitCommit
		withTree: tree
		message: 'aMessage'
		author: author
		committer: committer
		in: repository.
	commit parents: OrderedCollection new.
	commit store.

	repository updateRef: repository headsDir / 'master' to: commit hexHash.
	GitFSCK validate: repository.! !

!GitFilesystemUsageTests methodsFor: 'helpers' stamp: 'CamilloBruni 9/3/2012 19:27'!
createSomeCommits
	(workingCopy / 'file1') writeStreamDo: [ :stream | stream nextPutAll: 'content' ].
	self commit: 'first commit'.
	(workingCopy / 'dir1') ensureDirectory.
	(workingCopy / 'dir1' / 'file2') writeStreamDo: [ :stream | stream nextPutAll: 'more content' ].
	self commit: 'second commit'! !

!GitFilesystemUsageTests methodsFor: 'helpers' stamp: 'CamilloBruni 7/15/2011 16:26'!
reset
	workingCopy reset! !

!GitFilesystemUsageTests methodsFor: 'running' stamp: 'CamilloBruni 9/3/2012 19:26'!
setUp
	super setUp.
	shouldValidateRepos := true.
	reference := FileSystem memory / 'testRepo'.
	basicRepository := GitRepository on: reference.
	fsRepository := FileSystemGitRepository  on: reference.
	workingCopy := fsRepository head.! !

!GitFilesystemUsageTests methodsFor: 'running' stamp: 'CamilloBruni 9/3/2012 18:49'!
tearDown
	shouldValidateRepos
		ifFalse: [ GitFSCK validate: basicRepository ].! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 9/3/2012 16:41'!
testActiveBranch
	self assert: workingCopy branchName equals: 'master'.
	
	(workingCopy / 'aFile') writeStreamDo: [ :stream | ].
	self branch: 'branch 1' message: 'branch 1 commit'.
	self assert: workingCopy branchName equals: 'branch 1'.
	
	basicRepository updateHeadToBranch: 'master'.
	self assert: workingCopy branchName equals: 'master'.
	
	(workingCopy / 'anotherFile') writeStreamDo: [ :stream | ].
	self commit: 'a commit'.
	self flag: 'Why do we manually replace the symbolic reference in HEAD?'.
	basicRepository 
		basicUpdateRef: basicRepository headFile 
		to: basicRepository head hexHash.
	self assert: workingCopy branchName equals: 'master'! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'CamilloBruni 8/9/2011 20:09'!
testAddingEmptySubdir
	| ref filename |
	self assert: workingCopy root children isEmpty.
	
	filename := 'aFile'.
	ref := (workingCopy / 'foo' / 'bar') ensureDirectory / filename.
	ref writeStreamDo: [ :stream | stream nextPutAll: 'new file' ].
	self assert: ref exists.
	
	ref := (workingCopy / 'foo' / 'bar2' / 'emptyDir') ensureDirectory.
	self assert: ref exists.
	
	self commit: 'adding empty subdirs'.! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'CamilloBruni 8/9/2011 17:03'!
testAddingFile
	| ref filename |
	self assert: workingCopy root children isEmpty.
	
	filename := 'aFile'.
	ref := workingCopy / filename.
	self deny: ref exists.
	ref writeStreamDo: [ :stream | stream nextPutAll: 'new file' ].
	self assert: ref exists.
	self assert: (workingCopy / filename) exists.
	self commit: 'a commit'.
	
	self assert: ref exists.
	self assert: (workingCopy / filename) exists! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'CamilloBruni 8/9/2011 17:04'!
testAddingFileSubdir
	| ref filename |
	self assert: workingCopy root children isEmpty.
	
	filename := 'aFile'.
	ref := (workingCopy / 'foo' / 'bar') ensureDirectory / filename.
	self deny: ref exists.
	ref writeStreamDo: [ :stream | stream nextPutAll: 'new file' ].
	self assert: ref exists.
	self assert: (workingCopy / 'foo' / 'bar' / filename) exists.
	self commit: 'a commit'.
	
	self assert: ref exists.
	self assert: (workingCopy / 'foo' / 'bar' / filename) exists! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'CamilloBruni 9/3/2012 18:48'!
testAddingMultipleDirectoriesFails
	| dir1 subDir1 dir2 sha1name |
	dir1 := 'aDir'.
	subDir1 := dir1 , '/sub'.
	dir2 := 'dir 2'.
	sha1name := workingCopy name.
	(workingCopy / dir1) createDirectory.
	self assert: (workingCopy / dir1) exists.
	(workingCopy referenceTo: subDir1) createDirectory.
	self assert: (workingCopy referenceTo: subDir1) exists.
	(workingCopy / dir2) createDirectory.
	self assert: (workingCopy / dir2) exists.
		
	workingCopy commit: 'aCommit..'.
	"the commit should not have happened:"
	self assert: sha1name = workingCopy name.! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'CamilloBruni 9/3/2012 18:48'!
testAddingSingleDirectoryFails
	| ref dirname sha1name |
	dirname := 'aDir'.
	sha1name := workingCopy name.
	ref := workingCopy / dirname.
	ref createDirectory.
	self assert: ref exists.
	
	workingCopy commit: 'aCommit'.
	"the commit shouldn't have happened:"
	self assert: sha1name = workingCopy name
! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'MaxLeske 8/12/2011 08:54'!
testAddingWithReload
	| ref filename |
	self assert: workingCopy root children isEmpty.
	
	filename := 'aFile'.
	ref := workingCopy / filename.
	self deny: ref exists.
	ref writeStreamDo: [ :stream | stream nextPutAll: 'new file' ].
	self assert: ref exists.
	
	self commit: 'a commit'.
	workingCopy := fsRepository head.
	ref := workingCopy / filename.
	self assert: ref exists! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'MaxLeske 8/12/2011 08:57'!
testBranchMessageAndTag
	self createSomeCommits.
	self assert: workingCopy message = 'second commit'.
	
	(workingCopy / 'aChange') writeStreamDo: [ :stream | stream nextPutAll: 'changed' ].
	workingCopy
		branch: 'new branch'
		message: 'changed one file'
		andTag: 'test fork'.
		
	self assert: workingCopy branchName = 'new branch'.
	self assert: basicRepository branches size = 2.
	self 
		shouldnt: (basicRepository branches at: 'master')
		raise: Error.
	self
		shouldnt: (basicRepository branches at: 'new branch')
		raise: Error.
	self assert: workingCopy parents first message = 'second commit'.
	self assert: workingCopy message = 'changed one file'.
	self assert: workingCopy tagNames size = 1.
	self assert: workingCopy tagNames first = 'test fork'.
	self assert: (fsRepository tagNamed: 'test fork') = workingCopy! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'CamilloBruni 9/3/2012 16:45'!
testBranching
	| master branch |
	(workingCopy root / 'aFile') writeStreamDo: [ :stream | ].
	self commit: 'a commit'.
	master := basicRepository objectNamed: (basicRepository resolveRef: 'refs/heads/master').
	self assert: master message equals: 'a commit'.
	self assert: workingCopy branchName equals: 'master'.
	
	(workingCopy root / 'anotherFile') writeStreamDo: [ :stream | ].
	self branch: 'my fork' message: 'my first branch'.
	branch := basicRepository objectNamed: (basicRepository resolveRef: 'refs/heads/my fork').
	self assert: branch message equals: 'my first branch'.
	self assert: workingCopy branchName equals: 'my fork'.
	
	self assert: branch parents size equals: 1.
	self assert: branch parents first equals: master
	! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'CamilloBruni 7/15/2011 16:21'!
testCommitting
	| revision |
	revision := workingCopy revision.
	self assert: revision isNil.
	
	(workingCopy  / 'aFile') writeStreamDo: [ :stream | ].
	self commit: 'commit 1'.
	revision := workingCopy revision.
	self assert: (workingCopy  / 'aFile') exists.
	self assert: revision isNil not.
	self assert: revision tree entries size = 1.
	self assert: (revision tree entries includesKey: 'aFile').
	
	(workingCopy  / 'file2') writeStreamDo: [ :stream | ].
	self commit: 'commit 2'.
	revision := workingCopy revision.
	self assert: (workingCopy  / 'file2') exists.
	self assert: (workingCopy / 'aFile') exists.
	self assert: revision isNil not.
	self assert: revision tree entries size = 2.
	self assert: (revision tree entries includesKey: 'aFile').
	self assert: (revision tree entries includesKey: 'file2')! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'MaxLeske 8/12/2011 08:53'!
testCommittingCreateAndDelete
	self assert: workingCopy root children isEmpty.
	(workingCopy / 'newFile') writeStreamDo: [ :stream | stream nextPutAll: 'some content' ].
	
	workingCopy delete: (workingCopy / 'newFile').
	
	self commit: 'commit 1'.! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'CamilloBruni 7/15/2011 16:22'!
testCommittingWithReload
	(workingCopy / 'aFile') writeStreamDo: [ :stream | ].
	self commit: 'commit 1'.
	self assert: (workingCopy / 'aFile') exists.
	
	workingCopy := fsRepository head.
	(workingCopy / 'file2') writeStreamDo: [ :stream | ].
	self commit: 'commit 2'.
	self assert: (workingCopy / 'file2') exists.
	self assert: (workingCopy / 'aFile') exists! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 8/1/2011 17:13'!
testCompleteUsecase
	|git |
	git := workingCopy workingDirectory.

	workingCopy root children size.

	(git / 'f') writeStreamDo: [ :stream | stream nextPutAll: 'new file' ].
	self commit: 'adding files'.

	(git / 'f') delete.
	self commit: 'deleted files'.! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 8/1/2011 18:21'!
testCompleteUsecase2
	|git |
	git := workingCopy workingDirectory.
	
	(git / 'f') writeStreamDo: [ :stream | stream nextPutAll: 'new file' ].
	self commit: 'adding files'.

	(git / 'f') delete.
	self commit: 'deleted files'.! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'CamilloBruni 7/15/2011 16:19'!
testCopying
	| ref originalContent copyContent |
	self createSomeCommits.
	ref := workingCopy / 'copy'.
	self deny: ref exists.
	
	(workingCopy / 'file1') copyTo: ref.
	self commit: 'a commit'.
	self assert: ref exists.
	self assert: (workingCopy / 'file1') exists.
	self assert: (workingCopy / 'copy') exists.
	originalContent := (workingCopy / 'file1') readStream contents.
	copyContent := ref readStream contents.
	self assert: originalContent = copyContent.
	self assert: copyContent asString = 'content'.
	! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 7/15/2011 15:55'!
testCopyingExistingFile
	| ref originalContent copyContent |
	self createSomeCommits.
	ref := workingCopy / 'copy'.
	self deny: ref exists.
	
	(workingCopy / 'file1') copyTo: ref.
	self assert: ref exists.
	self assert: (workingCopy / 'copy') exists.
	originalContent := (workingCopy / 'file1') readStream contents.
	copyContent := ref readStream contents.
	self assert: originalContent = copyContent.
	self assert: copyContent asString = 'content'! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'CamilloBruni 7/15/2011 16:20'!
testCopyingWithReload
	| ref originalContent copyContent |
	self createSomeCommits.
	ref := workingCopy / 'copy'.
	self deny: ref exists.
	
	(workingCopy / 'file1') copyTo: ref.
	self commit: 'a commit'.
	workingCopy := fsRepository head.
	ref := workingCopy / 'copy'.
	self assert: ref exists.
	self assert: (workingCopy / 'file1') exists.
	originalContent := (workingCopy / 'file1') readStream contents.
	copyContent := ref readStream contents.
	self assert: originalContent = copyContent.
	self assert: copyContent asString = 'content'! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'MaxLeske 8/12/2011 08:57'!
testCreateAndDeleteFile
	self assert: workingCopy root children isEmpty.
	(workingCopy / 'newFile') writeStreamDo: [ :stream | stream nextPutAll: 'some content' ].
	self deny: workingCopy root children isEmpty.
	
	workingCopy delete: (workingCopy / 'newFile').
	self assert: workingCopy root children isEmpty.
	self deny: (workingCopy / 'newFile') exists! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'MaxLeske 8/12/2011 08:56'!
testCreateAndReadFile
	| filename |
	filename := 'missing File'.
	self deny: (workingCopy / filename) exists.
	self
		shouldnt: [ (workingCopy / filename) writeStreamDo: [ :stream |
			stream nextPutAll: 'initial content' ] ]
		raise: FSFileDoesNotExist.
	self assert: (workingCopy readStreamOn: filename) contents asString = 'initial content'! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 7/15/2011 15:56'!
testDeleteExistingFile
	self createSomeCommits.
	self assert: workingCopy root children size = 2.
	self assert: workingCopy root allChildren size = 4.
	
	workingCopy delete: (workingCopy / 'file1').
	self assert: workingCopy root children size = 1.
	self assert: workingCopy root allChildren size = 3.
	self deny: (workingCopy / 'file1') exists.
	self assert: (workingCopy / 'dir1' / 'file2') exists.
	
	self commit: 'deleted file1'.
	self deny: (workingCopy  / 'file1') exists! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 9/3/2012 18:35'!
testDeleteModifiedFile
	| ref path |
	path := 'dir1/file2'.
	self createSomeCommits.
	
	ref := workingCopy referenceTo: path.
	ref parent ensureDirectory.
	
	ref ensureDeleted writeStreamDo: [ :stream | 
		stream nextPutAll: 'changed it' ].
	
	self assert: ref readStream contents asString = 'changed it'.
	
	ref delete.
	self deny: ref exists.
	self deny: (workingCopy referenceTo: path) exists! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'MaxLeske 8/12/2011 09:00'!
testDeleting
	| ref  |
	self createSomeCommits.
	ref := workingCopy / 'myDir' / 'myFile'.
	self deny: ref exists.

	ref parent ensureDirectory.
	ref writeStreamDo: [ :stream | stream nextPutAll: 'content'].
	self assert: ref exists.
	
	self commit: 'added myFile'.
	self assert: ref exists.
	
	ref delete.
	self assert: ref parent exists.
	self deny: ref exists.
	self assert: ref parent children isEmpty.
	
	self commit: 'deleted myFile'.
	"since refs parent is empty we don't store it anymore"
	self deny: ref parent exists.
	self deny: (workingCopy / 'myDir' / 'anotherFile') exists.
	self deny: ref exists.! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'MaxLeske 8/12/2011 08:54'!
testDeletingDirectory
	| ref |
	self createSomeCommits.
	ref := workingCopy / 'myDir' / 'myFile'.
	self deny: ref exists.
	self deny: ref parent exists.
	
	ref parent ensureDirectory.
	ref writeStreamDo: [ :stream | stream nextPutAll: 'content' ].
	self assert: ref exists.
	self assert: ref parent exists.
	
	self commit: 'added myDir'.
	self assert: ref exists.
	self assert: ref parent exists.
	
	ref parent delete.
	self deny: ref exists.
	self deny: ref parent exists.
	
	self commit: 'removed myDir'.
	self deny: ref parent exists.
	self deny: ref exists.! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'MaxLeske 8/12/2011 08:54'!
testDeletingMultipleDirectories
	| ref ref2 |
	self createSomeCommits.
	ref := workingCopy referenceTo: '/a/b/c/d1/e/myFile'.
	ref parent ensureDirectory.
	ref writeStreamDo: [ :stream | stream nextPutAll: 'content'].
	self assert: ref exists.
	self assert: ref parent exists.
	
	
	ref2 := workingCopy referenceTo: '/a/b/c/d2/e/myFile'.
	ref2 parent ensureDirectory.
	ref2 writeStreamDo: [ :stream | stream nextPutAll: 'content'].
	self assert: ref2 exists.
	self assert: ref2 parent exists.

	self commit: 'added myFiles'.

	ref2 parent delete.
	self commit: 'deleted /a/b/c/d2/e'.
	self deny: ref2 exists.
	
	(workingCopy referenceTo: '/a/b/c/') delete.
	self commit: 'deleted /a/b/c/'.
	self deny: ref exists.
	self deny: ref2 exists.! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'MaxLeske 8/12/2011 08:58'!
testDeletingMultipleWithIntermediateCreate
	| ref ref2 |
	self createSomeCommits.
	ref := workingCopy referenceTo: '/a/b/c/d1/e/myFile'.
	ref parent ensureDirectory.
	ref writeStreamDo: [ :stream | stream nextPutAll: 'content' ].
	
	ref2 := workingCopy referenceTo: '/a/b/c/d2/e/myFile'.
	ref2 parent ensureDirectory.
	ref2 writeStreamDo: [ :stream | stream nextPutAll: 'content' ].
	self commit: 'added myFiles'.
	
	ref2 parent delete.
	(workingCopy referenceTo: '/a/b/c/') deleteAll.
	
	self deny: ref exists.
	self deny: ref2 exists.
	
	self commit: 'deleted /a/b/c/'.
	self deny: ref exists.
	self deny: ref2 exists.! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'MaxLeske 8/12/2011 08:55'!
testDetachingWorkingCopy
	self createSomeCommits.
	self assert: (workingCopy / 'dir1') exists.
	self assert: (workingCopy / 'file1') exists.
	self assert: (workingCopy / 'dir1' / 'file2') exists.
	self deny: workingCopy parents isEmpty.

	workingCopy detachWorkingCopy.
	self deny: (workingCopy / 'dir1') exists.
	self deny: (workingCopy / 'file1') exists.
	self deny: (workingCopy / 'dir1' / 'file2') exists.
	self deny: workingCopy parents isEmpty.
	
	workingCopy := fsRepository head.
	(workingCopy / 'file1') writeStreamDo: [ :stream | stream nextPutAll: 'remaining change' ].
	
	workingCopy detachWorkingCopy.
	self deny: (workingCopy / 'dir1') exists.
	self deny: (workingCopy / 'dir1' / 'file2') exists.
	self deny: (workingCopy / 'file1') exists.
	self deny: workingCopy parents isEmpty! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'MaxLeske 9/3/2012 20:58'!
testEmptyCommitTimeStamp
	"uncommitted working copy will not have a stamp"
	| commitStamp authorStamp repo fs |
	repo := FileSystem memory / 'repo.git'.
	fs := (FileSystemGitRepository on: repo) head.
	
	commitStamp := fs timeStampOfCommit.
	authorStamp := fs timeStampOfCreation.
	self assert: commitStamp isNil.
	self assert: authorStamp isNil.! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'MaxLeske 8/12/2011 08:55'!
testEquals
	| head |
	head := fsRepository head.
	self assert: head name isEmpty.
	self assert: workingCopy name isEmpty.
	self assert: head name = workingCopy name.
	self deny: head = workingCopy.
	
	(workingCopy / 'foo') writeStreamDo: [ :stream | stream nextPutAll: 'some content' ].
	self commit: 'a commit'.
	self assert: workingCopy name isEmpty not.
	self deny: head name = workingCopy name.
	self deny: head = workingCopy.
	
	head := workingCopy.
	self assert: head = workingCopy! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 9/3/2012 19:29'!
testGettingCommitTimestamp
	| commitStamp authorStamp repo fs |
	repo := FileSystem memory / 'repo.git'.
	self createFixedTimeStampCommitIn: repo.
	fs := (FileSystemGitRepository on: repo) head.
	
	commitStamp := fs timeStampOfCommit.
	self assert: DateAndTime equals: commitStamp species.
	self 
		assert: (DateAndTime year: 2011 month: 06 day: 28 hour: 22 minute: 10) asTimeStamp 
		equals: commitStamp.
		
	authorStamp := fs timeStampOfCreation.
	self assert: DateAndTime equals: authorStamp species.
	self 
		assert: (DateAndTime year: 2010 month: 06 day: 27 hour: 21 minute: 11) asTimeStamp 
		equals: authorStamp! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 7/19/2011 18:51'!
testLoadExistingFiles
	self createSomeCommits.
	
	self assert: (workingCopy root / 'file1') exists.
	self assert: (workingCopy root / 'dir1') exists.
	self assert: (workingCopy root / 'dir1' / 'file2') exists.! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 7/19/2011 18:51'!
testLoadExistingFilesFromHead
	self createSomeCommits.
	self assert: (workingCopy root / 'file1') exists.
	self assert: (workingCopy root / 'dir1') exists.
	self assert: (workingCopy root / 'dir1' / 'file2') exists.
	self deny: (workingCopy root / 'dir1' / 'file1') exists.! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 7/19/2011 18:51'!
testLoadExistingFilesFromRevision
	self createSomeCommits.
	workingCopy := workingCopy parents first.
	
	self assert: (workingCopy root / 'file1') exists.
	self deny: (workingCopy root / 'dir1') exists.
	self deny: (workingCopy root / 'dir1' / 'file2') exists.! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 7/15/2011 15:57'!
testModifyExistingFile
	| ref originalContent |
	self createSomeCommits.
	self assert: workingCopy root children size = 2.
	self assert: workingCopy root allChildren size = 4.
	
	ref := workingCopy / 'dir1' / 'file2'.
	originalContent := ref readStream contents asString.
	ref writeStreamDo: [ :stream | 
		stream 
			nextPutAll: originalContent;
			nextPutAll: '/moremoremore' ].
	self assert: workingCopy root children size = 2.
	self assert: workingCopy root allChildren size = 4.
	ref := workingCopy / 'dir1' / 'file2'.
	self assert: ref exists.
	self assert: ref readStream contents asString = 'more content/moremoremore'! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'MaxLeske 8/12/2011 08:52'!
testModifying
	| ref |	
	self createSomeCommits.
	ref := workingCopy / 'file1'.
	self assert: ref readStream contents asString = 'content'.
	ref writeStreamDo: [ :stream | stream nextPutAll: 'changed it' ].
	
	self commit: 'a commit'.
	self assert: ref readStream contents asString = 'changed it'.
	self assert: (fsRepository head / 'file1') readStream contents asString = 'changed it'.
	self assert: (fsRepository head parents first / 'file1') readStream contents asString = 'content'! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'MaxLeske 8/12/2011 08:57'!
testModifyingWithReload
	| ref |	
	self createSomeCommits.
	ref := workingCopy / 'file1'.
	self assert: ref readStream contents asString = 'content'.
	ref writeStreamDo: [ :stream | stream nextPutAll: 'changed it' ].
	
	self commit: 'a commit'.
	workingCopy := fsRepository head.
	ref := workingCopy / 'file1'.
	self assert: ref readStream contents asString = 'changed it'! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'CamilloBruni 7/15/2011 16:25'!
testParents
	workingCopy parents isEmpty.
	
	(workingCopy / 'aFile') writeStreamDo: [ :stream | ].
	self commit: 'a commit'.
	self assert: workingCopy parents isEmpty.
	
	(workingCopy / 'anotherfile') writeStreamDo: [ :stream | ].
	self commit: 'commit number 2'.
	self deny: workingCopy parents isEmpty.
	self assert: workingCopy parents size = 1! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'CamilloBruni 7/15/2011 16:25'!
testParentsWithReload
	workingCopy parents isEmpty.
	
	(workingCopy / 'afile') writeStreamDo: [ :stream | ].
	self commit: 'a commit'.
	workingCopy := fsRepository head.
	self assert: workingCopy parents isEmpty.
	
	(workingCopy / 'anotherfile') writeStreamDo: [ :stream | ].
	self commit: 'commit number 2'.
	workingCopy := fsRepository head.
	self deny: workingCopy parents isEmpty.
	self assert: workingCopy parents size = 1! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 7/15/2011 15:57'!
testReadExistingFile
	self createSomeCommits.
	self assert: (workingCopy / 'file1') exists.
	self assert: (workingCopy / 'file1') readStream contents asString = 'content'! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 7/15/2011 15:57'!
testReadExistingModifiedFile
	self createSomeCommits.
	(workingCopy / 'file1') writeStreamDo: [ :stream | stream nextPutAll: 'changed it' ].
	self assert: (workingCopy / 'file1') readStream contents asString = 'changed it'! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 9/3/2012 19:16'!
testReadNonexistentFile
	self 
		should: [ workingCopy readStreamOn: 'missing File' ]
		raise: FileDoesNotExist! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 9/3/2012 19:29'!
testReadingBareRepository
	|  repositoryEntries |
	self createSomeCommits.
	
	self deny: fsRepository head root children isEmpty.
	self assert: fsRepository head root children size = 2.
	
	repositoryEntries := #(
		'HEAD'
		'objects'
		'info'
		'refs').
	self assert: ((reference / '.git') childNames includesAllOf: repositoryEntries)! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 9/3/2012 19:27'!
testReadingNonBareRepository
	| repositoryEntries |
	self createSomeCommits.
	
	self deny: fsRepository head root children isEmpty.
	self assert: fsRepository head root children size = 2.
	
	self assert: reference children size = 1.
	self assert: reference children first basename = '.git'.
	
	repositoryEntries := #(
		'HEAD'
		'objects'
		'info'
		'refs').
	self assert: ((reference children first children collect: [ :each | each basename ]) includesAllOf: repositoryEntries)! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'MaxLeske 8/12/2011 09:00'!
testReset
	self assert: workingCopy root children isEmpty.
	(workingCopy / 'afile') writeStreamDo: [ :stream | stream nextPutAll: 'blah' ].
	(workingCopy / 'aFolder') ensureDirectory.
	(workingCopy root resolve: 'aFolder/afile') writeStreamDo: [ :stream | ].
	
	self reset.
	self assert: workingCopy root children isEmpty! !

!GitFilesystemUsageTests methodsFor: 'tests' stamp: 'CamilloBruni 7/15/2011 15:58'!
testResetWithDeletions
	| ref |
	self createSomeCommits.
	ref := workingCopy / 'file1'.
	self assert: ref exists.
	
	ref delete.
	self deny: ref exists.
	
	self reset.
	self assert: ref exists! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'CamilloBruni 7/15/2011 16:25'!
testRevisionChange
	| oldRevision newRevision |
	oldRevision := workingCopy revision.
	self assert: oldRevision isNil.
	
	(workingCopy / 'afile') writeStreamDo: [ :stream | ].
	self commit: 'a commit'.
	oldRevision := workingCopy revision.
	self deny: oldRevision isNil.
	
	(workingCopy / 'anotherfile') writeStreamDo: [ :stream | ].
	self commit: 'commit 2'.
	newRevision := workingCopy revision.
	self deny: oldRevision = newRevision.
	self assert: (newRevision parents includes: oldRevision)! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'CamilloBruni 8/1/2011 16:44'!
testRevisionChangeWithReload
	| oldRevision newRevision |
	oldRevision := workingCopy revision.
	self assert: oldRevision isNil.
	
	(workingCopy / 'afile') writeStreamDo: [ :stream | ].
	self commit: 'a commit'.
	oldRevision := workingCopy revision.
	self deny: workingCopy revision isNil.
	
	(workingCopy / 'anotherfile') writeStreamDo: [ :stream | ].
	self commit: 'commit 2'.
	newRevision  := workingCopy revision.
	self deny: oldRevision = workingCopy revision.
	self assert: (newRevision parents includes: oldRevision)! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'CamilloBruni 9/3/2012 20:59'!
testTagging
	| ref |
	(workingCopy / 'afile') ensureFile.
	self commit: 'a commit' andTag: 'my first tag'.
	ref := basicRepository tagsDir / 'my first tag'.
	
	self assert: ref exists.
	self assert: ref basename equals: 'my first tag'.
	self 
		assert: (basicRepository objectNamed: ref readStream contents asString trimBoth) message 
		equals: 'a commit'! !

!GitFilesystemUsageTests methodsFor: 'commit tests' stamp: 'CamilloBruni 9/3/2012 18:24'!
testTags
	self assert: workingCopy tagNames isEmpty.
	
	(workingCopy / 'afile') writeStreamDo: [ :stream | ].
	self commit: 'commit 1' andTag: 'tag 1'.
	self assert: workingCopy tagNames size = 1.
	self assert: (workingCopy tagNames includes: 'tag 1').
	
	(workingCopy / 'anotherfile') writeStreamDo: [ :stream | ].
	self commit: 'commit 2' andTag: 'tag number two'.
	self assert: workingCopy tagNames size = 2.
	self assert: (workingCopy tagNames includes: 'tag number two').
	
	basicRepository 
		updateRef: basicRepository tagsDir / 'tag3' 
		to: workingCopy revisionHash.
	self assert: workingCopy tagNames size = 3.
	self assert: (workingCopy tagNames includesAllOf: #('tag 1' 'tag number two' 'tag3'))! !

GitTestCase subclass: #GitHashTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

!GitHashTests methodsFor: 'tests' stamp: 'MaxLeske 2/27/2012 22:16'!
testAsByteHash
	| testHash |
	testHash := '00a350a77157772e1e35bb27b0582a8c51094fac'.
	self assert: (testHash asByteHash isKindOf: ByteArray).
	self assert: testHash asByteHash size = 20.
	self assert: testHash asByteHash = #[0 163 80 167 113 87 119 46 30 53 187 39 176 88 42 140 81 9 79 172].
	self assert: testHash asByteHash = testHash asByteHash asByteHash! !

!GitHashTests methodsFor: 'tests' stamp: 'MaxLeske 2/27/2012 22:17'!
testAsHexHash
	| testHash |
	testHash := '00a350a77157772e1e35bb27b0582a8c51094fac'.
	self assert: (testHash asHexHash isKindOf: String).
	self assert: testHash size = 40.
	self assert: testHash asHexHash size = testHash size.
	self assert: testHash asByteHash asHexHash = testHash.
	self assert: testHash asByteHash asHexHash asHexHash = testHash! !

!GitHashTests methodsFor: 'tests' stamp: 'MaxLeske 2/28/2012 18:33'!
testBlobHash
	| bytes hash blob dataSize |
	bytes := #[1 2 3].
	hash := #[174 210 151 62 75 138 127 241 179 
		15 245 196 117 30 90 43 56 152 158 116].
	blob := GitBlob bytes: bytes in: nil.
	dataSize := 
		blob typeCode size +
		1 + "space"
		bytes size asString size +
		1 + "null byte"
		bytes size.
	self assert: blob byteSignature size = dataSize.
	self assert: blob hash asByteHash =  hash.
	self assert: blob hash size = 20.
	self assert: (GitBlob bytes: bytes in: nil) hash = blob hash! !

!GitHashTests methodsFor: 'tests' stamp: 'MaxLeske 2/27/2012 22:15'!
testBytePadding
	| testHash |
	testHash := '00a350a77157772e1e35bb27b0582a8c51094fac'.
	self deny: (testHash asByteHash asHexHash beginsWith: 'a35')! !

!GitHashTests methodsFor: 'tests' stamp: 'MaxLeske 9/3/2012 21:06'!
testCommitHash
	| entryHash treeEntry tree message commit commitDataSize |
	entryHash := (GitHash from: #[1 2 3 ]) hash.
	treeEntry :=
		GitTreeEntry
			fileNamed: 'file1' hash: entryHash in: nil.
	tree := GitTree entries: {treeEntry} in: nil.
	message := 'a message'.
	commit :=
		GitCommit
			withTree: tree
			message: message
			author: self defaultStamp
			committer: self defaultStamp
			in: nil.
	commitDataSize :=
		GitCommit typeCode size +
		1 + "space"
		commit byteData size asString size +
		1 + "null byte"
		commit byteData size.
	self assert: commit byteSignature size = commitDataSize! !

!GitHashTests methodsFor: 'tests' stamp: 'MaxLeske 2/27/2012 22:16'!
testSize
	| testHash |
	testHash := '00a350a77157772e1e35bb27b0582a8c51094fac'.
	self assert: testHash size = 40.
	self assert: testHash asByteHash size = 20.
	self assert: testHash asByteHash asHexHash size = 40! !

!GitHashTests methodsFor: 'tests' stamp: 'MaxLeske 9/3/2012 21:06'!
testTreeHash
	| hash1 hash2 entry1 entry2 tree dataSize1 dataSize2 stream treeDataSize treeHash |
	hash1 := (GitHash from: #[1 2 3]) hash.
	hash2 := (GitHash from: #[4 5 6 7]) hash.
	treeHash := #[83 30 221 175 161 242 190 210 135 98 78 1 20 103 113 251 149 188 122 146].
	entry1 := 
		GitTreeEntry
			directoryNamed: 'dir1' hash: hash1 in: nil.
	entry2 :=
		GitTreeEntry
			fileNamed: 'file1' hash: hash2 in: nil.
	tree := GitTree entries: {entry1. entry2} in: nil.
	dataSize1 := 
		(GitTreeEntry printMode: GitTreeEntry dirMode) size +
		1 + "space"
		'dir1' size +
		1 + "null byte"
		hash1 size.
	dataSize2 := 
		(GitTreeEntry printMode: GitTreeEntry fileMode) size +
		1 + "space"
		'file1' size +
		1 + "null byte"
		hash2 size.
	stream := GitStream new.
	entry1 storeOn: stream.
	self assert: stream contents size = dataSize1.
	stream := GitStream new.
	entry2 storeOn: stream.
	self assert: stream contents size = dataSize2.
	treeDataSize :=
		GitTree typeCode size +
		1 + "space"
		(dataSize1 + dataSize2) asString size +
		1 + "null byte"
		dataSize1 +
		dataSize2.
	self assert: tree byteSignature size = treeDataSize.
	self assert: tree hash asByteHash = treeHash
	! !

GitTestCase subclass: #GitIndexTests
	instanceVariableNames: 'indexReader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

!GitIndexTests methodsFor: 'helpers' stamp: 'MaxLeske 9/29/2012 17:43'!
fieldsDo: aBlock
	"see 'index-format.txt' in the docs and the manpage for 'lstat'"
	{ 
	#metadataSeconds -> 4.
	#metadataNanos -> 4.
	#dataSeconds -> 4.
	#dataNanos -> 4.
	#deviceID -> 4.
	#inodeNumber -> 4.
	#mode -> 4.
	#uid -> 4.
	#gid -> 4.
	#size -> 4.
	#SHA1-> 20.
	#flags -> 2.
	#name -> nil
	} do: [ :assoc | aBlock value: assoc key value: assoc value ]! !

!GitIndexTests methodsFor: 'file contents' stamp: 'MaxLeske 9/30/2012 07:54'!
indexBytes
	^  #[68 73 82 67 0 0 0 2 0 0 0 1 80 103 221 72 0 0 0 0 80 103 221 72 0 0 0 0 1 0 0 4 1 4 95 118 0 0 129 164 0 0 1 245 0 0 0 20 0 0 0 4 118 1 128 114 224 156 93 49 200 198 227 17 59 138 160 254 98 81 149 202 0 7 98 97 114 46 116 120 116 0 0 0 86 73 59 98 117 203 165 21 53 169 25 125 112 216 55 29 186 138 23 224]! !

!GitIndexTests methodsFor: 'helpers' stamp: 'MaxLeske 9/30/2012 07:44'!
readEntryInto: aCollection
	"see 'index-format.txt' in the docs and the manpage for 'lstat'"
	self fieldsDo: [ :name :length |
		aCollection add:
			name ->
				(length
					ifNotNil: [ indexReader next: length ]
					ifNil: [ indexReader upTo: 0 ]) ]! !

!GitIndexTests methodsFor: 'running' stamp: 'MaxLeske 9/10/2012 08:42'!
setUp
	indexReader := self indexBytes readStream! !

!GitIndexTests methodsFor: 'tests' stamp: 'MaxLeske 9/10/2012 08:39'!
testIndexStructure
	self 
		verifyIndexHeader;
		verifyIndexEntries;
		verifyIndexExtensions! !

!GitIndexTests methodsFor: 'verifying' stamp: 'MaxLeske 9/30/2012 08:43'!
verifyFlags: aByteArray
	"see 'index-format.txt' in the docs"
	| byte1 assumedValid extended mergeStage intentToAdd nameLength |
	byte1 := aByteArray first.
	assumedValid := byte1 bitShift: -7.
	self assert: 0 equals: assumedValid.
	extended := (byte1 bitShift: -6) bitAnd: 2r01.
	self assert: 0 equals: extended.
	mergeStage := (byte1 bitShift: -4) bitAnd: 2r0011.
	self assert: 0 equals: mergeStage.
	intentToAdd := (byte1 bitShift: -3) bitAnd: 2r00001.
	self assert: 0 equals: intentToAdd.
	
	"12 bits name length. length if length < 0xFFF, else 0xFFF"
	nameLength := (byte1 bitAnd: 2r00000111) bitShift: 5.
	nameLength := aByteArray second bitOr: nameLength.
	self assert: 7 equals: nameLength! !

!GitIndexTests methodsFor: 'verifying' stamp: 'MaxLeske 9/30/2012 10:54'!
verifyIndexEntries
	"see 'index-format.txt' in the docs and the manpage for 'lstat'"
	| fields date mode blob padding message hash index |
	self readEntryInto: (fields := Dictionary new).
	date := (DateAndTime fromUnixTime: (fields at: #metadataSeconds) asInteger) asDate.
	self assert: (Date year: 2012 month: 9 day: 30) equals: date.
	self assert: 0 equals: (fields at: #metadataNanos) asInteger.
	
	date := (DateAndTime fromUnixTime: (fields at: #dataSeconds) asInteger) asDate.
	self assert: (Date year: 2012 month: 9 day: 30) equals: date.
	self assert: 0 equals: (fields at: #dataNanos) asInteger.
	
	"major and minor device number"
	self assert: #[1 0 0 4] equals: (fields at: #deviceID).
	self assert: 17063798 equals: (fields at: #inodeNumber) asInteger.
	self verifyMode: (fields at: #mode).
	self assert: 501 equals: (fields at: #uid) asInteger.
	self assert: 20 equals: (fields at: #gid) asInteger.
	self assert: 4 equals: (fields at: #size) asInteger.
	
	"new line terminated string 'baz'"
	blob := GitBlob bytes: #[98 97 122 10] in: nil.
	self 
		assert: #[118 1 128 114 224 156 93 49 200 198 227 17 59 138 160 254 98 81 149 202]
		equals: blob hash asByteHash.
	
	self verifyFlags: (fields at: #flags).
	self assert: 'bar.txt' equals: (fields at: #name) asString.
	
	padding := indexReader peek.
	padding := (indexReader next: 2) copyWith: padding.
	self assert: 0 equals: padding asInteger.
	
	index := indexReader contents.
	hash := GitHash from: (index copyFrom: 1to: index size - 20).
	
	self 
		assert: #[86 73 59 98 117 203 165 21 53 169 25 125 112 216 55 29 186 138 23 224]
		equals: hash byteHash! !

!GitIndexTests methodsFor: 'verifying' stamp: 'DamienCassou 1/29/2013 09:48'!
verifyIndexExtensions
	"self flag: 'to be implemented ' "! !

!GitIndexTests methodsFor: 'verifying' stamp: 'MaxLeske 9/30/2012 07:54'!
verifyIndexHeader
	"see 'index-format.txt' in the docs"
	| identifier version entryCount |
	identifier := indexReader next: 4.
	self assert:  identifier asString equals: 'DIRC'.
	version := indexReader next: 4.
	self assert: version asInteger equals: 2.
	entryCount := indexReader next: 4.
	self assert: entryCount asInteger equals: 1! !

!GitIndexTests methodsFor: 'verifying' stamp: 'MaxLeske 9/29/2012 18:41'!
verifyMode: aByteArray
	| byte3 modes mode permissions topBit byte4 permissionBits |
	self assert: 0 equals: (aByteArray first: 2) asInteger.
	
	byte3 := aByteArray third.
	modes := #(
		2r1000 "file"
		2r1010 "symlink"
		2r1110 "gitlink").
	
	mode := byte3 bitShift: -4.
	self assert: (modes includes: mode).
	
	"3 unused bits"
	self assert: 0 equals: (byte3 bitAnd: 2r00001110).
	
	permissions := #(
		8r755 "regular file"
		8r644 "regular file"
		0 "symlink / gitlink").
	"shift to position 9"
	topBit := (byte3 bitAnd: 1) bitShift: 8.
	byte4 := aByteArray fourth.
	"create UNIX 9-bit permissions"
	permissionBits := topBit bitOr: byte4.
	self assert: (permissions includes: permissionBits)! !

GitTestCase subclass: #GitLazyLoadingTests
	instanceVariableNames: 'filesystem repository workingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Tests'!

!GitLazyLoadingTests class methodsFor: 'history' stamp: 'CamilloBruni 8/1/2011 16:49'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #testLazyLoading; add: #testLookup; add: #testBasicCommit; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 60559; instVarAt: 2 put: (Duration seconds: 7200 nanoSeconds: 0); instVarAt: 3 put: 2455775; instVarAt: 4 put: 0; yourself)); yourself)! !

!GitLazyLoadingTests methodsFor: 'helpers' stamp: 'MaxLeske 10/18/2010 16:07'!
commit: message
	[ [ workingCopy commit: message ]
		on: GitStampNameRequest 
		do: [ :req | req resume: 'Homer Simpson' ] ]
			on: GitStampEmailRequest 
			do: [ :req | req resume: 'homer@nuke.com' ]! !

!GitLazyLoadingTests methodsFor: 'running' stamp: 'MaxLeske 9/3/2012 20:58'!
setUp
	super setUp.
	filesystem := FileSystem memory.
	repository := FileSystemGitRepository on: filesystem root.
	workingCopy := repository head.
	
	workingCopy / 'file1' writeStreamDo: [ :stream | stream nextPutAll: 'file1' ].
	workingCopy / 'file2' writeStreamDo: [ :stream | stream nextPutAll: 'file2' ].
	workingCopy / 'file3' writeStreamDo: [ :stream | stream nextPutAll: 'file3' ].
	self commit: 'added 3 files to root'.

	(workingCopy / 'dir1') createDirectory.
	(workingCopy / 'dir1' / 'file1') writeStreamDo: [ :stream | stream nextPutAll: 'file1 in dir1' ].
	(workingCopy / 'dir1' / 'file2') writeStreamDo: [ :stream | stream nextPutAll: 'file2 in dir1' ].
	(workingCopy / 'dir1' / 'file3') writeStreamDo: [ :stream | stream nextPutAll: 'file3 in dir1' ].
	self commit: 'added a directory with 3 files to root'.
	
	(workingCopy / 'dir2') createDirectory.
	(workingCopy / 'dir2' / 'file1') writeStreamDo: [ :stream | stream nextPutAll: 'file1 in dir2' ].
	(workingCopy / 'dir2' / 'file2') writeStreamDo: [ :stream | stream nextPutAll: 'file2 in dir2' ].
	(workingCopy / 'dir2' / 'file3') writeStreamDo: [ :stream | stream nextPutAll: 'file3 in dir2' ].
	self commit: 'added 3 files to dir2'.
	
	(workingCopy / 'dir2' / 'dir2.1') createDirectory.
	(workingCopy / 'dir2' / 'dir2.1' / 'file1') writeStreamDo: [ :stream | stream nextPutAll: 'file1 in dir2.1' ].
	(workingCopy / 'dir2' / 'dir2.1' / 'file2') writeStreamDo: [ :stream | stream nextPutAll: 'file2 in dir2.1' ].
	(workingCopy / 'dir2' / 'dir2.1' / 'file3') writeStreamDo: [ :stream | stream nextPutAll: 'file3 in dir2.1' ].
	self commit: 'added a subdir to dir2 and 3 files to the subdir'! !

!GitLazyLoadingTests methodsFor: 'running' stamp: 'CamilloBruni 6/22/2011 05:08'!
tearDown
	GitFSCK validate: repository repository.! !

!GitLazyLoadingTests methodsFor: 'tests' stamp: 'CamilloBruni 7/15/2011 15:59'!
testBasicCommit		
	self assert: (workingCopy / 'newFile') exists not.
	(workingCopy / 'newFile') writeStreamDo: [ :stream | stream nextPutAll: 'testcontent' ].
	self commit: 'test commit'.
	
	self assert: (repository head / 'newFile') exists! !

!GitLazyLoadingTests methodsFor: 'tests' stamp: 'CamilloBruni 8/1/2011 16:16'!
testLazyLoading
	| entries contents |
	entries := #(
		'/'
		'/file1' '/file2' '/file3'
		'/dir1' '/dir1/file1' '/dir1/file2' '/dir1/file3'
		'/dir2' '/dir2/file1' '/dir2/file2' '/dir2/file3'
		'/dir2/dir2.1' '/dir2/dir2.1/file1' '/dir2/dir2.1/file2' '/dir2/dir2.1/file3').
	self assert: ((repository head root allChildren collect: [ :each |
		each fullName ]) includesAllOf: entries).
	contents := (repository head / 'file1')
		readStreamDo: [ :stream | stream contents asString ].
	self assert: contents = 'file1'! !

!GitLazyLoadingTests methodsFor: 'tests' stamp: 'CamilloBruni 7/15/2011 16:00'!
testLookup
	| files directories ref |
	files := #(
		'/file1' '/file2' '/file3'
		'/dir1/file1' '/dir1/file2' '/dir1/file3'
		'/dir2/file1' '/dir2/file2' '/dir2/file3'
		'/dir2/dir2.1/file1' '/dir2/dir2.1/file2' '/dir2/dir2.1/file3').
	directories := #('/dir1' '/dir2' '/dir2/dir2.1').
	
	files do: [ :name |
		ref := workingCopy root resolve: name.
		self assert: ref exists.
		self assert: ref isFile ].
	directories do: [ :name |
		ref := workingCopy root resolve: name.
		self assert: ref exists.
		self assert: ref isDirectory ].
	
	self assert: workingCopy root children size = 5.
	self assert: workingCopy root entries size = 5.
	self assert: workingCopy root allChildren size = (files size + directories size + 1).
	self assert: workingCopy root allEntries size = (files size + directories size + 1).
	self assert: workingCopy root files size = 3.
	self assert: workingCopy root directories size = 2! !

GitTestCase subclass: #GitRepositoryTests
	instanceVariableNames: 'repository reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

!GitRepositoryTests class methodsFor: 'history' stamp: 'MaxLeske 2/28/2012 18:10'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #testStoreObjectCommitNoAuthor; add: #testStoreObjectTree; add: #testBranches; add: #testGitInitializeOnReferenceWithSubDirs; add: #testDirExistsButNotInitialized; add: #testNew; add: #testDirDoesntExist; add: #testEquals; add: #testResolveRef; add: #testCommit; add: #testObjectNamed; add: #testStoreObjectCommit; add: #testTags; add: #testStoreObjectBlob; add: #testLooseObjectBytesAt; add: #testInitializeOnDiskFilesystem; add: #testInitializeOnMemoryFilesystem; add: #testSetupDirectoryStructure; add: #testCreateReferencedDirectory; add: #testIsInitialized; add: #testStoreObjectCommitNoTree; add: #testBaseDir; add: #testOnClass; add: #testLooseObjectNames; add: #testDelete; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 60559; instVarAt: 2 put: (Duration seconds: 7200 nanoSeconds: 0); instVarAt: 3 put: 2455775; instVarAt: 4 put: 0; yourself)); yourself)! !

!GitRepositoryTests methodsFor: 'running' stamp: 'CamilloBruni 9/3/2012 18:54'!
setUp
	| commit1 commit2  blob1 blob2 tree1 tree2 stamp |
	super setUp.
	stamp := GitStamp new
		name: 'Homer Simpson';
		email: 'homer@nuke.com';
		yourself.
	reference := (FileSystem memory / 'test.git').
	repository := GitRepository on: reference.

	blob1 := (GitBlob bytes: 'testBlob' in: repository) store; yourself.
	blob2 := (GitBlob bytes: 'second test Blob' in: repository) store; yourself.
	tree1 := GitTree 
		entries: {
			GitTreeEntry
				fileNamed: 'blob1'
				hash: blob1 hash
				in: repository}
		in: repository.
	tree1 store.
	tree2 := GitTree 
		entries: {
			GitTreeEntry
				fileNamed: 'blob2'
				hash: blob2 hash
				in: repository}
		in: repository.
	tree2 store.
	commit1 := (GitCommit in: repository)
		tree: tree1;
		message: 'message1';
		author: stamp;
		committer: stamp;
		store;
		yourself.
	commit2 := (GitCommit in: repository)
		tree: tree2;
		message: 'message2';
		author: stamp;
		committer: stamp;
		parents: { commit1 hexHash };
		store;
		yourself.
	
	repository
		updateRef: repository headsDir / 'branch1' to: commit1 hexHash;
		updateRef: repository headsDir / 'master' to: commit2 hexHash;
		updateRef: repository headFile to: 'ref: refs/heads/master'! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'MaxLeske 6/30/2010 08:07'!
testBaseDir
	self assert: (reference basename endsWith: '.git').
	self assert: repository baseDir = reference.
	
	reference := reference resolve: 'noExtension'.
	repository := GitRepository on: reference.
	self deny: repository baseDir = reference.
	self assert: repository baseDir = (reference resolve: '.git')! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'MaxLeske 2/28/2012 09:49'!
testBranches
	| branches |
	branches := repository branches.
	self assert: branches size = 2.
	branches do: [ :each |
		self assert: (each class = GitCommit).
		self assert: (#('message1' 'message2') includes: each message) ]! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'MaxLeske 9/4/2012 22:12'!
testCommit
	| blob tree commit |
	blob := (GitBlob bytes: 'hello' in: repository) store; yourself.
	tree := GitTree
		entries: {(GitTreeEntry fileNamed: 'testFile' hash: blob hash in: repository)}
		in: repository.
	tree store.
	commit := (GitCommit in: repository)
		author: self defaultStamp;
		committer: self defaultStamp;
		tree: tree;
		message: 'initial commit';
		store;
		yourself.
	GitTag
		named: 'tagtest'
		for: commit
		message: 'First tag'
		tagger: self defaultStamp
		in: repository.
	GitLightweightTag 
		named: 'light tag' 
		for: commit 
		in: repository.
	repository updateRef: 'HEAD' to: commit hexHash! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'CamilloBruni 8/30/2012 14:09'!
testCreateReferencedDirectory
	| filesystem |
	filesystem := FileSystem memory.
	reference := filesystem root resolve: 'alpha/beta/gamma/repo.git'.
	repository := GitRepository on: reference.
	
	filesystem root allChildren do: [:each | self assert: each exists].
	
	filesystem := FileSystem memory.
	reference := filesystem root resolve: '/alpha/beta/repo.git'.
	(filesystem root / 'alpha') createDirectory.
	repository := GitRepository on: reference.
	
	self 
		shouldnt: [repository gitInitialize]
		raise: DirectoryExists
		description: 'The code should check if one of parent directories exists before trying to create it'.
	self assert: (filesystem root / 'alpha') exists.
	self assert: (filesystem root / 'alpha' / 'beta') exists.
	self assert: (filesystem root / 'alpha' / 'beta' / 'repo.git') exists.! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'MaxLeske 7/24/2010 15:17'!
testDelete
	self assert: repository exists description: 'Need a repository to delete.'.
	[ repository delete ]
		on: GitRepositoryDeleteRequest 
		do: [ :req | req resume: false].
	self assert: repository exists.
	
	[ repository delete ]
		on: GitRepositoryDeleteRequest 
		do: [ :req | req resume: true].
	self deny: repository exists description: 'Deletion of repository failed.'! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'MaxLeske 7/23/2010 10:00'!
testDirDoesntExist
	repository := GitRepository basicNew.
	repository instVarNamed: 'reference' put: (reference resolve: 'newRepo').
	self deny: repository exists.
	repository gitInitialize.
	self assert: repository exists! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'MaxLeske 7/23/2010 10:02'!
testDirExistsButNotInitialized
	reference := reference resolve: 'newRepo'.
	repository := GitRepository basicNew.
	repository instVarNamed: 'reference' put: reference.
	reference createDirectory.
	self deny: repository exists.
	repository gitInitialize.
	self assert: repository exists! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'CamilloBruni 8/30/2012 14:09'!
testEquals
	| repo2 |
	repo2 := GitRepository on: FileSystem memory workingDirectory .
	self deny: repository = repo2.
	
	repo2 := GitRepository on: repository baseDir.
	self assert: repository = repo2! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'CamilloBruni 8/30/2012 14:09'!
testGitInitializeOnReferenceWithSubDirs
	reference := FileSystem memory referenceTo: 'alpha/beta/testRepo.git'.
	repository := GitRepository basicNew.
	repository instVarNamed: 'reference' put: reference.
	self 
		shouldnt: [repository gitInitialize]
		raise: DirectoryDoesNotExist
		description: 'The reference of the repository points to a directory'
			, 'inside of a parent directory that does not exist.'
			, 'Create the parent directory first.'! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'MaxLeske 6/24/2012 10:08'!
testHeadFile
	self assert: (repository baseDir / 'HEAD') exists.
	self assert: repository headFile exists.
	self assert: (repository baseDir allFiles select: [ : file |
		file basename = 'HEAD' ]) size = 1.
	self shouldnt: [ repository validate ] raise: GitInvalidRepositoryError.
	
	repository headFile delete.
	self deny: repository headFile exists.
	self should: [ repository validate ] raise: GitInvalidRepositoryError	
	! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'CamilloBruni 9/2/2012 11:22'!
testInitializeOnDiskFilesystem
	reference := FileSystem disk workingDirectory / 'newRepo'.
	repository := GitRepository basicNew initializeOn: reference.
	self assert: (repository baseDir fileSystem isKindOf: FileSystem).
	self assert: repository baseDir = (reference / '.git').
	reference deleteAll.
	self deny: reference exists! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'CamilloBruni 9/2/2012 11:22'!
testInitializeOnMemoryFilesystem
	reference := FileSystem memory / 'newRepo'.
	repository := GitRepository basicNew initializeOn: reference.
	self assert: (repository baseDir fileSystem isKindOf: FileSystem).
	self assert: repository baseDir = (reference / '.git')! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'CamilloBruni 8/30/2012 14:10'!
testIsInitialized
	repository := GitRepository basicNew.
	repository instVarNamed: 'reference' put: (FileSystem memory / 'test.git').
	self deny: repository isInitialized.
	
	repository gitInitialize.
	self assert: repository isInitialized! !

!GitRepositoryTests methodsFor: 'class-tests' stamp: 'MaxLeske 8/11/2011 22:58'!
testNew
	self should: [ GitRepository new ] raise: Error! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'MaxLeske 2/28/2012 18:10'!
testObjectNamed
	| initialBlob loadedBlob |
	initialBlob := (GitBlob bytes: 'test' in: repository) store; yourself.
	loadedBlob := repository objectNamed: initialBlob hexHash.
	self assert: initialBlob = loadedBlob! !

!GitRepositoryTests methodsFor: 'class-tests' stamp: 'CamilloBruni 9/2/2012 11:21'!
testOnClass
	self should: [ GitRepository on: FileSystem disk ]
		raise: Error
		description: 'Please provide an instance of a filesystem, not a class.'.! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'MaxLeske 2/28/2012 16:34'!
testResolveRef
	| blob resolved |
	blob := (GitBlob bytes: 'test' in: repository) store; yourself.
	repository updateRef: 'HEAD' to: blob hexHash.
	
	resolved := repository resolveRef: 'HEAD'.
	self assert: blob hexHash = resolved! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'MaxLeske 6/30/2010 08:20'!
testSetupDirectoryStructure
	| dirs |
	dirs := #(
		'HEAD'
		'info'
		'objects'
		'objects/pack'
		'objects/info'
		'refs'
		'refs/heads'
		'refs/tags').
	dirs do: [ :dir | self assert: (repository baseDir resolveString: dir) exists ]! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'MaxLeske 2/28/2012 16:32'!
testStoreObjectCommitNoAuthor
	| commit |
	commit := GitCommit in: repository.
	commit tree: GitTree new.
	self 
		should: [ commit store ] 
		raise: GitInvalidObjectError
		whoseDescriptionIncludes: 'Author identity is required.'
		description: 'Author needs to be set before storing the commit.'! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'MaxLeske 2/28/2012 16:32'!
testStoreObjectCommitNoTree
	| commit |
	commit := GitCommit in: repository.
	self 
		should: [ commit store ] 
		raise: GitInvalidObjectError
		whoseDescriptionIncludes: 'Cannot have a commit without a tree.'
		description: 'Every commit needs a tree. Make sure this is checked for.'! !

!GitRepositoryTests methodsFor: 'tests' stamp: 'MaxLeske 9/5/2012 08:00'!
testTags
	| firstCommit tags |
	firstCommit := repository head parents first.
	GitLightweightTag
		named: 'tag1'
		for: firstCommit
		in: repository.
	
	tags := repository tags.
	self assert: tags size = 1.
	self assert: tags first name = 'tag1'.
	self assert: tags first object = firstCommit! !

GitTestCase subclass: #GitStampTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

!GitStampTests class methodsFor: 'history' stamp: 'CamilloBruni 8/1/2011 16:49'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #testPrintOn; add: #testStampReading; add: #testNow; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 60559; instVarAt: 2 put: (Duration seconds: 7200 nanoSeconds: 0); instVarAt: 3 put: 2455775; instVarAt: 4 put: 0; yourself)); yourself)! !

!GitStampTests methodsFor: 'tests' stamp: 'CamilloBruni 6/22/2011 05:34'!
testNow
	| stamp now |
	stamp := self defaultStamp.
	now := TimeStamp now.
	
	self assert: stamp timeStamp <= now.	
	self assert: stamp name = GitStamp defaultName.
	self assert: stamp email = GitStamp defaultEmail.! !

!GitStampTests methodsFor: 'tests' stamp: 'CamilloBruni 6/22/2011 05:35'!
testPrintOn
	| stamp template now |
	now := TimeStamp now.
	stamp := self defaultStamp.
	stamp timeStamp: now.
	
	template := 
		GitStamp defaultName, ' <',GitStamp defaultEmail,'> ', 
		now asUnixTime asString, 
		' ',
		(now offset positive ifTrue: ['+'] ifFalse: ['-']),
		(now offset hours printString forceTo: 2 paddingStartWith: $0),
		(now offset minutes printString forceTo: 2 paddingStartWith: $0).
	
	self assert: stamp printString = template! !

!GitStampTests methodsFor: 'tests' stamp: 'MaxLeske 7/22/2010 18:48'!
testStampReading
	| str stamp |
	str := 'Tony Garnock-Jones <tonygarnockjones@gmail.com> 1266614121 +1300'.
	stamp := GitStamp fromString: str.
	self assert: str = stamp printString.! !

GitTestCase subclass: #GitStorableObjectTests
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

!GitStorableObjectTests class methodsFor: 'history' stamp: 'MaxLeske 2/29/2012 19:14'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #testTypeCode; add: #testForType; add: #testWithSignature; add: #testFromLooseStream; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 60559; instVarAt: 2 put: (Duration seconds: 7200 nanoSeconds: 0); instVarAt: 3 put: 2455775; instVarAt: 4 put: 0; yourself)); yourself)! !

!GitStorableObjectTests class methodsFor: 'package selection' stamp: 'MaxLeske 7/24/2010 17:26'!
packageNamesUnderTest
	^#('FS-Git-Plumbing')! !

!GitStorableObjectTests methodsFor: 'helpers' stamp: 'MaxLeske 9/4/2012 22:22'!
buildMockFor: aGitObjectClass
	| tree fakeName |
	fakeName := (GitBlob bytes: 'test' in: repository) hash.
	tree := GitTree 
		entries: {
			GitTreeEntry 
				fileNamed: 'testFile' 
				hash: fakeName
				in: repository}
		in: repository.
	aGitObjectClass = GitBlob
		ifTrue: [ ^ GitBlob bytes: 'test' in: repository ].
	aGitObjectClass = GitCommit
		ifTrue: [ 
			^ (GitCommit in: repository)
				author: self defaultStamp;
				committer: self defaultStamp;
				tree: tree;
				message: 'initial commit';
				yourself ].
	aGitObjectClass = GitTag
		ifTrue: [ 
			^ GitTag
				named: 'testTag'
				for: ((self buildMockFor: GitCommit) store; yourself)
				message: 'aMessage'
				tagger: self defaultStamp
				in: repository ].
	aGitObjectClass = GitTree
		ifTrue: [ ^ GitTree entries: {(GitTreeEntry fileNamed: 'testFile' hash: fakeName in: repository)} in: repository ].
	self error: 'the class you provided needs to be instantiated to test #loadFrom:. Add a new entry to #buildMockFor:'! !

!GitStorableObjectTests methodsFor: 'running' stamp: 'CamilloBruni 8/30/2012 14:09'!
setUp
	super setUp.
	repository := GitRepository on: (FileSystem memory / 'repo')! !

!GitStorableObjectTests methodsFor: 'class-tests' stamp: 'MaxLeske 9/4/2012 22:20'!
testForType
	self assert: (GitStorableObject forType: 'blob') equals: GitBlob.
	self assert: (GitStorableObject forType: 'commit') equals: GitCommit.
	self assert: (GitStorableObject forType: 'tree') equals: GitTree.
	self assert: (GitStorableObject forType: 'tag') equals: GitTag! !

!GitStorableObjectTests methodsFor: 'class-tests' stamp: 'MaxLeske 9/4/2012 22:22'!
testFromLooseStream
	| stream loadedObject |
	GitStorableObject allSubclasses
		reject: [ :class | class isAbstract or: [ class = GitLightweightTag ] ]
		thenDo: [ :each || object |
			object := self buildMockFor: each.
			object store.
			stream := repository streamLooseObjectNamed: object hexHash.
			loadedObject := GitStorableObject fromLooseObjectStream: stream in: repository. 
			self assert: loadedObject isNil not.
			self assert: loadedObject class = (object class).
			self assert: loadedObject = object ]! !

!GitStorableObjectTests methodsFor: 'tests' stamp: 'MaxLeske 2/26/2012 16:46'!
testHashCreation! !

!GitStorableObjectTests methodsFor: 'class-tests' stamp: 'MaxLeske 2/29/2012 15:15'!
testTypeCode
	self 
		should: [ GitStorableObject typeCode ]
		raise: SubclassResponsibility! !

GitTestCase subclass: #GitTagTests
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

!GitTagTests class methodsFor: 'history' stamp: 'CamilloBruni 8/1/2011 16:49'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #testMakeLightTag; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 60559; instVarAt: 2 put: (Duration seconds: 7200 nanoSeconds: 0); instVarAt: 3 put: 2455775; instVarAt: 4 put: 0; yourself)); yourself)! !

!GitTagTests methodsFor: 'running' stamp: 'CamilloBruni 9/3/2012 18:55'!
setUp
	| blob tree commit |
	super setUp.
	repository := GitRepository on: (FileSystem memory / 'testRepo').
	blob := GitBlob bytes: 'test' in: repository.
	blob store.
	tree := GitTree 
		entries: {
			GitTreeEntry
				fileNamed: 'testFile'
				hash: blob hash
				in: repository}
		in: repository.
	tree store.
	commit := [ [ GitCommit withDefaultStamps ]
		on: GitStampNameRequest
		do: [ :req | req resume: 'Homer Simpson' ] ]
			on: GitStampEmailRequest
			do: [ :req | req resume: 'homer@nuke.com' ].
	commit
		repository: repository;
		tree: tree;
		message: 'myCommit';
		store.
	repository updateRef: repository headsDir / 'master' to: commit hexHash.! !

!GitTagTests methodsFor: 'tests' stamp: 'MaxLeske 9/5/2012 07:59'!
testMakeLightTag
	GitLightweightTag named: 'testTag' for: repository head in: repository.	
	self assert: (repository tagsDir / 'testTag') exists! !

!GitTagTests methodsFor: 'tests' stamp: 'MaxLeske 9/5/2012 08:00'!
testReadingLightTag
	| tagFile |
	GitLightweightTag named: 'testTag' for: repository head in: repository.
	
	tagFile := repository tagsDir / 'testTag'.
	self assert: tagFile exists.
	self assert: tagFile readStream contents asString last = Character lf.
	self assert: tagFile readStream contents size = 41.
	self 
		shouldnt: [ repository tags ]
		raise: GitObjectNotFoundError.
	self assert: repository tags size = 1! !

GitTestCase subclass: #GitTaglikeObjectTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

!GitTaglikeObjectTests class methodsFor: 'history' stamp: 'CamilloBruni 8/1/2011 16:49'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #testRetrievingProperties; add: #testLoadingAssociations; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 60559; instVarAt: 2 put: (Duration seconds: 7200 nanoSeconds: 0); instVarAt: 3 put: 2455775; instVarAt: 4 put: 0; yourself)); yourself)! !

!GitTaglikeObjectTests methodsFor: 'tests' stamp: 'MaxLeske 2/27/2012 21:45'!
testLoadingAssociations
	| taglikeObject |
	taglikeObject := GitCommit new.
	self assert: taglikeObject properties isEmpty.
	
	taglikeObject loadKey: 'keyname' value: 'keyobject'.
	self assert: (taglikeObject properties includesKey: 'keyname').
	self assert: (taglikeObject properties at: 'keyname') == 'keyobject'
	
	! !

!GitTaglikeObjectTests methodsFor: 'tests' stamp: 'MaxLeske 6/27/2010 20:44'!
testRetrievingProperties
	| object collection |
	self assert: GitTaglikeObject new properties isEmpty.
	
	collection := OrderedCollection new.
	collection add: Object new.
	object := GitTaglikeObject new.
	object properties: collection.
	
	self assert: object properties = collection.
	self assert: object properties isEmpty not! !

!GitTestCase class methodsFor: 'testing' stamp: 'MaxLeske 6/24/2012 18:46'!
isAbstract
	^ self = GitTestCase! !

!GitTestCase methodsFor: 'helpers' stamp: 'MaxLeske 8/12/2011 09:58'!
defaultStamp
	^ GitStamp now! !

!GitTestCase methodsFor: 'helpers' stamp: 'MaxLeske 2/26/2012 13:44'!
hexHashFor: anInteger
	^ (anInteger printStringBase: 16 length: 40 padded: true) asLowercase! !

!GitTestCase methodsFor: 'running' stamp: 'MaxLeske 8/12/2011 10:03'!
setUp
	"Setting these variables for the tests ensures that no FillInTheBlankMorph will
	stall the building of the image and that tests don't require user interaction."
	GitStamp ensureDefaultValues! !

!GitTestCase methodsFor: 'running' stamp: 'MaxLeske 8/12/2011 10:03'!
tearDown
	GitStamp
		defaultName: nil;
		defaultEmail: nil! !

GitTestCase subclass: #GitTreeEntryTests
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

!GitTreeEntryTests class methodsFor: 'history' stamp: 'CamilloBruni 8/1/2011 16:49'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #testPrintMode; add: #testSize; add: #testLessThanOrEqual; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 60559; instVarAt: 2 put: (Duration seconds: 7200 nanoSeconds: 0); instVarAt: 3 put: 2455775; instVarAt: 4 put: 0; yourself)); yourself)! !

!GitTreeEntryTests methodsFor: 'running' stamp: 'CamilloBruni 8/30/2012 14:09'!
setUp
	repository := GitRepository on: (FileSystem memory / 'test.git')! !

!GitTreeEntryTests methodsFor: 'tests' stamp: 'MaxLeske 9/3/2012 21:07'!
testLessThanOrEqual
	| entry1 entry2 entry3 entry4 entry5 hash |
	hash := (GitHash from: #[1 2 3]) hash.
	entry1 := GitTreeEntry 
		fileNamed: 'Connencton.doc'
		hash: hash
		in: repository.
	entry2 := GitTreeEntry 
		fileNamed: 'GitFS note.txt'
		hash: hash
		in: repository.
	entry3 := GitTreeEntry
		fileNamed: 'dummy.docx'
		hash: hash
		in: repository.
	entry4 := GitTreeEntry
		directoryNamed: 'aFolder'
		hash: hash
		in: repository.
	entry5 := GitTreeEntry
		directoryNamed: 'aFolder'
		hash: hash
		in: repository.
	
	self assert: entry1 <= entry2.
	self assert: entry1 <= entry3.
	self assert: entry2 <= entry3. "asciiValue of $G is smaller than that of $d"
	self assert: entry5 <= entry4 "entries for tree objects are compared with a trailing slash"! !

!GitTreeEntryTests methodsFor: 'tests' stamp: 'MaxLeske 9/3/2012 21:07'!
testLoadingHash
	| hash treeEntry tree |
	hash := (GitHash from: #[1 2 3]) hash.
	treeEntry := 
		GitTreeEntry
			fileNamed: 'file1' 
			hash: hash
			in: repository.
	tree := GitTree entries: {treeEntry} in: repository.
	tree store.
	
	self assert: (repository objectNamed: tree hexHash) entries anyOne entryHash = hash.
	self assert: (repository objectNamed: tree hexHash) entries anyOne = treeEntry! !

!GitTreeEntryTests methodsFor: 'class-tests' stamp: 'MaxLeske 7/10/2010 11:18'!
testPrintMode
	self assert: (GitTreeEntry printMode: GitTreeEntry fileMode) = '100644'.
	self assert: (GitTreeEntry printMode: GitTreeEntry dirMode) = '40000'! !

!GitTreeEntryTests methodsFor: 'tests' stamp: 'CamilloBruni 9/3/2012 18:56'!
testSize
	| treeEntry fileName mode  blob sizeToBe |
	fileName := 'testFile'.
	mode := GitTreeEntry printMode: GitTreeEntry fileMode.
	blob := GitBlob bytes: 'fooBlob' in: nil.
	treeEntry :=
		GitTreeEntry 
			fileNamed: fileName 
			hash: blob hash
			in: repository.
					
	sizeToBe := 
		(mode size) +
		(Character space asInteger asByteArray size) +
		(fileName size) +
		(0 decimalDigitLength) +
		(blob hash size).
	
	self assert: blob hexHash size = 40.
	self assert: blob hash size = 20.
	self assert: sizeToBe = 36.
	self assert: treeEntry size = sizeToBe.! !

GitTestCase subclass: #GitTreeTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

!GitTreeTests class methodsFor: 'history' stamp: 'CamilloBruni 8/1/2011 16:49'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #testAt; add: #testNoEntries; add: #testSettingEntries; add: #testRemoveEntry; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 60559; instVarAt: 2 put: (Duration seconds: 7200 nanoSeconds: 0); instVarAt: 3 put: 2455775; instVarAt: 4 put: 0; yourself)); yourself)! !

!GitTreeTests methodsFor: 'tests' stamp: 'CamilloBruni 9/3/2012 18:56'!
testAt
	| tree entry blob repo |
	repo := GitRepository on: (FileSystem memory / 'testRepo').
	blob := GitBlob bytes: 'testblob' in: repo.
	blob store.
	entry := GitTreeEntry
		fileNamed: 'testFile'
		hash: blob hash
		in: repo.
	tree := GitTree entries: {entry} in: repo.
	
	self assert: (tree at: entry entryName) = blob! !

!GitTreeTests methodsFor: 'tests' stamp: 'MaxLeske 6/26/2010 22:30'!
testNoEntries
	self assert: (GitTree new entries) species = Dictionary.
	self assert: (GitTree new entries) isEmpty! !

!GitTreeTests methodsFor: 'tests' stamp: 'CamilloBruni 9/3/2012 18:57'!
testRemoveEntry
	| tree collection entry1 entry2 entry3 |
	entry1 := GitTreeEntry
		fileNamed: 'entry 1'
		hash: 1
		in: nil.
	entry2 := GitTreeEntry
		fileNamed: 'entry 2'
		hash: 2
		in: nil.
	entry3 := GitTreeEntry
		fileNamed: 'entry 3'
		hash: 3
		in: nil.
	collection := OrderedCollection new add: entry1; add: entry2; add: entry3; yourself.
	tree := GitTree entries: collection in: nil.
	
	self assert: tree entries size = 3.
	self assert: (tree entries includesKey: entry1 entryName).
	self assert: (tree entries includesKey: entry2 entryName).
	self assert: (tree entries includesKey: entry3 entryName).
	
	tree removeEntryAt: entry2 entryName.
	self assert: tree entries size = 2.
	self deny: (tree entries includesKey: entry2 entryName).
	
	tree removeEntryAt: entry3 entryName.
	self assert: tree entries size = 1.
	self deny: (tree entries includesKey: entry3 entryName).
	
	tree removeEntryAt: entry1 entryName.
	self assert: tree entries isEmpty! !

!GitTreeTests methodsFor: 'tests' stamp: 'CamilloBruni 9/3/2012 18:57'!
testSettingEntries
	| collection tree entry1 entry2 |
	collection := OrderedCollection new.
	entry1 := GitTreeEntry 
		fileNamed: 'object1' 
		hash: 234
		in: nil.
	entry2 := GitTreeEntry 
		fileNamed: 'object2' 
		hash: 564
		in: nil.
	collection add: entry1; add: entry2.
	tree := GitTree entries: collection in: nil.
	
	self assert: (tree entries at: entry1 entryName)= entry1.
	self assert: (tree entries at: entry2 entryName) = entry2.
	self deny: entry1 = entry2! !

GitTestCase subclass: #GitZLibTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

!GitZLibTests methodsFor: 'tests' stamp: 'MaxLeske 9/8/2012 18:10'!
testReadStream
	| zipped complex complexReader zipReader zipper afterZipped |
	zipper := ZLibWriteStream on:  ByteArray new.
	zipper nextPutAll: 'foo bar' asByteArray.
	zipper close.
	zipped := zipper encodedStream contents.
	
	complex := 'before' asByteArray, zipped, 'baz' asByteArray.
	complexReader := complex readStream.
	self assert: (complexReader next: 6) asString equals: 'before'.
	self assert: complexReader position equals: 6.
	
	zipReader := GitZLibReadStream on: complexReader.
	self assert: zipReader contents asString equals: 'foo bar'.
	afterZipped := complexReader size - ('baz' size).
	self assert: complexReader position equals: afterZipped.
	self assert: complexReader upToEnd asString equals: 'baz'
	! !

GitTestCase subclass: #PackFileCreatorTests
	instanceVariableNames: 'sortedHashes creator repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

!PackFileCreatorTests methodsFor: 'running' stamp: 'MaxLeske 9/8/2012 21:14'!
setUp
	"byte N records the number of objects with names <= N.
	Consequence: byte 255 records the *total* number of objects in the pack"
	sortedHashes := {
		#[0 216 1 54 98 69 148 164 244 71 189 82 48 250 53 240 85 4 72 81] asInteger.
		#[20 216 1 54 98 69 148 164 244 71 189 82 48 250 53 240 85 4 72 81] asInteger.
		#[20 217 1 54 98 69 148 164 244 71 189 82 48 250 53 240 85 4 72 81] asInteger.
		#[20 217 1 54 99 69 148 164 244 71 189 82 48 250 53 240 85 4 72 81] asInteger.
		#[235 216 1 54 98 69 148 164 244 71 189 82 48 250 53 240 85 4 72 81] asInteger.
		#[236 216 1 54 98 69 148 164 244 71 189 82 48 250 53 240 85 4 72 81] asInteger.
		#[255 216 1 54 98 69 148 164 244 71 189 82 48 250 53 240 85 4 72 81] asInteger }.
	
	repository := GitRepository on: (FileSystem memory root / 'repo').
	1 to: 7 do: [ :index | 
		"I'm faking the names here. Calculating the hash will yield a different result!!"
		(GitBlob bytes: 'content', index asString in: repository)
			instVarNamed: 'integerHash' put: (sortedHashes at: index);
			store ].	
	
	creator := GitPackFileCreator new
		repository: repository;
		instVarNamed: 'sortedHashes' put: sortedHashes;
		yourself.
	"create hashDict with correct offsets"
	ByteArray streamContents: [ :stream | 
		creator 
			writePackFileHeaderOn: stream;
			writeObjectsOn: stream ].! !

!PackFileCreatorTests methodsFor: 'tests-index' stamp: 'MaxLeske 9/2/2012 10:40'!
testFanoutByte0
	| fanout |
	creator 
		instVarNamed: 'sortedHashes' 
		put: {#[0 216 1 54 98 69 148 164 244 71 189 82 48 250 53 240 85 4 72 81] asInteger}.
	fanout := creator fanoutOffsets.
	self assert: 256 equals: fanout contents size.
	fanout do: [ :offset |
		self assert: 1 equals: offset asInteger ].
	
	creator 
		instVarNamed: 'sortedHashes' 
		put: {#[3 216 1 54 98 69 148 164 244 71 189 82 48 250 53 240 85 4 72 81] asInteger}.
	fanout := creator fanoutOffsets.
	self assert: 256 equals: fanout contents size.
	self assert: 0 equals: fanout first asInteger.
	self assert: 0 equals: fanout second asInteger.
	self assert: 0 equals: fanout third asInteger.
	(fanout allButFirst: 3) do: [ :offset |
		self assert: 1 equals: offset asInteger ]! !

!PackFileCreatorTests methodsFor: 'tests-index' stamp: 'MaxLeske 9/2/2012 10:49'!
testFanoutByte255
	"byte N records the number of objects with names <= N.
	Consequence: byte 255 records the *total* number of objects in the pack"
	| fanout |
	creator 
		instVarNamed: 'sortedHashes' 
		put: {#[254 216 1 54 98 69 148 164 244 71 189 82 48 250 53 240 85 4 72 81] asInteger}.
	fanout := creator fanoutOffsets.
	self assert: 256 equals: fanout contents size.
	(fanout allButLast: 2) do: [ :offset |
		self assert: 0 equals: offset asInteger ].
	self assert: 1 equals: (fanout at: 254 + 1) asInteger.
	self assert: 1 equals: (fanout at: 255 + 1) asInteger.
	
	creator 
		instVarNamed: 'sortedHashes' 
		put: {#[255 216 1 54 98 69 148 164 244 71 189 82 48 250 53 240 85 4 72 81] asInteger}.
	fanout := creator fanoutOffsets.
	self assert: 256 equals: fanout contents size.
	(fanout allButLast) do: [ :offset |
		self assert: 0 equals: offset asInteger ].
	self assert: 1 equals: (fanout at: 255 + 1) asInteger! !

!PackFileCreatorTests methodsFor: 'tests-index' stamp: 'MaxLeske 9/2/2012 10:49'!
testFanoutOffsets
	"byte N records the number of objects with names <= N.
	Consequence: byte 255 records the *total* number of objects in the pack"
	| offsets |
	offsets := creator fanoutOffsets.
	self assert: 256 equals: offsets size.
	self assert: 1 equals: (offsets at: 0 + 1) asInteger.
	self assert: 1 equals: (offsets at: 1 + 1) asInteger.
	self assert: 4 equals: (offsets at: 20+ 1) asInteger.
	self assert: 5 equals: (offsets at: 235 + 1) asInteger.
	self assert: 6 equals: (offsets at: 236 + 1) asInteger.
	self assert: 7 equals: (offsets at: 255+ 1) asInteger! !

!PackFileCreatorTests methodsFor: 'tests-index' stamp: 'MaxLeske 9/2/2012 10:50'!
testFanoutTableCreation
	"byte N records the number of objects with names <= N.
	Consequence: byte 255 records the *total* number of objects in the pack"
	|  Name is already defined fanoutStream previous |	
	fanoutStream := (ByteArray streamContents: [ :stream | creator writeFanoutTableOn: stream ]) readStream.
	
	"the offsets in the fanout table are monotonic"
	previous := 0.
	[ fanoutStream atEnd ] whileFalse: [ | current |
		current := (fanoutStream next: 4) asInteger.
		self assert:  current >= previous.
		 previous := current ].
	
	self assert: fanoutStream size equals: 1024.
	self assert: 1 equals: ((fanoutStream position: 0) next: 4) asInteger.
	self assert: 4 equals: ((fanoutStream position: (20 * 4)) next: 4) asInteger.
	self assert: 5 equals: ((fanoutStream position: (235 * 4)) next: 4) asInteger.
	self assert: 6 equals: ((fanoutStream position: (236 * 4)) next: 4) asInteger.
	self assert: 7 equals: ((fanoutStream position: (255 * 4)) next: 4) asInteger.! !

!PackFileCreatorTests methodsFor: 'tests-index' stamp: 'MaxLeske 9/2/2012 20:52'!
testWrite4ByteOffsetTable
	| byteStream |
	byteStream := (ByteArray streamContents: [ :stream | creator writeOffsetTablesOn: stream ]) readStream.
	self assert: 4 * 7 equals: byteStream contents size.
	
	self deny: byteStream atEnd.
	[ byteStream atEnd ] whileFalse: [ | offset |
		offset := (byteStream next: 4) asInteger.
		"MSB is zero if the 8-byte offset table isn' used"
		self assert: 0 equals: (offset bitShift: -31).
		self assert:  offset <= (6 * 20) ].

	"smallest offset is always 12 because of 12 header bytes"	
	self assert: 12 equals: ((byteStream position: 0) next: 4) asInteger! !

!PackFileCreatorTests methodsFor: 'tests-index' stamp: 'MaxLeske 9/8/2012 21:32'!
testWrite8ByteOffsetTable
	"NOTE: cannot reliably test this because I can't generate enough objects without 
	blowing the memory"
	| byteStream |
	byteStream := (ByteArray streamContents: [ :stream | 
		creator
			write4ByteIndexTableOn: stream;
			writeOffsetTableOfSize: 8 on: stream ]) readStream.
	
	self assert: byteStream contents size equals: (7 * 4) + (7 * 8).
	self assert: (byteStream next: 4) equals: #[128 0 0 0].
	self assert: (byteStream next: 4) equals: #[128 0 0 8].
	self assert: (byteStream next: 4) equals: #[128 0 0 16].
	self assert: (byteStream next: 4) equals: #[128 0 0 24].
	self assert: (byteStream next: 4) equals: #[128 0 0 32].
	self assert: (byteStream next: 4) equals: #[128 0 0 40].
	self assert: (byteStream next: 4) equals: #[128 0 0 48].
	
	"each of the objects has size 8 (see #setUp) but the compressed size varies"
	self assert: (byteStream next: 8) asInteger equals: 12! !

!PackFileCreatorTests methodsFor: 'tests-index' stamp: 'MaxLeske 8/29/2012 20:56'!
testWriteCRCTableOn
	| bytes |
	bytes := ByteArray streamContents: [ :stream | creator writeCRCTableOn: stream ].
	self assert: 4 * 7 equals: bytes size! !

!PackFileCreatorTests methodsFor: 'tests' stamp: 'MaxLeske 9/2/2012 23:26'!
testWriteObjectHeaderOn
	| blob file contents |
	blob := GitBlob bytes: 'my blob with size greater than 32' in: nil.
	file := FileSystem memory root / 'afile'.
	file writeStreamDo: [ :stream | creator writeObjectHeader: blob on: stream ].
	contents := file readStreamDo: [ :stream | stream contents ].
	
	self assert: contents size equals: 2.
	"leading one: more header bytes follow
	011: blob typecode
	0001 size of blob part 1 (lower bits)"
	self assert: (contents at: 1) equals: 2r10110001.
	"leading zero: no more header bytes follow
	0000001: size of blob part 2 (higher bits)"
	self assert: (contents at: 2) equals: 2r00000010! !

!PackFileCreatorTests methodsFor: 'tests-index' stamp: 'MaxLeske 9/2/2012 11:00'!
testWriteObjectNamesOn
	| byteStream previous |
	byteStream := (ByteArray streamContents: [ :stream | creator writeObjectNamesOn: stream ]) readStream.
	self assert: 20 * 7 equals: byteStream contents size.
	
	"make sure that object names have bee sorted"
	self deny: byteStream atEnd.
	previous := 0.
	[ byteStream atEnd ] whileFalse: [ | current |
		current := (byteStream next: 20) asInteger.
		self assert: current > previous.
		previous := current ]! !

!PackFileCreatorTests methodsFor: 'tests' stamp: 'MaxLeske 9/8/2012 18:23'!
testWriteObjectsOn
	| blob file contents bytesRead |
	blob := GitBlob bytes: 'my blob with size greater than 32' in: repository.
	blob store.
	creator := GitPackFileCreator new
		repository: repository;
		instVarNamed: 'orderedHashes' put: (OrderedCollection with: blob hash);
		instVarNamed: 'hashDict' put: (Dictionary with: blob hash -> 21);
		yourself.
	file := FileSystem memory root / 'afile'.
	file writeStreamDo: [ :stream | creator writeObjectsOn: stream ].
	contents := file readStreamDo: [ :stream | stream contents ].
	contents := contents allButFirst: 2.	"ignore header"
	self assert: contents size equals: blob compressedForPack size.
	self shouldnt: [ bytesRead := (GitZLibReadStream on: contents) contents ] raise: Error.
	self assert: bytesRead equals: blob byteData! !

!PackFileCreatorTests methodsFor: 'tests-index' stamp: 'MaxLeske 9/2/2012 23:25'!
testwriteIndexFileTrailerOn
	| bytes index |
	index := GitIndexFileVersion2 new
		reference: (FileSystem memory root  / 'index');
		yourself.
	creator 
		indexFile: index;
		packFileChecksum: (GitHash from: 'bar') byteHash.
	index reference writeStreamDo: [ :stream | 
		stream nextPutAll: 'foo'.
		creator writeIndexFileTrailerOn: stream ].
	bytes := index reference readStream contents.
	
	self assert: 3 + (2 * 20) equals: bytes size! !

GitTestCase subclass: #PackFileTests
	instanceVariableNames: 'packReader filesystem repository packFile indexFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

!PackFileTests class methodsFor: 'testing' stamp: 'MaxLeske 6/24/2012 18:46'!
isAbstract
	^ self = PackFileTests! !

!PackFileTests class methodsFor: 'history' stamp: 'CamilloBruni 8/1/2011 16:49'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new))); add: (#failures->((Set new) add: #testVersion2PackfileStructure; yourself)); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 60559; instVarAt: 2 put: (Duration seconds: 7200 nanoSeconds: 0); instVarAt: 3 put: 2455775; instVarAt: 4 put: 0; yourself)); yourself)! !

!PackFileTests methodsFor: 'helpers' stamp: 'MaxLeske 9/2/2012 12:21'!
calculatePackChecksum
	| position packData |
	position := packReader position.
	self assert: (packReader skip: 20; atEnd).
	
	packReader position: 0.
	packData := packReader next: position.
	packReader position: position.
	
	^ GitHash from: packData! !

!PackFileTests methodsFor: 'helpers' stamp: 'MaxLeske 8/1/2011 20:20'!
compressedDataSize 
	"Expand the data for two reasons:
		1: to find next header we need to know the length
			of the compressed data.
		2: verify compressed data"
	| position compressedSize |
	position := packReader position.
	compressedSize := self compressedDataSize: packReader upToEnd.
	packReader position: position.
	
	^ compressedSize! !

!PackFileTests methodsFor: 'helpers' stamp: 'MaxLeske 9/8/2012 18:23'!
compressedDataSize: aByteArray
	| zlibReader |
	zlibReader := GitZLibReadStream on: aByteArray.
	^ zlibReader 
		contents;
		sourcePosition! !

!PackFileTests methodsFor: 'helpers' stamp: 'MaxLeske 8/2/2011 21:07'!
getEntryHeadersAt: position
"The most significant bit of every header byte states if the current byte is followed
by another header byte or by data.
First bit = 1: another header byte follows.
First bit = 0: data follows.
Thus, the n header bytes of an entry consist of n-1 bytes who's most significant
bit is 1 and 1 byte who's most significant bit is 0."
	| bytes oldPosition |
	oldPosition := packReader position.
	packReader position: position.
	bytes := ByteArray streamContents: [ :stream |			
		[ (packReader peek bitAnd: 2r10000000) isZero ] whileFalse:
			[ stream nextPut: packReader next ].
		stream nextPut: packReader next ].
	
	packReader position: oldPosition.
	^ bytes readStream ! !

!PackFileTests methodsFor: 'helpers' stamp: 'MaxLeske 8/1/2011 19:37'!
getSizeFromHeaders: aStream
"aStream contains the n header bytes of a pack entry.
The bytes are in network byte order (last  byte is most significant).
The last four bits of the first byte are the four least significant
bits of the bits describing the size of the following data. 
The number of bits describing the size of the data is (n - 1) * 7 + 4.
Note that the most significant bit of each byte encodes if another header
byte follows or not and thus has to be stripped (#bitAnd:) from the bits
that describe the size.
The four bits from the first byte do not need to be shifted. The following
bits need to be shifted to the left so that they make up the most significant
part of the bits already present."
	| size shift byte |
	byte := aStream next.
	size := byte bitAnd: 2r00001111.
	shift := 4.
	[ (byte bitAnd: 2r10000000) isZero ] whileFalse: [
		byte := aStream next.
		size := size bitOr: ((byte bitAnd: 2r01111111) bitShift: shift).
		shift := shift + 7 ].
	
	^ size! !

!PackFileTests methodsFor: 'helpers-testing' stamp: 'MaxLeske 7/30/2011 16:06'!
hasBlobSignature
	^ (packReader peek bitAnd: 2r0111000) = 2r00110000! !

!PackFileTests methodsFor: 'helpers-testing' stamp: 'MaxLeske 9/8/2012 18:23'!
hasCommitData
"If the current entry (first byte of data) is really commit data then the first four bytes will spell 'tree'"
	| compressedSize stream position |
	position := packReader position.
	self skipEntryHeader.	
	compressedSize := self compressedDataSize.
	stream := (GitZLibReadStream on: (packReader next: compressedSize)) contents readStream.
	packReader position: position.
	
	^ (stream next: 4) asString = GitTree typeCode! !

!PackFileTests methodsFor: 'helpers-testing' stamp: 'MaxLeske 7/30/2011 14:44'!
hasCommitSignature
	^ (packReader peek bitAnd: 2r01110000) = 2r00010000! !

!PackFileTests methodsFor: 'helpers-testing' stamp: 'MaxLeske 7/31/2011 16:57'!
hasOfsDeltaSignature 
	^ (packReader peek bitAnd: 2r01110000) = 2r01100000! !

!PackFileTests methodsFor: 'helpers-testing' stamp: 'MaxLeske 7/30/2011 16:09'!
hasRefDeltaSignature
	^ (packReader peek bitAnd: 2r01110000) = 2r01110000! !

!PackFileTests methodsFor: 'helpers-testing' stamp: 'MaxLeske 9/8/2012 18:23'!
hasTreeData
"If the current entry (first byte of data) is really tree data then the beginning of
the data will either be GitTreeEntry class>>dirMode of GitTreeEntry class>>fileMode."
	| compressedSize stream position mode |
	position := packReader position.
	self skipEntryHeader.
	compressedSize := self compressedDataSize.
	stream := (GitZLibReadStream on: (packReader next: compressedSize)) contents readStream.
	packReader position: position.
	
	mode := (stream next: 6) asString.
	^ (mode = (GitTreeEntry printMode: GitTreeEntry dirMode)) | 
		(mode = (GitTreeEntry printMode: GitTreeEntry fileMode))! !

!PackFileTests methodsFor: 'helpers-testing' stamp: 'MaxLeske 7/30/2011 14:44'!
hasTreeSignature
	^ (packReader peek bitAnd: 2r01110000) = 2r00100000! !

!PackFileTests methodsFor: 'file contents' stamp: 'MaxLeske 6/24/2012 19:53'!
indexBytesWithOfsDelta
	^ #[255 116 79 99 0 0 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 9 0 0 0 9 33 246 147 158 244 77 95 173 195 245 55 48 11 66 228 178 136 156 196 21 40 96 100 177 135 218 20 221 170 178 17 230 87 154 34 95 23 144 131 231 55 1 1 162 213 123 64 195 125 169 180 43 104 142 97 235 150 143 148 62 119 2 42 60 3 216 126 241 72 125 40 42 216 200 197 121 65 70 148 23 152 86 78 54 212 106 104 47 19 231 22 182 245 225 61 148 205 148 97 183 216 191 124 86 88 78 94 42 125 81 242 126 169 238 195 108 194 105 91 114 225 246 222 251 63 91 62 109 133 17 101 200 195 140 24 186 66 181 100 155 234 81 23 87 50 80 114 171 172 194 31 199 73 199 0 4 97 219 200 87 254 162 26 126 14 145 12 242 79 60 69 92 198 224 234 134 213 137 160 219 183 188 38 35 6 167 206 57 209 7 171 227 64 117 68 253 170 20 123 41 107 122 21 131 94 156 124 250 196 26 250 52 48 37 249 109 0 0 0 161 0 0 3 52 0 0 1 217 0 0 1 54 0 0 2 193 0 0 2 237 0 0 3 8 0 0 1 173 0 0 0 12 128 203 29 149 43 4 45 128 160 238 7 34 175 90 90 243 30 93 116 212 128 204 239 142 92 55 155 120 143 201 242 76 66 220 203 250 82 34 159 48]! !

!PackFileTests methodsFor: 'file contents' stamp: 'MaxLeske 6/27/2012 10:28'!
indexBytesWithRefDelta
	^ self subclassResponsibility! !

!PackFileTests methodsFor: 'file contents' stamp: 'MaxLeske 6/24/2012 20:24'!
indexBytesWithTag
	^ self subclassResponsibility! !

!PackFileTests methodsFor: 'helpers-testing' stamp: 'MaxLeske 7/30/2011 16:07'!
isEntryBlob
	^ self hasBlobSignature! !

!PackFileTests methodsFor: 'helpers-testing' stamp: 'MaxLeske 7/30/2011 14:29'!
isEntryCommit
	^ self hasCommitSignature & self hasCommitData
	! !

!PackFileTests methodsFor: 'helpers-testing' stamp: 'MaxLeske 6/24/2012 19:21'!
isEntryOfsDelta
	^ self hasOfsDeltaSignature and: [
		self verifyOfsDeltaDeltification ]! !

!PackFileTests methodsFor: 'helpers-testing' stamp: 'MaxLeske 6/24/2012 19:21'!
isEntryRefDelta
	^ self hasRefDeltaSignature and: [
		self verifyRefDeltaDeltification ]! !

!PackFileTests methodsFor: 'helpers-testing' stamp: 'MaxLeske 7/30/2011 14:42'!
isEntryTree
	^ self hasTreeSignature & self hasTreeData
	! !

!PackFileTests methodsFor: 'file contents' stamp: 'MaxLeske 6/24/2012 19:52'!
packBytesWithOfsDelta
	^ #[80 65 67 75 0 0 0 2 0 0 0 9 150 13 120 156 149 139 91 10 194 48 16 0 255 115 138 252 11 178 121 108 55 1 17 15 160 135 216 108 55 182 216 90 169 17 122 124 235 17 252 27 102 152 182 170 90 101 116 142 144 130 71 32 207 133 69 188 171 66 49 11 1 64 236 92 95 36 33 153 23 175 250 108 118 143 93 14 89 107 140 61 86 238 37 84 12 20 0 74 244 26 139 79 41 139 68 135 134 63 109 88 86 123 227 205 94 245 253 80 123 154 121 155 126 116 185 207 60 78 71 89 230 179 117 1 82 206 72 169 179 7 240 0 102 183 243 216 154 254 127 154 50 241 16 204 23 77 115 62 194 150 13 120 156 149 139 91 10 194 48 16 69 255 179 138 252 11 146 231 204 4 68 92 128 46 98 154 76 109 177 177 18 35 116 249 214 37 248 113 15 135 3 183 55 17 157 40 66 16 15 37 0 3 185 209 122 65 11 3 140 81 172 47 41 228 125 96 7 84 47 110 242 236 26 209 56 199 62 27 95 8 101 180 129 176 56 114 92 40 83 142 152 130 13 176 3 21 127 250 180 54 125 227 77 95 229 253 16 125 170 188 45 63 187 220 43 207 203 49 175 245 172 173 55 148 82 4 31 245 193 56 99 212 94 235 220 187 252 255 84 195 194 147 83 95 224 204 61 250 149 10 120 156 149 203 81 10 194 48 12 128 225 247 158 34 239 130 164 235 82 82 16 241 0 122 136 164 75 221 176 101 176 85 216 241 213 35 248 246 243 193 223 55 51 48 95 226 100 69 67 33 13 22 39 38 239 35 101 206 129 179 103 149 113 80 138 99 82 39 239 62 175 27 60 228 128 187 237 47 131 75 147 163 254 234 246 108 178 212 115 94 219 21 124 64 78 137 136 17 78 56 32 186 175 182 165 119 251 255 116 90 101 118 31 148 230 49 222 161 2 120 156 51 52 48 48 51 49 81 72 203 204 73 53 100 48 103 100 92 116 181 218 225 112 237 202 45 218 25 125 137 175 167 245 79 177 3 0 173 195 12 141 177 147 14 120 156 237 205 193 109 4 33 12 5 208 123 186 68 17 72 120 124 136 132 118 74 163 129 105 108 205 214 144 67 164 60 14 8 99 255 231 215 235 215 206 87 174 24 249 236 182 102 100 31 43 102 244 145 45 86 21 209 114 157 251 188 171 219 214 179 79 245 236 232 121 30 53 89 193 103 175 140 209 86 253 213 228 8 34 145 72 36 18 137 68 34 145 72 36 18 137 68 34 145 72 36 18 137 68 34 145 72 36 18 137 68 34 145 72 36 18 137 68 34 145 72 36 18 137 68 34 145 72 36 18 137 196 127 34 94 87 86 224 202 18 143 52 231 247 108 247 79 235 71 248 56 49 239 103 103 155 81 153 82 238 90 153 171 125 166 79 166 122 243 44 45 117 246 196 225 112 56 28 14 135 195 225 112 56 28 14 135 195 225 112 56 28 14 135 195 225 112 56 28 14 135 195 225 112 56 28 14 135 195 225 112 56 28 14 135 195 225 112 56 28 238 15 112 111 165 188 86 95 161 2 120 156 51 52 48 48 51 49 81 72 203 204 73 53 100 184 177 191 38 44 194 47 78 171 54 240 83 221 202 119 135 115 14 101 70 23 1 0 193 127 13 180 111 129 20 120 156 219 248 136 241 233 67 198 141 31 88 44 55 7 88 62 52 7 0 65 214 7 142 161 2 120 156 51 52 48 48 51 49 81 72 203 204 73 53 100 208 72 72 217 216 126 75 228 238 170 77 130 207 194 103 41 197 139 79 104 126 14 0 184 12 12 230 104 71 120 156 123 250 144 113 69 241 134 21 150 0 22 10 4 116 128 203 29 149 43 4 45 128 160 238 7 34 175 90 90 243 30 93 116 212]! !

!PackFileTests methodsFor: 'file contents' stamp: 'MaxLeske 6/24/2012 19:44'!
packBytesWithRefDelta
	^ #[80 65 67 75 0 0 0 2 0 0 0 9 150 13 120 156 149 139 91 10 194 48 16 0 255 115 138 252 11 178 121 108 55 1 17 15 160 135 216 108 55 182 216 90 169 17 122 124 235 17 252 27 102 152 182 170 90 101 116 142 144 130 71 32 207 133 69 188 171 66 49 11 1 64 236 92 95 36 33 153 23 175 250 108 118 143 93 14 89 107 140 61 86 238 37 84 12 20 0 74 244 26 139 79 41 139 68 135 134 63 109 88 86 123 227 205 94 245 253 80 123 154 121 155 126 116 185 207 60 78 71 89 230 179 117 1 82 206 72 169 179 7 240 0 102 183 243 216 154 254 127 154 50 241 16 204 23 77 115 62 194 150 13 120 156 149 139 91 10 194 48 16 69 255 179 138 252 11 146 231 204 4 68 92 128 46 98 154 76 109 177 177 18 35 116 249 214 37 248 113 15 135 3 183 55 17 157 40 66 16 15 37 0 3 185 209 122 65 11 3 140 81 172 47 41 228 125 96 7 84 47 110 242 236 26 209 56 199 62 27 95 8 101 180 129 176 56 114 92 40 83 142 152 130 13 176 3 21 127 250 180 54 125 227 77 95 229 253 16 125 170 188 45 63 187 220 43 207 203 49 175 245 172 173 55 148 82 4 31 245 193 56 99 212 94 235 220 187 252 255 84 195 194 147 83 95 224 204 61 250 149 10 120 156 149 203 81 10 194 48 12 128 225 247 158 34 239 130 164 235 82 82 16 241 0 122 136 164 75 221 176 101 176 85 216 241 213 35 248 246 243 193 223 55 51 48 95 226 100 69 67 33 13 22 39 38 239 35 101 206 129 179 103 149 113 80 138 99 82 39 239 62 175 27 60 228 128 187 237 47 131 75 147 163 254 234 246 108 178 212 115 94 219 21 124 64 78 137 136 17 78 56 32 186 175 182 165 119 251 255 116 90 101 118 31 148 230 49 222 161 2 120 156 51 52 48 48 51 49 81 72 203 204 73 53 100 48 103 100 92 116 181 218 225 112 237 202 45 218 25 125 137 175 167 245 79 177 3 0 173 195 12 141 177 147 14 120 156 237 205 193 109 4 33 12 5 208 123 186 68 17 72 120 124 136 132 118 74 163 129 105 108 205 214 144 67 164 60 14 8 99 255 231 215 235 215 206 87 174 24 249 236 182 102 100 31 43 102 244 145 45 86 21 209 114 157 251 188 171 219 214 179 79 245 236 232 121 30 53 89 193 103 175 140 209 86 253 213 228 8 34 145 72 36 18 137 68 34 145 72 36 18 137 68 34 145 72 36 18 137 68 34 145 72 36 18 137 68 34 145 72 36 18 137 68 34 145 72 36 18 137 68 34 145 72 36 18 137 196 127 34 94 87 86 224 202 18 143 52 231 247 108 247 79 235 71 248 56 49 239 103 103 155 81 153 82 238 90 153 171 125 166 79 166 122 243 44 45 117 246 196 225 112 56 28 14 135 195 225 112 56 28 14 135 195 225 112 56 28 14 135 195 225 112 56 28 14 135 195 225 112 56 28 14 135 195 225 112 56 28 14 135 195 225 112 56 28 238 15 112 111 165 188 86 95 161 2 120 156 51 52 48 48 51 49 81 72 203 204 73 53 100 184 177 191 38 44 194 47 78 171 54 240 83 221 202 119 135 115 14 101 70 23 1 0 193 127 13 180 127 55 1 1 162 213 123 64 195 125 169 180 43 104 142 97 235 150 143 148 62 120 156 219 248 136 241 233 67 198 141 31 88 44 55 7 88 62 52 7 0 65 214 7 142 161 2 120 156 51 52 48 48 51 49 81 72 203 204 73 53 100 208 72 72 217 216 126 75 228 238 170 77 130 207 194 103 41 197 139 79 104 126 14 0 184 12 12 230 120 216 191 124 86 88 78 94 42 125 81 242 126 169 238 195 108 194 105 91 114 120 156 123 250 144 113 69 241 134 21 150 0 22 10 4 116 186 55 135 207 98 139 116 127 42 115 209 155 183 207 21 210 63 246 127 155]! !

!PackFileTests methodsFor: 'file contents' stamp: 'MaxLeske 6/26/2012 17:20'!
packBytesWithTag
	^   #[80 65 67 75 0 0 0 2 0 0 0 10 150 13 120 156 149 139 91 10 194 48 16 0 255 115 138 252 11 178 121 108 55 1 17 15 160 135 216 108 55 182 216 90 169 17 122 124 235 17 252 27 102 152 182 170 90 101 116 142 144 130 71 32 207 133 69 188 171 66 49 11 1 64 236 92 95 36 33 153 23 175 250 108 118 143 93 14 89 107 140 61 86 238 37 84 12 20 0 74 244 26 139 79 41 139 68 135 134 63 109 88 86 123 227 205 94 245 253 80 123 154 121 155 126 116 185 207 60 78 71 89 230 179 117 1 82 206 72 169 179 7 240 0 102 183 243 216 154 254 127 154 50 241 16 204 23 77 115 62 194 150 13 120 156 149 139 91 10 194 48 16 69 255 179 138 252 11 146 231 204 4 68 92 128 46 98 154 76 109 177 177 18 35 116 249 214 37 248 113 15 135 3 183 55 17 157 40 66 16 15 37 0 3 185 209 122 65 11 3 140 81 172 47 41 228 125 96 7 84 47 110 242 236 26 209 56 199 62 27 95 8 101 180 129 176 56 114 92 40 83 142 152 130 13 176 3 21 127 250 180 54 125 227 77 95 229 253 16 125 170 188 45 63 187 220 43 207 203 49 175 245 172 173 55 148 82 4 31 245 193 56 99 212 94 235 220 187 252 255 84 195 194 147 83 95 224 204 61 250 149 10 120 156 149 203 81 10 194 48 12 128 225 247 158 34 239 130 164 235 82 82 16 241 0 122 136 164 75 221 176 101 176 85 216 241 213 35 248 246 243 193 223 55 51 48 95 226 100 69 67 33 13 22 39 38 239 35 101 206 129 179 103 149 113 80 138 99 82 39 239 62 175 27 60 228 128 187 237 47 131 75 147 163 254 234 246 108 178 212 115 94 219 21 124 64 78 137 136 17 78 56 32 186 175 182 165 119 251 255 116 90 101 118 31 148 230 49 222 161 2 120 156 51 52 48 48 51 49 81 72 203 204 73 53 100 48 103 100 92 116 181 218 225 112 237 202 45 218 25 125 137 175 167 245 79 177 3 0 173 195 12 141 177 147 14 120 156 237 205 193 109 4 33 12 5 208 123 186 68 17 72 120 124 136 132 118 74 163 129 105 108 205 214 144 67 164 60 14 8 99 255 231 215 235 215 206 87 174 24 249 236 182 102 100 31 43 102 244 145 45 86 21 209 114 157 251 188 171 219 214 179 79 245 236 232 121 30 53 89 193 103 175 140 209 86 253 213 228 8 34 145 72 36 18 137 68 34 145 72 36 18 137 68 34 145 72 36 18 137 68 34 145 72 36 18 137 68 34 145 72 36 18 137 68 34 145 72 36 18 137 68 34 145 72 36 18 137 196 127 34 94 87 86 224 202 18 143 52 231 247 108 247 79 235 71 248 56 49 239 103 103 155 81 153 82 238 90 153 171 125 166 79 166 122 243 44 45 117 246 196 225 112 56 28 14 135 195 225 112 56 28 14 135 195 225 112 56 28 14 135 195 225 112 56 28 14 135 195 225 112 56 28 14 135 195 225 112 56 28 14 135 195 225 112 56 28 238 15 112 111 165 188 86 95 161 2 120 156 51 52 48 48 51 49 81 72 203 204 73 53 100 184 177 191 38 44 194 47 78 171 54 240 83 221 202 119 135 115 14 101 70 23 1 0 193 127 13 180 127 55 1 1 162 213 123 64 195 125 169 180 43 104 142 97 235 150 143 148 62 120 156 219 248 136 241 233 67 198 141 31 88 44 55 7 88 62 52 7 0 65 214 7 142 161 2 120 156 51 52 48 48 51 49 81 72 203 204 73 53 100 208 72 72 217 216 126 75 228 238 170 77 130 207 194 103 41 197 139 79 104 126 14 0 184 12 12 230 120 216 191 124 86 88 78 94 42 125 81 242 126 169 238 195 108 194 105 91 114 120 156 123 250 144 113 69 241 134 21 150 0 22 10 4 116 194 9 120 156 21 140 65 14 131 32 16 0 239 188 98 239 77 26 96 151 34 73 99 250 128 246 17 128 11 177 74 48 202 193 254 190 114 154 185 204 212 240 229 216 64 171 244 112 232 56 17 77 38 249 41 98 50 104 81 202 64 154 41 232 97 112 49 146 50 162 253 54 134 88 75 153 155 104 62 67 227 163 93 236 158 121 135 143 63 225 205 199 194 240 44 254 92 187 189 114 241 243 122 191 154 17 20 146 180 26 81 91 184 73 45 165 16 189 135 62 74 117 135 205 199 69 252 1 19 236 45 76 48 240 65 115 56 0 100 65 207 154 113 222 24 245 40 194 116 66 83 167]! !

!PackFileTests methodsFor: 'helpers' stamp: 'CamilloBruni 8/30/2012 14:08'!
packOffsetOf: sha1
	| dummyFS pack |
	"GitPackFile / GitIndexFile already contain the necessary code."
	dummyFS := FileSystem memory.
	(dummyFS root / 'pack.idx') writeStreamDo: [ :stream | 
		stream nextPutAll: self indexBytesWithRefDelta ].
	(dummyFS root / 'pack.pack') writeStreamDo: [ :stream |
		stream nextPutAll: self packBytesWithRefDelta ].
	
	pack := GitPackFile on: dummyFS root / 'pack.pack' in: nil.
	^ pack indexFile offsetForIndex: (pack indexFile indexForObjectNamed: sha1)! !

!PackFileTests methodsFor: 'running' stamp: 'CamilloBruni 8/30/2012 14:09'!
setUp
	| packsDir |
	filesystem := FileSystem memory.
	repository := GitRepository on: (filesystem root / 'repo').
	repository  headFile writeStreamDo: [ :stream | 
		stream nextPutAll: '21f6939ef44d5fadc3f537300b42e4b2889cc415' ] .
	
	packsDir := filesystem root resolve: 'repo/.git/objects/pack'.
	packsDir ensureDirectory.	
	packFile := packsDir / 'pack-bbb272fda736770dc087758f6fc7c4b6324ea146.pack'.
	indexFile := packsDir / 'pack-bbb272fda736770dc087758f6fc7c4b6324ea146.idx'! !

!PackFileTests methodsFor: 'helpers' stamp: 'MaxLeske 8/1/2011 18:46'!
skipBaseObjectOffset
"The base object offset has a special encoding (basically it is the
same encoding used for encoding the size of object data).
See http://git.rsbx.net/Documents/Git_Data_Formats.txt.
This is the Smalltalk code that would decode the offset:

| byte offset |
	byte := packReader next.
	offset := byte bitAnd: 2r01111111.
	[ (byte bitAnd: 2r10000000) isZero ] whileFalse: [
		byte := packReader next.
		offset := ((offset + 1) bitShift: 7) bitOr: (byte bitAnd: 2r01111111) ]"
	
	self skipEntryHeader "same code"! !

!PackFileTests methodsFor: 'helpers' stamp: 'MaxLeske 7/30/2011 16:22'!
skipBaseObjectReference
	packReader skip: 20! !

!PackFileTests methodsFor: 'helpers' stamp: 'MaxLeske 7/30/2011 16:24'!
skipChecksum
	packReader skip: 20! !

!PackFileTests methodsFor: 'helpers' stamp: 'MaxLeske 7/30/2011 14:18'!
skipEntryHeader
	"First bit of 1: another header byte follows.
	First bit of 0: no more header bytes. Next byte is data."
	[ (packReader peek bitAnd: 2r10000000) isZero ] whileFalse: [ packReader next ].
	"skip last header byte"
	packReader next! !

!PackFileTests methodsFor: 'tests' stamp: 'MaxLeske 6/24/2012 19:51'!
testPackStructureWithOfsDelta
"see pack-format.txt in the 'technical' directory of the git sources.
Another good resource is this document: http://git.rsbx.net/Documents/Git_Data_Formats.txt.
Also, read comments in #verifyPackfileHeader and
#verifyPackfileEntries"
	packReader := self packBytesWithOfsDelta readStream.
		
	self 
		verifyPackHeader;
		verifyPackEntries! !

!PackFileTests methodsFor: 'tests' stamp: 'MaxLeske 6/24/2012 19:51'!
testPackStructureWithRefDelta
"see pack-format.txt in the 'technical' directory of the git sources.
Another good resource is this document: http://git.rsbx.net/Documents/Git_Data_Formats.txt.
Also, read comments in #verifyPackfileHeader and
#verifyPackfileEntries"
	packReader := self packBytesWithRefDelta readStream.
		
	self 
		verifyPackHeader;
		verifyPackEntries! !

!PackFileTests methodsFor: 'tests' stamp: 'MaxLeske 6/27/2012 10:52'!
testPackedObjectsDoWithRefDelta
	self 
		usePackWithRefDelta;
		verifyPackedObjectsDo! !

!PackFileTests methodsFor: 'tests' stamp: 'CamilloBruni 9/1/2012 12:10'!
testReadingPackedTag
	| loadedObject |
	self usePackWithTag.
	loadedObject := repository objectNamed: '25f43f451071dd8a6cf39accd5070d885de4b017'.
	self assert: GitTag equals: loadedObject class.
	
	self assert: 1 equals: repository tags size! !

!PackFileTests methodsFor: 'tests' stamp: 'MaxLeske 6/27/2012 10:56'!
testReadingWithRefDelta
	self 
		usePackWithRefDelta;
		verifyReadingPackfile! !

!PackFileTests methodsFor: 'tests' stamp: 'MaxLeske 6/27/2012 10:56'!
testUnpackingWithRefDelta
	self 
		usePackWithRefDelta;
		verifyUnpacking! !

!PackFileTests methodsFor: 'tests' stamp: 'MaxLeske 9/8/2012 13:34'!
testUnpackingWithoutIndexFileRefDelta
	| pack |
	self usePackWithRefDelta.
	indexFile delete.
	pack := GitPackFile on: packFile in: repository.
	pack unpack! !

!PackFileTests methodsFor: 'running' stamp: 'MaxLeske 6/24/2012 19:48'!
usePackWithRefDelta
	packFile writeStreamDo: [ :stream |
		stream nextPutAll: self packBytesWithRefDelta ].
	indexFile writeStreamDo: [ :stream |
		stream nextPutAll: self indexBytesWithRefDelta ] ! !

!PackFileTests methodsFor: 'running' stamp: 'MaxLeske 6/27/2012 10:24'!
usePackWithTag
	packFile writeStreamDo: [ :stream |
		stream nextPutAll: self packBytesWithTag ].
	indexFile writeStreamDo: [ :stream |
		stream nextPutAll: self indexBytesWithTag ].
	(repository tagsDir / 'testtag') writeStreamDo: [ :stream |
		stream nextPutAll: '25f43f451071dd8a6cf39accd5070d885de4b017' ]! !

!PackFileTests methodsFor: 'helpers-verifying' stamp: 'MaxLeske 9/8/2012 18:23'!
verifyDeltificationWithBaseAt: baseOffset
	| interpreter baseSize finalSize finalObjectBytes baseObjectBytes result dummyFS pack position unpackedDelta |
	"GitDeltaInterpreter GitPack and GitPackedObject already contain the necessary code."
	interpreter := GitDeltaInterpreter new.
	position := packReader position.
	unpackedDelta := (GitZLibReadStream on: packReader upToEnd) contents.
	packReader position: position.
	interpreter 
		instVarNamed: 'commands' put: unpackedDelta readStream;
		instVarNamed: 'instructions' put: unpackedDelta. 

	dummyFS := FileSystem memory.
	repository := GitRepository on: dummyFS root / 'repo'.
	
	(repository packsDir / 'pack.idx') writeStreamDo: [ :stream | 
		stream nextPutAll: self indexBytesWithRefDelta ].
	(repository packsDir / 'pack.pack') writeStreamDo: [ :stream |
		stream nextPutAll: self packBytesWithRefDelta ].
	 
	pack := GitPackFile on: repository packsDir / 'pack.pack' in: repository.

	baseSize := interpreter readBaseObjectSize.
	finalSize := interpreter readFinalObjectSize.
	baseObjectBytes := (pack objectAtOffset: baseOffset) unpackedBytes.
	finalObjectBytes := interpreter runAgainst: baseObjectBytes.
	
	result := baseObjectBytes size = baseSize.
	^ result and: [ (finalObjectBytes size = finalSize) ]! !

!PackFileTests methodsFor: 'helpers-verifying' stamp: 'MaxLeske 6/24/2012 19:35'!
verifyEntryOffsets
	[ self verifyOffsetsWithOfsDelta ]
		on: TestFailure
		do: [ self verifyOffsetsWithRefDelta ]! !

!PackFileTests methodsFor: 'helpers-verifying' stamp: 'MaxLeske 6/24/2012 19:34'!
verifyEntrySizes
	[ self verifySizesWithOfsDelta ]
		on: TestFailure
		do: [ self verifySizesWithRefDelta ]! !

!PackFileTests methodsFor: 'helpers-verifying' stamp: 'MaxLeske 6/24/2012 19:35'!
verifyOffsetsWithOfsDelta
	"the positions are given as additions because git uses zero based
	indices while Smalltalk uses 1 based indices. So the byte at position
	12 in the file is at position 12 + 1 in the ByteArray.
	
	The first header byte of each entry has the form
	xyyyzzzz
	x: 	if 1then another header byte follows
		if 0 then data follows
	y: 	001 - OBJ_COMMIT
		010 - OBJ_TREE
		011 - OBJ_BLOB
		100 - OBJ_TAG
		110 - OBJ_OFS_DELT (new packfile format)
		111 - OBJ_REF_DELTA (old packfile format)
	z: four least significant bits of bits describing size (see #getSizeFromHeaders:)"
	| content |
	content := packReader contents.
	self assert: 2r00010000 equals: ((content at: 12+1) bitAnd: 2r01110000). "commit"
	self assert: 2r00010000 equals: ((content at: 161+1) bitAnd: 2r01110000). "commit"
	self assert: 2r00010000 equals: ((content at: 310+1) bitAnd: 2r01110000). "commit"
	self assert: 2r00100000 equals: ((content at: 429+1) bitAnd: 2r01110000). "tree"
	self assert: 2r00110000 equals: ((content at: 473+1) bitAnd: 2r01110000). "blob"
	self assert: 2r00100000 equals: ((content at: 705+1) bitAnd: 2r01110000). "tree"
	self assert: 2r01100000 equals: ((content at: 749+1) bitAnd: 2r01110000). "ofs_delta (blob)"
	self assert: 2r00100000 equals: ((content at: 776+1) bitAnd: 2r01110000). "tree"
	self assert: 2r01100000 equals: ((content at: 820+1) bitAnd: 2r01110000) "ofs_delta (blob)"! !

!PackFileTests methodsFor: 'helpers-verifying' stamp: 'MaxLeske 6/24/2012 19:34'!
verifyOffsetsWithRefDelta
	"the positions are given as additions because git uses zero based
	indices while Smalltalk uses 1 based indices. So the byte at position
	12 in the file is at position 12 + 1 in the ByteArray.
	
	The first header byte of each entry has the form
	xyyyzzzz
	x: 	if 1then another header byte follows
		if 0 then data follows
	y: 	001 - OBJ_COMMIT
		010 - OBJ_TREE
		011 - OBJ_BLOB
		100 - OBJ_TAG
		110 - OBJ_OFS_DELT (new packfile format)
		111 - OBJ_REF_DELTA (old packfile format)
	z: four least significant bits of bits describing size (see #getSizeFromHeaders:)"
	| content |
	content := packReader contents.
	self assert: 2r00010000 equals: ((content at: 12+1) bitAnd: 2r01110000). "commit"
	self assert: 2r00010000 equals: ((content at: 161+1) bitAnd: 2r01110000). "commit"
	self assert: 2r00010000 equals: ((content at: 310+1) bitAnd: 2r01110000). "commit"
	self assert: 2r00100000 equals: ((content at: 429+1) bitAnd: 2r01110000). "tree"
	self assert: 2r00110000 equals: ((content at: 473+1) bitAnd: 2r01110000). "blob"
	self assert: 2r00100000 equals: ((content at: 705+1) bitAnd: 2r01110000). "tree"
	self assert: 2r01110000 equals: ((content at: 749+1) bitAnd: 2r01110000). "ref_delta (blob)"
	self assert: 2r00100000 equals: ((content at: 794+1) bitAnd: 2r01110000). "tree"
	self assert: 2r01110000 equals: ((content at: 838+1) bitAnd: 2r01110000) "ref_delta (blob)"! !

!PackFileTests methodsFor: 'verifying' stamp: 'MaxLeske 9/8/2012 18:30'!
verifyOfsDeltaDeltification
	| packedObject position result |
	"GitPackedObject already contains the necessary code."
	position := packReader position.
	packedObject := GitPackedOfsDelta new.
	packedObject sourceStream: packReader.

	self skipEntryHeader.
	result := self verifyDeltificationWithBaseAt: position - packedObject readBaseObjectOffset.
	packReader position: position.
	^ result! !

!PackFileTests methodsFor: 'verifying' stamp: 'MaxLeske 9/2/2012 23:28'!
verifyPackEntries
"see pack-format.txt in the 'technical' directory of the git sources.
Also, take a look at the comments in #verifyEntryOffsets, #verifyEntrySizes
and #expandAndVerify:."

	| checksum calculatedChecksum |
	self 
		verifyEntryOffsets;
		verifyEntrySizes.

	self assert: self isEntryCommit.
	self skipEntryHeader.
	packReader skip: self compressedDataSize.
	
	self assert: self isEntryCommit.	
	self skipEntryHeader.
	packReader skip: self compressedDataSize.

	self assert: self isEntryCommit.
	self skipEntryHeader.
	packReader skip: self compressedDataSize.
	
	self assert: self isEntryTree.
	self skipEntryHeader.
	packReader skip: self compressedDataSize.
	
	self assert: self isEntryBlob.
	self skipEntryHeader.
	packReader skip: self compressedDataSize.
	
	self assert: self isEntryTree.
	self skipEntryHeader.
	packReader skip: self compressedDataSize.
	
	[ self assert: self isEntryRefDelta.
	self skipEntryHeader.
	"deltified objects of type ref_delta reference their base object via SHA-1 name:"
	self skipBaseObjectReference.
	packReader skip: self compressedDataSize ]
		on: TestFailure
		do: [ self assert: self isEntryOfsDelta.
			self skipEntryHeader.
			"deltified objects of type ofs_delta reference their base object via offset:"
			self skipBaseObjectOffset.
			packReader skip: self compressedDataSize ].
	
	self assert: self isEntryTree.
	self skipEntryHeader.
	packReader skip: self compressedDataSize.
	
	[ self assert: self isEntryRefDelta.
	self skipEntryHeader.
	"deltified objects of type ref_delta reference their base object via SHA-1 name:"
	self skipBaseObjectReference.
	packReader skip: self compressedDataSize ]
		on: TestFailure
		do: [ self assert: self isEntryOfsDelta.
			self skipEntryHeader.
			"deltified objects of type ofs_delta reference their base object via offset:"
			self skipBaseObjectOffset.
			packReader skip: self compressedDataSize ].

	calculatedChecksum := self calculatePackChecksum.
	checksum := packReader next: 20.
	self 
		assert: checksum
		equals: calculatedChecksum byteHash.
	
	self assert: packReader atEnd! !

!PackFileTests methodsFor: 'verifying' stamp: 'MaxLeske 6/24/2012 19:52'!
verifyPackHeader
"see pack-format.txt in the 'technical' directory of the git doc'"
	| content |
	"4-byte signature: 'P', 'A', 'C', 'K'"
	content := packReader next: 4.
	self assert: 'PACK' equals: content asString.
	
	"4-byte version number (network byte order): 2 or 3 "
	content := packReader next: 4.
	self assert: #[0 0 0 2] equals: content.  "version 2"
	
	"4-byte number of objects contained in the pack (network byte order)"
	content := packReader next: 4.
	self assert: #[0 0 0 9] equals: content  "9 objects" ! !

!PackFileTests methodsFor: 'verifying' stamp: 'MaxLeske 6/24/2012 19:14'!
verifyPackedObjectsDo
	| pack index codes |
	pack := GitPackFile on: packFile in: repository.
	index := 1.
	codes := #('commit' 'commit' 'commit' 'tree' 'blob' 'tree' 'blob' 'tree' 'blob').
	pack packedObjectsDo: [ :packedObject |
		self assert: (packedObject object typeCode = (codes at: index)).
		index := index + 1 ]! !

!PackFileTests methodsFor: 'verifying' stamp: 'MaxLeske 6/15/2012 14:19'!
verifyReadingPackfile
	| workingCopy|
	workingCopy := repository head.
	self assert: 'blah2' equals: workingCopy message trimBoth.
	
	self assert: 1 equals: workingCopy parents size.
	workingCopy := workingCopy parents first.
	self assert: 'blah' equals: workingCopy message trimBoth.
	
	"I reset HEAD to the second to last commit. So the last commit is not reachable"
	workingCopy := repository objectNamed: 'fea21a7e0e910cf24f3c455cc6e0ea86d589a0db'.
	self assert: 'blah3' equals: workingCopy message trimBoth.
	
	"see if all object types are accessable"
	self 
		shouldnt: [ repository objectNamed: '98564e36d46a682f13e716b6f5e13d94cd9461b7' ] "tree"
		raise: Error.
	self 
		shouldnt: [ repository objectNamed: 'e1f6defb3f5b3e6d851165c8c38c18ba42b5649b' ] "tree"
		raise: Error.
	self 
		shouldnt: [ repository objectNamed: 'ea511757325072abacc21fc749c7000461dbc857' ] "tree"
		raise: Error.
	self 
		shouldnt: [ repository objectNamed: '370101a2d57b40c37da9b42b688e61eb968f943e' ] "original blob"
		raise: Error.
	self 
		shouldnt: [ repository objectNamed: 'd8bf7c56584e5e2a7d51f27ea9eec36cc2695b72' ] "blob in second commit (delta)"
		raise: Error.
	self 
		shouldnt: [ repository objectNamed: '286064b187da14ddaab211e6579a225f179083e7' ] "blob in third commit (delta)"
		raise: Error! !

!PackFileTests methodsFor: 'verifying' stamp: 'MaxLeske 6/24/2012 19:21'!
verifyRefDeltaDeltification
	| baseObjectName position result |
	position := packReader position.
	self skipEntryHeader.
	baseObjectName := (packReader next: 20) hex.
	result := self verifyDeltificationWithBaseAt: (self packOffsetOf: baseObjectName).
	packReader position: position.
	^ result! !

!PackFileTests methodsFor: 'helpers-verifying' stamp: 'MaxLeske 6/24/2012 19:34'!
verifySizesWithOfsDelta
	self 
		assert: 214 
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 12)).
	self
		assert: 214
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 161)).
	self
		assert: 165
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 310)).
	self
		assert: 33
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 429)).
	self
		assert: 28977
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 473)).
	self
		assert: 33
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 705)).
	self
		assert: 15
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 749)).
	self
		assert: 33
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 776)).
	self
		assert: 8
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 820))! !

!PackFileTests methodsFor: 'helpers-verifying' stamp: 'MaxLeske 6/24/2012 19:32'!
verifySizesWithRefDelta
	self 
		assert: 214 
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 12)).
	self
		assert: 214
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 161)).
	self
		assert: 165
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 310)).
	self
		assert: 33
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 429)).
	self
		assert: 28977
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 473)).
	self
		assert: 33
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 705)).
	self
		assert: 15
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 749)).
	self
		assert: 33
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 794)).
	self
		assert: 8
		equals: (self getSizeFromHeaders: (self getEntryHeadersAt: 838))! !

!PackFileTests methodsFor: 'verifying' stamp: 'MaxLeske 6/27/2012 11:10'!
verifyUnpacking
	| files filenames |
	files := [ (filesystem root resolve: 'repo/.git/objects') allFiles ].
	self assert: files value size = 2.
	(GitPackFile on: packFile in: repository) unpack.
	self assert: files value size = 11.
	files := files value reject: [ :reference | 
		(reference basename endsWith: 'pack')
		or: [ reference basename endsWith: 'idx' ] ].
	
	filenames := #(
		'a21a7e0e910cf24f3c455cc6e0ea86d589a0db'
		'f6939ef44d5fadc3f537300b42e4b2889cc415'
		'022a3c03d87ef1487d282ad8c8c57941469417'
		'511757325072abacc21fc749c7000461dbc857'
		'0101a2d57b40c37da9b42b688e61eb968f943e'
		'564e36d46a682f13e716b6f5e13d94cd9461b7'
		'bf7c56584e5e2a7d51f27ea9eec36cc2695b72'
		'f6defb3f5b3e6d851165c8c38c18ba42b5649b'
		'6064b187da14ddaab211e6579a225f179083e7' ) asOrderedCollection.
	
	self assert: files size = 9.
	files do: [ :reference |
		self assert: (filenames includes: reference basename).
		filenames remove: reference basename ].
	self assert: filenames isEmpty! !

PackFileTests subclass: #PackIndexVersion1Tests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

!PackIndexVersion1Tests methodsFor: 'file contents' stamp: 'MaxLeske 6/27/2012 10:55'!
indexBytesWithRefDelta
	^  #[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 9 0 0 0 9 0 0 0 161 33 246 147 158 244 77 95 173 195 245 55 48 11 66 228 178 136 156 196 21 0 0 3 70 40 96 100 177 135 218 20 221 170 178 17 230 87 154 34 95 23 144 131 231 0 0 1 217 55 1 1 162 213 123 64 195 125 169 180 43 104 142 97 235 150 143 148 62 0 0 1 54 119 2 42 60 3 216 126 241 72 125 40 42 216 200 197 121 65 70 148 23 0 0 2 193 152 86 78 54 212 106 104 47 19 231 22 182 245 225 61 148 205 148 97 183 0 0 2 237 216 191 124 86 88 78 94 42 125 81 242 126 169 238 195 108 194 105 91 114 0 0 3 26 225 246 222 251 63 91 62 109 133 17 101 200 195 140 24 186 66 181 100 155 0 0 1 173 234 81 23 87 50 80 114 171 172 194 31 199 73 199 0 4 97 219 200 87 0 0 0 12 254 162 26 126 14 145 12 242 79 60 69 92 198 224 234 134 213 137 160 219 186 55 135 207 98 139 116 127 42 115 209 155 183 207 21 210 63 246 127 155 37 16 209 35 222 149 252 123 193 22 97 177 101 39 125 14 162 57 30 111]! !

!PackIndexVersion1Tests methodsFor: 'file contents' stamp: 'MaxLeske 6/26/2012 17:20'!
indexBytesWithTag
	^ #[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 10 0 0 0 10 0 0 0 161 33 246 147 158 244 77 95 173 195 245 55 48 11 66 228 178 136 156 196 21 0 0 3 107 37 244 63 69 16 113 221 138 108 243 154 204 213 7 13 136 93 228 176 23 0 0 3 70 40 96 100 177 135 218 20 221 170 178 17 230 87 154 34 95 23 144 131 231 0 0 1 217 55 1 1 162 213 123 64 195 125 169 180 43 104 142 97 235 150 143 148 62 0 0 1 54 119 2 42 60 3 216 126 241 72 125 40 42 216 200 197 121 65 70 148 23 0 0 2 193 152 86 78 54 212 106 104 47 19 231 22 182 245 225 61 148 205 148 97 183 0 0 2 237 216 191 124 86 88 78 94 42 125 81 242 126 169 238 195 108 194 105 91 114 0 0 3 26 225 246 222 251 63 91 62 109 133 17 101 200 195 140 24 186 66 181 100 155 0 0 1 173 234 81 23 87 50 80 114 171 172 194 31 199 73 199 0 4 97 219 200 87 0 0 0 12 254 162 26 126 14 145 12 242 79 60 69 92 198 224 234 134 213 137 160 219 48 240 65 115 56 0 100 65 207 154 113 222 24 245 40 194 116 66 83 167 176 68 163 37 148 76 108 44 119 43 80 84 243 243 27 33 219 107 175 244]! !

PackFileTests subclass: #PackIndexVersion2Tests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Tests'!

!PackIndexVersion2Tests methodsFor: 'file contents' stamp: 'MaxLeske 6/27/2012 10:28'!
indexBytesWithRefDelta
	^ #[255 116 79 99 0 0 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 9 0 0 0 9 33 246 147 158 244 77 95 173 195 245 55 48 11 66 228 178 136 156 196 21 40 96 100 177 135 218 20 221 170 178 17 230 87 154 34 95 23 144 131 231 55 1 1 162 213 123 64 195 125 169 180 43 104 142 97 235 150 143 148 62 119 2 42 60 3 216 126 241 72 125 40 42 216 200 197 121 65 70 148 23 152 86 78 54 212 106 104 47 19 231 22 182 245 225 61 148 205 148 97 183 216 191 124 86 88 78 94 42 125 81 242 126 169 238 195 108 194 105 91 114 225 246 222 251 63 91 62 109 133 17 101 200 195 140 24 186 66 181 100 155 234 81 23 87 50 80 114 171 172 194 31 199 73 199 0 4 97 219 200 87 254 162 26 126 14 145 12 242 79 60 69 92 198 224 234 134 213 137 160 219 183 188 38 35 205 236 7 179 209 7 171 227 64 117 68 253 170 20 123 41 129 10 32 104 94 156 124 250 196 26 250 52 48 37 249 109 0 0 0 161 0 0 3 70 0 0 1 217 0 0 1 54 0 0 2 193 0 0 2 237 0 0 3 26 0 0 1 173 0 0 0 12 186 55 135 207 98 139 116 127 42 115 209 155 183 207 21 210 63 246 127 155 32 129 183 53 182 202 246 131 141 151 241 229 42 129 80 88 101 205 117 166]! !

!PackIndexVersion2Tests methodsFor: 'file contents' stamp: 'MaxLeske 6/26/2012 17:21'!
indexBytesWithTag
	^  #[255 116 79 99 0 0 0 2 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 2 0 0 0 2 0 0 0 2 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 3 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 4 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 5 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 7 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 8 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 9 0 0 0 10 0 0 0 10 33 246 147 158 244 77 95 173 195 245 55 48 11 66 228 178 136 156 196 21 37 244 63 69 16 113 221 138 108 243 154 204 213 7 13 136 93 228 176 23 40 96 100 177 135 218 20 221 170 178 17 230 87 154 34 95 23 144 131 231 55 1 1 162 213 123 64 195 125 169 180 43 104 142 97 235 150 143 148 62 119 2 42 60 3 216 126 241 72 125 40 42 216 200 197 121 65 70 148 23 152 86 78 54 212 106 104 47 19 231 22 182 245 225 61 148 205 148 97 183 216 191 124 86 88 78 94 42 125 81 242 126 169 238 195 108 194 105 91 114 225 246 222 251 63 91 62 109 133 17 101 200 195 140 24 186 66 181 100 155 234 81 23 87 50 80 114 171 172 194 31 199 73 199 0 4 97 219 200 87 254 162 26 126 14 145 12 242 79 60 69 92 198 224 234 134 213 137 160 219 183 188 38 35 19 63 180 220 205 236 7 179 209 7 171 227 64 117 68 253 170 20 123 41 129 10 32 104 94 156 124 250 196 26 250 52 48 37 249 109 0 0 0 161 0 0 3 107 0 0 3 70 0 0 1 217 0 0 1 54 0 0 2 193 0 0 2 237 0 0 3 26 0 0 1 173 0 0 0 12 48 240 65 115 56 0 100 65 207 154 113 222 24 245 40 194 116 66 83 167 211 37 64 223 162 36 127 113 80 187 228 13 122 151 147 24 141 103 25 197]! !

!PackIndexVersion2Tests methodsFor: 'tests' stamp: 'MaxLeske 6/24/2012 19:19'!
testCRC
	"CRCs are only found in version 2 index files"
	self usePackWithOfsDelta.
	{ 
	'fea21a7e0e910cf24f3c455cc6e0ea86d589a0db' -> 12.
	'21f6939ef44d5fadc3f537300b42e4b2889cc415' -> 161.
	'77022a3c03d87ef1487d282ad8c8c57941469417' -> 310.
	'ea511757325072abacc21fc749c7000461dbc857' -> 429.
	'370101a2d57b40c37da9b42b688e61eb968f943e' -> 473.
	'98564e36d46a682f13e716b6f5e13d94cd9461b7' -> 705.
	'd8bf7c56584e5e2a7d51f27ea9eec36cc2695b72' -> 749.
	'e1f6defb3f5b3e6d851165c8c38c18ba42b5649b' -> 776.
	'286064b187da14ddaab211e6579a225f179083e7' -> 820 }
	do: [ :assoc | self verifyCRCFor: assoc key at: assoc value ]! !

!PackIndexVersion2Tests methodsFor: 'tests' stamp: 'MaxLeske 6/24/2012 19:51'!
testPackedObjectsDoWithOfsDelta
	self 
		usePackWithOfsDelta;
		verifyPackedObjectsDo! !

!PackIndexVersion2Tests methodsFor: 'tests' stamp: 'MaxLeske 6/24/2012 19:15'!
testUnpackingWithOfsDelta
	self 
		usePackWithOfsDelta;
		verifyUnpacking! !

!PackIndexVersion2Tests methodsFor: 'tests' stamp: 'MaxLeske 9/8/2012 19:19'!
testUnpackingWithoutIndexFileOfsDelta
	| pack |
	self usePackWithOfsDelta.
	indexFile delete.
	pack := GitPackFile on: packFile in: repository.
	pack unpack! !

!PackIndexVersion2Tests methodsFor: 'running' stamp: 'MaxLeske 6/24/2012 18:48'!
usePackWithOfsDelta
	packFile writeStreamDo: [ :stream |
		stream nextPutAll: self packBytesWithOfsDelta ].
	indexFile writeStreamDo: [ :stream |
		stream nextPutAll: self indexBytesWithOfsDelta ] ! !

!PackIndexVersion2Tests methodsFor: 'verifying' stamp: 'MaxLeske 6/24/2012 19:20'!
verifyCRCFor: hexHash at: offset
	| pack object index offsetFound |
	pack := GitPackFile on: packFile in: repository.
	index := pack indexFile indexForObjectNamed: hexHash.
	offsetFound := pack indexFile offsetForIndex: index.
	
	self assert: offsetFound equals: offset.
	object := pack objectAtOffset: offsetFound.
	self assert: object crc equals: (pack indexFile crcAt: index)! !

TestCase subclass: #MCGitWriterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Monticello-Tests'!

!MCGitWriterTest class methodsFor: 'history' stamp: 'CamilloBruni 8/1/2011 16:49'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #testMethodPathForClass; add: #testMethodPathForMetaClass; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 60559; instVarAt: 2 put: (Duration seconds: 7200 nanoSeconds: 0); instVarAt: 3 put: 2455775; instVarAt: 4 put: 0; yourself)); yourself)! !

!MCGitWriterTest methodsFor: 'tests' stamp: 'CamilloBruni 9/2/2012 11:16'!
testMethodPathForClass
	"Most basic test, just making sure that it does not raise errors"
	| writer |
	writer := MCGitWriter new.
	writer stream: (FileLocator imageDirectory).
	self shouldnt: [ writer methodPathFor: (Integer>>#even) methodReference ] raise: Error.  ! !

!MCGitWriterTest methodsFor: 'tests' stamp: 'CamilloBruni 9/1/2012 12:11'!
testMethodPathForMetaClass
	"Most basic test, just making sure that it does not raise errors"
	| writer |
	writer := MCGitWriter new.
	writer stream: (FileLocator imageDirectory).
	self shouldnt: [ writer methodPathFor: (Integer class>>#new) methodReference ] raise: Error.  ! !

Object subclass: #FileSystemGitRepository
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Core'!

!FileSystemGitRepository commentStamp: '<historical>' prior: 0!
I represent a git repository. Every message sent to me will return an FSGitFilesystem object or a collection of such objects.!

!FileSystemGitRepository class methodsFor: 'instance creation' stamp: 'MaxLeske 7/9/2010 15:10'!
on: anFSReference
	^ self new initializeOn: anFSReference! !

!FileSystemGitRepository methodsFor: 'accessing' stamp: 'CamilloBruni 7/13/2011 17:25'!
branchNamed: aString
	^ self filesystemOn: (repository branchNamed: aString)! !

!FileSystemGitRepository methodsFor: 'accessing' stamp: 'CamilloBruni 7/13/2011 17:23'!
branchNames
	^ repository branchNames! !

!FileSystemGitRepository methodsFor: 'accessing' stamp: 'CamilloBruni 7/15/2011 15:18'!
branches
	^ repository branches collect: [ :commit | 
		self filesystemOn: commit ]! !

!FileSystemGitRepository methodsFor: 'accessing' stamp: 'MaxLeske 8/12/2011 09:29'!
commitNamed: hexHash
	^ self filesystemOn: (repository objectNamed: hexHash)! !

!FileSystemGitRepository methodsFor: 'private' stamp: 'CamilloBruni 8/30/2012 14:06'!
filesystemOn: aGitCommit
	^ (GitFilesystem store: (self gitStoreOn: aGitCommit))
			repository: self;
			yourself! !

!FileSystemGitRepository methodsFor: 'private' stamp: 'CamilloBruni 9/2/2012 12:33'!
gitStoreOn: aGitCommit
	^ GitStore memory
		repository: repository;
		revision: aGitCommit;
		yourself! !

!FileSystemGitRepository methodsFor: 'accessing' stamp: 'CamilloBruni 9/2/2012 12:32'!
head
	^ self filesystemOn: (repository headIfAbsent: [ nil ])! !

!FileSystemGitRepository methodsFor: 'initialize-release' stamp: 'MaxLeske 7/23/2010 09:59'!
initializeOn: anFSReference
	repository := GitRepository on: anFSReference! !

!FileSystemGitRepository methodsFor: 'accessing' stamp: 'MaxLeske 8/25/2011 19:12'!
lastVersions: anInteger 
	| commits |
	commits := OrderedCollection new.
	self 
		recursivelyCollectCommits: repository head
		into: commits
		limit: anInteger.
	
	^ commits collect: [ :each |
		self filesystemOn: each ] ! !

!FileSystemGitRepository methodsFor: 'private' stamp: 'MaxLeske 8/25/2011 19:16'!
recursivelyCollectCommits: aCommit into: aCollection
	self
		recursivelyCollectCommits: aCommit
		into: aCollection
		limit: nil ! !

!FileSystemGitRepository methodsFor: 'private' stamp: 'CamilloBruni 9/3/2012 15:54'!
recursivelyCollectCommits: aCommit into: aCollection limit: anInteger
	anInteger notNil & anInteger = 0 ifTrue: [ ^ self ].
	
	self flag: 'TODO'.
	"aCommit isLoaded ifFalse: [ aCommit loadLazily ]."
	aCollection add: aCommit.
	aCommit parents do: [ :parent | 
		self 
			recursivelyCollectCommits: parent
			into: aCollection
			limit:
				(anInteger
					ifNil: [ nil ]
					ifNotNil: [ anInteger - 1 ]) ]! !

!FileSystemGitRepository methodsFor: 'initialize-release' stamp: 'CamilloBruni 6/22/2011 05:08'!
repository
	^ repository! !

!FileSystemGitRepository methodsFor: 'accessing' stamp: 'CamilloBruni 7/13/2011 17:25'!
tagNamed: aString
	^ self filesystemOn: (repository tagNamed: aString)! !

!FileSystemGitRepository methodsFor: 'accessing' stamp: 'MaxLeske 11/8/2010 17:24'!
tagNames
	^ repository tagNames! !

!FileSystemGitRepository methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 20:06'!
tags
	| tags |
	
	tags := Dictionary new.
	
	repository tags do: [ :tag | 
		tags at: tag put: (self filesystemOn: tag object) ].
	
	^ tags! !

!FileSystemGitRepository methodsFor: 'accessing' stamp: 'CamilloBruni 8/9/2011 16:58'!
validate
	^ 	repository validate! !

!FileSystemGitRepository methodsFor: 'accessing' stamp: 'MaxLeske 8/25/2011 19:16'!
versions
	| commits |
	commits := OrderedCollection new.
	self 
		recursivelyCollectCommits: repository head
		into: commits
		limit: nil.
	
	^ commits collect: [ :each |
		self filesystemOn: each ] ! !

Object subclass: #GitAbstractObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Core'!

!GitAbstractObject class methodsFor: 'testing' stamp: 'MaxLeske 9/8/2012 13:04'!
canDecode: anObject
	^ self isAbstract not 
		and: [ anObject = self byteTypeCode ] ! !

!GitAbstractObject class methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 12:58'!
decodeClassFrom: anObject
	^ self allSubclasses 
		detect: [ :class | class canDecode: anObject ]
		ifNone: [ GitInvalidObjectError signal: 'no class could decode ', anObject asString ]! !

!GitAbstractObject class methodsFor: 'testing' stamp: 'MaxLeske 9/8/2012 12:58'!
isAbstract
	^ self = GitAbstractObject! !

!GitAbstractObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 16:30'!
byteData
	^ GitStream streamContents:  [ :stream | self byteDataOn: stream ]! !

!GitAbstractObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 16:30'!
byteDataOn: aStream
	self storeOn: aStream! !

!GitAbstractObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 16:30'!
byteSignature
	^ GitStream streamContents: [ :stream | self byteSignatureOn: stream ]! !

!GitAbstractObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 16:30'!
byteSignatureOn: aStream
	| data |
	data := self byteData.
	"format for object hash (see manual -> 'Object storage format'):
	<ascii type without space> + <space> + <ascii decimal size> + <byte\0> + <binary object data>"
	aStream
		nextPutAll: self typeCode;
		space;
		nextPutAll: data size asString; "ASCII value for $0 is not 0 but 48!!"
		nullByte;
		nextPutAll: data! !

!GitAbstractObject methodsFor: 'storing' stamp: 'MaxLeske 9/8/2012 16:34'!
compressedForPack
	^ GitStream streamContents: [ :stream | self compressedForPackOn: stream ]! !

!GitAbstractObject methodsFor: 'storing' stamp: 'MaxLeske 9/8/2012 16:34'!
compressedForPackOn: aStream
	<todo: 'use commented code once memory filesystems return a stream that respects the binary setting'>
	"| zip |
	zip := ZLibWriteStream on: aStream.
	[ self byteDataOn: zip ]
		ensure: [ zip close ]"
	
	| zip |
	zip := ZLibWriteStream on: ByteArray new.
	[ self byteDataOn: zip ]
		ensure: [ zip close ].
		
	aStream nextPutAll: zip encodedStream contents! !

!GitAbstractObject methodsFor: 'storing' stamp: 'MaxLeske 9/8/2012 16:34'!
compressedOn: aStream
	<todo: 'use commented code once memory filesystems return a stream that respects the binary setting'>
	"| zip |
	zip := ZLibWriteStream on: aStream.
	[ self byteSignatureOn: zip ]
		ensure: [ zip close ]"
	
	| zip |
	zip := ZLibWriteStream on: ByteArray new.
	[ zip nextPutAll: (GitStream streamContents: [ :stream | self byteSignatureOn: stream ]) ]
		ensure: [ zip close ].
		
	aStream nextPutAll: zip encodedStream contents! !

GitAbstractObject subclass: #GitObject
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Core'!

!GitObject commentStamp: '<historical>' prior: 0!
I am an abstract object that defines messages to which every object (in git speak) responds.

Instance Variables:
	repository <GitRepository>
		A private variable that a GitObject uses to lazily load itself!

!GitObject class methodsFor: 'initialize-release' stamp: 'MaxLeske 9/8/2012 12:58'!
in: aGitRepository
	^ self new initializeOn: aGitRepository; yourself! !

!GitObject class methodsFor: 'testing' stamp: 'MaxLeske 2/29/2012 15:13'!
isAbstract
	^ self = GitObject! !

!GitObject methodsFor: 'visiting' stamp: 'CamilloBruni 6/21/2011 06:13'!
accept: aVisitor
	self subclassResponsibility! !

!GitObject methodsFor: 'initialize-release' stamp: 'MaxLeske 7/24/2010 17:21'!
initializeOn: aGitRepository
	repository := aGitRepository! !

!GitObject methodsFor: 'testing' stamp: 'CamilloBruni 7/15/2011 19:22'!
isTree
	^ false! !

!GitObject methodsFor: 'initialize-release' stamp: 'MaxLeske 7/23/2010 14:52'!
loadFrom: aStream
"This method implements the loading of a GitObject from a stored byte sequence."

	self subclassResponsibility! !

!GitObject methodsFor: 'public-accessing' stamp: 'MaxLeske 6/30/2010 14:24'!
repository
	^repository! !

!GitObject methodsFor: 'public-accessing' stamp: 'MaxLeske 6/30/2010 14:24'!
repository: aGitRepository
	repository := aGitRepository! !

!GitObject methodsFor: 'public-testing' stamp: 'MaxLeske 6/24/2012 12:10'!
size
	| stream |
	stream := GitStream new.
	self storeOn: stream.
	^ stream size! !

!GitObject methodsFor: 'storing' stamp: 'MaxLeske 6/24/2012 11:17'!
storeOn: aStream
"This method defines the byte sequence for the signature calculation (GitObjectSignature) and also the content of a particular object that is stored in the repository."

	self subclassResponsibility! !

!GitObject methodsFor: 'validation' stamp: 'CamilloBruni 6/21/2011 06:16'!
validate! !

GitObject subclass: #GitStorableObject
	instanceVariableNames: 'integerHash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Core'!

!GitStorableObject commentStamp: '<historical>' prior: 0!
I am an abstract class defining common messages to which all object (in git speak) respond that can actually be stored, i.e. commits, trees, tags, blobs.

Instance Variables:
	signature	<GitObjectSignature>
		Lazily loaded signature of the object. See class comment for GitObjectSignature.!

GitStorableObject subclass: #GitBlob
	instanceVariableNames: 'bytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Core'!

!GitBlob commentStamp: '<historical>' prior: 0!
I am the git object responsible for storing content. I do not know or care what data I hold.

Instance Variables:
	bytes	<ByteArray>
		The contents I hold, stored in a ByteArray.!

!GitBlob class methodsFor: 'accessing' stamp: 'MaxLeske 2/29/2012 14:25'!
byteTypeCode
	^ 2r00110000! !

!GitBlob class methodsFor: 'instance creation' stamp: 'MaxLeske 2/28/2012 16:28'!
bytes: aByteArray in: aRepository
	^ self new 
		bytes: aByteArray asByteArray;
		repository: aRepository;
		yourself! !

!GitBlob class methodsFor: 'accessing' stamp: 'tonyg 2/22/2010 07:19'!
typeCode
	^ 'blob'! !

!GitBlob methodsFor: 'visiting' stamp: 'MaxLeske 8/12/2012 11:23'!
accept: aVisitor
	aVisitor visitBlob: self! !

!GitBlob methodsFor: 'public-accessing' stamp: 'MaxLeske 7/23/2010 14:56'!
bytes
"Answers the contents of a blob object."

	^ bytes! !

!GitBlob methodsFor: 'public-accessing' stamp: 'MaxLeske 2/28/2012 16:26'!
bytes: aByteArray
	bytes := aByteArray! !

!GitBlob methodsFor: 'initialize-release' stamp: 'MaxLeske 2/28/2012 16:26'!
loadFrom: aStream
	bytes := aStream contents.
	^ self! !

!GitBlob methodsFor: 'storing' stamp: 'MaxLeske 6/24/2012 11:17'!
storeOn: aStream
	aStream nextPutAll: bytes! !

!GitStorableObject class methodsFor: 'accessing' stamp: 'MaxLeske 2/29/2012 14:25'!
byteTypeCode
	"001 - OBJ_COMMIT
	010 - OBJ_TREE
	011 - OBJ_BLOB
	100 - OBJ_TAG
	110 - OBJ_OFS_DELT (new packfile format)
	111 - OBJ_REF_DELTA (old packfile format)"
	self subclassResponsibility! !

!GitStorableObject class methodsFor: 'testing' stamp: 'MaxLeske 9/5/2012 07:59'!
canDecode: anObject
	^ self isAbstract not 
		and: [ anObject = self typeCode
		or: [ anObject = self byteTypeCode ] ]! !

!GitStorableObject class methodsFor: 'initialize-release' stamp: 'MaxLeske 9/4/2012 21:46'!
forType: aString
	^ self decodeClassFrom: aString! !

!GitStorableObject class methodsFor: 'initialize-release' stamp: 'MaxLeske 7/1/2012 19:35'!
fromLooseObjectStream: aStream in: aGitRepository
	| code length limitedStream object |
	code := (aStream upTo: Character space asInteger) asString.
	length := (aStream upTo: 0) asString asInteger.
	limitedStream := ReadStream on: (aStream next: length).
	object := (self forType: code) in: aGitRepository.
	^object loadFrom: limitedStream! !

!GitStorableObject class methodsFor: 'initialize-release' stamp: 'MaxLeske 9/4/2012 21:38'!
fromPackedObjectStream: aStream type: byteTypeCode in: aRepository
	| class |
	class := self decodeClassFrom: byteTypeCode.
	^ (class in: aRepository) loadFrom: aStream! !

!GitStorableObject class methodsFor: 'initialize-release' stamp: 'MaxLeske 2/28/2012 15:13'!
named: aHexHash in: aRepository
	^ self 
		fromStream: (aRepository streamObjectNamed: aHexHash)
		inRepository: aRepository! !

!GitStorableObject class methodsFor: 'accessing' stamp: 'MaxLeske 2/29/2012 14:22'!
typeCode
	self subclassResponsibility! !

!GitStorableObject methodsFor: 'comparing' stamp: 'MaxLeske 2/28/2012 11:07'!
= other
	^ self hash = other hash! !

!GitStorableObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 18:29'!
byteTypeCode
	^ self class byteTypeCode! !

!GitStorableObject methodsFor: 'accessing' stamp: 'MaxLeske 8/29/2012 14:39'!
crc
	^ CRC crc32FromCollection: self compressedForPack! !

!GitStorableObject methodsFor: 'comparing' stamp: 'MaxLeske 9/2/2012 12:17'!
hash
	^ integerHash ifNil: [ 
		integerHash := (GitHash from: self byteSignature) hash ]! !

!GitStorableObject methodsFor: 'public-accessing' stamp: 'MaxLeske 2/27/2012 21:43'!
hexHash
	^ self hash asHexHash! !

!GitStorableObject methodsFor: 'public-storing' stamp: 'MaxLeske 2/28/2012 18:59'!
store
	self repository storeObject: self! !

!GitStorableObject methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 15:47'!
typeCode
	^ self class typeCode! !

GitStorableObject subclass: #GitTaglikeObject
	instanceVariableNames: 'message properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Core'!

!GitTaglikeObject commentStamp: '<historical>' prior: 0!
I am an abstract class defining common protocol for git objects that behave like tags.

Instance Variables:
	message	<String>
		Holds the message of the tag like object, if used.
	properties	<(Collection of: (Association of: String -> ByteArray))>
		Holds arbitrary key value pairs not specified by git that can be used by applications to store additional data.!

GitTaglikeObject subclass: #GitCommit
	instanceVariableNames: 'tree parents author committer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Core'!

!GitCommit commentStamp: '<historical>' prior: 0!
I represent the state of a git repository in time. It is mandatory to provide me with a message describing the changes.

Instance Variables:
	tree	<GitTree>
		Holds a tree representing the root of the repository.
	parents	<Collection of: GitCommit>
		Holds a collection of parent commits. A parent commit represents 
		the state the repository was in when the changes occurred that led to the current commit.
		In case of a merge it is possible for a commit to have more than one parent.
	author	<GitStamp>
		Denotes the author of the content committed.
	committer	<GitStamp>
		Denotes the committer of the commit. The committer might be a different
		person than the author.!

!GitCommit class methodsFor: 'accessing' stamp: 'MaxLeske 2/29/2012 14:26'!
byteTypeCode
	^ 2r00010000! !

!GitCommit class methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 22:21'!
typeCode
	^ 'commit'! !

!GitCommit class methodsFor: 'instance creation' stamp: 'MaxLeske 7/24/2010 17:18'!
withDefaultStamps
	| s |
	s := GitStamp now.
	^ self new 
		author: s;
		committer: s;
		yourself! !

!GitCommit class methodsFor: 'instance creation' stamp: 'CamilloBruni 9/3/2012 18:59'!
withTree: aGitTree message: aString author: aGitStampForAuthor committer: aGitStampForCommitter in: aRepository
	^self new
		tree: aGitTree;
		message: aString;
		author: aGitStampForAuthor;
		committer: aGitStampForCommitter;
		repository: aRepository;
		yourself! !

!GitCommit methodsFor: 'visiting' stamp: 'MaxLeske 8/13/2012 21:53'!
accept: aVisitor
	aVisitor visitCommit: self! !

!GitCommit methodsFor: 'public-accessing' stamp: 'MaxLeske 2/28/2012 11:11'!
author
	^ author! !

!GitCommit methodsFor: 'public-accessing' stamp: 'MaxLeske 5/26/2010 19:52'!
author: aGitStamp
	author := aGitStamp! !

!GitCommit methodsFor: 'private' stamp: 'MaxLeske 2/26/2012 11:29'!
basicParents 
	^ parents ifNil: [ parents := OrderedCollection new ]! !

!GitCommit methodsFor: 'public-accessing' stamp: 'MaxLeske 2/28/2012 11:12'!
committer
	^ committer! !

!GitCommit methodsFor: 'public-accessing' stamp: 'MaxLeske 5/26/2010 19:51'!
committer: aGitStamp
	committer := aGitStamp! !

!GitCommit methodsFor: 'initialize-release' stamp: 'MaxLeske 2/27/2012 21:47'!
initialize
	super initialize.
	parents  := OrderedCollection new.
	message := ''.
	parents := OrderedCollection new! !

!GitCommit methodsFor: 'loading' stamp: 'MaxLeske 2/26/2012 10:20'!
loadAuthor: aString
	self author: (GitStamp fromString: aString)! !

!GitCommit methodsFor: 'loading' stamp: 'MaxLeske 2/26/2012 10:20'!
loadCommitter: aString
	self committer: (GitStamp fromString: aString)! !

!GitCommit methodsFor: 'loading' stamp: 'MaxLeske 2/26/2012 11:27'!
loadParent: aHexHash
	self basicParents add: aHexHash! !

!GitCommit methodsFor: 'loading' stamp: 'MaxLeske 2/26/2012 11:28'!
loadParents
	^ self basicParents collect: [ :parentHash |
		self repository objectNamed: parentHash ]! !

!GitCommit methodsFor: 'loading' stamp: 'MaxLeske 2/26/2012 11:24'!
loadTree: aHexHash
	self tree: (self repository objectNamed: aHexHash)
	! !

!GitCommit methodsFor: 'public-accessing' stamp: 'MaxLeske 2/26/2012 11:28'!
parents
	^ self loadParents! !

!GitCommit methodsFor: 'public-accessing' stamp: 'MaxLeske 5/26/2010 20:04'!
parents: aGitCommitCollection
	^ parents := aGitCommitCollection! !

!GitCommit methodsFor: 'printing' stamp: 'CamilloBruni 6/22/2011 04:33'!
printOn: aStream
	super printOn: aStream.
	self message
		ifNotNilDo: [ :msg|
			aStream
				nextPutAll: '(''';
				nextPutAll: msg;
				nextPutAll: ''')' ]! !

!GitCommit methodsFor: 'storing' stamp: 'MaxLeske 6/24/2012 11:15'!
storeFixedKeysOn: aStream
	"Looking at builtin-commit-tree.c, the order of properties is fixed:
	tree, parents, author, committer, everything else, message."
	self saveKey: GitTree typeCode value: tree hexHash to: aStream.
	self basicParents do: [ :parentHash | self saveKey: 'parent' value: parentHash to: aStream].
	self saveKey: 'author' value: author printString to: aStream.
	self saveKey: 'committer' value: committer printString to: aStream.! !

!GitCommit methodsFor: 'public-accessing' stamp: 'MaxLeske 6/24/2012 11:10'!
tags
	^ self tagsInRepository: repository! !

!GitCommit methodsFor: 'public-accessing' stamp: 'MaxLeske 6/24/2012 11:10'!
tagsInRepository: aGitRepos
	^ aGitRepos tags select: [ :tag | tag object = self ]! !

!GitCommit methodsFor: 'public-accessing' stamp: 'MaxLeske 2/28/2012 11:12'!
tree
	^ tree! !

!GitCommit methodsFor: 'public-accessing' stamp: 'MaxLeske 5/26/2010 19:49'!
tree: aGitTree
	tree := aGitTree! !

!GitCommit methodsFor: 'private' stamp: 'MaxLeske 2/26/2012 10:14'!
validKeys
	^ #(
		tree
		parent
		author
		committer)! !

!GitCommit methodsFor: 'validating' stamp: 'MaxLeske 9/4/2012 21:14'!
validate
	super validate.
	tree ifNil: [ GitInvalidObjectError signal: 'Cannot have a commit without a tree.' ].
	tree class = GitTree ifFalse: [ GitInvalidObjectError signal: 'The tree of this commit object is not of class GitTree.' ].
	author ifNil: [ GitInvalidObjectError signal: 'Author identity is required.' ].
	committer ifNil: [ GitInvalidObjectError signal: 'Committer identity is required.' ]! !

GitTaglikeObject subclass: #GitTag
	instanceVariableNames: 'tagger object name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Core'!

!GitTag commentStamp: '<historical>' prior: 0!
I have the responsibility of associating a human readable tag (a string) with a commit, e.g. 'version 0.5' -> '2341f8c0615bbcc465ac4686025e880786430697'. Since I am a full tag and can hold additional information, the tag ref points to my object name and I in turn point to the commit.

Full tags have the advantage of knowing the tagger (and the date of tagging) and can hold a message (e.g. a PGP signature).
I incorporate both possibilities.

Instance Variables:
	message (inherited)	<String>
		arbitrary message (e.g. comment or PGP signature)
	tagger	<GitStamp>
		Who created the tag.
	object	<GitCommit>
		The commit referenced by the tag name.
	name	<String>
		The human readable tag (or tag name) that describes the referenced commit.!

GitTag subclass: #GitLightweightTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Core'!

!GitLightweightTag commentStamp: '<historical>' prior: 0!
I have the responsibility of associating a human readable tag (a string) with a commit, e.g. 'version 0.5' -> '2341f8c0615bbcc465ac4686025e880786430697'. In contrast to a full tag the tag ref references a commit directly

Instance Variables:
	object	<GitCommit>
		The commit referenced by the tag name.
	name	<String>
		The human readable tag (or tag name) that describes the referenced commit.!

!GitLightweightTag class methodsFor: 'instance creation' stamp: 'MaxLeske 9/4/2012 22:08'!
named: aString for: aGitCommit in: aGitRepository
	^ self new
		name: aString;
		object: aGitCommit;
		repository: aGitRepository;
		store;
		yourself! !

!GitLightweightTag methodsFor: 'comparing' stamp: 'MaxLeske 9/4/2012 20:52'!
hash
	^ self name asByteArray asInteger bitXor: self object hash! !

!GitLightweightTag methodsFor: 'public-testing' stamp: 'MaxLeske 9/4/2012 20:53'!
isLightWeightTag
	^ true! !

!GitLightweightTag methodsFor: 'storing' stamp: 'MaxLeske 9/4/2012 21:01'!
store
	self updateTagRef! !

!GitLightweightTag methodsFor: 'storing' stamp: 'MaxLeske 9/4/2012 21:00'!
updateTagRef
	self repository 
		updateRef: self repository tagsDir / self name 
		to: self object hexHash! !

!GitLightweightTag methodsFor: 'validating' stamp: 'MaxLeske 9/4/2012 21:17'!
validateMessage 
	^ self! !

!GitLightweightTag methodsFor: 'validating' stamp: 'MaxLeske 9/4/2012 21:16'!
validateTagger
	^ self! !

!GitTag class methodsFor: 'accessing' stamp: 'MaxLeske 2/29/2012 14:26'!
byteTypeCode
	^ 2r01000000! !

!GitTag class methodsFor: 'instance creation' stamp: 'MaxLeske 9/4/2012 22:11'!
named: tagName for: aGitCommit message: message in: aGitRepository
	^ self
		named: tagName 
		for: aGitCommit
		message: message 
		tagger: GitStamp now
		in: aGitRepository ! !

!GitTag class methodsFor: 'instance creation' stamp: 'MaxLeske 9/4/2012 22:12'!
named: tagName for: aGitCommit message: message tagger: aGitStamp in: aGitRepository
	^ self new
		name: tagName;
		object: aGitCommit;
		message: message;
		tagger: aGitStamp;
		repository: aGitRepository;
		store;
		yourself! !

!GitTag class methodsFor: 'accessing' stamp: 'tonyg 2/25/2010 16:16'!
typeCode
	^ 'tag'! !

!GitTag methodsFor: 'visiting' stamp: 'MaxLeske 8/13/2012 21:54'!
accept: aVisitor
	aVisitor visitTag: self! !

!GitTag methodsFor: 'public-testing' stamp: 'MaxLeske 9/4/2012 20:52'!
isLightWeightTag
	^ false! !

!GitTag methodsFor: 'loading' stamp: 'MaxLeske 2/28/2012 18:46'!
loadObject: aHexHash
	self object: (self repository objectNamed: aHexHash)! !

!GitTag methodsFor: 'loading' stamp: 'MaxLeske 2/26/2012 10:32'!
loadTag: aString
	self name: aString! !

!GitTag methodsFor: 'loading' stamp: 'MaxLeske 2/26/2012 10:33'!
loadTagger: aString
	self tagger: (GitStamp fromString: aString)! !

!GitTag methodsFor: 'loading' stamp: 'MaxLeske 6/24/2012 13:31'!
loadType: aString
	self object typeCode = aString ifFalse: [ 
		GitInvalidObjectError signal: 'This tag points to an object which is of',
			' a different type than the tag expected',
			' (e.g. the real object is of type commit but the tag says it''s a tree).' ]! !

!GitTag methodsFor: 'public-accessing' stamp: 'MaxLeske 6/30/2010 15:11'!
name
	^ name! !

!GitTag methodsFor: 'public-accessing' stamp: 'MaxLeske 6/30/2010 13:59'!
name: aString
	name := aString! !

!GitTag methodsFor: 'public-accessing' stamp: 'MaxLeske 8/12/2011 08:29'!
object
	^ object! !

!GitTag methodsFor: 'public-accessing' stamp: 'MaxLeske 6/30/2010 14:01'!
object: aGitCommit
	self assert: aGitCommit species = GitCommit.
	object := aGitCommit! !

!GitTag methodsFor: 'printing' stamp: 'MaxLeske 8/12/2011 08:43'!
printOn: aStream
	super printOn: aStream.
	aStream
		<< '("';
		<< self name;
		<< '")'! !

!GitTag methodsFor: 'storing' stamp: 'MaxLeske 9/4/2012 20:59'!
store
	super store.
	self updateTagRef! !

!GitTag methodsFor: 'storing' stamp: 'MaxLeske 6/24/2012 11:15'!
storeFixedKeysOn: aStream
	"From builtin-mktag.c:
	A signature file has a very simple fixed format: four lines
	of ""object <sha1>"" + ""type <typename>"" + ""tag <tagname>"" +
	""tagger <committer>"", followed by a blank line, a free-form tag
	message and a signature block that git itself doesn't care about,
	but that can be verified with gpg or similar."
	self saveKey: 'object' value: self object hexHash to: aStream.
	self saveKey: 'type' value: self object typeCode to: aStream.
	self saveKey: 'tag' value: self name to: aStream.
	self saveKey: 'tagger' value: self tagger printString to: aStream.! !

!GitTag methodsFor: 'public-accessing' stamp: 'tonyg 2/25/2010 16:30'!
tagger
	^ tagger! !

!GitTag methodsFor: 'public-accessing' stamp: 'MaxLeske 6/30/2010 14:00'!
tagger: aGitStamp
	self assert: aGitStamp species = GitStamp.
	tagger := aGitStamp! !

!GitTag methodsFor: 'storing' stamp: 'MaxLeske 9/4/2012 21:00'!
updateTagRef
	self repository 
		updateRef: self repository tagsDir / self name 
		to: self hexHash! !

!GitTag methodsFor: 'private' stamp: 'MaxLeske 2/26/2012 10:30'!
validKeys
	^ #(
		object
		type
		tag
		tagger)! !

!GitTag methodsFor: 'validating' stamp: 'MaxLeske 9/4/2012 21:10'!
validate
	self 
		validateName;
		validateObject;
		validateTagger;
		validateMessage! !

!GitTag methodsFor: 'validating' stamp: 'MaxLeske 9/4/2012 21:59'!
validateName
	self name ifNotNil: [ ^ self ].
	
	GitInvalidObjectError signal: 'Tag name is required.' ! !

!GitTag methodsFor: 'validating' stamp: 'MaxLeske 9/4/2012 21:15'!
validateObject
	self object ifNotNil: [ ^ self  ].
	
	GitInvalidObjectError signal: 'Cannot have a tag without a tagged object.'! !

!GitTag methodsFor: 'validating' stamp: 'MaxLeske 9/4/2012 21:16'!
validateTagger
	self tagger ifNotNil: [ ^ self ].
	
	GitInvalidObjectError signal: 'Tagger identity is required for full tags.' ! !

!GitTaglikeObject class methodsFor: 'testing' stamp: 'MaxLeske 9/4/2012 21:55'!
isAbstract
	^ self = GitTaglikeObject! !

!GitTaglikeObject methodsFor: 'testing' stamp: 'MaxLeske 2/26/2012 10:29'!
isKeyValid: aString
	^ self validKeys includes: aString! !

!GitTaglikeObject methodsFor: 'initialize-release' stamp: 'MaxLeske 2/29/2012 16:03'!
loadFrom: aStream
	| key value |
	[ aStream peek = Character lf asInteger ] whileFalse: [
		key := (aStream upTo: Character space asInteger) asString.
		value := (aStream upTo: Character lf asInteger) asString.
		self loadKey: key value: value].
	aStream next.
	message := aStream upToEnd asString.
	^self
! !

!GitTaglikeObject methodsFor: 'loading' stamp: 'MaxLeske 2/26/2012 10:28'!
loadKey: key value: value
	(self isKeyValid: key) ifTrue: [ ^ self loadValidKey: key value: value ].
	self properties at: key put: value! !

!GitTaglikeObject methodsFor: 'loading' stamp: 'MaxLeske 2/26/2012 11:24'!
loadValidKey: key value: value
	| selector |
	selector := ('load', (key asIdentifier: true)) asSymbol asMutator.
	self perform: selector with: value! !

!GitTaglikeObject methodsFor: 'public-accessing' stamp: 'tonyg 2/25/2010 16:22'!
message
	^ message! !

!GitTaglikeObject methodsFor: 'public-accessing' stamp: 'tonyg 2/25/2010 16:22'!
message: aString
	message := aString! !

!GitTaglikeObject methodsFor: 'public-accessing' stamp: 'MaxLeske 2/27/2012 21:46'!
properties
	^ properties ifNil: [ properties := Dictionary new ]! !

!GitTaglikeObject methodsFor: 'public-accessing' stamp: 'tonyg 2/25/2010 16:23'!
properties: anObject
	^ properties := anObject! !

!GitTaglikeObject methodsFor: 'storing' stamp: 'MaxLeske 9/8/2012 16:12'!
saveKey: key value: value to: aStream
	aStream 
		nextPutAll: key asByteArray; 
		nextPut: Character space asInteger; 
		nextPutAll: value asByteArray; 
		nextPut: Character lf asInteger! !

!GitTaglikeObject methodsFor: 'storing' stamp: 'MaxLeske 6/24/2012 11:15'!
storeFixedKeysOn: aStream
	self subclassResponsibility! !

!GitTaglikeObject methodsFor: 'storing' stamp: 'MaxLeske 9/8/2012 16:12'!
storeOn: aStream
	self validate.
	self storeFixedKeysOn: aStream.
	properties ifNotNil: [ properties keysAndValuesDo: [ :key :value |
		self saveKey: key value: value to: aStream ] ].
	aStream 
		nextPut: Character lf asInteger;
		nextPutAll: message! !

!GitTaglikeObject methodsFor: 'private' stamp: 'MaxLeske 2/26/2012 10:30'!
validKeys
	self subclassResponsibility! !

!GitTaglikeObject methodsFor: 'validating' stamp: 'MaxLeske 9/4/2012 21:12'!
validate
	super validate.
	self validateMessage! !

!GitTaglikeObject methodsFor: 'validating' stamp: 'MaxLeske 9/4/2012 21:13'!
validateMessage
	message ifNotNil: [ ^ self  ].
	
	GitValidationError signal: 'Message is required for validation.'! !

GitStorableObject subclass: #GitTree
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Core'!

!GitTree commentStamp: '<historical>' prior: 0!
I represent a node in a git repository that can contain child nodes (mostly I simply represent a directory).

Instance Variables:
	entries	<aCollection of: GitTreeEntry>
		Holds references to all the child nodes together with some 
		additional information (see the class comment for GitTreeEntry).!

!GitTree class methodsFor: 'accessing' stamp: 'MaxLeske 2/29/2012 14:27'!
byteTypeCode
	^ 2r00100000! !

!GitTree class methodsFor: 'accessing' stamp: 'MaxLeske 2/28/2012 16:28'!
entries: aCollection in: aRepository
	^ self new 
		entries: aCollection;
		repository: aRepository;
		yourself! !

!GitTree class methodsFor: 'accessing' stamp: 'tonyg 2/22/2010 07:17'!
typeCode
	^ 'tree'! !

!GitTree methodsFor: 'visiting' stamp: 'MaxLeske 8/13/2012 22:15'!
accept: aVisitor
	aVisitor visitTree: self! !

!GitTree methodsFor: 'accessing' stamp: 'MaxLeske 2/28/2012 18:09'!
at: aName
	^ (self entryAt: aName) object! !

!GitTree methodsFor: 'public-accessing' stamp: 'MaxLeske 6/26/2010 22:28'!
entries
	^ entries ifNil: [Dictionary new]! !

!GitTree methodsFor: 'public-accessing' stamp: 'MaxLeske 6/24/2012 11:00'!
entries: aCollection
	aCollection do: [ :each | self putEntry: each ]! !

!GitTree methodsFor: 'public-accessing' stamp: 'tonyg 2/23/2010 19:10'!
entryAt: aName
	^ entries at: aName! !

!GitTree methodsFor: 'public-accessing' stamp: 'MaxLeske 10/11/2010 23:14'!
entryAt: aName ifAbsent: aBlock
	^ entries 
		at: aName
		ifAbsent: aBlock! !

!GitTree methodsFor: 'public-accessing' stamp: 'MaxLeske 10/18/2010 09:46'!
entryAt: aName ifPresent: presentBlock ifAbsent: absentBlock
	^ entries 
		at: aName
		ifPresent: presentBlock
		ifAbsent: absentBlock! !

!GitTree methodsFor: 'initialize-release' stamp: 'tonyg 2/23/2010 20:18'!
initialize
	super initialize.
	entries := Dictionary new.! !

!GitTree methodsFor: 'public-testing' stamp: 'MaxLeske 6/24/2012 09:51'!
isEmpty
	^ self size isZero! !

!GitTree methodsFor: 'public-testing' stamp: 'CamilloBruni 7/15/2011 19:22'!
isTree
	^ true! !

!GitTree methodsFor: 'initialize-release' stamp: 'MaxLeske 6/24/2012 11:01'!
loadFrom: aStream
	[ aStream atEnd ] whileFalse: [ | entry |
		entry := (GitTreeEntry in: repository) loadFrom: aStream.
		self putEntry: entry ].
	^ self! !

!GitTree methodsFor: 'public-accessing' stamp: 'MaxLeske 6/24/2012 10:57'!
objects
	^ entries collect: [ :entry | entry object ]! !

!GitTree methodsFor: 'printing' stamp: 'CamilloBruni 7/5/2011 16:54'!
printOn: aStream
	super printOn: aStream.
	aStream << '( '.
	entries keys 
		do: [ :name| aStream << name]
		separatedBy: [ aStream << ', '].
	aStream << ' )'! !

!GitTree methodsFor: 'public-adding' stamp: 'MaxLeske 7/10/2010 10:17'!
putEntry: anEntry
	entries at: anEntry entryName put: anEntry! !

!GitTree methodsFor: 'public-removing' stamp: 'tonyg 2/23/2010 19:14'!
removeEntryAt: aFileName
	entries removeKey: aFileName! !

!GitTree methodsFor: 'public-removing' stamp: 'CamilloBruni 5/17/2011 18:42'!
removeEntryAt: aFileName ifAbsent: aBlock
	entries removeKey: aFileName ifAbsent: aBlock! !

!GitTree methodsFor: 'public-testing' stamp: 'MaxLeske 6/8/2010 22:36'!
size
	| total |
	total := 0.
	self entries do: [:each | total := total + (each size)].
	^total! !

!GitTree methodsFor: 'storing' stamp: 'MaxLeske 6/24/2012 11:17'!
storeOn: aStream
	entries values sorted do: [ :entry | 
		entry storeOn: aStream ]! !

!GitTree methodsFor: 'validation' stamp: 'MaxLeske 2/28/2012 20:02'!
validate
	super validate.
	self entries do: [:entry| entry validate].! !

GitObject subclass: #GitTreeEntry
	instanceVariableNames: 'entryName entryHash isInFilemode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Core'!

!GitTreeEntry commentStamp: '<historical>' prior: 0!
I represent an entry for a child node of a GitTree. I provide additionally information about the object (either another tree or a blob) I reference.

Instance Variables:
	mode	<Integer>
		Octal representation of the type of entry ('chmod' bit settings).
		The mode for newly created objects is either that of 'self fileMode' or 'self dirMode'.
		Loaded entries may have a varying bit sequence because git only pays attention
		to the executable bit.
	objectSignature	<GitObjectSignature>
		The signature of the object referenced.
	entryName	<String>
		'Physical' name of the entry. On a filesystem this would be the name of the
		file or directory.!

!GitTreeEntry class methodsFor: 'public' stamp: 'MaxLeske 6/23/2010 19:10'!
dirMode
	^8r040000! !

!GitTreeEntry class methodsFor: 'instance creation' stamp: 'CamilloBruni 9/3/2012 17:29'!
directoryNamed: aString hash: integerHash in: aRepository
	^ self new
		entryName: aString;
		entryHash: integerHash;
		repository: aRepository;
		beInDirectorymode;
		yourself! !

!GitTreeEntry class methodsFor: 'public' stamp: 'MaxLeske 6/23/2010 19:13'!
fileMode
	^8r100644! !

!GitTreeEntry class methodsFor: 'instance creation' stamp: 'CamilloBruni 9/3/2012 17:29'!
fileNamed: aString hash: integerHash in: aRepository
	^ self new
		entryName: aString;
		entryHash: integerHash;
		repository: aRepository;
		beInFilemode;
		yourself! !

!GitTreeEntry class methodsFor: 'public' stamp: 'MaxLeske 7/21/2010 18:59'!
modeFor: aReference
	^ aReference isDirectory 
		ifTrue: [ self dirMode ]
		ifFalse: [ self fileMode ]! !

!GitTreeEntry class methodsFor: 'printing' stamp: 'MaxLeske 7/10/2010 11:10'!
printMode: octalMode
	^octalMode printStringBase: 8! !

!GitTreeEntry methodsFor: 'comparing' stamp: 'MaxLeske 7/24/2010 17:04'!
<= other
	"For sorting reasons, directories are compared
	with a virtual slash appended."
	| myTail otherTail |
	myTail := otherTail := ''.
	self mode = (self class dirMode)
		ifTrue: [ myTail := '/' ].
	other mode = (self class dirMode)
		ifTrue: [otherTail := '/' ].
	
	^ self entryName, myTail <= (other entryName, otherTail)! !

!GitTreeEntry methodsFor: 'comparing' stamp: 'MaxLeske 2/27/2012 21:31'!
= other
	^ other class = self class and: [
		other entryHash = self entryHash ]! !

!GitTreeEntry methodsFor: 'public-accessing' stamp: 'MaxLeske 2/26/2012 14:04'!
beInDirectorymode
	isInFilemode := false! !

!GitTreeEntry methodsFor: 'public-accessing' stamp: 'MaxLeske 2/26/2012 14:04'!
beInFilemode
	isInFilemode := true! !

!GitTreeEntry methodsFor: 'public-accessing' stamp: 'MaxLeske 2/26/2012 12:04'!
entryHash
	^ entryHash! !

!GitTreeEntry methodsFor: 'public-accessing' stamp: 'MaxLeske 2/26/2012 13:59'!
entryHash: hexHash
	entryHash := hexHash! !

!GitTreeEntry methodsFor: 'public-accessing' stamp: 'CamilloBruni 9/3/2012 17:33'!
entryHexHash
	^ entryHash asHexHash! !

!GitTreeEntry methodsFor: 'public-accessing' stamp: 'MaxLeske 7/10/2010 10:16'!
entryName
	^ entryName! !

!GitTreeEntry methodsFor: 'public-accessing' stamp: 'MaxLeske 2/26/2012 14:05'!
entryName: aString
	entryName := aString! !

!GitTreeEntry methodsFor: 'comparing' stamp: 'MaxLeske 2/28/2012 11:10'!
hash
	^ self class hash bitXor: (self mode bitXor: entryName hash)! !

!GitTreeEntry methodsFor: 'public-testing' stamp: 'MaxLeske 2/26/2012 14:04'!
isInDirectorymode
	^ isInFilemode not! !

!GitTreeEntry methodsFor: 'public-testing' stamp: 'MaxLeske 2/26/2012 14:04'!
isInFilemode
	^ isInFilemode! !

!GitTreeEntry methodsFor: 'initialize-release' stamp: 'MaxLeske 2/28/2012 14:13'!
loadFrom: aStream
	self loadModeFrom: aStream.
	entryName := (aStream upTo: 0) asString.
	entryHash := (aStream next: 20) asInteger.
	^self! !

!GitTreeEntry methodsFor: 'initialize-release' stamp: 'MaxLeske 6/24/2012 15:12'!
loadModeFrom: aStream
	| mode |
	mode := 
		Integer 
			readFrom: (aStream upTo: Character space asInteger) asString 
			base: 8.
	mode = self class fileMode ifTrue: [ ^ self beInFilemode ].
	mode = self class dirMode ifTrue: [ ^ self beInDirectorymode ].
	
	GitInvalidObjectError signal: 'This tree entry has an invalid filemode.'! !

!GitTreeEntry methodsFor: 'public-accessing' stamp: 'MaxLeske 2/26/2012 14:03'!
mode
	^ self isInFilemode
		ifTrue: [ self class fileMode ]
		ifFalse: [ self class dirMode ]! !

!GitTreeEntry methodsFor: 'public-accessing' stamp: 'MaxLeske 2/26/2012 12:04'!
object
	^ self repository objectNamed: self entryHash! !

!GitTreeEntry methodsFor: 'printing' stamp: 'MaxLeske 6/23/2010 19:17'!
printMode
	^self class printMode: self mode! !

!GitTreeEntry methodsFor: 'printing' stamp: 'CamilloBruni 7/11/2011 17:27'!
printOn: aStream
	super printOn: aStream.
	self entryName ifNil: [ ^ self ].
	aStream
		<< '(''';
		nextPutAll: self entryName;
		<< ''')'.! !

!GitTreeEntry methodsFor: 'storing' stamp: 'MaxLeske 9/8/2012 16:10'!
storeOn: aStream.
	aStream 
		nextPutAll: self printMode asByteArray;
		nextPut: Character space asInteger;
		nextPutAll: entryName asByteArray;
		nextPut: 0;
		nextPutAll: entryHash asByteArray! !

!GitTreeEntry methodsFor: 'validation' stamp: 'MaxLeske 6/24/2012 15:13'!
validate
	isInFilemode ifNil: [ GitInvalidObjectError signal: 'Filemode is required for tree entries.' ].
	entryHash ifNil: [ GitInvalidObjectError signal: 'A valid signature is required for the tree entry to point to.' ].
	entryName ifNil: [ GitInvalidObjectError signal: 'A tree entry requires a name.' ].
	entryName ifEmpty: [ GitInvalidObjectError signal: 'Cannot use empty name for a tree entry.' ].! !

GitAbstractObject subclass: #GitPackedObject
	instanceVariableNames: 'pack sourceStream startPosition unpackedBytes repository typeByte crc dataStartPosition lengthInPack unpackedLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Packs'!

GitPackedObject subclass: #GitPackedDelta
	instanceVariableNames: 'deltaBase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Packs'!

!GitPackedDelta class methodsFor: 'testing' stamp: 'MaxLeske 9/8/2012 13:00'!
isAbstract
	^ self = GitPackedDelta! !

!GitPackedDelta methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 12:17'!
basicDeltaBase
	self subclassResponsibility! !

!GitPackedDelta methodsFor: 'public-accessing' stamp: 'MaxLeske 9/8/2012 12:18'!
deltaBase
	^ deltaBase ifNil: [ self basicDeltaBase ]! !

!GitPackedDelta methodsFor: 'public-accessing' stamp: 'MaxLeske 9/8/2012 12:02'!
deltaBaseName
	^ self subclassResponsibility! !

GitPackedDelta subclass: #GitPackedOfsDelta
	instanceVariableNames: 'relativeDeltaBaseOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Packs'!

!GitPackedOfsDelta class methodsFor: 'testing' stamp: 'MaxLeske 2/29/2012 21:20'!
canDecode: byteTypeCode
	^ (byteTypeCode bitXor: 2r01100000) isZero! !

!GitPackedOfsDelta methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 19:01'!
basicDeltaBase
	^ deltaBase := self pack objectAtOffset: self deltaBaseOffset! !

!GitPackedOfsDelta methodsFor: 'public-accessing' stamp: 'MaxLeske 9/8/2012 13:25'!
deltaBaseName
	^ self deltaBase object hexHash! !

!GitPackedOfsDelta methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 19:02'!
deltaBaseOffset
	^ self startPosition - relativeDeltaBaseOffset! !

!GitPackedOfsDelta methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 19:04'!
deltaBaseOffset: anInteger
	relativeDeltaBaseOffset := anInteger! !

!GitPackedOfsDelta methodsFor: 'processing' stamp: 'MaxLeske 9/8/2012 18:26'!
readBaseObjectOffset 
"modified big endian encoding.
Most significant bit of each byte indicates if that byte is the last
byte encoding for the value (bit = 0) or if another byte follows (bit = 1)"
	| byte offset |
	byte := self sourceStream next.
	offset := byte bitAnd: 2r01111111.
	[ (byte bitAnd: 2r10000000) isZero ] whileFalse: [
		byte := self sourceStream next.
		offset := ((offset + 1) << 7) bitOr: (byte bitAnd: 2r01111111) ].
	
	^ offset! !

!GitPackedOfsDelta methodsFor: 'processing' stamp: 'MaxLeske 9/8/2012 19:18'!
readHeaders
	super readHeaders.
	self deltaBaseOffset: self readBaseObjectOffset! !

!GitPackedOfsDelta methodsFor: 'processing' stamp: 'MaxLeske 9/8/2012 18:58'!
unpack
	| baseOffset base interpreter |
	(self pack hasIndexFile not
	and: [ (self pack repository hasLooseObject: self deltaBaseName) not ]) ifTrue: [ ^ self ].

	interpreter := self loadDeltaInterpreter.
	self runDeltaInterpreter: interpreter against: self deltaBase! !

GitPackedDelta subclass: #GitPackedRefDelta
	instanceVariableNames: 'deltaBaseName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Packs'!

!GitPackedRefDelta class methodsFor: 'testing' stamp: 'MaxLeske 2/29/2012 21:19'!
canDecode: byteTypeCode
	^ (byteTypeCode bitXor: 2r01110000) isZero! !

!GitPackedRefDelta methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 16:36'!
basicDeltaBase
	^ deltaBase := self pack repository objectNamed: self deltaBaseName! !

!GitPackedRefDelta methodsFor: 'public-accessing' stamp: 'MaxLeske 9/8/2012 18:57'!
deltaBaseName
	^ deltaBaseName! !

!GitPackedRefDelta methodsFor: 'public-accessing' stamp: 'MaxLeske 9/8/2012 18:58'!
deltaBaseName: hexHash
	deltaBaseName := hexHash! !

!GitPackedRefDelta methodsFor: 'as yet unclassified' stamp: 'MaxLeske 9/8/2012 18:57'!
readHeaders
	super readHeaders.
	self deltaBaseName: (self sourceStream next: 20) asHexHash! !

!GitPackedRefDelta methodsFor: 'processing' stamp: 'MaxLeske 9/8/2012 18:59'!
unpack
	| hexHash interpreter |
	(self pack hasIndexFile not
	and: [ (self pack repository hasLooseObject: self deltaBaseName) not ]) ifTrue: [ ^ self ].

	interpreter := self loadDeltaInterpreter.
	self runDeltaInterpreter: interpreter against: self deltaBase! !

GitPackedObject subclass: #GitPackedNonDelta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Packs'!

!GitPackedNonDelta class methodsFor: 'testing' stamp: 'MaxLeske 2/29/2012 21:23'!
canDecode: byteTypeCode 
	"all types but OFS_DELTA and REF_DELTA"
	^ (byteTypeCode bitXor: 2r01100000) isZero not
		and: [ (byteTypeCode bitXor: 2r01110000) isZero not ]! !

!GitPackedNonDelta methodsFor: 'processing' stamp: 'MaxLeske 9/8/2012 18:21'!
unpack
	| reader |
	reader := GitZLibReadStream on: self sourceStream.
	unpackedBytes :=  reader contents! !

!GitPackedObject class methodsFor: 'accessing' stamp: 'MaxLeske 2/29/2012 21:11'!
byteTypeCodeFrom: aStream
	^ aStream peek bitAnd: 2r01110000! !

!GitPackedObject class methodsFor: 'instance creation' stamp: 'MaxLeske 9/8/2012 10:26'!
fromPack: aPack at: anOffset in: aRepository
	| stream typeCode class |
	stream := aPack readStream.
	stream position: anOffset.
	typeCode := self byteTypeCodeFrom: stream.
	class := self decodeClassFrom: typeCode.
	
	^ class new
		repository: aRepository;
		pack: aPack;
		loadFrom: stream;
		yourself! !

!GitPackedObject class methodsFor: 'testing' stamp: 'MaxLeske 9/8/2012 13:00'!
isAbstract
	^ self = GitPackedObject! !

!GitPackedObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 15:30'!
byteData
	^ self unpackedBytes! !

!GitPackedObject methodsFor: 'accessing' stamp: 'MaxLeske 2/29/2012 19:09'!
byteTypeCode
	^ typeByte bitAnd: 2r01110000! !

!GitPackedObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 20:48'!
compressedData
	^ self sourceStream contents 
		copyFrom: self startPosition + 1
		to: self stopPosition! !

!GitPackedObject methodsFor: 'processing' stamp: 'MaxLeske 9/8/2012 17:08'!
computeCRC
	crc := CRC crc32FromCollection: self compressedData! !

!GitPackedObject methodsFor: 'public-accessing' stamp: 'MaxLeske 6/17/2012 12:49'!
crc
	^ crc! !

!GitPackedObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 18:54'!
dataStartPosition
	^ dataStartPosition! !

!GitPackedObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 18:53'!
dataStartPosition: anInteger
	dataStartPosition := anInteger! !

!GitPackedObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 15:31'!
hexHash
	^ (GitHash from: self byteSignature) hexHash! !

!GitPackedObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 20:45'!
lengthInPack
	^ lengthInPack! !

!GitPackedObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 20:45'!
lengthInPack: anInteger
	lengthInPack := anInteger! !

!GitPackedObject methodsFor: 'processing' stamp: 'MaxLeske 9/8/2012 18:56'!
loadDeltaInterpreter
	| reader unpackedDelta |
	self sourceStream position: self dataStartPosition.
	reader := GitZLibReadStream on: self sourceStream.

	^ GitDeltaInterpreter on: reader contents! !

!GitPackedObject methodsFor: 'initialize-release' stamp: 'MaxLeske 9/8/2012 20:45'!
loadFrom: aStream
	self 
		sourceStream: aStream;
		startPosition: aStream position; 
		readHeaders;
		dataStartPosition: aStream position;
		unpack;
		lengthInPack: aStream position - self startPosition;
		computeCRC! !

!GitPackedObject methodsFor: 'public-accessing' stamp: 'MaxLeske 7/1/2012 19:33'!
object
	^ GitStorableObject 
		fromPackedObjectStream: self unpackedBytes readStream
		type: self byteTypeCode
		in: self repository! !

!GitPackedObject methodsFor: 'public-accessing' stamp: 'tonyg 2/23/2010 11:05'!
pack
	^ pack! !

!GitPackedObject methodsFor: 'public-accessing' stamp: 'tonyg 2/23/2010 11:05'!
pack: anObject
	pack := anObject! !

!GitPackedObject methodsFor: 'processing' stamp: 'MaxLeske 9/8/2012 20:47'!
readHeaders
	typeByte := self sourceStream peek.
	self unpackedLength:  self readUnpackedDataSize! !

!GitPackedObject methodsFor: 'processing' stamp: 'MaxLeske 9/8/2012 17:11'!
readUnpackedDataSize
	| size shift byte |
	byte := self sourceStream next.
	size := byte bitAnd: 2r00001111.
	shift := 4.
	[ (byte bitAnd: 2r10000000) isZero ] whileFalse: [
		byte := self sourceStream next.
		size := size bitOr: ((byte bitAnd: 127) << shift).
		shift := shift + 7].
	
	^ size! !

!GitPackedObject methodsFor: 'public-accessing' stamp: 'MaxLeske 2/29/2012 19:23'!
repository
	^ repository! !

!GitPackedObject methodsFor: 'public-accessing' stamp: 'MaxLeske 7/26/2010 12:54'!
repository: aRepository
	repository := aRepository! !

!GitPackedObject methodsFor: 'processing' stamp: 'MaxLeske 9/8/2012 18:30'!
runDeltaInterpreter: interpreter against: base
	typeByte :=  base byteTypeCode.
	unpackedBytes := interpreter runAgainst: base byteData! !

!GitPackedObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 17:11'!
sourceStream
	^ sourceStream! !

!GitPackedObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 17:13'!
sourceStream: aStream
	sourceStream := aStream! !

!GitPackedObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 17:10'!
startPosition
	^ startPosition! !

!GitPackedObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 17:22'!
startPosition: anInteger
	startPosition := anInteger! !

!GitPackedObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 20:45'!
stopPosition
	^ self startPosition + self lengthInPack! !

!GitPackedObject methodsFor: 'public-accessing' stamp: 'MaxLeske 9/8/2012 14:47'!
store
	self repository storeObject: self! !

!GitPackedObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 16:33'!
typeCode
	^ (GitStorableObject decodeClassFrom: self byteTypeCode) typeCode! !

!GitPackedObject methodsFor: 'processing' stamp: 'MaxLeske 2/29/2012 21:13'!
unpack
	self subclassResponsibility! !

!GitPackedObject methodsFor: 'accessing' stamp: 'tonyg 2/23/2010 20:09'!
unpackedBytes
	^ unpackedBytes! !

!GitPackedObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 20:47'!
unpackedLength
	^ unpackedLength! !

!GitPackedObject methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 20:47'!
unpackedLength: anInteger
	unpackedLength := anInteger! !

Object subclass: #GitAbstractProtocol
	instanceVariableNames: 'url refs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Remote'!

!GitAbstractProtocol commentStamp: '<historical>' prior: 0!
Contains public methods that are valid for all Git protocols!

!GitAbstractProtocol class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 12/21/2011 14:49'!
connectTo: aUrl
	^ self basicNew
		initializeWith: aUrl! !

!GitAbstractProtocol class methodsFor: 'example' stamp: 'DamienCassou 1/28/2013 20:47'!
example1
	|git|
	
	"setting up the remote repository"
	git := GitAbstractProtocol url: 'git://github.com/dh83/p.git'.

	"inspecting the repository returning list/dicts with GitObjectSignature"
	git refs.
	git branches.
	git tags.
	git head.

	"loading a remote object"
	^ git want: git head! !

!GitAbstractProtocol class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 12/21/2011 14:37'!
protocolForScheme: aScheme
	^ self allSubclasses detect: [ :class| class schemes includes: aScheme ]! !

!GitAbstractProtocol class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 12/21/2011 14:49'!
url: anUrlString
	| url protocol |
	url := anUrlString asUrl.
	protocol := self protocolForScheme: url scheme.
	^ protocol connectTo: url! !

!GitAbstractProtocol methodsFor: 'accessing' stamp: 'CamilloBruni 10/8/2012 14:22'!
branches
	^ self refsPrefixed: 'refs/heads'! !

!GitAbstractProtocol methodsFor: 'accessing' stamp: 'DamienCassou 1/31/2013 16:28'!
fetchRefs
	^ self subclassResponsibility! !

!GitAbstractProtocol methodsFor: 'commands' stamp: 'DamienCassou 1/31/2013 16:34'!
head
	^ self refs at: 'HEAD'! !

!GitAbstractProtocol methodsFor: 'accessing' stamp: 'CamilloBruni 12/21/2011 14:50'!
host
	^ self url authority! !

!GitAbstractProtocol methodsFor: 'initialize-release' stamp: 'DamienCassou 1/29/2013 15:45'!
initializeWith: aUrl
	super initialize.
	url := aUrl asUrl.
! !

!GitAbstractProtocol methodsFor: 'accessing' stamp: 'DamienCassou 1/31/2013 16:27'!
refs
	^ refs ifNil: [ refs := self fetchRefs ]! !

!GitAbstractProtocol methodsFor: 'accessing' stamp: 'CamilloBruni 10/8/2012 14:23'!
refsPrefixed: aPrefix
	
	|result|
	
	result := Dictionary new.
	self refs keysAndValuesDo: [ :key :ref|
		(key beginsWith: aPrefix) ifTrue: [
			result at: (key copyAfterLast: $/) put: ref]].
	
	^ result! !

!GitAbstractProtocol methodsFor: 'accessing' stamp: 'CamilloBruni 12/21/2011 14:48'!
repository
	^ url fullPath! !

!GitAbstractProtocol methodsFor: 'accessing' stamp: 'CamilloBruni 10/8/2012 14:23'!
tags
	^ self refsPrefixed: 'refs/tags'! !

!GitAbstractProtocol methodsFor: 'as yet unclassified' stamp: 'DamienCassou 1/30/2013 13:36'!
targetClass
	^ self classToBeTested ! !

!GitAbstractProtocol methodsFor: 'accessing' stamp: 'CamilloBruni 12/21/2011 14:50'!
url
	^ url! !

GitAbstractProtocol subclass: #GitDumbHTTPProtocol
	instanceVariableNames: 'client stream outputStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Remote'!

!GitDumbHTTPProtocol commentStamp: '<historical>' prior: 0!
https://raw.github.com/git/gitscm/master/public/docs/http-protocol.txt
!

!GitDumbHTTPProtocol class methodsFor: 'as yet unclassified' stamp: 'DamienCassou 1/28/2013 21:09'!
connectTo: aUrl
	^ (self isSmartRepository: aUrl)
		ifTrue: [GitSmartHTTPProtocol connectTo: aUrl ]
		ifFalse: [super connectTo: aUrl  ]! !

!GitDumbHTTPProtocol class methodsFor: 'as yet unclassified' stamp: 'DamienCassou 1/29/2013 15:08'!
isSmartRepository: aUrl
	|head|
	"https://raw.github.com/git/gitscm/master/public/docs/http-protocol.txt"
	self flag: 'we should fix this username/password thing'.
	head := ZnClient new
		url: aUrl asZnUrl / 'info' / 'refs';
		queryAt: 'service' put: 'git-upload-pack';
		"username: 'admin' password: 'admin';"
		enforceHttpSuccess: true;
		head;
		response.
	^ head contentType matches: ZnMimeType applicationGitUploadPackAdvertisement! !

!GitDumbHTTPProtocol class methodsFor: 'as yet unclassified' stamp: 'DamienCassou 1/28/2013 21:08'!
schemes
	"Smart and Dumb protocols both allow http and https. Negotiation is handled by the dumb protocol."
	^ #(http https)! !

!GitDumbHTTPProtocol methodsFor: 'command' stamp: 'CamilloBruni 10/8/2012 14:25'!
head
	^ self resolveRef: (self readFile: 'HEAD') contents asString! !

!GitDumbHTTPProtocol methodsFor: 'command' stamp: 'CamilloBruni 10/8/2012 14:34'!
httpAlternates
	self flag: 'TODO: read packfile'.
	^ self objectsInfo: 'http-alternates'! !

!GitDumbHTTPProtocol methodsFor: 'command' stamp: 'CamilloBruni 1/15/2012 22:53'!
info: aString
	^ self readFile: '/info/', aString! !

!GitDumbHTTPProtocol methodsFor: 'command' stamp: 'CamilloBruni 10/8/2012 14:29'!
objectsInfo: aString
	^ self readFile: '/objects/info/', aString! !

!GitDumbHTTPProtocol methodsFor: 'command' stamp: 'CamilloBruni 10/8/2012 14:30'!
packs
	self flag: 'TODO: read packfile'.
	^ self objectsInfo: 'packs'! !

!GitDumbHTTPProtocol methodsFor: 'pivate' stamp: 'CamilloBruni 10/8/2012 14:22'!
parseRefs: aResponse
	refs := Dictionary new.
	aResponse contents asString linesDo: [ :line| |split|
		split := line splitOn: String tab.
		refs at: split second put: split first ].
	^ refs! !

!GitDumbHTTPProtocol methodsFor: 'command' stamp: 'DamienCassou 1/28/2013 20:31'!
readFile: aPath
	self flag: 'to be fixed '.
	^ ZnEasy get: url asString, aPath username: 'admin' password: 'admin'! !

!GitDumbHTTPProtocol methodsFor: 'command' stamp: 'CamilloBruni 10/8/2012 14:15'!
refs
	^ self parseRefs: (self info: 'refs')! !

!GitDumbHTTPProtocol methodsFor: 'command' stamp: 'CamilloBruni 10/8/2012 14:27'!
resolveRef: aRefString
	^  self refs at: (aRefString splitOn: String space) second trimBoth! !

!GitDumbHTTPProtocol methodsFor: 'command' stamp: 'CamilloBruni 10/8/2012 14:33'!
want: aSignature
	^ self readFile: 'objects/', (aSignature first: 2), '/', (aSignature allButFirst: 2)! !

GitAbstractProtocol subclass: #GitProtocol
	instanceVariableNames: 'stream reader writer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Remote'!

!GitProtocol commentStamp: '<historical>' prior: 0!
Implements the git:// protocol.

https://github.com/git/git/blob/master/Documentation/technical/pack-protocol.txt

https://github.com/git/git/blob/master/Documentation/technical/protocol-capabilities.txt

https://github.com/git/git/blob/master/Documentation/technical/protocol-common.txt!

!GitProtocol class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 12/21/2011 14:35'!
schemes
	^ #(git)! !

!GitProtocol methodsFor: 'private connection' stamp: 'DamienCassou 1/31/2013 12:34'!
closeConnection
	self isConnected
		ifTrue: [writer flushPacket.
				stream close.
				stream := nil]! !

!GitProtocol methodsFor: 'commands' stamp: 'CamilloBruni 2/12/2013 17:10'!
fetchRefs
	| null |
	self openConnection.
	null := Character null asString.
	writer
		sendCommand: 'git-upload-pack' 
		arguments: (self repository, null, self hostInformation, null)
		withLineTerminator: false.
	refs := reader parseUploadPackResponse.
	^ refs! !

!GitProtocol methodsFor: 'configuration' stamp: 'Camillobruni 8/19/2011 17:34'!
hostInformation
	^ 'host=myserver.com'! !

!GitProtocol methodsFor: 'private connection' stamp: 'DamienCassou 1/31/2013 12:30'!
isConnected
	^ stream notNil and: [ stream isConnected ]! !

!GitProtocol methodsFor: 'private connection' stamp: 'DamienCassou 1/31/2013 16:33'!
openConnection
	| tempStream |
	self isConnected
		ifTrue: [ ^ self ].
		
	"Use tempStream to ensure that 'stream' is only set when everything is ok"
	tempStream := SocketStream openConnectionToHostNamed: self host port: 9418.
	
	tempStream 
		timeout: 10 "seconds";
		binary.

	stream := tempStream.
	reader := GitProtocolReader on: stream.
	writer := GitProtocolWriter on: stream.
	! !

!GitProtocol methodsFor: 'private accessing' stamp: 'DamienCassou 1/31/2013 16:36'!
reader
	^ reader! !

!GitProtocol methodsFor: 'private accessing' stamp: 'DamienCassou 1/31/2013 16:23'!
stream
	^ stream! !

!GitProtocol methodsFor: 'commands' stamp: 'CamilloBruni 12/25/2011 14:00'!
want: gitSignature 
	^ self wantAll: { gitSignature }! !

!GitProtocol methodsFor: 'commands' stamp: 'DamienCassou 1/31/2013 12:46'!
want: gitSignature capabilities: capabilities
	^ self wantAll: { gitSignature } capabilities: capabilities! !

!GitProtocol methodsFor: 'commands' stamp: 'DamienCassou 1/31/2013 12:44'!
wantAll: gitSignatures 
	^ self 
		wantAll: gitSignatures 
		capabilities: GitProtocolCapabilities multiAck sideBand64k ofsDelta! !

!GitProtocol methodsFor: 'commands' stamp: 'CamilloBruni 2/12/2013 17:39'!
wantAll: gitSignatures capabilities: capabilities
"TODO:
#readPackfileResponse writes pack to file. need to unpack that file into a repository and read from there. Then answer the objects."
	writer 
		sendWantAll: gitSignatures 
		capabilities: capabilities 
		shallowLines: nil 
		depth: nil.
	
	self flag: 'proper negotiation phase missing...'.
	
	writer flushPacket; done.
	^ reader readPackfileResponse
	! !

!GitProtocol methodsFor: 'private connection' stamp: 'DamienCassou 1/31/2013 16:31'!
withOpenConnection: aBlock
	self openConnection.
	aBlock
		ensure: [ self closeConnection ]! !

!GitProtocol methodsFor: 'private accessing' stamp: 'DamienCassou 1/31/2013 16:36'!
writer
	^ writer! !

GitProtocol subclass: #GitSmartHTTPProtocol
	instanceVariableNames: 'outputStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Remote'!

!GitSmartHTTPProtocol commentStamp: '<historical>' prior: 0!
The Git smart http protocol looks just like the Git protocol, that why I inherit from it.

https://raw.github.com/git/gitscm/master/public/docs/http-protocol.txt!

!GitSmartHTTPProtocol class methodsFor: 'as yet unclassified' stamp: 'DamienCassou 1/28/2013 21:08'!
schemes
	"Smart and Dumb protocols both allow http and https. Negotiation is handled by the dumb one."
	^ #()! !

!GitSmartHTTPProtocol methodsFor: 'accessing' stamp: 'DamienCassou 1/29/2013 14:16'!
client
	^ ZnClient new
		enforceHttpSuccess: true;
		yourself! !

!GitSmartHTTPProtocol methodsFor: 'private' stamp: 'CamilloBruni 2/12/2013 17:53'!
clientForPostService: serviceName
 	^ self client
		url: self url asZnUrl / serviceName;
		yourself! !

!GitSmartHTTPProtocol methodsFor: 'private' stamp: 'CamilloBruni 2/12/2013 17:30'!
clientForService: aServiceName
 	^ self client
		url: self url asString, '/info/refs';
		queryAt: 'service' put: aServiceName;
		yourself
	! !

!GitSmartHTTPProtocol methodsFor: 'private' stamp: 'CamilloBruni 2/12/2013 17:51'!
clientForUploadPack
	^ self clientForPostService: 'git-upload-pack'! !

!GitSmartHTTPProtocol methodsFor: 'private' stamp: 'CamilloBruni 2/12/2013 17:50'!
clientForUploadPackService
	^ self clientForService: 'git-upload-pack'! !

!GitSmartHTTPProtocol methodsFor: 'accessing' stamp: 'CamilloBruni 2/12/2013 16:54'!
firstWantCapabilityListSeparator
	self halt.
	^ Character null! !

!GitSmartHTTPProtocol methodsFor: 'accessing' stamp: 'DamienCassou 1/29/2013 16:20'!
flush
	| entity data |
	entity := ZnStringEntity type: ZnMimeType applicationGitUploadPackRequest.
	entity string: self outputStream contents.
	
	data := self client
		url: self url asString, '/info/refs' ;
		queryAt: 'service' put: 'git-upload-pack';
		entity: entity;
		post.
	stream := data readStream! !

!GitSmartHTTPProtocol methodsFor: 'private' stamp: 'CamilloBruni 2/12/2013 17:50'!
loadRefs
	stream := self clientForUploadPackService
		streaming: true;
		get.
	self flag: 'TODO: use streaming response'.
	
	reader := GitProtocolReader on: stream.
	writer := GitProtocolWriter on: stream.
	
	^ reader readPktLine; readZeroLine; parseUploadPackResponse
! !

!GitSmartHTTPProtocol methodsFor: 'accessing' stamp: 'DamienCassou 1/29/2013 15:02'!
openConnection
	"open http connection"
	^ self client! !

!GitSmartHTTPProtocol methodsFor: 'commands' stamp: 'DamienCassou 1/29/2013 15:02'!
outputStream
	^ outputStream ifNil: [ outputStream := '' writeStream ]! !

!GitSmartHTTPProtocol methodsFor: 'commands' stamp: 'DamienCassou 1/28/2013 20:53'!
refs
	^ refs := self loadRefs! !

!GitSmartHTTPProtocol methodsFor: 'commands' stamp: 'CamilloBruni 2/12/2013 17:52'!
wantAll: gitSignatures capabilities: capabilities
	| contents entity|
	
	self flag: 'TODO: use streaming response'.
	
	contents := String streamContents: [ :s|
		outputStream := s.
		writer := GitProtocolWriter on: outputStream.
		writer 
			sendWantAll: gitSignatures 
			capabilities: capabilities 
			shallowLines: nil 
			depth: nil.
		
		writer flushPacket; done ].

	entity := ZnStringEntity type: ZnMimeType applicationGitUploadPackRequest.
	entity string: contents.
	
	stream :=  self clientForUploadPack
		streaming: true;
		entity: entity;
		post.
	
	reader := GitProtocolReader on: stream.
	^ reader readPackfileResponse
	! !

Object subclass: #GitDeltaInterpreter
	instanceVariableNames: 'source instructions output commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Packs'!

!GitDeltaInterpreter class methodsFor: 'initialize-release' stamp: 'MaxLeske 6/24/2012 10:45'!
on: aByteArray
	^ self new instructions: aByteArray! !

!GitDeltaInterpreter methodsFor: 'public-accessing' stamp: 'tonyg 2/23/2010 12:01'!
instructions
	^ instructions! !

!GitDeltaInterpreter methodsFor: 'public-accessing' stamp: 'tonyg 2/23/2010 12:01'!
instructions: anObject
	instructions := anObject! !

!GitDeltaInterpreter methodsFor: 'processing' stamp: 'MaxLeske 8/1/2011 19:17'!
readBaseObjectSize
	^ self readVariableInteger! !

!GitDeltaInterpreter methodsFor: 'processing' stamp: 'MaxLeske 8/1/2011 19:17'!
readFinalObjectSize
	^ self readVariableInteger! !

!GitDeltaInterpreter methodsFor: 'processing' stamp: 'MaxLeske 8/12/2011 08:31'!
readVariableInteger
"modified little endian encoding.
Most significant bit of each byte indicates if that byte is the last
byte encoding for the value (bit = 0) or if another byte follows (bit = 1)"
	| value shift byte |
	value := 0.
	shift := 0.
	[ byte := commands next.
	value := value bitOr: ((byte bitAnd: 127) << shift).
	shift := shift + 7 ] doWhileFalse: [ (byte bitAnd: 128) isZero ].
	
	^ value! !

!GitDeltaInterpreter methodsFor: 'executing' stamp: 'tonyg 2/23/2010 12:20'!
run
	[commands atEnd] whileFalse: [self runNextCommand]! !

!GitDeltaInterpreter methodsFor: 'public-executing' stamp: 'MaxLeske 9/8/2012 16:55'!
runAgainst: aByteArray
	source := aByteArray.
	commands := instructions readStream.
	source size = self readBaseObjectSize ifFalse: [ 
		GitInvalidPackFileError signal: 'Actual size of delta base object is not the same as announced by packfile.' ].
	output := (ByteArray new: self readFinalObjectSize) writeStream.
	self run.

	^ output contents! !

!GitDeltaInterpreter methodsFor: 'executing' stamp: 'MaxLeske 6/24/2012 13:29'!
runNextCommand
	| cmd |
	cmd := commands next.
	cmd = 0 ifTrue: [ GitInvalidBytesError signal: 'opcode 0 is a reserved byte. This delta is invalid.' ].
	cmd < 128
		ifTrue: [output nextPutAll: (commands next: cmd)]
		ifFalse: [ | offset size |
			offset := 0.
			(cmd bitAnd: 2r00000001) isZero ifFalse: [ offset := commands next].
			(cmd bitAnd: 2r00000010) isZero ifFalse: [ offset := offset bitOr: commands next << 8 ].
			(cmd bitAnd: 2r00000100) isZero ifFalse: [ offset := offset bitOr: commands next << 16 ].
			(cmd bitAnd: 2r00001000) isZero ifFalse: [ offset := offset bitOr: commands next << 24 ].

			size := 0.
			(cmd bitAnd: 2r00010000) isZero ifFalse: [size := commands next].
			(cmd bitAnd: 2r00100000) isZero ifFalse: [size := size bitOr: commands next << 8 ].
			(cmd bitAnd: 2r01000000) isZero ifFalse: [size := size bitOr: commands next << 16 ].
			size = 0 ifTrue: [ size := 16r10000 ].
			
			output nextPutAll: (source copyFrom: offset + 1 to: offset + size) ]! !

Object subclass: #GitFSCK
	uses: TGitVisitor
	instanceVariableNames: 'all repository reachable unreachable errors referenceContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Utilities'!

GitFSCK class
	uses: TGitVisitor classTrait
	instanceVariableNames: ''!

!GitFSCK class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 6/21/2011 06:05'!
validate: aGitRepository
	^ self new 
		repository: aGitRepository; 
		validate! !

!GitFSCK methodsFor: 'accessing' stamp: 'MaxLeske 6/24/2012 09:46'!
addError: error for: anObject
	(self errorsFor: anObject) add: error! !

!GitFSCK methodsFor: 'validating' stamp: 'MaxLeske 6/24/2012 09:50'!
collectError: error for: anObject
	| errorObject |
	errorObject :=	(error respondsTo: #copyUpTo:)
		ifTrue: [ error copyUpTo: referenceContext ]	
		ifFalse: [ error ].
	self addError: errorObject for: anObject! !

!GitFSCK methodsFor: 'validating' stamp: 'CamilloBruni 6/22/2011 05:01'!
collectObjects
	all := repository looseObjects.
	self flag: 'TODO: collect packed objects'.
	all := all reject: [ :each| each species == GitTag]! !

!GitFSCK methodsFor: 'validating' stamp: 'CamilloBruni 6/22/2011 04:19'!
collectUnreachableErrors	
	unreachable do: [ :each|
		self collectError: 'unreachable object' for: each].! !

!GitFSCK methodsFor: 'accessing' stamp: 'MaxLeske 6/24/2012 09:47'!
errorsFor: anObject
	^ errors
		at: anObject
		ifAbsentPut: OrderedCollection new! !

!GitFSCK methodsFor: 'testing' stamp: 'MaxLeske 8/13/2012 22:22'!
isReachable: anObject
	^ reachable includes: anObject! !

!GitFSCK methodsFor: 'validating' stamp: 'CamilloBruni 7/21/2011 15:05'!
mark: anObject
	unreachable remove: anObject ifAbsent: [].
	reachable add: anObject.! !

!GitFSCK methodsFor: 'accessing' stamp: 'CamilloBruni 6/22/2011 03:45'!
repository
	^ repository! !

!GitFSCK methodsFor: 'accessing' stamp: 'CamilloBruni 6/21/2011 06:06'!
repository: aGitRepository
	repository := aGitRepository! !

!GitFSCK methodsFor: 'public-validating' stamp: 'MaxLeske 6/24/2012 15:32'!
validate
	self collectObjects.
	referenceContext := thisContext.
	errors := Dictionary new.
	unreachable := all copy.
	reachable := Set new.
	self validateHead.
	self validateBranches.
	self validateTags.
	
	self validateUnreachableObjects.
	
	errors ifEmpty: [ ^ self ].
	GitInvalidRepositoryError signal: 'GitFSCK found errors in the validated repository.'! !

!GitFSCK methodsFor: 'public-validating' stamp: 'MaxLeske 2/28/2012 20:02'!
validate: anObject
	[ anObject validate ]
		on: GitError
		do: [ :error | self collectError: error for: anObject ]! !

!GitFSCK methodsFor: 'public-validating' stamp: 'MaxLeske 8/12/2012 11:55'!
validateBranches
	[ repository branches do: [ :head| self visit: head ] ]
		on: GitError
		do: [ :error | 
			self collectError: error for: repository ]! !

!GitFSCK methodsFor: 'public-validating' stamp: 'MaxLeske 8/12/2012 11:55'!
validateHead
	self validateHeadFile.
	[ repository head ifNotNilDo: [ :head | self visit: head ] ]
		on: GitError
		do: [ :error | 
			self collectError: error for: repository ]! !

!GitFSCK methodsFor: 'public-validating' stamp: 'MaxLeske 6/24/2012 15:33'!
validateHeadFile
	[ repository headFile exists ifFalse: [ GitInvalidRepositoryError signal: 'Could not find ''HEAD''' ] ]
		on: GitError
		do: [ :error |
			self collectError: error for: repository ]! !

!GitFSCK methodsFor: 'validating' stamp: 'CamilloBruni 6/21/2011 06:27'!
validateObjects
	self halt.
	self flag: 'Validate all object files'! !

!GitFSCK methodsFor: 'public-validating' stamp: 'MaxLeske 8/12/2012 11:55'!
validateTags
	[ repository tags do: [ :tag | self visit: tag ] ]
		on: GitError
		do: [ :error | 
			self collectError: error for: repository ]! !

!GitFSCK methodsFor: 'public-validating' stamp: 'MaxLeske 8/12/2012 12:05'!
validateUnreachableObjects
	| unreachableCopy reachableCopy |
	unreachable ifEmpty: [ ^ self ].
	
	self collectUnreachableErrors.
	unreachableCopy := unreachable copy.
	reachableCopy := reachable copy.
	self visit: unreachable.
	reachable := reachableCopy.
	unreachable := unreachableCopy.! !

!GitFSCK methodsFor: 'visiting' stamp: 'MaxLeske 8/13/2012 22:22'!
visitBlob: aBlob
	(self isReachable: aBlob) ifTrue: [ ^ self].
	
	self 
		mark: aBlob;
		validate: aBlob! !

!GitFSCK methodsFor: 'visiting' stamp: 'CamilloBruni 9/3/2012 18:32'!
visitCommit: aCommit
	(self isReachable: aCommit) ifTrue: [ ^ self ].
	
	self
		mark: aCommit;
		validate: aCommit;
		visit: aCommit tree;
		visit: aCommit parents.! !

!GitFSCK methodsFor: 'visiting' stamp: 'MaxLeske 8/13/2012 22:29'!
visitTag: aTag
	(self isReachable: aTag) ifTrue: [ ^ self ].
	
	self
		mark: aTag; 
		validate: aTag.
	aTag isLightWeightTag ifTrue: [ ^ self ].
	
	self visit: aTag object! !

!GitFSCK methodsFor: 'visiting' stamp: 'MaxLeske 8/13/2012 22:29'!
visitTree: aTree
	(self isReachable: aTree) ifTrue: [ ^ self ].
	
	self 
		mark: aTree;
		validate: aTree;
		visitCollection: aTree objects! !

Object subclass: #GitHash
	instanceVariableNames: 'integerHash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Utilities'!

!GitHash class methodsFor: 'instance creation' stamp: 'MaxLeske 9/1/2012 09:56'!
from: aStringOrByteArray
	^ self new
		from: aStringOrByteArray;
		yourself! !

!GitHash methodsFor: 'public-accessing' stamp: 'MaxLeske 9/1/2012 09:55'!
byteHash
	^ integerHash asByteHash! !

!GitHash methodsFor: 'initialize-release' stamp: 'MaxLeske 9/1/2012 09:53'!
from: aStringOrByteArray
	integerHash := SecureHashAlgorithm new hashMessage: aStringOrByteArray! !

!GitHash methodsFor: 'public-accessing' stamp: 'MaxLeske 9/1/2012 09:54'!
hash
	^ integerHash ! !

!GitHash methodsFor: 'public-accessing' stamp: 'MaxLeske 9/1/2012 09:54'!
hexHash
	^ integerHash asHexHash! !

Object subclass: #GitIndex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Core'!

Object subclass: #GitIndexFile
	instanceVariableNames: 'fullStream crcTable fanoutTable fourByteOffsetStream hashStream eightByteOffsetStream reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Packs'!

!GitIndexFile class methodsFor: 'testing' stamp: 'MaxLeske 6/24/2012 15:51'!
canDecode: aByteArray
	^ self subclassResponsibility! !

!GitIndexFile class methodsFor: 'testing' stamp: 'MaxLeske 6/24/2012 15:57'!
hasVersion2MagicNumber: aByteArray
	^ (aByteArray first: 4) = self version2MagicNumber! !

!GitIndexFile class methodsFor: 'testing' stamp: 'MaxLeske 6/24/2012 16:07'!
hasVersionNumber2: aByteArray
	^ (aByteArray copyFrom: 5 to: 8) = #[ 0 0 0 2 ]! !

!GitIndexFile class methodsFor: 'instance creation' stamp: 'MaxLeske 6/24/2012 16:04'!
on: aReference
	| bytes class |
	bytes := aReference readStreamDo: [ :stream | stream contents ].
	class := self subclasses detect: [ :subclass | 
		subclass canDecode: bytes ].
	^ class new
		initializeWith: bytes;
		yourself! !

!GitIndexFile class methodsFor: 'accessing' stamp: 'MaxLeske 6/24/2012 15:58'!
version2MagicNumber
	"The magic number is (\377 is a non ascii character
	equalling the integer 255): \377tOc"
	^ #[ 255 116 79 99 ]! !

!GitIndexFile methodsFor: 'private' stamp: 'MaxLeske 6/23/2012 19:35'!
boundsFor: hexHash
	| fanoutIndex |
	"get highest possible index from fanout table:
	160 bit hash. We want the upper 8 bits."
	fanoutIndex := hexHash asIntegerHash >> 152. 

	^ { 
		"lower boundary is at the next lower fanout index"
		self indexForFanout: fanoutIndex - 1.
		self indexForFanout: fanoutIndex }! !

!GitIndexFile methodsFor: 'accessing' stamp: 'MaxLeske 6/24/2012 09:57'!
crcAt: index
	^ (crcTable readStream
		position: (index * 4);
		next: 4) asInteger! !

!GitIndexFile methodsFor: 'private' stamp: 'MaxLeske 6/24/2012 20:06'!
findBinary: anInteger from: lowerBound to: upperBound
	^ self subclassResponsibility! !

!GitIndexFile methodsFor: 'accessing' stamp: 'MaxLeske 9/1/2012 10:21'!
indexForFanout: fanoutIndex
	fanoutIndex isZero ifTrue: [ ^ 0 ].
	^ fanoutTable unsignedLongAt: (fanoutIndex * 4) + 1 bigEndian: true.! !

!GitIndexFile methodsFor: 'accessing' stamp: 'MaxLeske 6/24/2012 20:09'!
indexForObjectNamed: hexHash
	| integerHash index low high test bounds |
	integerHash := hexHash asIntegerHash.
	bounds := self boundsFor: hexHash.
	low := bounds first.
	high := bounds second.
	^ self findBinary: integerHash from: low to: high! !

!GitIndexFile methodsFor: 'initialize-release' stamp: 'MaxLeske 6/24/2012 15:49'!
initializeWith: aByteArray
	fullStream :=  aByteArray readStream
	! !

!GitIndexFile methodsFor: 'accessing' stamp: 'MaxLeske 6/24/2012 20:10'!
offsetForIndex: index
	^ self subclassResponsibility! !

!GitIndexFile methodsFor: 'public-accessing' stamp: 'MaxLeske 6/24/2012 20:15'!
offsetForObjectNamed: hexHash
	^ self subclassResponsibility! !

!GitIndexFile methodsFor: 'accessing' stamp: 'MaxLeske 8/29/2012 15:38'!
reference
	^ reference! !

!GitIndexFile methodsFor: 'accessing' stamp: 'MaxLeske 8/29/2012 15:39'!
reference: aReference
	reference := aReference! !

GitIndexFile subclass: #GitIndexFileVersion1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Packs'!

!GitIndexFileVersion1 class methodsFor: 'testing' stamp: 'MaxLeske 6/24/2012 16:05'!
canDecode: aByteArray
	"assume that any index which is not version 2 is versino 1. 
	There is no mechanism for easily checking version 1 indices apart from
	manually reassembling the different tables and running it through SHA1"
	^ (self hasVersion2MagicNumber: aByteArray) not
		and: [ (self hasVersionNumber2: aByteArray) not ]! !

!GitIndexFileVersion1 methodsFor: 'private' stamp: 'MaxLeske 6/24/2012 20:10'!
findBinary: anInteger from: lowerBound to: upperBound
	| index low high |
	low := lowerBound.
	high := upperBound.
	[ index := high + low // 2. low > high ] whileFalse: [ | test offset |
		"4 bytes index into offset table, 20 bytes"
		hashStream position: index * 24.
		offset := hashStream next: 4.
		test := (hashStream next: 20) asInteger.
		test = anInteger 
			ifTrue: [ ^ offset asInteger ]
			ifFalse: [ anInteger > test
				ifTrue: [  low := index + 1 ]
				ifFalse: [ high := index - 1 ] ] ].
	self flag: 'throw an exception here instead of answering nil'.
	^ nil! !

!GitIndexFileVersion1 methodsFor: 'initialize-release' stamp: 'MaxLeske 6/24/2012 20:21'!
initializeWith: aByteArray
	| objectCount |
	super initializeWith: aByteArray.
	fanoutTable := fullStream next: 1024. "256 4-byte big-endian entries."
	objectCount := self indexForFanout: 255.
	hashStream := (fullStream next: objectCount * 24) readStream! !

!GitIndexFileVersion1 methodsFor: 'accessing' stamp: 'MaxLeske 6/27/2012 10:50'!
offsetForIndex: index
	"in case of version 1 index files, the index is already the offset in the pack file"
	^ index! !

!GitIndexFileVersion1 methodsFor: 'accessing' stamp: 'MaxLeske 6/24/2012 20:20'!
offsetForObjectNamed: hexHash
	"Careful:
	#indexForObjectNamed for version 1 indices answers offset into pack file!!"
	^ self indexForObjectNamed: hexHash! !

GitIndexFile subclass: #GitIndexFileVersion2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Packs'!

!GitIndexFileVersion2 class methodsFor: 'testing' stamp: 'MaxLeske 6/24/2012 16:05'!
canDecode: aByteArray
	^ (self hasVersion2MagicNumber: aByteArray)
		and: [ self hasVersionNumber2: aByteArray ]! !

!GitIndexFileVersion2 methodsFor: 'private' stamp: 'MaxLeske 6/24/2012 20:09'!
findBinary: anInteger from: lowerBound to: upperBound
	| index low high |
	low := lowerBound.
	high := upperBound.
	[ index := high + low // 2. low > high ] whileFalse: [ | test |
		hashStream position: index * 20.
		test := (hashStream next: 20) asInteger.
		test = anInteger 
			ifTrue: [ ^ index ]
			ifFalse: [ anInteger > test
				ifTrue: [  low := index + 1 ]
				ifFalse: [ high := index - 1 ] ] ].
	self flag: 'throw an exception here instead of answering nil'.
	^ nil! !

!GitIndexFileVersion2 methodsFor: 'private' stamp: 'MaxLeske 6/24/2012 15:50'!
indexMagicNumber
	"The magic number is (\377 is a non ascii character
	equalling the integer 255): \377tOc"
	^ #[ 255 116 79 99 ]! !

!GitIndexFileVersion2 methodsFor: 'private' stamp: 'MaxLeske 6/24/2012 15:50'!
indexVersionTwo
	"Byte for version number (version 2)"
	^ #[0 0 0 2]! !

!GitIndexFileVersion2 methodsFor: 'initialize-release' stamp: 'MaxLeske 6/24/2012 15:50'!
initializeWith: aByteArray
	| objectCount |
	super initializeWith: aByteArray.
	self verifyIndexFile.
	fanoutTable := fullStream next: 1024. "256 4-byte big-endian entries."
	objectCount := self indexForFanout: 255.
	hashStream := (fullStream next: objectCount * 20) readStream.
	crcTable := fullStream next: objectCount * 4.
	fourByteOffsetStream := (fullStream next: objectCount * 4) readStream.
	eightByteOffsetStream := (fullStream next: objectCount * 8) readStream! !

!GitIndexFileVersion2 methodsFor: 'accessing' stamp: 'MaxLeske 6/24/2012 20:12'!
offsetForIndex: index
	| offset |
	fourByteOffsetStream position: (index * 4).
	offset := (fourByteOffsetStream next: 4) asInteger.
	"if there are more than 2GB entries (MSB set to 1), lookup in 8-byte offset table"
	^ (offset >= 16r80000000)
		ifFalse: [ offset ]
		ifTrue: [ 
			eightByteOffsetStream position: ((offset bitAnd: 16r7FFFFFFF) * 8).
			(eightByteOffsetStream next: 8) asInteger ]! !

!GitIndexFileVersion2 methodsFor: 'accessing' stamp: 'MaxLeske 6/24/2012 20:21'!
offsetForObjectNamed: hexHash
	^ self offsetForIndex: (self indexForObjectNamed: hexHash)! !

!GitIndexFileVersion2 methodsFor: 'verifying' stamp: 'MaxLeske 6/24/2012 15:50'!
verifyIndexFile
	self
		verifyIndexMagicNumber;
		verifyIndexVersion! !

!GitIndexFileVersion2 methodsFor: 'verifying' stamp: 'MaxLeske 6/24/2012 15:50'!
verifyIndexMagicNumber
	(fullStream next: 4) = self indexMagicNumber ifTrue: [ ^ self ]. 
	
	GitInvalidIndexFileError signal: 'Bad magic number. ',
	'Either this index file is corrupt or it is not a version 2 index.'! !

!GitIndexFileVersion2 methodsFor: 'verifying' stamp: 'MaxLeske 6/24/2012 15:50'!
verifyIndexVersion
	(fullStream next: 4) = self indexVersionTwo ifFalse: [
		GitInvalidIndexFileError signal: 'This index file is not of version 2.' ]! !

Object subclass: #GitModificationManager
	instanceVariableNames: 'createdPaths deletedPaths repository cache treeMap storedObjects hasChanges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Core'!

!GitModificationManager commentStamp: '<historical>' prior: 0!
I track the changes made to a GitFilesystem. On a commit all the changes are saved to "disk" and I am reset.!

!GitModificationManager class methodsFor: 'initialize-release' stamp: 'MaxLeske 10/18/2010 17:34'!
initializeWith: aRepository with: aCache for: aRevision
	^ self new 
		initializeWith: aRepository 
		with: aCache 
		for: aRevision! !

!GitModificationManager methodsFor: 'accessing' stamp: 'MaxLeske 10/17/2010 18:03'!
cache: aFilesystem
	cache := aFilesystem! !

!GitModificationManager methodsFor: 'accessing' stamp: 'CamilloBruni 7/15/2011 18:05'!
clearRootTree
	cache workingDirectory children do: [ :reference|
		reference deleteAll].
	
	self 
		initializeWith: repository
		with: cache
		for: nil! !

!GitModificationManager methodsFor: 'enumerating' stamp: 'CamilloBruni 7/5/2011 13:17'!
createdPathsDo: aBlock	
	| tree |
	createdPaths associations do: [ :assoc | 
		tree := self treeAt: assoc key. 
		assoc value do: [ :path |
			aBlock 
				value: tree
				value: path ] ]! !

!GitModificationManager methodsFor: 'testing' stamp: 'CamilloBruni 7/15/2011 20:58'!
hasModifications
	^ hasChanges! !

!GitModificationManager methodsFor: 'initialize-release' stamp: 'CamilloBruni 9/2/2012 12:38'!
initializeWith: aRepository with: aCache for: aRevision
	hasChanges := false.
	repository := aRepository.
	cache := aCache.
	treeMap := Dictionary new.
	createdPaths := Dictionary new.
	deletedPaths := Dictionary new.
	treeMap
		at: Path root
		put: (aRevision
			ifNotNil: [ self newTreeFrom: aRevision tree ]
			ifNil: [ self newTreeAt: Path root ])! !

!GitModificationManager methodsFor: 'testing' stamp: 'CamilloBruni 7/5/2011 17:05'!
isDeleted: aPath
	deletedPaths
			at: aPath parent
			ifPresent: [ :set | ^ set includes: aPath ].
	deletedPaths keysAndValuesDo: [ :parent :set|
			(parent contains: aPath)
				ifTrue: [
					(set anySatisfy: [ :path| path contains: aPath])
						ifTrue: [ ^ true ]
				].
		].
	^ false! !

!GitModificationManager methodsFor: 'private' stamp: 'CamilloBruni 9/3/2012 17:33'!
lookupTreeAt: aPath
	|tree|
	tree := self rootTree.
	"walk down the tree from the root directory by directory"
	aPath do: [ :segment |
		tree := tree
			entryAt: segment
			ifPresent: [ :entry | 
				"let's try to load the entry, might still be that it has been freshly added by a previous processCreation send"
				^ repository objectNamed: entry entryHexHash ifAbsent: [ nil]]
			ifAbsent: [ ^ nil ] ].! !

!GitModificationManager methodsFor: 'accessing' stamp: 'MaxLeske 3/6/2011 13:33'!
mapAll: aKeyedCollection
	aKeyedCollection associations do: [ :assoc | 
		treeMap 
			at: assoc key
			ifAbsentPut: [ assoc value ] ]! !

!GitModificationManager methodsFor: 'accessing' stamp: 'CamilloBruni 9/2/2012 12:44'!
markCreated: aPath 
	^ self 
		markCreated: aPath 
		inTree: (self treeAt: aPath parent)! !

!GitModificationManager methodsFor: 'accessing' stamp: 'CamilloBruni 8/30/2012 14:07'!
markCreated: aPath inTree: aTree
	| newTree |
	aPath = Path root ifTrue: [ ^ self ].

	treeMap
		at: aPath parent
		ifAbsentPut: [ self newTreeFrom: aTree ].
	
	(createdPaths
		at: aPath parent
		ifAbsentPut: [ GitSetWrapper new]) 
			add: aPath.! !

!GitModificationManager methodsFor: 'accessing' stamp: 'CamilloBruni 7/5/2011 16:23'!
markDeleted: aPath 
	^ self markDeleted: aPath 
		inTree: (self treeAt: aPath parent)! !

!GitModificationManager methodsFor: 'accessing' stamp: 'CamilloBruni 8/30/2012 13:54'!
markDeleted: aPath inTree: aTree
	| duplicateDeletions |
	aPath isRoot ifTrue: [self halt].
	hasChanges := true.
	
	"remove any children of the deleted path"
	duplicateDeletions := OrderedCollection new.
	deletedPaths keysAndValuesDo: [ :key :paths|
		(paths includesSubPath: aPath)
			ifTrue: [ duplicateDeletions add: key]].
	duplicateDeletions do: [:aKey | deletedPaths removeKey: aKey].
		
	"collect a list of deleted paths"
	(deletedPaths
		at: aPath parent
		ifAbsentPut: [ GitSetWrapper new]) 
			add: aPath.! !

!GitModificationManager methodsFor: 'accessing' stamp: 'CamilloBruni 8/1/2011 16:30'!
markDirectoryCreated: aPath 
	^ self markCreated: aPath! !

!GitModificationManager methodsFor: 'accessing' stamp: 'CamilloBruni 8/1/2011 16:30'!
markFileCreated: aPath 
	"only files trigger changes"
	hasChanges := true.
	^ self markCreated: aPath! !

!GitModificationManager methodsFor: 'accessing' stamp: 'MaxLeske 11/12/2010 21:56'!
nameOf: aPath
	| tree |
	tree := treeMap at: aPath parent.
	^ (tree entryAt: aPath basename) objectSignature hexHash! !

!GitModificationManager methodsFor: 'operations' stamp: 'CamilloBruni 9/3/2012 17:30'!
newTreeAt: aPath
	^ GitTree new
		repository: repository;
		yourself! !

!GitModificationManager methodsFor: 'private' stamp: 'CamilloBruni 9/3/2012 17:16'!
newTreeFrom: aTree
	self haltIf: repository isNil.
	^ GitTree 
		entries: aTree entries 
		in: repository! !

!GitModificationManager methodsFor: 'operations' stamp: 'CamilloBruni 9/3/2012 18:54'!
processBlobAt: path in: tree
	| reference data blob entry |
	reference := cache referenceTo: path.
	
	reference isFile ifFalse: [ ^ self].
	
	data := reference readStreamDo: [ :stream | stream contents ].
	blob := GitBlob bytes: data in: repository.
	blob store.
	
	entry := GitTreeEntry
		fileNamed: path basename
		hash: blob hash
		in: repository.
		
	tree putEntry: entry! !

!GitModificationManager methodsFor: 'operations' stamp: 'CamilloBruni 8/9/2011 19:14'!
processBlobs
	"only save new files here and put new git tree entries into their parent"
	
	| reference data blob entry |
	self createdPathsDo: [ :tree :path |
		self processBlobAt: path in: tree]! !

!GitModificationManager methodsFor: 'operations' stamp: 'CamilloBruni 7/15/2011 19:34'!
processChanges
	self processBlobs.
	self processCreations.
	self processDeletions.
	self storeTrees.! !

!GitModificationManager methodsFor: 'operations' stamp: 'CamilloBruni 9/3/2012 17:30'!
processCreationOf: entries from: entryPath
	|tree childTree|
	entries
		select: [ :path | (cache referenceTo: path) isDirectory ]
		thenDo: [ :directory |
			childTree := (self treeAt: directory).
			"don't process empty trees for now"
			childTree isEmpty ifFalse: [
				tree := (self treeAt: entryPath) 
					putEntry: (GitTreeEntry
						fileNamed: directory basename
						hash: childTree hash
						in: repository).
				self flag: 'TODO: update refs only once after processing all deletes and creates'.
				self updateParentSignaturesOfChanged: tree at: entryPath.]]! !

!GitModificationManager methodsFor: 'operations' stamp: 'CamilloBruni 8/9/2011 19:10'!
processCreations
	"create the deepest trees first to avoid regenration of signatures of the parent trees"
	| paths|
	paths := (createdPaths associations sorted: [ :assoc1 :assoc2 |
		assoc2 value maxDepth <= assoc1 value maxDepth ]).
	paths do: [ :assoc |
		self processCreationOf: assoc value from: assoc key]! !

!GitModificationManager methodsFor: 'operations' stamp: 'CamilloBruni 8/1/2011 16:59'!
processDeletionOf: entries from: entryPath
	"remove all the deleted files/paths from its parent (the current tree)"
	|  target tree|
	tree := self treeAt: entryPath.
	entries do: [ :path |
		tree removeEntryAt: path basename ifAbsent: []].
	entryPath isRoot ifTrue: [ ^ self].
	"update the entry in the repository with the new tree"
	self flag: 'TODO: update refs only once after processing all deletes and creates'.
	self updateParentSignaturesOfChanged: tree at: entryPath.! !

!GitModificationManager methodsFor: 'operations' stamp: 'CamilloBruni 8/1/2011 16:59'!
processDeletions
	| entryPath target |
	deletedPaths copy keysAndValuesDo: [ :path :deletedEntries |
		self processDeletionOf: deletedEntries from: path]! !

!GitModificationManager methodsFor: 'accessing' stamp: 'CamilloBruni 9/2/2012 12:40'!
repository: aRepository
	repository := aRepository.
	"recursively walk over the treeMap and change the repository".
	treeMap do: [ :gitObject | gitObject repository: aRepository ]! !

!GitModificationManager methodsFor: 'accessing' stamp: 'CamilloBruni 8/30/2012 14:07'!
rootTree
	^ treeMap at: Path root! !

!GitModificationManager methodsFor: 'operations' stamp: 'CamilloBruni 7/5/2011 13:20'!
storeCreatedTrees
	createdPaths keysDo: [ :path | self storeTreeAt: path].
	"(createdPaths associations sorted: [ :assoc1 :assoc2 |
		assoc2 value maxSize <= assoc1 value maxSize ]) do: [ :assoc |
			self storeTreeAt: assoc key]."! !

!GitModificationManager methodsFor: 'operations' stamp: 'CamilloBruni 7/5/2011 13:19'!
storeDeletedTrees
	"store the changed trees"
	deletedPaths keysDo: [ :path | self storeTreeAt: path].! !

!GitModificationManager methodsFor: 'operations' stamp: 'MaxLeske 2/28/2012 16:22'!
storeTree: aTree 
	(storedObjects includes: aTree) ifTrue: [ ^ self ].
	storedObjects add: aTree.
	"don't store empty trees"
	aTree isEmpty ifFalse: [ aTree store ].! !

!GitModificationManager methodsFor: 'operations' stamp: 'CamilloBruni 8/1/2011 17:10'!
storeTreeAt: aPath
	aPath isRoot ifTrue: [ ^ self ].
	"bubble up the tree hierarchy and save all of them"
	self storeTreeAt: aPath parent.
	self storeTree: (self treeAt: aPath).! !

!GitModificationManager methodsFor: 'operations' stamp: 'MaxLeske 2/28/2012 16:22'!
storeTrees
	storedObjects := Set new.
	self storeCreatedTrees.
	self storeDeletedTrees.
	self rootTree store! !

!GitModificationManager methodsFor: 'private' stamp: 'CamilloBruni 8/9/2011 19:28'!
treeAt: aPath
	| tree |
	treeMap
		at: aPath
		ifPresent: [ :aTree| ^ aTree].
	tree := (self lookupTreeAt: aPath)	
				ifNil: [ self newTreeAt: aPath ].
	treeMap at: aPath put: tree.
	^ tree ! !

!GitModificationManager methodsFor: 'accessing' stamp: 'CamilloBruni 7/15/2011 21:10'!
updateCacheAt: aPath with: aGitTree.
	treeMap 
		at: aPath
		ifAbsentPut: [ aGitTree]! !

!GitModificationManager methodsFor: 'operations' stamp: 'CamilloBruni 9/3/2012 18:54'!
updateParentSignaturesOfChanged: target at: aPath 
	"recursively update the refs of the target and subsequently remove empty directories"
	|parent|
	self flag: 'TODO: update refs only once after processing all deletes and creates'.
	aPath isRoot ifTrue: [ ^ self ].
	parent := self treeAt: aPath parent.
	target isEmpty 
		ifTrue: [
			parent removeEntryAt: aPath basename.]
		ifFalse: [
			parent putEntry: 
				(GitTreeEntry
					fileNamed: aPath basename
					hash: target hash
					in: repository)].
	self updateParentSignaturesOfChanged: parent at: aPath parent. ! !

Object subclass: #GitPackFile
	instanceVariableNames: 'objectCount packData repository reference indexFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Packs'!

!GitPackFile class methodsFor: 'instance creation' stamp: 'MaxLeske 2/29/2012 18:03'!
on: aReference in: aRepository
	^ self new
		initializeWith: aReference
		in: aRepository! !

!GitPackFile class methodsFor: 'instance creation' stamp: 'MaxLeske 8/12/2012 13:47'!
pack: aRepository
	| instance |
	instance := self new.
	instance repository: aRepository.
	(GitPackFileCreator on: instance) repackWithoutDelification.
	
	^ instance! !

!GitPackFile methodsFor: 'operations' stamp: 'MaxLeske 8/12/2012 13:33'!
delete
	self reference delete! !

!GitPackFile methodsFor: 'public-testing' stamp: 'MaxLeske 9/8/2012 13:20'!
hasIndexFile
	^ self indexFile notNil! !

!GitPackFile methodsFor: 'accessing' stamp: 'MaxLeske 6/23/2012 20:13'!
indexFile
	^ indexFile ! !

!GitPackFile methodsFor: 'initialize-release' stamp: 'MaxLeske 9/1/2012 20:45'!
initializeIndex 
	| noExtension indexReference |
	noExtension := self reference basename copyUpToLast: $..
	indexReference := (self reference parent / noExtension), 'idx'.
	indexReference exists ifFalse: [ ^ self ].
	indexFile := GitIndexFile on: indexReference! !

!GitPackFile methodsFor: 'initialize-release' stamp: 'MaxLeske 6/23/2012 20:39'!
initializeWith: aReference in: aRepository
	self 
		repository: aRepository;
		reference: aReference;
		readHeaders;
		initializeIndex! !

!GitPackFile methodsFor: 'public-accessing' stamp: 'MaxLeske 9/8/2012 10:09'!
numberOfObjects
	^ objectCount! !

!GitPackFile methodsFor: 'public-accessing' stamp: 'MaxLeske 6/23/2012 17:08'!
objectAtOffset: offset 
	^ GitPackedObject
		fromPack: self
		at: offset
		in: self repository! !

!GitPackFile methodsFor: 'public-accessing' stamp: 'MaxLeske 6/23/2012 19:34'!
objectNamed: hexHash
	^ self objectAtOffset: (indexFile offsetForObjectNamed: hexHash)! !

!GitPackFile methodsFor: 'accessing' stamp: 'MaxLeske 6/23/2012 17:08'!
packData
	^ packData ifNil: [ 
		packData := self reference readStreamDo: [ :stream | stream contents ] ].! !

!GitPackFile methodsFor: 'enumerating' stamp: 'MaxLeske 9/8/2012 20:45'!
packedObjectsDo: aBlock
	| position |
	"First entry is at position 12, after header"
	position := 12.
	objectCount timesRepeat: [ | object |
		object := GitPackedObject
			fromPack: self
			at: position
			in: repository.
		position := position + object lengthInPack.
		aBlock value: object ]! !

!GitPackFile methodsFor: 'initialize-release' stamp: 'MaxLeske 9/8/2012 08:55'!
readHeaders
	| stream |
	stream := self readStream.
	self
		verifyPackFileIdentifierFrom: stream;
		verifyPackFileVersionFrom: stream.
	objectCount := (stream next: 4) asInteger.! !

!GitPackFile methodsFor: 'accessing' stamp: 'MaxLeske 6/23/2012 17:09'!
readStream
	^ self packData readStream! !

!GitPackFile methodsFor: 'accessing' stamp: 'MaxLeske 2/29/2012 18:47'!
reference
	^ reference! !

!GitPackFile methodsFor: 'accessing' stamp: 'MaxLeske 2/29/2012 18:48'!
reference: aReference
	reference := aReference! !

!GitPackFile methodsFor: 'public-operations' stamp: 'MaxLeske 8/5/2012 18:09'!
repackWithoutDelification
	(GitPackFileCreator on: self) repackWithoutDelification! !

!GitPackFile methodsFor: 'accessing' stamp: 'MaxLeske 2/29/2012 17:46'!
repository
	^ repository! !

!GitPackFile methodsFor: 'accessing' stamp: 'MaxLeske 2/29/2012 17:46'!
repository: anObject
	repository := anObject! !

!GitPackFile methodsFor: 'public-operations' stamp: 'MaxLeske 9/8/2012 10:06'!
unpack
	GitPackFileUnpacker unpack: self! !

!GitPackFile methodsFor: 'initialize-release' stamp: 'MaxLeske 9/8/2012 08:53'!
verifyPackFileIdentifierFrom: aStream
	| id |
	id := (aStream next: 4) asString.
	id = 'PACK' ifTrue: [ ^ self ].
	
	GitInvalidPackFileError signal: 'This doesn''t seem to be a pack file. Name was: ', id, 'but should have been ''PACK'''! !

!GitPackFile methodsFor: 'initialize-release' stamp: 'MaxLeske 9/8/2012 08:54'!
verifyPackFileVersionFrom: aStream
	| version |
	version := (aStream next: 4) asInteger.
	(#(1 2) includes: version) ifTrue: [ ^ self ].
	
	GitInvalidPackFileError signal: 'Pack file version was: ', (version asString),' but can only read versions 1 and 2'! !

Object subclass: #GitPackFileCreator
	uses: TGitVisitor
	instanceVariableNames: 'packFile repository orderedHashes hashDict sortedHashes indexFile packFileChecksum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Packs'!

GitPackFileCreator class
	uses: TGitVisitor classTrait
	instanceVariableNames: ''!

!GitPackFileCreator class methodsFor: 'instance creation' stamp: 'MaxLeske 8/5/2012 18:08'!
on: aPackFile
	^ self new initializeWith: aPackFile! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 8/29/2012 15:29'!
addObject: aGitObject
	| hash |
	hash := aGitObject hash.
	self hashDict 
		at: hash
		ifAbsent: [
			self hashDict at: hash put: nil.
			self orderedHashes add: hash ]! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 9/1/2012 20:30'!
fanoutOffsets
	^ Array streamContents: [ :stream || reader |
		reader := self sortedHashes readStream.
		0 to: 255 do: [ :byte |
			[ reader atEnd not
			and: [ (reader peek bitShift: -152) = byte ] ] whileTrue: [ reader next ].
		
			stream nextPut: (reader position asByteArrayOfSize: 4) ] ]! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 8/19/2012 18:39'!
hashDict
	^ hashDict ifNil: [ hashDict := Dictionary new ]! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 8/29/2012 15:36'!
indexFile
	^ indexFile! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 8/29/2012 15:36'!
indexFile: anIndexFile
	indexFile := anIndexFile! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 8/19/2012 19:11'!
indexFileIdentifier
	"The magic number is (\377 is a non ascii character
	equalling the integer 255): \377tOc"
	^ #[ 255 116 79 99 ]! !

!GitPackFileCreator methodsFor: 'initialize-release' stamp: 'MaxLeske 8/29/2012 15:35'!
initializeWith: aPackFile
	| dir |
	self 
		packFile: aPackFile;
		indexFile: GitIndexFileVersion2 new;
		repository: aPackFile repository.
	dir := aPackFile repository packsDir.
	aPackFile reference:  dir / 'tmp_pack_XXXXXX'.
	self indexFile reference: dir / 'tmp_idx_XXXXXX'! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 8/29/2012 15:29'!
numberOfObjects
	^ self hashDict size! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 8/19/2012 18:35'!
orderedHashes
	^ orderedHashes ifNil: [ orderedHashes := OrderedCollection new ]! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 8/5/2012 18:10'!
packFile
	^ packFile! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 8/5/2012 18:10'!
packFile: aPackFile
	packFile := aPackFile! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 8/29/2012 15:53'!
packFileChecksum
	^ packFileChecksum! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 8/29/2012 15:53'!
packFileChecksum: aByteArray
	packFileChecksum := aByteArray asByteArray! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 8/12/2012 14:24'!
packFileIdentifier
	^ #[80 65 67 75] "'PACK' asByteArray"! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 9/2/2012 20:50'!
recordOffset: anInteger for: aHash
	self hashDict at: aHash put: anInteger! !

!GitPackFileCreator methodsFor: 'public-operations' stamp: 'MaxLeske 8/19/2012 18:44'!
repackWithoutDelification
	self 
		visitRepository: self packFile repository;
		writePackFile;
		writeIndexFile;
		writeFileNames
	! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 8/12/2012 14:27'!
repository
	^ repository! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 8/12/2012 14:27'!
repository: aGitRepository
	repository := aGitRepository! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 8/29/2012 15:31'!
sortedHashes
	^ sortedHashes ifNil: [ sortedHashes := self orderedHashes asSortedCollection ]! !

!GitPackFileCreator methodsFor: 'accessing' stamp: 'MaxLeske 8/19/2012 19:09'!
versionNumber
	^ #[0 0 0 2] "version 2"! !

!GitPackFileCreator methodsFor: 'visiting' stamp: 'MaxLeske 8/18/2012 15:57'!
visitBlob: aBlob
	self addObject: aBlob! !

!GitPackFileCreator methodsFor: 'visiting' stamp: 'MaxLeske 8/18/2012 15:57'!
visitCommit: aCommit
	self 
		addObject: aCommit;
		visitTree: aCommit tree;
		visitCollection: aCommit parents! !

!GitPackFileCreator methodsFor: 'visiting' stamp: 'MaxLeske 8/18/2012 16:42'!
visitTag: aTag
	aTag isLightWeightTag ifTrue: [ ^ self ].
	
	self 
		addObject: aTag;
		visitCommit: aTag object! !

!GitPackFileCreator methodsFor: 'visiting' stamp: 'MaxLeske 8/18/2012 15:58'!
visitTree: aTree
	self
		addObject: aTree; 
		visitCollection: aTree objects! !

!GitPackFileCreator methodsFor: 'operations-writing-index' stamp: 'MaxLeske 9/2/2012 20:50'!
write4ByteIndexTableOn: aStream
	| index |
	index := 0.
	self sortedHashes do: [ :integer |
		aStream nextPutAll: ((index bitOr: 16r80000000) asByteArrayOfSize: 4).
		index := index + 8 ]! !

!GitPackFileCreator methodsFor: 'operations-writing-index' stamp: 'MaxLeske 8/29/2012 21:22'!
writeCRCTableOn: aStream
	self sortedHashes do: [ :integer || object |
		object := self repository objectNamed: integer asHexHash.
		aStream nextPutAll: (object crc asByteArrayOfSize: 4) ]! !

!GitPackFileCreator methodsFor: 'operations-writing-index' stamp: 'MaxLeske 8/28/2012 15:20'!
writeFanoutTableOn: aStream
	"fanout byte N is the offset for the object names whose first byte <= N"
	self fanoutOffsets do: [ :offset |
		aStream nextPutAll: offset ]! !

!GitPackFileCreator methodsFor: 'operations-writing' stamp: 'MaxLeske 9/2/2012 12:20'!
writeFileNames
	| finalHash message name |
	message := (self sortedHashes gather: [ :integer | integer asByteArray ]) asByteArray.
	finalHash := GitHash from: message.
	name := self packFile reference parent / ('pack-', finalHash hexHash).
	self packFile reference moveTo: name, 'pack'.
	self indexFile reference moveTo: name, 'idx'! !

!GitPackFileCreator methodsFor: 'operations-writing-index' stamp: 'MaxLeske 8/29/2012 20:31'!
writeIndexFile
	self indexFile reference writeStreamDo: [ :stream | 
		self
			writeIndexFileHeaderOn: stream;
			writeFanoutTableOn: stream;
			writeObjectNamesOn: stream;
			writeCRCTableOn: stream;
			writeOffsetTablesOn: stream;
			writeIndexFileTrailerOn: stream ]! !

!GitPackFileCreator methodsFor: 'operations-writing-index' stamp: 'MaxLeske 8/19/2012 19:09'!
writeIndexFileHeaderOn: aStream
	aStream
		nextPutAll: self indexFileIdentifier;
		nextPutAll: self versionNumber! !

!GitPackFileCreator methodsFor: 'operations-writing-index' stamp: 'MaxLeske 9/1/2012 19:51'!
writeIndexFileTrailerOn: aStream
	aStream 
		nextPutAll: self packFileChecksum;
		nextPutAll: (GitHash from: aStream contents) byteHash! !

!GitPackFileCreator methodsFor: 'operations-writing-pack' stamp: 'MaxLeske 8/12/2012 18:34'!
writeObjectHeader: anObject on: aStream
	| type size byte |
	type := anObject class byteTypeCode. "e.g. 2r00110000"
	size := anObject size.
	
	byte := type bitOr: (size bitAnd: 2r00001111).
	size := size bitShift: -4.
	[ size > 0 ] whileTrue: [
		aStream nextPut: (byte bitOr: 2r10000000).
		byte := size bitAnd: 2r01111111.
		size := size bitShift: -7 ].
	aStream nextPut: byte! !

!GitPackFileCreator methodsFor: 'operations-writing-index' stamp: 'MaxLeske 8/29/2012 20:19'!
writeObjectNamesOn: aStream
	self sortedHashes do: [ :integer |
		aStream nextPutAll: integer asByteHash ]! !

!GitPackFileCreator methodsFor: 'operations-writing-pack' stamp: 'MaxLeske 9/8/2012 15:27'!
writeObjectsOn: aStream
	self sortedHashes do: [ :hash || object |
		object := self repository objectNamed: hash asHexHash.
		self recordOffset: aStream position for: hash.
		self writeObjectHeader: object on: aStream.
		object compressedForPackOn: aStream ]! !

!GitPackFileCreator methodsFor: 'operations-writing-index' stamp: 'MaxLeske 9/2/2012 20:49'!
writeOffsetTableOfSize: size on: aStream
	self sortedHashes do: [ :integer |
		aStream nextPutAll: ((self hashDict at: integer) asByteArrayOfSize: size) ]! !

!GitPackFileCreator methodsFor: 'operations-writing-index' stamp: 'MaxLeske 9/2/2012 20:52'!
writeOffsetTablesOn: aStream
	self sortedHashes size >  16r80000000
		ifFalse: [ self writeOffsetTableOfSize: 4 on: aStream ]
		ifTrue: [
			self 
				write4ByteIndexTableOn: aStream;
				writeOffsetTableOfSize: 8 on: aStream ]! !

!GitPackFileCreator methodsFor: 'operations-writing-pack' stamp: 'MaxLeske 9/1/2012 09:47'!
writePackFile
	self packFile reference writeStreamDo: [ :stream |
		self
			writePackFileHeaderOn: stream;
			writeObjectsOn: stream;
			writePackFileTrailerOn: stream ]! !

!GitPackFileCreator methodsFor: 'operations-writing-pack' stamp: 'MaxLeske 8/19/2012 19:09'!
writePackFileHeaderOn: aStream
	aStream
		nextPutAll: self packFileIdentifier;
		nextPutAll: self versionNumber;
		nextPutAll: (self numberOfObjects asByteArrayOfSize: 4)! !

!GitPackFileCreator methodsFor: 'operations-writing' stamp: 'MaxLeske 9/3/2012 21:07'!
writePackFileTrailer
	| checksum size reader |
	reader := self packFile readStream.
	checksum := [ (GitHash from: reader) hash ]
		ensure: [ reader close ].
	size := self packFile reference entry size.
	self packFile reference writeStreamDo: [ :stream |
		stream position: size + 1.
		stream nextPutAll: checksum asByteArray ]! !

!GitPackFileCreator methodsFor: 'operations-writing-pack' stamp: 'MaxLeske 9/1/2012 20:06'!
writePackFileTrailerOn: aStream
	self packFileChecksum: (GitHash from: aStream contents) byteHash.
	
	aStream nextPutAll: self packFileChecksum ! !

Object subclass: #GitPackFileUnpacker
	instanceVariableNames: 'packFile deltaQueue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Packs'!

!GitPackFileUnpacker class methodsFor: 'instance creation' stamp: 'MaxLeske 9/8/2012 10:02'!
unpack: aGitPackFile
	self new
		packFile: aGitPackFile;
		unpack! !

!GitPackFileUnpacker methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 10:29'!
deltaQueue
	^ deltaQueue ifNil: [ deltaQueue := OrderedCollection new ]! !

!GitPackFileUnpacker methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 10:03'!
packFile
	^ packFile! !

!GitPackFileUnpacker methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 10:03'!
packFile: aGitPackFile
	packFile := aGitPackFile! !

!GitPackFileUnpacker methodsFor: 'operations' stamp: 'MaxLeske 9/8/2012 12:49'!
processDeltas
	self deltaQueue do: [ :packedDelta | 
		self unpackDelta: packedDelta ]! !

!GitPackFileUnpacker methodsFor: 'accessing' stamp: 'MaxLeske 9/8/2012 10:28'!
queueDelta: aPackedObject
	self deltaQueue add: aPackedObject ! !

!GitPackFileUnpacker methodsFor: 'public-operations' stamp: 'MaxLeske 9/8/2012 13:24'!
unpack
	self packFile hasIndexFile
		ifTrue: [ self unpackWithIndexFile ]
		ifFalse: [ self unpackWithoutIndexFile ]! !

!GitPackFileUnpacker methodsFor: 'operations' stamp: 'MaxLeske 9/8/2012 12:50'!
unpackDelta: aPackedDelta
	(self packFile repository hasLooseObject: aPackedDelta deltaBaseName)
		ifTrue: [ aPackedDelta unpack; store ]
		ifFalse: [ self queueDelta: aPackedDelta ]! !

!GitPackFileUnpacker methodsFor: 'operations' stamp: 'MaxLeske 9/8/2012 10:05'!
unpackWithIndexFile
	self packFile packedObjectsDo: [ :packedObject |
		packedObject object store ]! !

!GitPackFileUnpacker methodsFor: 'operations' stamp: 'MaxLeske 9/8/2012 20:45'!
unpackWithoutIndexFile
	| reader count |
	reader := self packFile readStream.
	reader skip: 12. "skip header"
	
	count := self packFile numberOfObjects.
	count timesRepeat: [ | packedObject |
		packedObject := self packFile objectAtOffset: reader position.
		packedObject class = GitPackedNonDelta 
			ifTrue: [ packedObject store ]
			ifFalse: [ self unpackDelta: packedObject ].
		reader position: reader position + packedObject lengthInPack.
		
		count := count - 1 ].
	self processDeltas! !

Object subclass: #GitProtocolCapabilities
	instanceVariableNames: 'capabilities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Remote'!

!GitProtocolCapabilities commentStamp: '<historical>' prior: 0!
https://github.com/git/git/blob/master/Documentation/technical/protocol-capabilities.txt!

!GitProtocolCapabilities class methodsFor: 'instance creation' stamp: 'CamilloBruni 1/15/2012 22:30'!
deleteRefs
	^ self new deleteRefs! !

!GitProtocolCapabilities class methodsFor: 'instance creation' stamp: 'CamilloBruni 1/15/2012 22:30'!
includeTag
	^ self new includeTag! !

!GitProtocolCapabilities class methodsFor: 'instance creation' stamp: 'CamilloBruni 1/15/2012 22:30'!
multiAck
	^ self new multiAck! !

!GitProtocolCapabilities class methodsFor: 'instance creation' stamp: 'CamilloBruni 1/15/2012 22:31'!
noProgress
	^ self new noProgress! !

!GitProtocolCapabilities class methodsFor: 'instance creation' stamp: 'CamilloBruni 1/15/2012 22:31'!
ofsDelta
	^ self new ofsDelta! !

!GitProtocolCapabilities class methodsFor: 'instance creation' stamp: 'CamilloBruni 1/15/2012 22:31'!
reportStatus
	^ self new reportStatus! !

!GitProtocolCapabilities class methodsFor: 'instance creation' stamp: 'CamilloBruni 1/15/2012 22:31'!
shallow
	^ self new shallow! !

!GitProtocolCapabilities class methodsFor: 'instance creation' stamp: 'CamilloBruni 1/15/2012 22:31'!
sideBand
	^ self new sideBand! !

!GitProtocolCapabilities class methodsFor: 'instance creation' stamp: 'CamilloBruni 1/15/2012 22:31'!
sideBand64k
	^ self new sideBand64k! !

!GitProtocolCapabilities class methodsFor: 'instance creation' stamp: 'CamilloBruni 1/15/2012 22:32'!
thinPack
	^ self new thinPack! !

!GitProtocolCapabilities methodsFor: 'capabilities' stamp: 'CamilloBruni 1/15/2012 22:31'!
deleteRefs

	"If the server sends back the 'delete-refs' capability, it means that
it is capable of accepting a zero-id value as the target
value of a reference update.  It is not sent back by the client, it
simply informs the client that it can be sent zero-id values
to delete references."

	^ self enable: #'delete-refs'
! !

!GitProtocolCapabilities methodsFor: 'private' stamp: 'CamilloBruni 1/15/2012 22:24'!
disable: aCapability
	capabilities remove: aCapability ifAbsent: [].! !

!GitProtocolCapabilities methodsFor: 'private' stamp: 'CamilloBruni 1/15/2012 22:24'!
enable: aCapability
	capabilities add: aCapability.! !

!GitProtocolCapabilities methodsFor: 'capabilities' stamp: 'CamilloBruni 1/15/2012 22:31'!
includeTag

	"The 'include-tag' capability is about sending annotated tags if we are
sending objects they point to.  If we pack an object to the client, and
a tag object points exactly at that object, we pack the tag object too.
In general this allows a client to get all new annotated tags when it
fetches a branch, in a single network connection.

Clients MAY always send include-tag, hardcoding it into a request when
the server advertises this capability. The decision for a client to
request include-tag only has to do with the client's desires for tag
data, whether or not a server had advertised objects in the
refs/tags/* namespace.

Servers MUST pack the tags if their referrant is packed and the client
has requested include-tags.

Clients MUST be prepared for the case where a server has ignored
include-tag and has not actually sent tags in the pack.  In such
cases the client SHOULD issue a subsequent fetch to acquire the tags
that include-tag would have otherwise given the client.

The server SHOULD send include-tag, if it supports it, regardless
of whether or not there are tags available."

	^ self enable: #'include-tag'
! !

!GitProtocolCapabilities methodsFor: 'initialize-release' stamp: 'CamilloBruni 1/15/2012 22:25'!
initialize
	super initialize.
	capabilities := Set new.! !

!GitProtocolCapabilities methodsFor: 'capabilities' stamp: 'CamilloBruni 1/15/2012 22:31'!
multiAck

	"The 'multi_ack' capability allows the server to return 'ACK obj-id
continue' as soon as it finds a commit that it can use as a common
base, between the client's wants and the client's have set.

By sending this early, the server can potentially head off the client
from walking any further down that particular branch of the client's
repository history.  The client may still need to walk down other
branches, sending have lines for those, until the server has a
complete cut across the DAG, or the client has said 'done'

Without multi_ack, a client sends have lines in --date-order until
the server has found a common base.  That means the client will send
have lines that are already known by the server to be common, because
they overlap in time with another branch that the server hasn't found
a common base on yet.

For example suppose the client has commits in caps that the server
doesn't and the server has commits in lower case that the client
doesn't, as in the following diagram:

       +---- u ---------------------- x
      /              +----- y
     /              /
    a -- b -- c -- d -- E -- F
       \
	+--- Q -- R -- S

If the client wants x,y and starts out by saying have F,S, the server
doesn't know what F,S is.  Eventually the client says 'have d' and
the server sends 'ACK d continue' to let the client know to stop
walking down that line (so don't send c-b-a), but it's not done yet,
it needs a base for x. The client keeps going with S-R-Q, until a
gets reached, at which point the server has a clear base and it all
ends.

Without multi_ack the client would have sent that c-b-a chain anyway,
interleaved with S-R-Q."
	
	^ self enable: #'multi_ack'! !

!GitProtocolCapabilities methodsFor: 'capabilities' stamp: 'CamilloBruni 1/15/2012 22:18'!
noProgress

	"The client was started with 'git clone -q' or something, and doesn't
want that side band 2.  Basically the client just says 'I do not
wish to receive stream 2 on sideband, so do not send it to me, and if
you did, I will drop it on the floor anyway'.  However, the sideband
channel 3 is still used for error responses."

	^ self enable: #'no-progress'! !

!GitProtocolCapabilities methodsFor: 'capabilities' stamp: 'CamilloBruni 1/15/2012 22:31'!
ofsDelta

	"Server can send, and client understand PACKv2 with delta referring to
its base by position in pack rather than by an obj-id.  That is, they can
send/read OBJ_OFS_DELTA (aka type 6) in a packfile."
	
	^ self enable: #'ofs-delta'! !

!GitProtocolCapabilities methodsFor: 'printing' stamp: 'DamienCassou 1/31/2013 13:27'!
printOn: aStream
	capabilities 
		do: [ :capability|
			aStream nextPutAll: capability ]
		separatedBy: [ aStream nextPut: Character space].! !

!GitProtocolCapabilities methodsFor: 'capabilities' stamp: 'CamilloBruni 1/15/2012 22:31'!
reportStatus
	
	"The upload-pack process can receive a 'report-status' capability,
which tells it that the client wants a report of what happened after
a packfile upload and reference update.  If the pushing client requests
this capability, after unpacking and updating references the server
will respond with whether the packfile unpacked successfully and if
each reference was updated successfully.  If any of those were not
successful, it will send back an error message.  See pack-protocol.txt
for example messages."
	
	^ self enable: #'report-status'! !

!GitProtocolCapabilities methodsFor: 'capabilities' stamp: 'CamilloBruni 1/15/2012 22:31'!
shallow

	"This capability adds 'deepen', 'shallow' and 'unshallow' commands to
the  fetch-pack/upload-pack protocol so clients can request shallow
clones."
	
	^ self enable: #'shallow'! !

!GitProtocolCapabilities methodsFor: 'capabilities' stamp: 'CamilloBruni 1/15/2012 22:31'!
sideBand

	"Comment see GitProtocolCapabilities >> # sideBand:"
	
	self disable: #'side-band-64k'.
	^ self enable: #'side-band'.! !

!GitProtocolCapabilities methodsFor: 'capabilities' stamp: 'CamilloBruni 1/15/2012 22:31'!
sideBand64k

	"Comment see GitProtocolCapabilities >> # sideBand:"

	self disable: #'side-band'.
	^ self enable: #'side-band-64k'.! !

!GitProtocolCapabilities methodsFor: 'capabilities' stamp: 'CamilloBruni 1/15/2012 22:20'!
sideBand: is64k
	
	"This capability means that server can send, and client understand multiplexed
progress reports and error info interleaved with the packfile itself.

These two options are mutually exclusive. A modern client always
favors 'side-band-64k'.

Either mode indicates that the packfile data will be streamed broken
up into packets of up to either 1000 bytes in the case of 'side_band',
or 65520 bytes in the case of 'side_band_64k'. Each packet is made up
of a leading 4-byte pkt-line length of how much data is in the packet,
followed by a 1-byte stream code, followed by the actual data.

The stream code can be one of:

 1 - pack data
 2 - progress messages
 3 - fatal error message just before stream aborts

The 'side-band-64k' capability came about as a way for newer clients
that can handle much larger packets to request packets that are
actually crammed nearly full, while maintaining backward compatibility
for the older clients.

Further, with side-band and its up to 1000-byte messages, it's actually
999 bytes of payload and 1 byte for the stream code. With side-band-64k,
same deal, you have up to 65519 bytes of data and 1 byte for the stream
code.

The client MUST send only maximum of one of 'side-band' and 'side-
band-64k'.  Server MUST diagnose it as an error if client requests
both."
	
	^ is64k
		ifTrue: [ self sideBand ] 
		ifFalse: [ self sideBand64k ]
! !

!GitProtocolCapabilities methodsFor: 'capabilities' stamp: 'CamilloBruni 1/15/2012 22:19'!
thinPack

	"This capability means that the server can send a 'thin' pack, a pack
which does not contain base objects; if those base objects are available
on client side. Client requests 'thin-pack' capability when it
understands how to 'thicken' it by adding required delta bases making
it self-contained.

Client MUST NOT request 'thin-pack' capability if it cannot turn a thin
pack into a self-contained pack."
	
	^ self enable: #'thin-pack'! !

Object subclass: #GitProtocolReader
	instanceVariableNames: 'stream fourByteLookahead'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Remote'!

!GitProtocolReader commentStamp: '<historical>' prior: 0!
Takes care of reading responses from a server

https://github.com/git/git/blob/master/Documentation/technical/pack-protocol.txt!

!GitProtocolReader class methodsFor: 'configuration' stamp: 'DamienCassou 1/30/2013 16:51'!
nakValue
	^ #[78 65 75 10] "NAK\n"! !

!GitProtocolReader class methodsFor: 'instance creation' stamp: 'DamienCassou 1/30/2013 16:44'!
on: aStream
	^ self basicNew
		initializeWith: aStream;
		yourself! !

!GitProtocolReader methodsFor: 'private receiving' stamp: 'CamilloBruni 2/12/2013 18:08'!
fourByteLookahead
	^ fourByteLookahead ifNil: [ fourByteLookahead := self stream next: 4 ]! !

!GitProtocolReader methodsFor: 'initialize-release' stamp: 'DamienCassou 1/30/2013 16:25'!
initializeWith: aStream
	self initialize.
	stream := aStream.! !

!GitProtocolReader methodsFor: 'receiving' stamp: 'DamienCassou 2/4/2013 08:57'!
parseUploadPackResponse
	| result firstLine firstSplit capabilities|

	result := Dictionary new.
	
	"the first line is special: after a null character, there is a list of capabilities" 
	firstLine := self readPktLineIfZero: [Error signal: 'The response was not well formed' ].
	firstSplit := Character null split: firstLine.
	
	"e.g., 'multi_ack thin-pack side-band side-band-64k ofs-delta'"
	result at: #capabilities put: (Character space split: firstSplit second).
	
	"e.g., '32f1d219977eff6d466950ddb6e086dc7d5f3f4f HEAD'"
	firstSplit := Character space split: firstSplit first.
	result at: firstSplit second put: firstSplit first.
	
	self readLines: [ :line |
		| parts |
		(line beginsWith: '#') ifFalse: [ 
			parts := Character space split: line.
			result at: parts second put: parts first ]].
	^ result! !

!GitProtocolReader methodsFor: 'private receiving' stamp: 'CamilloBruni 2/12/2013 18:07'!
peekForNAK
	^  self fourByteLookahead = #[78 65 75 10]  "NAK\n"! !

!GitProtocolReader methodsFor: 'private receiving' stamp: 'DamienCassou 1/30/2013 16:29'!
readContentOfLength: anInteger
	^ stream next: anInteger - 4 "skip length header bytes"! !

!GitProtocolReader methodsFor: 'private receiving' stamp: 'CamilloBruni 2/12/2013 18:08'!
readLineLength
	| lineLength |
	lineLength := Integer readFrom: self fourByteLookahead asString base: 16.
	self resetFourByteLookahead.
	^ lineLength! !

!GitProtocolReader methodsFor: 'private receiving' stamp: 'DamienCassou 1/30/2013 17:10'!
readLines: aBlock
	
	self readLinesUpTo: '0000' do: aBlock! !

!GitProtocolReader methodsFor: 'private receiving' stamp: 'DamienCassou 1/30/2013 17:10'!
readLinesUpTo: terminator do: aBlock
	" read input until we get the terminating line"
	[true] whileTrue: [
		|pktLine|
		pktLine := self readPktLineIfZero: [ ^ self ].
		pktLine = terminator ifTrue: [ ^ self ].
		aBlock value: pktLine ]! !

!GitProtocolReader methodsFor: 'dead-code?' stamp: 'DamienCassou 1/30/2013 16:30'!
readPackfile
	|  objects |
	self isThisEverCalled.
	objects := OrderedCollection new.
	
	self readLines: [ :line| 
		| isContent code |
		code := line first.
		isContent := (code == 1 asCharacter).
		isContent 
			ifFalse: [ Transcript show: (line allButFirst: 1); cr. ]
			ifTrue: [ objects add: (GitPackedObject loadFrom: (line allButFirst: 1) readStream)]
	].

	^ objects! !

!GitProtocolReader methodsFor: 'private receiving' stamp: 'DamienCassou 1/30/2013 16:30'!
readPackfileResponse
"TODO:
find out, why SocketStream doesn't deliver all of the data or corrupts it (or who else does).
Careful: when using Transcript for debugging, the code might become so slow that you won't see any problems with receiving data..."
	
	self readUntilNAK.
	
	^ ByteArray streamContents: [ :packStream | 
		[ :job | [
			self 
				readSideBandResponseIfData: [ :data | packStream nextPutAll: data ]
				ifMessage: [ :message | job title: (message splitOn: Character lf) first asString ]
				ifError: [ :errorMessage | Error signal: errorMessage ]
				ifZero: [ ^ packStream contents ].
			stream atEnd ] whileFalse
		] asJob run ].! !

!GitProtocolReader methodsFor: 'private receiving' stamp: 'DamienCassou 1/30/2013 16:31'!
readPktLine
	^ self readPktLineIfZero: [ Error signal: 'Special case 0000 encountered.' ]! !

!GitProtocolReader methodsFor: 'private receiving' stamp: 'DamienCassou 1/31/2013 10:53'!
readPktLineIfZero: aBlock
	" A PktLine consist of a 4 byte line length and data.
	The encoded length also includes the 4 bytes, hence the shortest sequence is 0004 denoting the empty line.
	Example:
		pkt line   contents
		0004       ''
		0007foo    'foo'
	
	The special 4-bytes 0000 triggers aBlock."
		
	| totalLineLength |
	totalLineLength := self readLineLength.
	^ totalLineLength = 0
		ifTrue: aBlock 
		ifFalse: [ | content |
			content := (self readContentOfLength: totalLineLength) asString.
			"Server SHOULD terminate each non-flush line using LF (\n) terminator;
			client MUST NOT complain if there is no terminator."
			(content isEmpty or: [ content last ~= Character lf])
				ifTrue: [ content ]
				ifFalse: [ content allButLast ]]
				! !

!GitProtocolReader methodsFor: 'private receiving' stamp: 'DamienCassou 1/30/2013 16:32'!
readSideBandResponseIfData: dataBlock ifMessage: messageBlock ifError: errorBlock ifZero: zeroBlock
	| length streamCode data |
	length := self readLineLength.
	length = 0
		ifTrue: [ ^ zeroBlock value ].
	streamCode := stream next.
	streamCode > 3
		ifTrue: [ self error: 'Unknown stream code ', streamCode asString].
	data := stream next: length - 5. "4-byte content length + streamCode byte"
	streamCode = 1
		ifTrue: [^ dataBlock value: data ].
	streamCode = 2
		ifTrue: [^ messageBlock value: data ].
	streamCode = 3
		ifTrue: [^ errorBlock value: data ].
	self error: 'Should never happen '! !

!GitProtocolReader methodsFor: 'private receiving' stamp: 'CamilloBruni 2/12/2013 18:08'!
readUntilNAK
	| length |
	[ 
		length := self readLineLength.
		length = 0 ifTrue: [ ^ self ].
			
		self peekForNAK 
			ifTrue: [ ^ self resetFourByteLookahead ].
			
	true.] whileTrue.! !

!GitProtocolReader methodsFor: 'private receiving' stamp: 'CamilloBruni 2/12/2013 17:17'!
readZeroLine
	self readPktLineIfZero: [ ^ self ].
	Error signal: 'Expected 0000'! !

!GitProtocolReader methodsFor: 'private receiving' stamp: 'CamilloBruni 2/12/2013 18:08'!
resetFourByteLookahead
	fourByteLookahead := nil! !

!GitProtocolReader methodsFor: 'accessing' stamp: 'DamienCassou 1/30/2013 16:51'!
stream
	^ stream! !

Object subclass: #GitProtocolWriter
	instanceVariableNames: 'stream firstWantCapabilityListSeparator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Remote'!

!GitProtocolWriter commentStamp: '<historical>' prior: 0!
Takes care of writing requests to a server!

!GitProtocolWriter class methodsFor: 'instance creation' stamp: 'DamienCassou 1/30/2013 17:27'!
on: aStream
	^ self basicNew
		initializeWith: aStream;
		yourself! !

!GitProtocolWriter methodsFor: 'helpers' stamp: 'DamienCassou 1/31/2013 13:27'!
concatenateArguments: aString andCapabilities: capabilities
	^ String
		streamContents: [ :str |
			
			str	nextPutAll: aString.
			
			str nextPut: self firstWantCapabilityListSeparator.
			
			capabilities isString
				ifTrue: [ str nextPutAll: capabilities ]
				ifFalse: [ str print: capabilities]]! !

!GitProtocolWriter methodsFor: 'helpers' stamp: 'DamienCassou 1/30/2013 17:49'!
concatenateCommand: commandName withArguments: arguments
	^ commandName, String space, arguments! !

!GitProtocolWriter methodsFor: 'sending' stamp: 'DamienCassou 1/30/2013 18:22'!
done
	self sendCommand: 'done' withLineTerminator: true.
	self flush.! !

!GitProtocolWriter methodsFor: 'helpers' stamp: 'DamienCassou 1/30/2013 17:29'!
encodePktLine: data
	| dataSize |
	dataSize :=  4 "data length string" + data size.
	^ ((dataSize printStringBase: 16) asLowercase padLeftTo: 4 with: $0), data.! !

!GitProtocolWriter methodsFor: 'configuration' stamp: 'CamilloBruni 2/12/2013 16:55'!
firstWantCapabilityListSeparator
	^ firstWantCapabilityListSeparator! !

!GitProtocolWriter methodsFor: 'configuration' stamp: 'CamilloBruni 2/12/2013 17:02'!
firstWantCapabilityListSeparator: aCharacter
	firstWantCapabilityListSeparator := aCharacter! !

!GitProtocolWriter methodsFor: 'sending' stamp: 'DamienCassou 1/30/2013 17:30'!
flush
	stream flush! !

!GitProtocolWriter methodsFor: 'sending' stamp: 'DamienCassou 1/30/2013 18:21'!
flushPacket
	self sendData: '0000'.
	self flush.! !

!GitProtocolWriter methodsFor: 'initialize-release' stamp: 'CamilloBruni 2/12/2013 16:56'!
initialize 
	super initialize.
	firstWantCapabilityListSeparator := Character space! !

!GitProtocolWriter methodsFor: 'initialize-release' stamp: 'DamienCassou 1/30/2013 17:27'!
initializeWith: aStream
	self initialize.
	stream := aStream! !

!GitProtocolWriter methodsFor: 'sending' stamp: 'DamienCassou 1/30/2013 17:49'!
sendCommand: commandName arguments: arguments withLineTerminator: aBoolean
	^ self
		sendCommand: (self concatenateCommand: commandName withArguments:  arguments)
		withLineTerminator: aBoolean! !

!GitProtocolWriter methodsFor: 'sending' stamp: 'DamienCassou 1/30/2013 17:48'!
sendCommand: aCommandString withLineTerminator: aBoolean
	| command |
	command := aBoolean
					ifTrue:  [ aCommandString , String lf ]
					ifFalse: [ aCommandString ].
	self sendData: (self encodePktLine: command).
	! !

!GitProtocolWriter methodsFor: 'private sending' stamp: 'DamienCassou 2/4/2013 09:38'!
sendData: aString
	Transcript show: '> ', aString; cr; cr.
	stream nextPutAll: aString.
	self flush.
	^ aString! !

!GitProtocolWriter methodsFor: 'sending' stamp: 'DamienCassou 1/31/2013 14:24'!
sendDepth: depth
	^ self sendCommand: 'deepen' arguments: depth asString withLineTerminator: true! !

!GitProtocolWriter methodsFor: 'sending' stamp: 'DamienCassou 1/31/2013 14:06'!
sendShallowLines: shallowLines
	^ shallowLines do: [ :shallow | self sendCommand: 'shallow' arguments: shallow withLineTerminator: true ]! !

!GitProtocolWriter methodsFor: 'sending' stamp: 'DamienCassou 1/31/2013 14:09'!
sendWant: gitSignature
	^ self sendCommand: 'want' arguments: gitSignature withLineTerminator: true! !

!GitProtocolWriter methodsFor: 'sending' stamp: 'DamienCassou 1/31/2013 14:13'!
sendWantAll: gitSignatures capabilities: capabilities shallowLines: shallowLines depth: depth
	"Ask the server to send all gitSignatures."

	"The capabilities must be attached at the end."
	self sendWant: (self concatenateArguments: gitSignatures first andCapabilities: capabilities).
	2 to: gitSignatures size do: [ :i | self sendWant: (gitSignatures at: i) ].
	shallowLines ifNotNil: [ self sendShallowLines: shallowLines ].
	depth ifNotNil: [ self sendDepth: depth ]! !

Object subclass: #GitRepository
	instanceVariableNames: 'reference packs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Core'!

!GitRepository commentStamp: '<historical>' prior: 0!
I am responsible for managing low level operations on a repository. I keep a reference to the location of the physical repository.

Instance Variables
	reference:		<FSReference>
		Holds a reference to the physical location of the repository.
		
!

!GitRepository class methodsFor: 'instance creation' stamp: 'MaxLeske 8/11/2011 22:15'!
new
	self error: 'This class should be instantiated with a Filesystem.'! !

!GitRepository class methodsFor: 'initialize-release' stamp: 'CamilloBruni 8/30/2012 13:58'!
on: aReference
	^self basicNew initializeOn: aReference asFileReference
	! !

!GitRepository methodsFor: 'comparing' stamp: 'CamilloBruni 7/20/2011 13:07'!
= other
	(other isKindOf: self class)
		ifFalse: [ ^ false ].
	^ self baseDir = (other baseDir)! !

!GitRepository methodsFor: 'visiting' stamp: 'MaxLeske 8/13/2012 21:55'!
accept: aVisitor
	aVisitor visitRepository: self! !

!GitRepository methodsFor: 'accessing-objects' stamp: 'CamilloBruni 9/3/2012 16:32'!
activeBranchName
	"Answers the name of the currently active branch which is the branch referenced in HEAD. This method can answer nil."

	| headContents headObject |
	
	headContents := self headFile readStreamDo: [ :stream | stream contents asString trimBoth ].
	(headContents beginsWith: 'ref:')
		ifTrue: [ ^ headContents copyAfterLast: $/ ].
	
	headObject := self objectNamed: headContents.
	^ self branches keyAtValue: headObject ifAbsent: [ nil ]! !

!GitRepository methodsFor: 'public-locations' stamp: 'CamilloBruni 7/15/2011 15:40'!
baseDir
"Answers the reference to the actual repository location. If e.g. the repository was initialized with a reference to '/foo' but the repository were actually at '/foo/.git' then this method would answer a reference to '/foo/.git'".

	(reference isRoot not and: [reference basename endsWith: '.git'])
		ifTrue: [^reference]
		ifFalse: [^reference resolve: '.git']! !

!GitRepository methodsFor: 'private' stamp: 'CamilloBruni 9/3/2012 16:19'!
basicUpdateRef: refPath to: aString
	| target pathReference |
	target := [(self baseDir resolve: refPath) readStreamDo: [ :stream | stream contents ]]
		on: FileDoesNotExist do: [:ex | ex return: nil].

	(target isNil not and: [target beginsWith: 'ref:']) ifTrue: [
		^ self updateRef: (target allButFirst: 4) withBlanksTrimmed to: aString ].
	
	self flag: 'rather make sure we never get strings in here...'.
	pathReference := refPath isString 
		ifTrue: [self baseDir resolve: refPath]
		ifFalse: [ refPath ].
		
	pathReference parent ensureDirectory.
	pathReference ensureDeleted writeStreamDo: [ :stream | 
		stream 
			nextPutAll: aString; 
			nextPut: Character lf ]! !

!GitRepository methodsFor: 'public-accessing-objects' stamp: 'MaxLeske 2/28/2012 18:21'!
branchNamed: aString
	^ self objectNamed: (self resolveRef: (self headsDir / aString) fullName)! !

!GitRepository methodsFor: 'public-accessing-objects' stamp: 'MaxLeske 10/29/2010 22:17'!
branchNames
	| branchRefs branchNames |
	branchRefs := self headsDir children.
	branchRefs isEmpty
		ifFalse: [ ^ branchRefs collect: [ :ref | ref basename ] ]
		ifTrue: [ | packedRefs |
			packedRefs := self packedRefs.
			packedRefs ifNil: [ ^ OrderedCollection new ].
			branchNames := OrderedCollection new.
			packedRefs keysAndValuesDo: [ :refName :refSignature | 
				(refName includesSubString: 'heads') ifTrue: [
					branchNames add: (refName subStrings: '/') last ] ].
			^ branchNames ]! !

!GitRepository methodsFor: 'public-accessing-objects' stamp: 'MaxLeske 2/28/2012 18:18'!
branches
"Answers a dictionary of all GitCommit objects referenced in '/refs/heads'."

	| dictionary heads |
	dictionary := Dictionary new.
	self headsDir exists ifFalse: [ ^ dictionary ].
	heads := self headsDir children.
	heads isEmpty
		ifFalse: [ heads do: [ :each |
			dictionary at: each basename put: 
				(each readStreamDo: [ :stream |
					self objectNamed: (stream next: 40) asString ]) ] ]
		ifTrue: [ | packedRefs | 
			packedRefs := self packedRefs .
			packedRefs ifNil: [ ^ dictionary ].
			packedRefs keysAndValuesDo: [ :refName :refHash | 
				(refName includesSubString: 'heads') ifTrue: [ 
					dictionary 
						at: refName
						put: (self objectNamed: refHash) ] ] ] .
		
	^ dictionary! !

!GitRepository methodsFor: 'private' stamp: 'MaxLeske 2/26/2012 16:37'!
collectTagsFromLooseRefs
	| tags |
	tags := Dictionary new.
	
	self tagsDir children do: [ :ref |
		ref readStreamDo: [ :stream |
			tags 
				at: ref basename
				put: (self objectNamed: (stream next: 40) asString) ] ].
		
	^ tags! !

!GitRepository methodsFor: 'private' stamp: 'MaxLeske 2/26/2012 12:21'!
collectTagsFromPackedRefs
	| tags packedRefs |
	tags := Dictionary new.
	
	packedRefs := self packedRefs. 
	packedRefs ifNotNil: [
		packedRefs keysAndValuesDo: [ :refName :refHash | 
			(refName includesSubString: 'tags') ifTrue: [
				tags
					at: refName
					put: (self objectNamed: refHash) ] ] ].
	
	^ tags! !

!GitRepository methodsFor: 'enumerating' stamp: 'MaxLeske 8/12/2012 11:51'!
commits: aCollection do: aBlock
	"aBlock takes as arguments a commit and optionally an exit block"
	aCollection ifNil: [ ^ self ].
	
	aCollection do: [ :commit | 
		aBlock valueWithEnoughArguments: (Array with: commit with: [ ^ self ]).
		self commits: commit parents do: aBlock ]! !

!GitRepository methodsFor: 'public-enumerating' stamp: 'MaxLeske 8/12/2012 11:52'!
commitsDo: aBlock
	"you can stop iteration by using the exit block given as second
	optional argument to aBlock. E.g: [ :commit :exit | ... exit value ]"
	self commits: (Array with: self head) do: aBlock! !

!GitRepository methodsFor: 'public-accessing' stamp: 'MaxLeske 7/24/2010 15:13'!
delete
	"Deletes the repository irrevocably."
	
	GitRepositoryDeleteRequest signal
		ifTrue: [ self baseDir delete ]! !

!GitRepository methodsFor: 'private' stamp: 'CamilloBruni 9/2/2012 12:28'!
emptyRootCommit
	"Create a root commit for an empty repository."
	^ GitCommit new
		repository: self;
		tree: (GitTree new
			repository: self)
		yourself! !

!GitRepository methodsFor: 'initialize-release' stamp: 'CamilloBruni 9/2/2012 12:14'!
ensureGitDirectories

	self baseDir ensureDirectory.
	self gitDirectories do: [ :dir | 
		(self baseDir resolve: dir) ensureDirectory ].! !

!GitRepository methodsFor: 'public-testing' stamp: 'MaxLeske 6/24/2012 11:43'!
exists
	^self baseDir exists and: [ self isInitialized ]! !

!GitRepository methodsFor: 'private' stamp: 'MaxLeske 7/11/2010 12:32'!
gitDirectories
	^#('objects' 
		'objects/pack' 
		'objects/info' 
		'refs'
		'refs/heads' 
		'refs/tags' 
		'info')! !

!GitRepository methodsFor: 'initialize-release' stamp: 'CamilloBruni 9/2/2012 12:14'!
gitInitialize
	"This should do roughly the same as the git-init command"
	self exists
		ifTrue: [ ^ self ].
	self ensureGitDirectories.
	self initializeHEAD.! !

!GitRepository methodsFor: 'testing' stamp: 'MaxLeske 9/8/2012 11:52'!
hasLooseObject: aHexHash
	^ (self referenceToObjectNamed: aHexHash) exists! !

!GitRepository methodsFor: 'comparing' stamp: 'CamilloBruni 7/15/2011 18:14'!
hash
	^ reference basename hash bitXor: self class name hash! !

!GitRepository methodsFor: 'public-accessing-objects' stamp: 'CamilloBruni 9/2/2012 11:19'!
head
	"Answers the GitCommit object referenced in / via 'HEAD'."
	^ self headIfAbsent: [ 
			GitObjectNotFoundError
				signal: 'HEAD reference not found'
				with: 'HEAD' ]! !

!GitRepository methodsFor: 'public-locations' stamp: 'CamilloBruni 9/3/2012 16:51'!
headFile
	^ self baseDir / 'HEAD'! !

!GitRepository methodsFor: 'public-accessing-objects' stamp: 'CamilloBruni 9/2/2012 11:21'!
headIfAbsent: aBlock
"Answers the GitCommit object referenced in / via 'HEAD'."
	
	^ self headRef 
		ifNil: aBlock
		ifNotNil: [ :hexHash | self objectNamed: hexHash ]! !

!GitRepository methodsFor: 'public-accessing-objects' stamp: 'CamilloBruni 9/2/2012 12:27'!
headOrEmptyRootCommit
	"Answers the GitCommit object referenced in / via 'HEAD' or if the repos is fresh an empty head commit"
	^ self headIfAbsent: [ 
			self emptyRootCommit ]! !

!GitRepository methodsFor: 'accessing-references' stamp: 'MaxLeske 8/11/2011 21:23'!
headRef
	^ self resolveRef: 'HEAD'! !

!GitRepository methodsFor: 'public-locations' stamp: 'CamilloBruni 8/9/2011 17:41'!
headsDir
	^ self baseDir resolve: 'refs/heads'! !

!GitRepository methodsFor: 'initialize-release' stamp: 'CamilloBruni 9/2/2012 11:47'!
initializeHEAD
	self baseDir / 'HEAD'
		writeStreamDo: [ :stream | 
			stream
				nextPutAll: 'ref: refs/heads/master';
				lf ]! !

!GitRepository methodsFor: 'initialize-release' stamp: 'CamilloBruni 8/30/2012 13:59'!
initializeOn: anFSReference
	reference := anFSReference.
	self gitInitialize! !

!GitRepository methodsFor: 'public-testing' stamp: 'CamilloBruni 9/2/2012 11:33'!
isInitialized
	^ (self gitDirectories allSatisfy: [ :each | (self baseDir resolve: each) exists ]) and: [ self headFile exists ]! !

!GitRepository methodsFor: 'testing' stamp: 'MaxLeske 6/24/2012 11:21'!
isObjectDirectory: aReference
	^ aReference isDirectory and: [ aReference basename size = 2 ]! !

!GitRepository methodsFor: 'enumerating' stamp: 'MaxLeske 7/1/2012 19:35'!
looseObjectNamed: aHexHash ifAbsent: aBlock
	| stream |
	stream :=
		self 
			streamLooseObjectNamed: aHexHash
			ifAbsent: [ ^ aBlock value ].
	^ GitStorableObject 
		fromLooseObjectStream: stream
		in: self! !

!GitRepository methodsFor: 'enumerating' stamp: 'MaxLeske 6/24/2012 11:24'!
looseObjectNamesDo: aBlock 
	self objectDirectoriesDo: [ :dirReference | 
		dirReference files do: [ :fileReference | | hash |
			hash := dirReference basename , fileReference basename.
			aBlock value: hash ] ]! !

!GitRepository methodsFor: 'private' stamp: 'MaxLeske 2/26/2012 11:53'!
looseObjectPathFor: aHexHash
	^ 'objects/' , (aHexHash first: 2) , '/' , (aHexHash allButFirst: 2)! !

!GitRepository methodsFor: 'accessing-objects' stamp: 'CamilloBruni 6/21/2011 05:37'!
looseObjects
	| r |
	r := OrderedCollection new.
	self looseObjectsDo: [ :n | r add: n ].
	^ r! !

!GitRepository methodsFor: 'enumerating' stamp: 'MaxLeske 2/28/2012 18:17'!
looseObjectsDo: aBlock
	self flag: 'replace #objectNamed: with a message that only looks up loose objects'.
	self looseObjectNamesDo: [ :hexHash|
		aBlock value: (self objectNamed: hexHash)]! !

!GitRepository methodsFor: 'enumerating' stamp: 'MaxLeske 6/24/2012 11:34'!
objectDirectoriesDo: aBlock
	| root regex |
	root := self baseDir resolve: 'objects'.
	root exists ifFalse: [ GitInvalidRepositoryError signal: 'This repository has not been initialized.' ].
	regex := '[a-f0-9][a-f0-9]' asRegex.
	root directories 
		select: [ :dirReference | regex matches: dirReference basename ]
		thenDo: aBlock! !

!GitRepository methodsFor: 'public-accessing-objects' stamp: 'CamilloBruni 9/2/2012 18:55'!
objectNamed: aHash
	^ self 
		objectNamed: aHash asHexHash 
		ifAbsent: [ 
			GitObjectNotFoundError 
				signal: aHash printString, ' not found'
				with: aHash]! !

!GitRepository methodsFor: 'public-accessing-objects' stamp: 'MaxLeske 2/29/2012 17:34'!
objectNamed: aHash ifAbsent: aBlock
	^ self
		looseObjectNamed: aHash
		ifAbsent: [ 
			self 
				packedObjectNamed: aHash
				ifAbsent: aBlock ]! !

!GitRepository methodsFor: 'public-operations' stamp: 'MaxLeske 8/12/2012 21:12'!
pack
	self packsDo: [ :pack | pack delete ].
	packs := nil.
	self packs add: (GitPackFile pack: self)! !

!GitRepository methodsFor: 'accessing-objects' stamp: 'MaxLeske 2/29/2012 15:32'!
packedObjectNamed: aHexHash
	self 
		packedObjectNamed: aHexHash 
		ifAbsent: [ 
			GitObjectNotFoundError 
				signal: 'Could not find the requested object in any pack.'
				with: aHexHash ]! !

!GitRepository methodsFor: 'accessing-objects' stamp: 'MaxLeske 2/29/2012 19:23'!
packedObjectNamed: aHexHash ifAbsent: aBlock
	self packsDo: [ :pack |
		(pack objectNamed: aHexHash) ifNotNilDo: [ :object | ^ object object ] ].
	^ aBlock value! !

!GitRepository methodsFor: 'accessing-references' stamp: 'MaxLeske 2/26/2012 12:12'!
packedRefs
	| packedRefs dictionary hexHash refName stream |
	packedRefs := self baseDir resolve: 'packed-refs'.
	packedRefs exists ifFalse: [^ nil].
	
	dictionary := Dictionary new.
	stream := ReadStream on: 
		(packedRefs readStreamDo: [ :str | str contents asString ]).
	[ stream atEnd ] whileFalse: [
		stream peek = $#
			ifTrue: [ stream upTo: Character lf ]
			ifFalse: [
				hexHash := stream upTo: Character space.
				refName := stream upTo: Character lf.
				dictionary at: refName put: hexHash ] ].
	^ dictionary! !

!GitRepository methodsFor: 'accessing-packs' stamp: 'MaxLeske 8/12/2012 21:18'!
packs
	packs ifNil: [
		packs := OrderedCollection new.
		self packsDir files 
			reject: [ :file | file basename endsWith: '.idx' ]
			thenDo: [ :packfile | packs add: (GitPackFile on: packfile in: self) ] ].
		
	^ packs! !

!GitRepository methodsFor: 'locations' stamp: 'MaxLeske 8/12/2012 13:43'!
packsDir
	^ self baseDir resolve: 'objects/pack'! !

!GitRepository methodsFor: 'enumerating' stamp: 'MaxLeske 8/12/2012 13:30'!
packsDo: aBlock		
	self packs do: [ :pack | aBlock value: pack ]! !

!GitRepository methodsFor: 'accessing-references' stamp: 'MaxLeske 9/8/2012 11:53'!
referenceTo: aGitStorableObject
	^ self referenceToObjectNamed: aGitStorableObject hexHash! !

!GitRepository methodsFor: 'accessing-references' stamp: 'MaxLeske 9/8/2012 11:52'!
referenceToObjectNamed: aHexHash
	| pathReference |
	pathReference := self baseDir resolve: (self looseObjectPathFor: aHexHash asHexHash).
	pathReference parent ensureDirectory.
	^ pathReference! !

!GitRepository methodsFor: 'accessing-references' stamp: 'MaxLeske 6/15/2012 14:19'!
resolveLooseRef: refPath
	| target |
	refPath exists ifFalse: [ ^ nil ].
	target := refPath readStreamDo: [ :stream | stream contents asString ].
	(target beginsWith: 'ref:') 
		ifTrue: [^ self resolveRef: (target allButFirst: 4) trimBoth].
	^ target substrings first "Ignore other junk after the hash."! !

!GitRepository methodsFor: 'public-accessing-references' stamp: 'MaxLeske 6/24/2012 09:55'!
resolveRef: name
"From the git-rev-parse manpage:
            1. if $GIT_DIR/<name> exists, that is what you mean (this is usually useful only for HEAD, FETCH_HEAD, ORIG_HEAD and MERGE_HEAD);
            2. otherwise, $GIT_DIR/refs/<name> if exists;
            3. otherwise, $GIT_DIR/refs/tags/<name> if exists;
            4. otherwise, $GIT_DIR/refs/heads/<name> if exists;
            5. otherwise, $GIT_DIR/refs/remotes/<name> if exists;
            6. otherwise, $GIT_DIR/refs/remotes/<name>/HEAD if exists."
	| havePackedRefs packedRefs basePath|	
	havePackedRefs := false.
	basePath := self baseDir .
	packedRefs := nil.
	#(	''
		'refs/'
		'refs/tags/'
		'refs/heads/'
		'refs/remotes/'
		"We don't do the last case (number 6) from the manual yet."
	) do: [ :prefix |
		(self resolveLooseRef: (basePath resolve: (prefix , name)))
			ifNotNilDo: [ :result | ^ result ].
		havePackedRefs ifFalse: [
				packedRefs := self packedRefs. 
				havePackedRefs := true ].
		packedRefs ifNotNil: [
			self packedRefs at: prefix , name 
					ifPresent: [ :result | ^ result ] ] ].
	self flag: 'raise exception instead of answering nil?'.
	^ nil! !

!GitRepository methodsFor: 'storing' stamp: 'MaxLeske 9/8/2012 15:40'!
storeLooseObject: aGitStorableObject
	| objectReference |
	objectReference := (self referenceTo: aGitStorableObject).
	objectReference exists ifTrue: [ ^ self ]. "prevent overwrites"
	
	objectReference writeStreamDo: [ :stream | 
		stream binary.
		aGitStorableObject compressedOn: stream ]! !

!GitRepository methodsFor: 'public-storing' stamp: 'MaxLeske 9/8/2012 14:47'!
storeObject: anObject
"Stores a GitStorableObject in the repository and answers it."

	^ self storeLooseObject: anObject! !

!GitRepository methodsFor: 'accessing-objects' stamp: 'MaxLeske 2/28/2012 20:15'!
streamLooseObjectNamed: aHexHash
	^ self 
		streamLooseObjectNamed: aHexHash 
		ifAbsent: [ GitObjectNotFoundError
			signal: 'Could not find loose object.' 
			with: aHexHash ]! !

!GitRepository methodsFor: 'accessing-objects' stamp: 'MaxLeske 9/8/2012 18:23'!
streamLooseObjectNamed: aHexHash ifAbsent: aBlock
	^ (self baseDir resolve: (self looseObjectPathFor: aHexHash)) 
		readStreamDo: [ :stream | (GitZLibReadStream on: stream binary contents) contents readStream ]
		ifAbsent: aBlock! !

!GitRepository methodsFor: 'accessing-objects' stamp: 'MaxLeske 2/28/2012 20:18'!
streamObjectNamed: aHexHash
	^ self 
		streamLooseObjectNamed: aHexHash
		ifAbsent: [ self streamPackedObjectNamed: aHexHash ]! !

!GitRepository methodsFor: 'accessing-objects' stamp: 'MaxLeske 2/28/2012 20:20'!
streamPackedObjectNamed: aHexHash
	^ self 
		streamPackedObjectNamed: aHexHash
		ifAbsent: [ 
			GitObjectNotFoundError 
				signal: 'No pack contained the requested object.'
				with: aHexHash ]! !

!GitRepository methodsFor: 'accessing-objects' stamp: 'MaxLeske 6/24/2012 09:52'!
streamPackedObjectNamed: aHexHash ifAbsent: aBlock
	| packedObject |
	packedObject :=
		self 
			packedObjectNamed: aHexHash
			ifAbsent: [ nil ].
	^ packedObject
		ifNotNil: [ packedObject byteStream ]
		ifNil: aBlock! !

!GitRepository methodsFor: 'public-accessing-objects' stamp: 'Camillobruni 8/18/2011 16:53'!
tagNamed: aString
	^ self tagNamed: aString ifAbsent: [ 
		GitObjectNotFoundError 
			signal: 'Tag ', aString, ' not found.'
			with: aString ] ! !

!GitRepository methodsFor: 'public-accessing-objects' stamp: 'MaxLeske 2/26/2012 12:17'!
tagNamed: aString ifAbsent: aBlock
	(self resolveRef: 'refs/tags/', aString) ifNotNilDo: [ :tagRef|
		 ^ self objectNamed: tagRef ifAbsent: aBlock ].
	^ aBlock value! !

!GitRepository methodsFor: 'public-accessing-objects' stamp: 'CamilloBruni 7/11/2011 17:31'!
tagNames
	| tagRefs tagNames packedRefs|
	tagRefs := self tagsDir children.
	tagRefs isEmpty
		ifFalse: [ ^ tagRefs collect: [ :ref | ref basename ] ].
	packedRefs := self packedRefs.
	packedRefs ifNil: [ ^ OrderedCollection new ].
	tagNames := OrderedCollection new.
	packedRefs keysAndValuesDo: [ :refName :refSignature | 
		(refName includesSubString: 'tags') ifTrue: [
			tagNames add: (refName subStrings: '/') last ] ].
	^ tagNames ! !

!GitRepository methodsFor: 'public-accessing-objects' stamp: 'MaxLeske 9/5/2012 08:06'!
tags
	|  referencedObjects tags |
	
	tags := OrderedCollection new.
	
	self tagsDir exists ifFalse: [ ^ tags ].
	
	referencedObjects := self collectTagsFromPackedRefs.
	referencedObjects addAll: self collectTagsFromLooseRefs.
	
	referencedObjects keysAndValuesDo: [ :name :object |
		tags add: (object class = GitCommit
			ifTrue: [ "this is a lightweight tag"
				GitLightweightTag
					named: name
					for: object
					in: self ]
			ifFalse: [ "this is a full tag and will be loaded later"
				 object ]) ].
	
	^ tags! !

!GitRepository methodsFor: 'public-locations' stamp: 'MaxLeske 7/23/2010 17:47'!
tagsDir
	^ self baseDir resolve: 'refs/tags'! !

!GitRepository methodsFor: 'public-accessing-references' stamp: 'MaxLeske 11/2/2010 22:32'!
updateHeadToBranch: branchName
"Updates the reference in 'HEAD' to branchName"

	self basicUpdateRef: 'HEAD' to: 'ref: refs/heads/' , branchName! !

!GitRepository methodsFor: 'public-accessing-references' stamp: 'CamilloBruni 9/3/2012 18:22'!
updateRef: refPath to: hexHash
"Updates the file denoted by refPath to reference the object with the sha1 name in aGitObjectSignature.
If the file denoted by refPath does not yet exist it will be created."

	self basicUpdateRef: refPath to: hexHash asHexHash! !

!GitRepository methodsFor: 'validating' stamp: 'CamilloBruni 8/9/2011 16:58'!
validate
	^ GitFSCK validate: self! !

!GitRepository methodsFor: 'public-locations' stamp: 'MaxLeske 6/24/2012 11:37'!
workingDir
"Answers the reference the repository object was initialized on (as opposed to were the repository is located; see #baseDir)."

	^ reference! !

Object subclass: #GitSetWrapper
	instanceVariableNames: 'set maxDepth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Core'!

!GitSetWrapper commentStamp: 'CamilloBruni 8/1/2011 18:32' prior: 0!
I am used to track changes made to a certain directory in a git filesystem. Each change is recorded by the FSGitModificationManager which stores the modified paths for each parent directory in a FSGitSetWrapper.!

!GitSetWrapper methodsFor: 'testing' stamp: 'MaxLeske 10/18/2010 12:14'!
= aSet
	^ set = aSet! !

!GitSetWrapper methodsFor: 'adding' stamp: 'CamilloBruni 7/15/2011 19:43'!
add: newObject
	maxDepth := maxDepth max: newObject size.
	set add: newObject! !

!GitSetWrapper methodsFor: 'testing' stamp: 'CamilloBruni 7/5/2011 16:34'!
allSatisfy: aBlock
	^ set allSatisfy: aBlock! !

!GitSetWrapper methodsFor: 'accessing' stamp: 'MaxLeske 10/19/2010 09:38'!
anyOne
	^ set anyOne! !

!GitSetWrapper methodsFor: 'testing' stamp: 'CamilloBruni 7/5/2011 17:07'!
anySatisfy: aBlock
	^ set anySatisfy: aBlock! !

!GitSetWrapper methodsFor: 'enumerating' stamp: 'MaxLeske 10/18/2010 12:13'!
collect: aBlock
	^ set collect: aBlock! !

!GitSetWrapper methodsFor: 'enumerating' stamp: 'MaxLeske 10/18/2010 12:13'!
do: aBlock
	set do: aBlock! !

!GitSetWrapper methodsFor: 'testing' stamp: 'MaxLeske 10/18/2010 12:15'!
includes: anObject
	^ set includes: anObject! !

!GitSetWrapper methodsFor: 'testing' stamp: 'CamilloBruni 8/30/2012 14:11'!
includesSubPath: aPath 
	^ set anySatisfy: [ :el| aPath contains: el]! !

!GitSetWrapper methodsFor: 'initialize-release' stamp: 'CamilloBruni 7/15/2011 19:43'!
initialize
	super initialize.
	set := Set new.
	maxDepth := 0! !

!GitSetWrapper methodsFor: 'accessing' stamp: 'CamilloBruni 7/15/2011 19:44'!
maxDepth
	^ maxDepth! !

!GitSetWrapper methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 8/1/2011 17:05'!
printOn: aStream
	aStream << self class name.
	aStream << '('.
	set do: [ :path| aStream << path basename]
		separatedBy: [ aStream << ', '].
	aStream << ')'.! !

!GitSetWrapper methodsFor: 'enumerating' stamp: 'MaxLeske 10/18/2010 12:13'!
select: aBlock
	^ set select: aBlock! !

!GitSetWrapper methodsFor: 'enumerating' stamp: 'MaxLeske 10/19/2010 09:07'!
select: selectBlock thenDo: doBlock
	set
		select: selectBlock
		thenDo: doBlock! !

!GitSetWrapper methodsFor: 'enumerating' stamp: 'MaxLeske 10/18/2010 22:31'!
sorted: aBlock
	^ set sorted: aBlock! !

Object subclass: #GitStamp
	instanceVariableNames: 'name email timeStamp'
	classVariableNames: 'DefaultEmail DefaultName'
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Core'!

!GitStamp commentStamp: '<historical>' prior: 0!
I am responsible for providing a name, an e-mail address and a timestamp in the format specified by git.

Instance Variables:
	name	<String>
		First and last name of the person referenced.
	email	<String>
		E-mail address of the person referenced.
	timeStamp	<TimeStamp>
		A timestamp denoting the time the operation this stamp is associated
		with was performed (e.g. a commit).!

!GitStamp class methodsFor: 'accessing' stamp: 'MaxLeske 8/12/2011 09:59'!
defaultEmail
	DefaultEmail isEmptyOrNil 
		ifTrue: [ ^ GitStampEmailRequest signal ]
		ifFalse: [ ^ DefaultEmail ].
	^ self defaultEmail! !

!GitStamp class methodsFor: 'accessing' stamp: 'CamilloBruni 6/22/2011 05:33'!
defaultEmail: aString
	DefaultEmail := aString! !

!GitStamp class methodsFor: 'accessing' stamp: 'MaxLeske 8/12/2011 10:00'!
defaultName
	DefaultName isEmptyOrNil 
		ifTrue: [ ^ GitStampNameRequest signal ]
		ifFalse: [ ^ DefaultName ].
	^ self defaultName! !

!GitStamp class methodsFor: 'accessing' stamp: 'lr 4/13/2010 16:21'!
defaultName: aString
	DefaultName := aString! !

!GitStamp class methodsFor: 'accessing' stamp: 'CamilloBruni 6/22/2011 05:37'!
ensureDefaultValues
	DefaultName ifNil: [
			self defaultName: 'John Doe'].
	DefaultEmail ifNil: [
			self defaultEmail: 'john@foo.com']! !

!GitStamp class methodsFor: 'instance creation' stamp: 'tonyg 2/23/2010 21:29'!
fromString: aString
	^ self readFrom: (ReadStream on: aString)! !

!GitStamp class methodsFor: 'instance creation' stamp: 'lr 4/13/2010 16:50'!
now
	^ self new 
		name: self defaultName; 
		email: self defaultEmail;
		yourself! !

!GitStamp class methodsFor: 'instance creation' stamp: 'MaxLeske 6/24/2012 13:31'!
readFrom: aStream
	| author email secondsSince1970 sign zoneOffset |
	author := (aStream upTo: $<) trimBoth.
	email := (aStream upTo: $>) trimBoth.
	aStream skipSeparators.
	secondsSince1970 := Integer readFrom: aStream.
	aStream skipSeparators.
	sign := aStream next.
	('-+' includes: sign) ifFalse: [ 
		GitInvalidObjectError signal: 'Invalid timezone sign found while loading a GitStamp object.' ].
	
	zoneOffset := Integer readFrom: aStream.
	zoneOffset := (zoneOffset // 100) hours + (zoneOffset \\ 100) minutes.
	sign = $- ifTrue: [zoneOffset := zoneOffset negated].
	
	^ self new
		name: author;
		email: email; 
		timeStamp: ((DateAndTime fromUnixTime: secondsSince1970) offset: zoneOffset) asTimeStamp;
		yourself! !

!GitStamp class methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 18:57'!
requestEmail
	self flag: 'this is basically a nightmare...'.
	((Smalltalk class canUnderstand: #isHeadless) and: [ Smalltalk isHeadless ])
		ifTrue: [ self error: 'Please set the default email using GitStamp defaultEmail:' ].
	^UIManager default 
		request: 'Please provide a valid e-mail address so that you can be contacted if necessary.'
		initialAnswer: 'user@domain.ext'! !

!GitStamp class methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 18:57'!
requestName
	self flag: 'this is basically a nightmare...'.
	((Smalltalk class canUnderstand: #isHeadless) and: [ Smalltalk isHeadless ])
		ifTrue: [ self error: 'Please set the default name using GitStamp defaultName:' ].
	^UIManager default 
		request: 'Please provide your full name to identify your actions.'
		initialAnswer: 'Firstname Lastname'! !

!GitStamp methodsFor: 'private' stamp: 'tonyg 2/23/2010 21:24'!
cleanUp: aString
	^ aString copyWithoutAll: '<>', String lf! !

!GitStamp methodsFor: 'public-accessing' stamp: 'tonyg 2/23/2010 21:21'!
email
	^ email! !

!GitStamp methodsFor: 'public-accessing' stamp: 'CamilloBruni 6/22/2011 05:18'!
email: aString
	email := self cleanUp: aString! !

!GitStamp methodsFor: 'initialize-release' stamp: 'lr 4/13/2010 16:46'!
initialize
	super initialize.
	timeStamp := TimeStamp now! !

!GitStamp methodsFor: 'public-accessing' stamp: 'tonyg 2/23/2010 21:22'!
name
	^ name! !

!GitStamp methodsFor: 'public-accessing' stamp: 'tonyg 2/23/2010 21:23'!
name: aString
	name := self cleanUp: aString! !

!GitStamp methodsFor: 'printing' stamp: 'lr 7/19/2010 13:48'!
printOn: aStream
	| offset |
	aStream
		nextPutAll: name;
		nextPutAll: ' <'; nextPutAll: email; nextPutAll: '> ';
		nextPutAll: timeStamp asUnixTime printString;
		nextPut: Character space.
	offset := timeStamp offset.
	"a negative Duration will return a negative SmallInteger for e.g. #hours.
	To print our custom string we need to prepend our own $- and work with a
	positive Duration."
	offset negative
		ifTrue: [aStream nextPut: $-. offset := offset negated]
		ifFalse: [aStream nextPut: $+].
	aStream
		nextPutAll: (offset hours printString forceTo: 2 paddingStartWith: $0);
		nextPutAll: (offset minutes printString forceTo: 2 paddingStartWith: $0).! !

!GitStamp methodsFor: 'public-accessing' stamp: 'tonyg 2/23/2010 21:21'!
timeStamp
	^ timeStamp! !

!GitStamp methodsFor: 'public-accessing' stamp: 'MaxLeske 5/25/2010 20:30'!
timeStamp: aTimeStamp
	timeStamp := aTimeStamp! !

Object subclass: #GitStream
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Plumbing-Utilities'!

!GitStream commentStamp: '<historical>' prior: 0!
I am a wrapper for a WriteStream on a ByteArray. I provide convenience conversions for certain content that is written to the stream to simplify code (e.g. converting a String argument to a ByteArray before writing it on the stream).

Instance Variables:
	stream	<WriteStream>
		The internally used WriteStream!

!GitStream class methodsFor: 'instance creation' stamp: 'MaxLeske 9/8/2012 16:22'!
streamContents: aBlock
	^ self new streamContents: aBlock! !

!GitStream methodsFor: 'public-accessing' stamp: 'MaxLeske 4/23/2010 13:44'!
contents
	^stream contents! !

!GitStream methodsFor: 'initialize-release' stamp: 'MaxLeske 4/23/2010 13:45'!
initialize
	stream := WriteStream on: ByteArray new! !

!GitStream methodsFor: 'public-accessing' stamp: 'MaxLeske 7/23/2010 15:25'!
lf
"Appends the linefeed character to the stream."

	self nextPut: Character lf! !

!GitStream methodsFor: 'public-accessing' stamp: 'MaxLeske 4/23/2010 13:43'!
nextPut: aCharacter
	stream nextPut: aCharacter asInteger! !

!GitStream methodsFor: 'public-accessing' stamp: 'MaxLeske 4/23/2010 13:44'!
nextPutAll: aString
	stream nextPutAll: aString asByteArray ! !

!GitStream methodsFor: 'public-accessing' stamp: 'MaxLeske 6/24/2010 10:55'!
nextPutBytes: aByteArray
	stream nextPutAll: aByteArray! !

!GitStream methodsFor: 'public-accessing' stamp: 'MaxLeske 4/23/2010 13:51'!
nullByte
	self nextPut: 0! !

!GitStream methodsFor: 'public-testing' stamp: 'MaxLeske 6/24/2012 12:05'!
size
	^ stream size! !

!GitStream methodsFor: 'public-accessing' stamp: 'MaxLeske 4/23/2010 13:44'!
space
	self nextPut: Character space! !

!GitStream methodsFor: 'public-operations' stamp: 'MaxLeske 9/8/2012 16:21'!
streamContents: aBlock
	aBlock value: self.
	^ self contents! !

Object subclass: #MCGitClassReader
	instanceVariableNames: 'classFolder definitions className classDefinition instanceMethodDefinitions classMethodDefinitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Monticello'!

!MCGitClassReader class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 7/12/2011 13:36'!
loadDefinitionsFrom: aFile
	^ self new readFrom: aFile! !

!MCGitClassReader class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 7/12/2011 13:39'!
loadDefinitionsFrom: aFile into: aStream
	^ self new 
		definitions: aStream;
		readFrom: aFile! !

!MCGitClassReader methodsFor: 'loading' stamp: 'CamilloBruni 7/12/2011 16:51'!
classInstVarNames
	self flag: 'TODO'.
	^ #()! !

!MCGitClassReader methodsFor: 'acessing' stamp: 'CamilloBruni 1/23/2012 23:32'!
className
	^ className ! !

!MCGitClassReader methodsFor: 'acessing' stamp: 'CamilloBruni 7/12/2011 13:39'!
definitions: aStream
	definitions := aStream! !

!MCGitClassReader methodsFor: 'loading' stamp: 'CamilloBruni 1/24/2012 14:44'!
loadCassDefinition
	"this clearly needs refactoring :/ "
	| tokens classDefinitionFile metaClassDefinitionFile metaDefinition commentFile traitCompositionString lastIndex classTraitCompositionString classDefinitionStream|
	
	className := classFolder name copyUpToLast: $..
	
	classDefinitionFile := classFolder reference / 'instance-side' / 'definition.st'.
	classDefinitionStream := classDefinitionFile readStream contents asString.
	tokens := Scanner new scanTokens: classDefinitionStream.
	
	classDefinitionStream := classDefinitionStream readStream.
	traitCompositionString := (classDefinitionStream
		match: 'uses:';
		upToAll: 'instanceVariableNames:') withBlanksTrimmed.
	traitCompositionString isEmptyOrNil ifTrue: [traitCompositionString := '{}'].
	
	metaClassDefinitionFile := classFolder reference / 'class-side' / 'definition.st'.
	
	metaClassDefinitionFile exists ifTrue: [
		classTraitCompositionString := (metaClassDefinitionFile readStream contents asString readStream
			match: 'uses:';
			upToAll: 'instanceVariableNames:') withBlanksTrimmed].
		
	classTraitCompositionString isEmptyOrNil ifTrue: [classTraitCompositionString := '{}'].
	lastIndex := tokens size.
	commentFile := classFolder reference / 'README.txt'.
	
	^ MCClassDefinition
		name: (tokens at: 3)
		superclassName: (tokens at: 1)
		traitComposition: traitCompositionString
		classTraitComposition: classTraitCompositionString
		category: (tokens at: lastIndex - 1)
		instVarNames: ((tokens at: 5) findTokens: ' ')
		classVarNames: ((tokens at: 7) findTokens: ' ')
		poolDictionaryNames: ((tokens at: lastIndex - 2) findTokens: ' ')
		classInstVarNames: (self classInstVarNames)
		type: (self typeOfSubclass: (tokens at: 2))
		comment: commentFile readStream contents asString
		commentStamp: (TimeStamp now)! !

!MCGitClassReader methodsFor: 'loading' stamp: 'CamilloBruni 1/23/2012 23:45'!
loadClassMethodDefinitions
	^ self loadMethodsFrom: (classFolder reference / 'class-side') meta: true! !

!MCGitClassReader methodsFor: 'loading' stamp: 'CamilloBruni 1/23/2012 23:41'!
loadDefinitions
	classDefinition := self loadCassDefinition.
	definitions add: classDefinition.
	
	instanceMethodDefinitions := self loadInstanceMethodDefinitions.
	definitions addAll: instanceMethodDefinitions.
	
	classMethodDefinitions := self loadClassMethodDefinitions.
	definitions addAll: classMethodDefinitions.! !

!MCGitClassReader methodsFor: 'loading' stamp: 'CamilloBruni 1/23/2012 23:25'!
loadInstanceMethodDefinitions
	^ self loadMethodsFrom: (classFolder reference / 'instance-side') meta: false! !

!MCGitClassReader methodsFor: 'loading' stamp: 'CamilloBruni 1/23/2012 23:40'!
loadMethodDefinitionFrom: aFile meta: isMeta
	| methods |
	"
	self flag: 'TODO: check for multiple methods per file!!'.
	^ MCMethodDefinition
		className: self className
		classIsMeta: isMeta
		selector: #test
		category: aFile parent basename
		timeStamp: nil
		source: sources"
		
	methods := (MCStReader on: aFile readStream) definitions.
	self assert: methods size == 1.
	^ methods first! !

!MCGitClassReader methodsFor: 'loading' stamp: 'CamilloBruni 1/23/2012 23:34'!
loadMethodsFrom: aMethodFolder meta: isMeta
	| methodFiles categories |
	aMethodFolder exists ifFalse: [ ^ #() ].
	
	"all methods are in a category"
	categories := aMethodFolder directories.
	
	methodFiles := categories gather: [ :categoryFolder|
		categoryFolder glob: [ :file| file name endsWith: '.st' ]].
	
	^ methodFiles collect: [ :methodSource|
		self loadMethodDefinitionFrom: methodSource reference meta: isMeta ]! !

!MCGitClassReader methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 7/12/2011 13:38'!
readFrom: aFile
	classFolder := aFile.
	self loadDefinitions.
	^ definitions! !

!MCGitClassReader methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 7/12/2011 16:51'!
typeOfSubclass: aSymbol
	#(
		(subclass: normal)
		(variableSubclass: variable)
		(variableByteSubclass: bytes)
		(variableWordSubclass: words)
		(weakSubclass: weak)
		) do: [:ea | ea first = aSymbol ifTrue: [^ ea second]].
	self error: 'Unrecognized class definition'! !

MCRepository subclass: #MCGitRepository
	instanceVariableNames: 'reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Monticello'!

!MCGitRepository class methodsFor: 'configuration' stamp: 'lr 10/29/2010 14:41'!
creationTemplate
	^ self name , ' directory: ''repo.git'''! !

!MCGitRepository class methodsFor: 'configuration' stamp: 'lr 10/29/2010 14:35'!
description
	^ 'Git'! !

!MCGitRepository class methodsFor: 'instance creation' stamp: 'CamilloBruni 8/30/2012 14:08'!
directory: aString
	^ self reference: (FileSystem disk referenceTo: aString)! !

!MCGitRepository class methodsFor: 'configuration' stamp: 'lr 10/29/2010 14:41'!
fillInTheBlankRequest
	^ 'Local Git Repository'! !

!MCGitRepository class methodsFor: 'testing' stamp: 'lr 10/29/2010 14:40'!
isAbstractClass
	self shouldBeImplemented! !

!MCGitRepository class methodsFor: 'configuration' stamp: 'lr 10/29/2010 14:40'!
morphicConfigure
	^ self fillInTheBlankConfigure! !

!MCGitRepository class methodsFor: 'instance creation' stamp: 'lr 10/29/2010 14:37'!
reference: aReference
	^ self new initializeReference: aReference! !

!MCGitRepository methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2011 01:03'!
alwaysStoreDiffs
	^ true! !

!MCGitRepository methodsFor: 'private' stamp: 'CamilloBruni 9/2/2012 18:44'!
basicStoreVersion: aVersion

	| filesystem |
	
	filesystem := self gitHeadFilesystem.
	
	MCGitWriter
		fileOut: aVersion
		on: (filesystem root "/ aVersion package name")
			ensureDirectory.
			
	filesystem
		commit: aVersion info message
		andTag: aVersion info name.
	filesystem validate.! !

!MCGitRepository methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/28/2011 23:59'!
cacheAllFileNamesDuring: aBlock
	^ aBlock value! !

!MCGitRepository methodsFor: 'accessing' stamp: 'lr 10/29/2010 14:42'!
description
	^ 'git:/', reference asString! !

!MCGitRepository methodsFor: 'accessing-git' stamp: 'CamilloBruni 1/23/2012 19:04'!
gitHeadFilesystem
	^ self repository head! !

!MCGitRepository methodsFor: 'interface' stamp: 'CamilloBruni 1/23/2012 19:04'!
includesVersionNamed: aString
	self flag: '(aString copyUpToLast: $.)'.
	^ self repository tagNames includes: aString.! !

!MCGitRepository methodsFor: 'initialization' stamp: 'lr 10/29/2010 14:38'!
initializeReference: aReference
	reference := aReference! !

!MCGitRepository methodsFor: 'morphic' stamp: 'lr 10/29/2010 15:07'!
morphicOpen: aWorkingCopy
	(MCFileRepositoryInspector repository: self workingCopy: aWorkingCopy)
		show! !

!MCGitRepository methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 20:17'!
readableFileNames
	"^ self repository tags keys collect: [ :tag| tag object signature hexHash, '.git' ]"
	^ self repository tags keys collect: [ :tag| tag name, '.git' ]! !

!MCGitRepository methodsFor: 'accessing' stamp: 'lr 10/29/2010 14:45'!
reference
	^ reference! !

!MCGitRepository methodsFor: 'accessing-git' stamp: 'MaxLeske 9/3/2012 20:58'!
repository
	^ FileSystemGitRepository on: self reference! !

!MCGitRepository methodsFor: 'interface' stamp: 'CamilloBruni 1/23/2012 22:28'!
versionFromFileNamed: aString
	| tag filesystem package |
	
	tag := (aString copyAfterLast: $.) isAllDigits
		ifTrue:  [ aString ]
		ifFalse: [ aString copyUpToLast: $. ].
	filesystem := self repository tagNamed: tag.
	"filesystem := self repository head."
	package := (aString copyUpToLast: $.) copyUpToLast: $-.
	
	"^ (MCGitReader on: filesystem root / package) version"
	^ (MCGitReader on: filesystem root / tag) version! !

!MCGitRepository methodsFor: 'interface' stamp: 'Camillobruni 8/18/2011 12:13'!
versionWithInfo: aVersionInfo ifAbsent: aBlock
	(self includesVersionNamed: aVersionInfo name)
		ifFalse: [ ^ aBlock value].
	^ self versionFromFileNamed: aVersionInfo name.! !

MCGitRepository subclass: #MCOSGitRepository
	instanceVariableNames: 'remote pushAutomatically'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileSystem-Git-Monticello'!

!MCOSGitRepository class methodsFor: 'configuration' stamp: 'CamilloBruni 1/23/2012 19:46'!
creationTemplate
	^ self name , ' directory: ''repo.git'' remote: ''git://host:user/project'' push: true'! !

!MCOSGitRepository class methodsFor: 'configuration' stamp: 'CamilloBruni 1/23/2012 18:41'!
description
	^ 'OS-Git'! !

!MCOSGitRepository class methodsFor: 'instance creation' stamp: 'CamilloBruni 8/30/2012 14:08'!
directory: aString remote: remote push: shouldPush
	^ (self reference: (FileSystem disk referenceTo: aString))
		remote: remote;
		pushAutomatically: shouldPush;
		yourself! !

!MCOSGitRepository class methodsFor: 'configuration' stamp: 'CamilloBruni 1/23/2012 18:43'!
fillInTheBlankRequest
	^ 'Local OS Git Repository'! !

!MCOSGitRepository methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 1/23/2012 19:47'!
basicStoreVersion: aVersion

	super basicStoreVersion: aVersion.
	
	self pushAutomatically ifTrue: [ self push ].
! !

!MCOSGitRepository methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 1/23/2012 18:45'!
description
	^ 'git:/', reference asString, ' => ', remote! !

!MCOSGitRepository methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 1/23/2012 19:49'!
gitCommand: aCommandString
	"push the contents using OS Process"
	
	| localPath command |
	
	localPath := 	self repository repository baseDir pathString.
		
	command := OSProcess thisOSProcess 
		waitForCommand: 'git --git-dir="', localPath, aCommandString.
		
	self assert: command succeeded ! !

!MCOSGitRepository methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 1/23/2012 19:49'!
pull
	"pull the contents using OS Process"
	
	^ self gitCommand: ' pull "', self remote, '" master'.! !

!MCOSGitRepository methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 1/23/2012 19:49'!
push
	"push the contents using OS Process"
	
	^ self gitCommand: '" push "', self remote, '" master'.! !

!MCOSGitRepository methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 19:44'!
pushAutomatically
	^ pushAutomatically! !

!MCOSGitRepository methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 19:44'!
pushAutomatically: aBoolean
	pushAutomatically := aBoolean! !

!MCOSGitRepository methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 18:46'!
remote
	^ remote! !

!MCOSGitRepository methodsFor: 'accessing' stamp: 'CamilloBruni 1/23/2012 18:47'!
remote: aString
	self remote = aString
		ifFalse:[
			remote := aString.
			self updateRemote ].! !

!MCOSGitRepository methodsFor: 'private' stamp: 'CamilloBruni 1/23/2012 18:47'!
updateRemote
	! !
